#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Downcounter register"]
    pub downcounter: DOWNCOUNTER,
    #[doc = "0x04 - Preset value register"]
    pub preset: PRESET,
    _reserved2: [u8; 4048usize],
    #[doc = "0xfd8 - Interrupt clear enable register"]
    pub clr_en: CLR_EN,
    #[doc = "0xfdc - Interrupt set enable register"]
    pub set_en: SET_EN,
    #[doc = "0xfe0 - Status register"]
    pub status: STATUS,
    #[doc = "0xfe4 - Enable register"]
    pub enable: ENABLE,
    #[doc = "0xfe8 - Clear register"]
    pub clr_stat: CLR_STAT,
    #[doc = "0xfec - Set register"]
    pub set_stat: SET_STAT,
}
#[doc = "Downcounter register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [downcounter](downcounter) module"]
pub type DOWNCOUNTER = crate::Reg<u32, _DOWNCOUNTER>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DOWNCOUNTER;
#[doc = "`read()` method returns [downcounter::R](downcounter::R) reader structure"]
impl crate::Readable for DOWNCOUNTER {}
#[doc = "`write(|w| ..)` method takes [downcounter::W](downcounter::W) writer structure"]
impl crate::Writable for DOWNCOUNTER {}
#[doc = "Downcounter register"]
pub mod downcounter;
#[doc = "Preset value register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [preset](preset) module"]
pub type PRESET = crate::Reg<u32, _PRESET>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PRESET;
#[doc = "`read()` method returns [preset::R](preset::R) reader structure"]
impl crate::Readable for PRESET {}
#[doc = "`write(|w| ..)` method takes [preset::W](preset::W) writer structure"]
impl crate::Writable for PRESET {}
#[doc = "Preset value register"]
pub mod preset;
#[doc = "Interrupt clear enable register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clr_en](clr_en) module"]
pub type CLR_EN = crate::Reg<u32, _CLR_EN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLR_EN;
#[doc = "`write(|w| ..)` method takes [clr_en::W](clr_en::W) writer structure"]
impl crate::Writable for CLR_EN {}
#[doc = "Interrupt clear enable register"]
pub mod clr_en;
#[doc = "Interrupt set enable register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [set_en](set_en) module"]
pub type SET_EN = crate::Reg<u32, _SET_EN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SET_EN;
#[doc = "`write(|w| ..)` method takes [set_en::W](set_en::W) writer structure"]
impl crate::Writable for SET_EN {}
#[doc = "Interrupt set enable register"]
pub mod set_en;
#[doc = "Status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [status](status) module"]
pub type STATUS = crate::Reg<u32, _STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _STATUS;
#[doc = "`read()` method returns [status::R](status::R) reader structure"]
impl crate::Readable for STATUS {}
#[doc = "Status register"]
pub mod status;
#[doc = "Enable register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [enable](enable) module"]
pub type ENABLE = crate::Reg<u32, _ENABLE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ENABLE;
#[doc = "`read()` method returns [enable::R](enable::R) reader structure"]
impl crate::Readable for ENABLE {}
#[doc = "Enable register"]
pub mod enable;
#[doc = "Clear register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clr_stat](clr_stat) module"]
pub type CLR_STAT = crate::Reg<u32, _CLR_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLR_STAT;
#[doc = "`write(|w| ..)` method takes [clr_stat::W](clr_stat::W) writer structure"]
impl crate::Writable for CLR_STAT {}
#[doc = "Clear register"]
pub mod clr_stat;
#[doc = "Set register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [set_stat](set_stat) module"]
pub type SET_STAT = crate::Reg<u32, _SET_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SET_STAT;
#[doc = "`write(|w| ..)` method takes [set_stat::W](set_stat::W) writer structure"]
impl crate::Writable for SET_STAT {}
#[doc = "Set register"]
pub mod set_stat;
