#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - CAN control"]
    pub cntl: CNTL,
    #[doc = "0x04 - Status register"]
    pub stat: STAT,
    #[doc = "0x08 - Error counter"]
    pub ec: EC,
    #[doc = "0x0c - Bit timing register"]
    pub bt: BT,
    #[doc = "0x10 - Interrupt register"]
    pub int: INT,
    #[doc = "0x14 - Test register"]
    pub test: TEST,
    #[doc = "0x18 - Baud rate prescaler extension register"]
    pub brpe: BRPE,
    _reserved7: [u8; 4usize],
    #[doc = "0x20 - Message interface command request"]
    pub if1_cmdreq: IF_CMDREQ,
    _reserved_8_if1_cmdmsk: [u8; 4usize],
    #[doc = "0x28 - Message interface mask 1"]
    pub if1_msk1: IF_MSK1,
    #[doc = "0x2c - Message interface 1 mask 2"]
    pub if1_msk2: IF_MSK2,
    #[doc = "0x30 - Message interface 1 arbitration 1"]
    pub if1_arb1: IF_ARB1,
    #[doc = "0x34 - Message interface 1 arbitration 2"]
    pub if1_arb2: IF_ARB2,
    #[doc = "0x38 - Message interface 1 message control"]
    pub if1_mctrl: IF_MCTRL,
    #[doc = "0x3c - Message interface data A1"]
    pub if1_da1: IF_DA1,
    #[doc = "0x40 - Message interface 1 data A2"]
    pub if1_da2: IF_DA2,
    #[doc = "0x44 - Message interface 1 data B1"]
    pub if1_db1: IF_DB1,
    #[doc = "0x48 - Message interface 1 data B2"]
    pub if1_db2: IF_DB2,
    _reserved18: [u8; 52usize],
    #[doc = "0x80 - Message interface command request"]
    pub if2_cmdreq: IF_CMDREQ,
    _reserved_19_if2_cmdmsk: [u8; 4usize],
    #[doc = "0x88 - Message interface mask 1"]
    pub if2_msk1: IF_MSK1,
    #[doc = "0x8c - Message interface 1 mask 2"]
    pub if2_msk2: IF_MSK2,
    #[doc = "0x90 - Message interface 1 arbitration 1"]
    pub if2_arb1: IF_ARB1,
    #[doc = "0x94 - Message interface 1 arbitration 2"]
    pub if2_arb2: IF_ARB2,
    #[doc = "0x98 - Message interface 1 message control"]
    pub if2_mctrl: IF_MCTRL,
    #[doc = "0x9c - Message interface data A1"]
    pub if2_da1: IF_DA1,
    #[doc = "0xa0 - Message interface 1 data A2"]
    pub if2_da2: IF_DA2,
    #[doc = "0xa4 - Message interface 1 data B1"]
    pub if2_db1: IF_DB1,
    #[doc = "0xa8 - Message interface 1 data B2"]
    pub if2_db2: IF_DB2,
    _reserved29: [u8; 84usize],
    #[doc = "0x100 - Transmission request 1"]
    pub txreq1: TXREQ1,
    #[doc = "0x104 - Transmission request 2"]
    pub txreq2: TXREQ2,
    _reserved31: [u8; 24usize],
    #[doc = "0x120 - New data 1"]
    pub nd1: ND1,
    #[doc = "0x124 - New data 2"]
    pub nd2: ND2,
    _reserved33: [u8; 24usize],
    #[doc = "0x140 - Interrupt pending 1"]
    pub ir1: IR1,
    #[doc = "0x144 - Interrupt pending 2"]
    pub ir2: IR2,
    _reserved35: [u8; 24usize],
    #[doc = "0x160 - Message valid 1"]
    pub msgv1: MSGV1,
    #[doc = "0x164 - Message valid 2"]
    pub msgv2: MSGV2,
    _reserved37: [u8; 24usize],
    #[doc = "0x180 - CAN clock divider register"]
    pub clkdiv: CLKDIV,
}
impl RegisterBlock {
    #[doc = "0x24 - Message interface command mask (read direction)"]
    #[inline(always)]
    pub fn if1_cmdmsk_r(&self) -> &IF_CMDMSK_R {
        unsafe { &*(((self as *const Self) as *const u8).add(36usize) as *const IF_CMDMSK_R) }
    }
    #[doc = "0x24 - Message interface command mask (read direction)"]
    #[inline(always)]
    pub fn if1_cmdmsk_r_mut(&self) -> &mut IF_CMDMSK_R {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(36usize) as *mut IF_CMDMSK_R) }
    }
    #[doc = "0x24 - Message interface command mask (write direction)"]
    #[inline(always)]
    pub fn if1_cmdmsk_w(&self) -> &IF_CMDMSK_W {
        unsafe { &*(((self as *const Self) as *const u8).add(36usize) as *const IF_CMDMSK_W) }
    }
    #[doc = "0x24 - Message interface command mask (write direction)"]
    #[inline(always)]
    pub fn if1_cmdmsk_w_mut(&self) -> &mut IF_CMDMSK_W {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(36usize) as *mut IF_CMDMSK_W) }
    }
    #[doc = "0x84 - Message interface command mask (read direction)"]
    #[inline(always)]
    pub fn if2_cmdmsk_r(&self) -> &IF_CMDMSK_R {
        unsafe { &*(((self as *const Self) as *const u8).add(132usize) as *const IF_CMDMSK_R) }
    }
    #[doc = "0x84 - Message interface command mask (read direction)"]
    #[inline(always)]
    pub fn if2_cmdmsk_r_mut(&self) -> &mut IF_CMDMSK_R {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(132usize) as *mut IF_CMDMSK_R) }
    }
    #[doc = "0x84 - Message interface command mask (write direction)"]
    #[inline(always)]
    pub fn if2_cmdmsk_w(&self) -> &IF_CMDMSK_W {
        unsafe { &*(((self as *const Self) as *const u8).add(132usize) as *const IF_CMDMSK_W) }
    }
    #[doc = "0x84 - Message interface command mask (write direction)"]
    #[inline(always)]
    pub fn if2_cmdmsk_w_mut(&self) -> &mut IF_CMDMSK_W {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(132usize) as *mut IF_CMDMSK_W) }
    }
}
#[doc = "CAN control\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cntl](cntl) module"]
pub type CNTL = crate::Reg<u32, _CNTL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CNTL;
#[doc = "`read()` method returns [cntl::R](cntl::R) reader structure"]
impl crate::Readable for CNTL {}
#[doc = "`write(|w| ..)` method takes [cntl::W](cntl::W) writer structure"]
impl crate::Writable for CNTL {}
#[doc = "CAN control"]
pub mod cntl;
#[doc = "Status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [stat](stat) module"]
pub type STAT = crate::Reg<u32, _STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _STAT;
#[doc = "`read()` method returns [stat::R](stat::R) reader structure"]
impl crate::Readable for STAT {}
#[doc = "`write(|w| ..)` method takes [stat::W](stat::W) writer structure"]
impl crate::Writable for STAT {}
#[doc = "Status register"]
pub mod stat;
#[doc = "Error counter\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ec](ec) module"]
pub type EC = crate::Reg<u32, _EC>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EC;
#[doc = "`read()` method returns [ec::R](ec::R) reader structure"]
impl crate::Readable for EC {}
#[doc = "Error counter"]
pub mod ec;
#[doc = "Bit timing register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [bt](bt) module"]
pub type BT = crate::Reg<u32, _BT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BT;
#[doc = "`read()` method returns [bt::R](bt::R) reader structure"]
impl crate::Readable for BT {}
#[doc = "`write(|w| ..)` method takes [bt::W](bt::W) writer structure"]
impl crate::Writable for BT {}
#[doc = "Bit timing register"]
pub mod bt;
#[doc = "Interrupt register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [int](int) module"]
pub type INT = crate::Reg<u32, _INT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INT;
#[doc = "`read()` method returns [int::R](int::R) reader structure"]
impl crate::Readable for INT {}
#[doc = "Interrupt register"]
pub mod int;
#[doc = "Test register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [test](test) module"]
pub type TEST = crate::Reg<u32, _TEST>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TEST;
#[doc = "`read()` method returns [test::R](test::R) reader structure"]
impl crate::Readable for TEST {}
#[doc = "`write(|w| ..)` method takes [test::W](test::W) writer structure"]
impl crate::Writable for TEST {}
#[doc = "Test register"]
pub mod test;
#[doc = "Baud rate prescaler extension register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [brpe](brpe) module"]
pub type BRPE = crate::Reg<u32, _BRPE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BRPE;
#[doc = "`read()` method returns [brpe::R](brpe::R) reader structure"]
impl crate::Readable for BRPE {}
#[doc = "`write(|w| ..)` method takes [brpe::W](brpe::W) writer structure"]
impl crate::Writable for BRPE {}
#[doc = "Baud rate prescaler extension register"]
pub mod brpe;
#[doc = "Message interface command request\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_cmdreq](if_cmdreq) module"]
pub type IF_CMDREQ = crate::Reg<u32, _IF_CMDREQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_CMDREQ;
#[doc = "`read()` method returns [if_cmdreq::R](if_cmdreq::R) reader structure"]
impl crate::Readable for IF_CMDREQ {}
#[doc = "`write(|w| ..)` method takes [if_cmdreq::W](if_cmdreq::W) writer structure"]
impl crate::Writable for IF_CMDREQ {}
#[doc = "Message interface command request"]
pub mod if_cmdreq;
#[doc = "Message interface command mask (write direction)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_cmdmsk_w](if_cmdmsk_w) module"]
pub type IF_CMDMSK_W = crate::Reg<u32, _IF_CMDMSK_W>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_CMDMSK_W;
#[doc = "`read()` method returns [if_cmdmsk_w::R](if_cmdmsk_w::R) reader structure"]
impl crate::Readable for IF_CMDMSK_W {}
#[doc = "`write(|w| ..)` method takes [if_cmdmsk_w::W](if_cmdmsk_w::W) writer structure"]
impl crate::Writable for IF_CMDMSK_W {}
#[doc = "Message interface command mask (write direction)"]
pub mod if_cmdmsk_w;
#[doc = "Message interface command mask (read direction)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_cmdmsk_r](if_cmdmsk_r) module"]
pub type IF_CMDMSK_R = crate::Reg<u32, _IF_CMDMSK_R>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_CMDMSK_R;
#[doc = "`read()` method returns [if_cmdmsk_r::R](if_cmdmsk_r::R) reader structure"]
impl crate::Readable for IF_CMDMSK_R {}
#[doc = "`write(|w| ..)` method takes [if_cmdmsk_r::W](if_cmdmsk_r::W) writer structure"]
impl crate::Writable for IF_CMDMSK_R {}
#[doc = "Message interface command mask (read direction)"]
pub mod if_cmdmsk_r;
#[doc = "Message interface mask 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_msk1](if_msk1) module"]
pub type IF_MSK1 = crate::Reg<u32, _IF_MSK1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_MSK1;
#[doc = "`read()` method returns [if_msk1::R](if_msk1::R) reader structure"]
impl crate::Readable for IF_MSK1 {}
#[doc = "`write(|w| ..)` method takes [if_msk1::W](if_msk1::W) writer structure"]
impl crate::Writable for IF_MSK1 {}
#[doc = "Message interface mask 1"]
pub mod if_msk1;
#[doc = "Message interface 1 mask 2\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_msk2](if_msk2) module"]
pub type IF_MSK2 = crate::Reg<u32, _IF_MSK2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_MSK2;
#[doc = "`read()` method returns [if_msk2::R](if_msk2::R) reader structure"]
impl crate::Readable for IF_MSK2 {}
#[doc = "`write(|w| ..)` method takes [if_msk2::W](if_msk2::W) writer structure"]
impl crate::Writable for IF_MSK2 {}
#[doc = "Message interface 1 mask 2"]
pub mod if_msk2;
#[doc = "Message interface 1 arbitration 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_arb1](if_arb1) module"]
pub type IF_ARB1 = crate::Reg<u32, _IF_ARB1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_ARB1;
#[doc = "`read()` method returns [if_arb1::R](if_arb1::R) reader structure"]
impl crate::Readable for IF_ARB1 {}
#[doc = "`write(|w| ..)` method takes [if_arb1::W](if_arb1::W) writer structure"]
impl crate::Writable for IF_ARB1 {}
#[doc = "Message interface 1 arbitration 1"]
pub mod if_arb1;
#[doc = "Message interface 1 arbitration 2\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_arb2](if_arb2) module"]
pub type IF_ARB2 = crate::Reg<u32, _IF_ARB2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_ARB2;
#[doc = "`read()` method returns [if_arb2::R](if_arb2::R) reader structure"]
impl crate::Readable for IF_ARB2 {}
#[doc = "`write(|w| ..)` method takes [if_arb2::W](if_arb2::W) writer structure"]
impl crate::Writable for IF_ARB2 {}
#[doc = "Message interface 1 arbitration 2"]
pub mod if_arb2;
#[doc = "Message interface 1 message control\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_mctrl](if_mctrl) module"]
pub type IF_MCTRL = crate::Reg<u32, _IF_MCTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_MCTRL;
#[doc = "`read()` method returns [if_mctrl::R](if_mctrl::R) reader structure"]
impl crate::Readable for IF_MCTRL {}
#[doc = "`write(|w| ..)` method takes [if_mctrl::W](if_mctrl::W) writer structure"]
impl crate::Writable for IF_MCTRL {}
#[doc = "Message interface 1 message control"]
pub mod if_mctrl;
#[doc = "Message interface data A1\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_da1](if_da1) module"]
pub type IF_DA1 = crate::Reg<u32, _IF_DA1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_DA1;
#[doc = "`read()` method returns [if_da1::R](if_da1::R) reader structure"]
impl crate::Readable for IF_DA1 {}
#[doc = "`write(|w| ..)` method takes [if_da1::W](if_da1::W) writer structure"]
impl crate::Writable for IF_DA1 {}
#[doc = "Message interface data A1"]
pub mod if_da1;
#[doc = "Message interface 1 data A2\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_da2](if_da2) module"]
pub type IF_DA2 = crate::Reg<u32, _IF_DA2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_DA2;
#[doc = "`read()` method returns [if_da2::R](if_da2::R) reader structure"]
impl crate::Readable for IF_DA2 {}
#[doc = "`write(|w| ..)` method takes [if_da2::W](if_da2::W) writer structure"]
impl crate::Writable for IF_DA2 {}
#[doc = "Message interface 1 data A2"]
pub mod if_da2;
#[doc = "Message interface 1 data B1\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_db1](if_db1) module"]
pub type IF_DB1 = crate::Reg<u32, _IF_DB1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_DB1;
#[doc = "`read()` method returns [if_db1::R](if_db1::R) reader structure"]
impl crate::Readable for IF_DB1 {}
#[doc = "`write(|w| ..)` method takes [if_db1::W](if_db1::W) writer structure"]
impl crate::Writable for IF_DB1 {}
#[doc = "Message interface 1 data B1"]
pub mod if_db1;
#[doc = "Message interface 1 data B2\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [if_db2](if_db2) module"]
pub type IF_DB2 = crate::Reg<u32, _IF_DB2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IF_DB2;
#[doc = "`read()` method returns [if_db2::R](if_db2::R) reader structure"]
impl crate::Readable for IF_DB2 {}
#[doc = "`write(|w| ..)` method takes [if_db2::W](if_db2::W) writer structure"]
impl crate::Writable for IF_DB2 {}
#[doc = "Message interface 1 data B2"]
pub mod if_db2;
#[doc = "Transmission request 1\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [txreq1](txreq1) module"]
pub type TXREQ1 = crate::Reg<u32, _TXREQ1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TXREQ1;
#[doc = "`read()` method returns [txreq1::R](txreq1::R) reader structure"]
impl crate::Readable for TXREQ1 {}
#[doc = "Transmission request 1"]
pub mod txreq1;
#[doc = "Transmission request 2\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [txreq2](txreq2) module"]
pub type TXREQ2 = crate::Reg<u32, _TXREQ2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TXREQ2;
#[doc = "`read()` method returns [txreq2::R](txreq2::R) reader structure"]
impl crate::Readable for TXREQ2 {}
#[doc = "Transmission request 2"]
pub mod txreq2;
#[doc = "New data 1\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [nd1](nd1) module"]
pub type ND1 = crate::Reg<u32, _ND1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ND1;
#[doc = "`read()` method returns [nd1::R](nd1::R) reader structure"]
impl crate::Readable for ND1 {}
#[doc = "New data 1"]
pub mod nd1;
#[doc = "New data 2\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [nd2](nd2) module"]
pub type ND2 = crate::Reg<u32, _ND2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ND2;
#[doc = "`read()` method returns [nd2::R](nd2::R) reader structure"]
impl crate::Readable for ND2 {}
#[doc = "New data 2"]
pub mod nd2;
#[doc = "Interrupt pending 1\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ir1](ir1) module"]
pub type IR1 = crate::Reg<u32, _IR1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IR1;
#[doc = "`read()` method returns [ir1::R](ir1::R) reader structure"]
impl crate::Readable for IR1 {}
#[doc = "Interrupt pending 1"]
pub mod ir1;
#[doc = "Interrupt pending 2\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ir2](ir2) module"]
pub type IR2 = crate::Reg<u32, _IR2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IR2;
#[doc = "`read()` method returns [ir2::R](ir2::R) reader structure"]
impl crate::Readable for IR2 {}
#[doc = "Interrupt pending 2"]
pub mod ir2;
#[doc = "Message valid 1\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [msgv1](msgv1) module"]
pub type MSGV1 = crate::Reg<u32, _MSGV1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MSGV1;
#[doc = "`read()` method returns [msgv1::R](msgv1::R) reader structure"]
impl crate::Readable for MSGV1 {}
#[doc = "Message valid 1"]
pub mod msgv1;
#[doc = "Message valid 2\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [msgv2](msgv2) module"]
pub type MSGV2 = crate::Reg<u32, _MSGV2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MSGV2;
#[doc = "`read()` method returns [msgv2::R](msgv2::R) reader structure"]
impl crate::Readable for MSGV2 {}
#[doc = "Message valid 2"]
pub mod msgv2;
#[doc = "CAN clock divider register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clkdiv](clkdiv) module"]
pub type CLKDIV = crate::Reg<u32, _CLKDIV>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLKDIV;
#[doc = "`read()` method returns [clkdiv::R](clkdiv::R) reader structure"]
impl crate::Readable for CLKDIV {}
#[doc = "`write(|w| ..)` method takes [clkdiv::W](clkdiv::W) writer structure"]
impl crate::Writable for CLKDIV {}
#[doc = "CAN clock divider register"]
pub mod clkdiv;
