#[doc = "Reader of register IF%s_MCTRL"]
pub type R = crate::R<u32, super::IF_MCTRL>;
#[doc = "Writer for register IF%s_MCTRL"]
pub type W = crate::W<u32, super::IF_MCTRL>;
#[doc = "Register IF%s_MCTRL `reset()`'s with value 0"]
impl crate::ResetValue for super::IF_MCTRL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `DLC3_0`"]
pub type DLC3_0_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `DLC3_0`"]
pub struct DLC3_0_W<'a> {
    w: &'a mut W,
}
impl<'a> DLC3_0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | ((value as u32) & 0x0f);
        self.w
    }
}
#[doc = "End of buffer\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EOB_A {
    #[doc = "1: Single message object or last message object of a FIFO buffer."]
    SINGLE_MESSAGE_OBJECT = 1,
    #[doc = "0: Message object belongs to a FIFO buffer and is not the last message object of that FIFO buffer."]
    MESSAGE_OBJECT_BELONGS_TO_FIFO = 0,
}
impl From<EOB_A> for bool {
    #[inline(always)]
    fn from(variant: EOB_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EOB`"]
pub type EOB_R = crate::R<bool, EOB_A>;
impl EOB_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EOB_A {
        match self.bits {
            true => EOB_A::SINGLE_MESSAGE_OBJECT,
            false => EOB_A::MESSAGE_OBJECT_BELONGS_TO_FIFO,
        }
    }
    #[doc = "Checks if the value of the field is `SINGLE_MESSAGE_OBJECT`"]
    #[inline(always)]
    pub fn is_single_message_object(&self) -> bool {
        *self == EOB_A::SINGLE_MESSAGE_OBJECT
    }
    #[doc = "Checks if the value of the field is `MESSAGE_OBJECT_BELONGS_TO_FIFO`"]
    #[inline(always)]
    pub fn is_message_object_belongs_to_fifo(&self) -> bool {
        *self == EOB_A::MESSAGE_OBJECT_BELONGS_TO_FIFO
    }
}
#[doc = "Write proxy for field `EOB`"]
pub struct EOB_W<'a> {
    w: &'a mut W,
}
impl<'a> EOB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EOB_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Single message object or last message object of a FIFO buffer."]
    #[inline(always)]
    pub fn single_message_object(self) -> &'a mut W {
        self.variant(EOB_A::SINGLE_MESSAGE_OBJECT)
    }
    #[doc = "Message object belongs to a FIFO buffer and is not the last message object of that FIFO buffer."]
    #[inline(always)]
    pub fn message_object_belongs_to_fifo(self) -> &'a mut W {
        self.variant(EOB_A::MESSAGE_OBJECT_BELONGS_TO_FIFO)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Transmit request\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXRQST_A {
    #[doc = "1: The transmission of this message object is requested and is not yet done"]
    REQUEST = 1,
    #[doc = "0: This message object is not waiting for transmission."]
    WAIT = 0,
}
impl From<TXRQST_A> for bool {
    #[inline(always)]
    fn from(variant: TXRQST_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TXRQST`"]
pub type TXRQST_R = crate::R<bool, TXRQST_A>;
impl TXRQST_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXRQST_A {
        match self.bits {
            true => TXRQST_A::REQUEST,
            false => TXRQST_A::WAIT,
        }
    }
    #[doc = "Checks if the value of the field is `REQUEST`"]
    #[inline(always)]
    pub fn is_request(&self) -> bool {
        *self == TXRQST_A::REQUEST
    }
    #[doc = "Checks if the value of the field is `WAIT`"]
    #[inline(always)]
    pub fn is_wait(&self) -> bool {
        *self == TXRQST_A::WAIT
    }
}
#[doc = "Write proxy for field `TXRQST`"]
pub struct TXRQST_W<'a> {
    w: &'a mut W,
}
impl<'a> TXRQST_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXRQST_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The transmission of this message object is requested and is not yet done"]
    #[inline(always)]
    pub fn request(self) -> &'a mut W {
        self.variant(TXRQST_A::REQUEST)
    }
    #[doc = "This message object is not waiting for transmission."]
    #[inline(always)]
    pub fn wait(self) -> &'a mut W {
        self.variant(TXRQST_A::WAIT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Remote enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RMTEN_A {
    #[doc = "1: At the reception of a remote frame, TXRQST is set."]
    TXRQSTSET = 1,
    #[doc = "0: At the reception of a remote frame, TXRQST is left unchanged."]
    UNCHANGED = 0,
}
impl From<RMTEN_A> for bool {
    #[inline(always)]
    fn from(variant: RMTEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `RMTEN`"]
pub type RMTEN_R = crate::R<bool, RMTEN_A>;
impl RMTEN_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RMTEN_A {
        match self.bits {
            true => RMTEN_A::TXRQSTSET,
            false => RMTEN_A::UNCHANGED,
        }
    }
    #[doc = "Checks if the value of the field is `TXRQSTSET`"]
    #[inline(always)]
    pub fn is_txrqstset(&self) -> bool {
        *self == RMTEN_A::TXRQSTSET
    }
    #[doc = "Checks if the value of the field is `UNCHANGED`"]
    #[inline(always)]
    pub fn is_unchanged(&self) -> bool {
        *self == RMTEN_A::UNCHANGED
    }
}
#[doc = "Write proxy for field `RMTEN`"]
pub struct RMTEN_W<'a> {
    w: &'a mut W,
}
impl<'a> RMTEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RMTEN_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "At the reception of a remote frame, TXRQST is set."]
    #[inline(always)]
    pub fn txrqstset(self) -> &'a mut W {
        self.variant(RMTEN_A::TXRQSTSET)
    }
    #[doc = "At the reception of a remote frame, TXRQST is left unchanged."]
    #[inline(always)]
    pub fn unchanged(self) -> &'a mut W {
        self.variant(RMTEN_A::UNCHANGED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "Receive interrupt enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RXIE_A {
    #[doc = "1: INTPND will be set after successful reception of a frame."]
    INTPNDSET = 1,
    #[doc = "0: INTPND will be left unchanged after successful reception of a frame."]
    UNCHANGED = 0,
}
impl From<RXIE_A> for bool {
    #[inline(always)]
    fn from(variant: RXIE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `RXIE`"]
pub type RXIE_R = crate::R<bool, RXIE_A>;
impl RXIE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RXIE_A {
        match self.bits {
            true => RXIE_A::INTPNDSET,
            false => RXIE_A::UNCHANGED,
        }
    }
    #[doc = "Checks if the value of the field is `INTPNDSET`"]
    #[inline(always)]
    pub fn is_intpndset(&self) -> bool {
        *self == RXIE_A::INTPNDSET
    }
    #[doc = "Checks if the value of the field is `UNCHANGED`"]
    #[inline(always)]
    pub fn is_unchanged(&self) -> bool {
        *self == RXIE_A::UNCHANGED
    }
}
#[doc = "Write proxy for field `RXIE`"]
pub struct RXIE_W<'a> {
    w: &'a mut W,
}
impl<'a> RXIE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RXIE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "INTPND will be set after successful reception of a frame."]
    #[inline(always)]
    pub fn intpndset(self) -> &'a mut W {
        self.variant(RXIE_A::INTPNDSET)
    }
    #[doc = "INTPND will be left unchanged after successful reception of a frame."]
    #[inline(always)]
    pub fn unchanged(self) -> &'a mut W {
        self.variant(RXIE_A::UNCHANGED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "Transmit interrupt enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXIE_A {
    #[doc = "1: INTPND will be set after a successful reception of a frame."]
    INTPNDSET = 1,
    #[doc = "0: The INTPND bit will be left unchanged after a successful reception of a frame."]
    UNCHANGED = 0,
}
impl From<TXIE_A> for bool {
    #[inline(always)]
    fn from(variant: TXIE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TXIE`"]
pub type TXIE_R = crate::R<bool, TXIE_A>;
impl TXIE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXIE_A {
        match self.bits {
            true => TXIE_A::INTPNDSET,
            false => TXIE_A::UNCHANGED,
        }
    }
    #[doc = "Checks if the value of the field is `INTPNDSET`"]
    #[inline(always)]
    pub fn is_intpndset(&self) -> bool {
        *self == TXIE_A::INTPNDSET
    }
    #[doc = "Checks if the value of the field is `UNCHANGED`"]
    #[inline(always)]
    pub fn is_unchanged(&self) -> bool {
        *self == TXIE_A::UNCHANGED
    }
}
#[doc = "Write proxy for field `TXIE`"]
pub struct TXIE_W<'a> {
    w: &'a mut W,
}
impl<'a> TXIE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXIE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "INTPND will be set after a successful reception of a frame."]
    #[inline(always)]
    pub fn intpndset(self) -> &'a mut W {
        self.variant(TXIE_A::INTPNDSET)
    }
    #[doc = "The INTPND bit will be left unchanged after a successful reception of a frame."]
    #[inline(always)]
    pub fn unchanged(self) -> &'a mut W {
        self.variant(TXIE_A::UNCHANGED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Use acceptance mask If UMASK is set to 1, the message object's mask bits have to be programmed during initialization of the message object before MAGVAL is set to 1.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UMASK_A {
    #[doc = "1: Use mask (MSK\\[28:0\\], MXTD, and MDIR) for acceptance filtering."]
    USE_MASK = 1,
    #[doc = "0: Mask ignored."]
    MASK_IGNORED = 0,
}
impl From<UMASK_A> for bool {
    #[inline(always)]
    fn from(variant: UMASK_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `UMASK`"]
pub type UMASK_R = crate::R<bool, UMASK_A>;
impl UMASK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UMASK_A {
        match self.bits {
            true => UMASK_A::USE_MASK,
            false => UMASK_A::MASK_IGNORED,
        }
    }
    #[doc = "Checks if the value of the field is `USE_MASK`"]
    #[inline(always)]
    pub fn is_use_mask(&self) -> bool {
        *self == UMASK_A::USE_MASK
    }
    #[doc = "Checks if the value of the field is `MASK_IGNORED`"]
    #[inline(always)]
    pub fn is_mask_ignored(&self) -> bool {
        *self == UMASK_A::MASK_IGNORED
    }
}
#[doc = "Write proxy for field `UMASK`"]
pub struct UMASK_W<'a> {
    w: &'a mut W,
}
impl<'a> UMASK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UMASK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Use mask (MSK\\[28:0\\], MXTD, and MDIR) for acceptance filtering."]
    #[inline(always)]
    pub fn use_mask(self) -> &'a mut W {
        self.variant(UMASK_A::USE_MASK)
    }
    #[doc = "Mask ignored."]
    #[inline(always)]
    pub fn mask_ignored(self) -> &'a mut W {
        self.variant(UMASK_A::MASK_IGNORED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Interrupt pending\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INTPND_A {
    #[doc = "1: This message object is the source of an interrupt. The Interrupt Identifier in the Interrupt Register will point to this message object if there is no other interrupt source with higher priority."]
    INTSOURCE = 1,
    #[doc = "0: This message object is not the source of an interrupt."]
    NOINTSOURCE = 0,
}
impl From<INTPND_A> for bool {
    #[inline(always)]
    fn from(variant: INTPND_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `INTPND`"]
pub type INTPND_R = crate::R<bool, INTPND_A>;
impl INTPND_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INTPND_A {
        match self.bits {
            true => INTPND_A::INTSOURCE,
            false => INTPND_A::NOINTSOURCE,
        }
    }
    #[doc = "Checks if the value of the field is `INTSOURCE`"]
    #[inline(always)]
    pub fn is_intsource(&self) -> bool {
        *self == INTPND_A::INTSOURCE
    }
    #[doc = "Checks if the value of the field is `NOINTSOURCE`"]
    #[inline(always)]
    pub fn is_nointsource(&self) -> bool {
        *self == INTPND_A::NOINTSOURCE
    }
}
#[doc = "Write proxy for field `INTPND`"]
pub struct INTPND_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPND_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INTPND_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This message object is the source of an interrupt. The Interrupt Identifier in the Interrupt Register will point to this message object if there is no other interrupt source with higher priority."]
    #[inline(always)]
    pub fn intsource(self) -> &'a mut W {
        self.variant(INTPND_A::INTSOURCE)
    }
    #[doc = "This message object is not the source of an interrupt."]
    #[inline(always)]
    pub fn nointsource(self) -> &'a mut W {
        self.variant(INTPND_A::NOINTSOURCE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Message lost (only valid for message objects in the direction receive).\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MSGLST_A {
    #[doc = "1: The Message Handler stored a new message into this object when NEWDAT was still set, the CPU has lost a message."]
    THE_MESSAGE_HANDLER = 1,
    #[doc = "0: No message lost since this bit was reset last by the CPU."]
    NO_MESSAGE_LOST_SINCE_RESET = 0,
}
impl From<MSGLST_A> for bool {
    #[inline(always)]
    fn from(variant: MSGLST_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `MSGLST`"]
pub type MSGLST_R = crate::R<bool, MSGLST_A>;
impl MSGLST_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MSGLST_A {
        match self.bits {
            true => MSGLST_A::THE_MESSAGE_HANDLER,
            false => MSGLST_A::NO_MESSAGE_LOST_SINCE_RESET,
        }
    }
    #[doc = "Checks if the value of the field is `THE_MESSAGE_HANDLER`"]
    #[inline(always)]
    pub fn is_the_message_handler(&self) -> bool {
        *self == MSGLST_A::THE_MESSAGE_HANDLER
    }
    #[doc = "Checks if the value of the field is `NO_MESSAGE_LOST_SINCE_RESET`"]
    #[inline(always)]
    pub fn is_no_message_lost_since_reset(&self) -> bool {
        *self == MSGLST_A::NO_MESSAGE_LOST_SINCE_RESET
    }
}
#[doc = "Write proxy for field `MSGLST`"]
pub struct MSGLST_W<'a> {
    w: &'a mut W,
}
impl<'a> MSGLST_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MSGLST_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The Message Handler stored a new message into this object when NEWDAT was still set, the CPU has lost a message."]
    #[inline(always)]
    pub fn the_message_handler(self) -> &'a mut W {
        self.variant(MSGLST_A::THE_MESSAGE_HANDLER)
    }
    #[doc = "No message lost since this bit was reset last by the CPU."]
    #[inline(always)]
    pub fn no_message_lost_since_reset(self) -> &'a mut W {
        self.variant(MSGLST_A::NO_MESSAGE_LOST_SINCE_RESET)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "New data\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum NEWDAT_A {
    #[doc = "1: The message handler or the CPU has written new data into the data portion of this message object."]
    THE_MESSAGE_HANDLER = 1,
    #[doc = "0: No new data has been written into the data portion of this message object by the message handler since this flag was cleared last by the CPU."]
    NO_NEW_DATA_HAS_BEEN_WRITTEN = 0,
}
impl From<NEWDAT_A> for bool {
    #[inline(always)]
    fn from(variant: NEWDAT_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `NEWDAT`"]
pub type NEWDAT_R = crate::R<bool, NEWDAT_A>;
impl NEWDAT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> NEWDAT_A {
        match self.bits {
            true => NEWDAT_A::THE_MESSAGE_HANDLER,
            false => NEWDAT_A::NO_NEW_DATA_HAS_BEEN_WRITTEN,
        }
    }
    #[doc = "Checks if the value of the field is `THE_MESSAGE_HANDLER`"]
    #[inline(always)]
    pub fn is_the_message_handler(&self) -> bool {
        *self == NEWDAT_A::THE_MESSAGE_HANDLER
    }
    #[doc = "Checks if the value of the field is `NO_NEW_DATA_HAS_BEEN_WRITTEN`"]
    #[inline(always)]
    pub fn is_no_new_data_has_been_written(&self) -> bool {
        *self == NEWDAT_A::NO_NEW_DATA_HAS_BEEN_WRITTEN
    }
}
#[doc = "Write proxy for field `NEWDAT`"]
pub struct NEWDAT_W<'a> {
    w: &'a mut W,
}
impl<'a> NEWDAT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: NEWDAT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The message handler or the CPU has written new data into the data portion of this message object."]
    #[inline(always)]
    pub fn the_message_handler(self) -> &'a mut W {
        self.variant(NEWDAT_A::THE_MESSAGE_HANDLER)
    }
    #[doc = "No new data has been written into the data portion of this message object by the message handler since this flag was cleared last by the CPU."]
    #[inline(always)]
    pub fn no_new_data_has_been_written(self) -> &'a mut W {
        self.variant(NEWDAT_A::NO_NEW_DATA_HAS_BEEN_WRITTEN)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - Data length code The Data Length Code of a Message Object must be defined the same as in all the corresponding objects with the same identifier at other nodes. When the Message Handler stores a data frame, it will write the DLC to the value given by the received message. 0000 to 1000 = Data frame has 0 - 8 data bytes. 1001 to 1111 = Data frame has 8 data bytes."]
    #[inline(always)]
    pub fn dlc3_0(&self) -> DLC3_0_R {
        DLC3_0_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bit 7 - End of buffer"]
    #[inline(always)]
    pub fn eob(&self) -> EOB_R {
        EOB_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Transmit request"]
    #[inline(always)]
    pub fn txrqst(&self) -> TXRQST_R {
        TXRQST_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Remote enable"]
    #[inline(always)]
    pub fn rmten(&self) -> RMTEN_R {
        RMTEN_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Receive interrupt enable"]
    #[inline(always)]
    pub fn rxie(&self) -> RXIE_R {
        RXIE_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Transmit interrupt enable"]
    #[inline(always)]
    pub fn txie(&self) -> TXIE_R {
        TXIE_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Use acceptance mask If UMASK is set to 1, the message object's mask bits have to be programmed during initialization of the message object before MAGVAL is set to 1."]
    #[inline(always)]
    pub fn umask(&self) -> UMASK_R {
        UMASK_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Interrupt pending"]
    #[inline(always)]
    pub fn intpnd(&self) -> INTPND_R {
        INTPND_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Message lost (only valid for message objects in the direction receive)."]
    #[inline(always)]
    pub fn msglst(&self) -> MSGLST_R {
        MSGLST_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - New data"]
    #[inline(always)]
    pub fn newdat(&self) -> NEWDAT_R {
        NEWDAT_R::new(((self.bits >> 15) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:3 - Data length code The Data Length Code of a Message Object must be defined the same as in all the corresponding objects with the same identifier at other nodes. When the Message Handler stores a data frame, it will write the DLC to the value given by the received message. 0000 to 1000 = Data frame has 0 - 8 data bytes. 1001 to 1111 = Data frame has 8 data bytes."]
    #[inline(always)]
    pub fn dlc3_0(&mut self) -> DLC3_0_W {
        DLC3_0_W { w: self }
    }
    #[doc = "Bit 7 - End of buffer"]
    #[inline(always)]
    pub fn eob(&mut self) -> EOB_W {
        EOB_W { w: self }
    }
    #[doc = "Bit 8 - Transmit request"]
    #[inline(always)]
    pub fn txrqst(&mut self) -> TXRQST_W {
        TXRQST_W { w: self }
    }
    #[doc = "Bit 9 - Remote enable"]
    #[inline(always)]
    pub fn rmten(&mut self) -> RMTEN_W {
        RMTEN_W { w: self }
    }
    #[doc = "Bit 10 - Receive interrupt enable"]
    #[inline(always)]
    pub fn rxie(&mut self) -> RXIE_W {
        RXIE_W { w: self }
    }
    #[doc = "Bit 11 - Transmit interrupt enable"]
    #[inline(always)]
    pub fn txie(&mut self) -> TXIE_W {
        TXIE_W { w: self }
    }
    #[doc = "Bit 12 - Use acceptance mask If UMASK is set to 1, the message object's mask bits have to be programmed during initialization of the message object before MAGVAL is set to 1."]
    #[inline(always)]
    pub fn umask(&mut self) -> UMASK_W {
        UMASK_W { w: self }
    }
    #[doc = "Bit 13 - Interrupt pending"]
    #[inline(always)]
    pub fn intpnd(&mut self) -> INTPND_W {
        INTPND_W { w: self }
    }
    #[doc = "Bit 14 - Message lost (only valid for message objects in the direction receive)."]
    #[inline(always)]
    pub fn msglst(&mut self) -> MSGLST_W {
        MSGLST_W { w: self }
    }
    #[doc = "Bit 15 - New data"]
    #[inline(always)]
    pub fn newdat(&mut self) -> NEWDAT_W {
        NEWDAT_W { w: self }
    }
}
