#[doc = "Reader of register IF%s_MSK2"]
pub type R = crate::R<u32, super::IF_MSK2>;
#[doc = "Writer for register IF%s_MSK2"]
pub type W = crate::W<u32, super::IF_MSK2>;
#[doc = "Register IF%s_MSK2 `reset()`'s with value 0xffff"]
impl crate::ResetValue for super::IF_MSK2 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0xffff
    }
}
#[doc = "Reader of field `MSK28_16`"]
pub type MSK28_16_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `MSK28_16`"]
pub struct MSK28_16_W<'a> {
    w: &'a mut W,
}
impl<'a> MSK28_16_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x1fff) | ((value as u32) & 0x1fff);
        self.w
    }
}
#[doc = "Mask message direction\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MDIR_A {
    #[doc = "1: The message direction bit (DIR) is used for acceptance filtering."]
    THE_MESSAGE_DIRECTION_IS_USED = 1,
    #[doc = "0: The message direction bit (DIR) has no effect on acceptance filtering."]
    THE_MESSAGE_DIRECTIO_IS_NOT_USED = 0,
}
impl From<MDIR_A> for bool {
    #[inline(always)]
    fn from(variant: MDIR_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `MDIR`"]
pub type MDIR_R = crate::R<bool, MDIR_A>;
impl MDIR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MDIR_A {
        match self.bits {
            true => MDIR_A::THE_MESSAGE_DIRECTION_IS_USED,
            false => MDIR_A::THE_MESSAGE_DIRECTIO_IS_NOT_USED,
        }
    }
    #[doc = "Checks if the value of the field is `THE_MESSAGE_DIRECTION_IS_USED`"]
    #[inline(always)]
    pub fn is_the_message_direction_is_used(&self) -> bool {
        *self == MDIR_A::THE_MESSAGE_DIRECTION_IS_USED
    }
    #[doc = "Checks if the value of the field is `THE_MESSAGE_DIRECTIO_IS_NOT_USED`"]
    #[inline(always)]
    pub fn is_the_message_directio_is_not_used(&self) -> bool {
        *self == MDIR_A::THE_MESSAGE_DIRECTIO_IS_NOT_USED
    }
}
#[doc = "Write proxy for field `MDIR`"]
pub struct MDIR_W<'a> {
    w: &'a mut W,
}
impl<'a> MDIR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MDIR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The message direction bit (DIR) is used for acceptance filtering."]
    #[inline(always)]
    pub fn the_message_direction_is_used(self) -> &'a mut W {
        self.variant(MDIR_A::THE_MESSAGE_DIRECTION_IS_USED)
    }
    #[doc = "The message direction bit (DIR) has no effect on acceptance filtering."]
    #[inline(always)]
    pub fn the_message_directio_is_not_used(self) -> &'a mut W {
        self.variant(MDIR_A::THE_MESSAGE_DIRECTIO_IS_NOT_USED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Mask extend identifier\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MXTD_A {
    #[doc = "1: The extended identifier bit (IDE) is used for acceptance filtering."]
    THE_EXTENDED_IDENTIFIER_IS_USED = 1,
    #[doc = "0: The extended identifier bit (IDE) has no effect on acceptance filtering."]
    THE_EXTENDED_IDENTIFIER_IS_NOT_USED = 0,
}
impl From<MXTD_A> for bool {
    #[inline(always)]
    fn from(variant: MXTD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `MXTD`"]
pub type MXTD_R = crate::R<bool, MXTD_A>;
impl MXTD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MXTD_A {
        match self.bits {
            true => MXTD_A::THE_EXTENDED_IDENTIFIER_IS_USED,
            false => MXTD_A::THE_EXTENDED_IDENTIFIER_IS_NOT_USED,
        }
    }
    #[doc = "Checks if the value of the field is `THE_EXTENDED_IDENTIFIER_IS_USED`"]
    #[inline(always)]
    pub fn is_the_extended_identifier_is_used(&self) -> bool {
        *self == MXTD_A::THE_EXTENDED_IDENTIFIER_IS_USED
    }
    #[doc = "Checks if the value of the field is `THE_EXTENDED_IDENTIFIER_IS_NOT_USED`"]
    #[inline(always)]
    pub fn is_the_extended_identifier_is_not_used(&self) -> bool {
        *self == MXTD_A::THE_EXTENDED_IDENTIFIER_IS_NOT_USED
    }
}
#[doc = "Write proxy for field `MXTD`"]
pub struct MXTD_W<'a> {
    w: &'a mut W,
}
impl<'a> MXTD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MXTD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The extended identifier bit (IDE) is used for acceptance filtering."]
    #[inline(always)]
    pub fn the_extended_identifier_is_used(self) -> &'a mut W {
        self.variant(MXTD_A::THE_EXTENDED_IDENTIFIER_IS_USED)
    }
    #[doc = "The extended identifier bit (IDE) has no effect on acceptance filtering."]
    #[inline(always)]
    pub fn the_extended_identifier_is_not_used(self) -> &'a mut W {
        self.variant(MXTD_A::THE_EXTENDED_IDENTIFIER_IS_NOT_USED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:12 - Identifier mask 0 = The corresponding bit in the identifier of the message can not inhibit the match in the acceptance filtering. 1 = The corresponding identifier bit is used for acceptance filtering."]
    #[inline(always)]
    pub fn msk28_16(&self) -> MSK28_16_R {
        MSK28_16_R::new((self.bits & 0x1fff) as u16)
    }
    #[doc = "Bit 14 - Mask message direction"]
    #[inline(always)]
    pub fn mdir(&self) -> MDIR_R {
        MDIR_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Mask extend identifier"]
    #[inline(always)]
    pub fn mxtd(&self) -> MXTD_R {
        MXTD_R::new(((self.bits >> 15) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:12 - Identifier mask 0 = The corresponding bit in the identifier of the message can not inhibit the match in the acceptance filtering. 1 = The corresponding identifier bit is used for acceptance filtering."]
    #[inline(always)]
    pub fn msk28_16(&mut self) -> MSK28_16_W {
        MSK28_16_W { w: self }
    }
    #[doc = "Bit 14 - Mask message direction"]
    #[inline(always)]
    pub fn mdir(&mut self) -> MDIR_W {
        MDIR_W { w: self }
    }
    #[doc = "Bit 15 - Mask extend identifier"]
    #[inline(always)]
    pub fn mxtd(&mut self) -> MXTD_W {
        MXTD_W { w: self }
    }
}
