#[doc = "Reader of register STAT"]
pub type R = crate::R<u32, super::STAT>;
#[doc = "Writer for register STAT"]
pub type W = crate::W<u32, super::STAT>;
#[doc = "Register STAT `reset()`'s with value 0"]
impl crate::ResetValue for super::STAT {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Last error code Type of the last error to occur on the CAN bus.The LEC field holds a code which indicates the type of the last error to occur on the CAN bus. This field will be cleared to 0 when a message has been transferred (reception or transmission) without error. The unused code 111 may be written by the CPU to check for updates.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum LEC_A {
    #[doc = "0: No error."]
    NO_ERROR = 0,
    #[doc = "1: Stuff error: More than 5 equal bits in a sequence have occurred in a part of a received message where this is not allowed."]
    STUFF_ERROR_MORE_TH = 1,
    #[doc = "2: Form error: A fixed format part of a received frame has the wrong format."]
    FORM_ERROR_A_FIXED = 2,
    #[doc = "3: AckError: The message this CAN core transmitted was not acknowledged."]
    ACKERROR_THE_MESSAG = 3,
    #[doc = "4: Bit1Error: During the transmission of a message (with the exception of the arbitration field), the device wanted to send a HIGH/recessive level (bit of logical value 1), but the monitored bus value was LOW/dominant."]
    BIT1ERROR_DURING_TH = 4,
    #[doc = "5: Bit0Error: During the transmission of a message (or acknowledge bit, or active error flag, or overload flag), the device wanted to send a LOW/dominant level (data or identifier bit logical value 0), but the monitored Bus value was HIGH/recessive. During busoff recovery this status is set each time a sequence of 11 HIGH/recessive bits has been monitored. This enables the CPU to monitor the proceeding of the busoff recovery sequence (indicating the bus is not stuck at LOW/dominant or continuously disturbed)."]
    BIT0ERROR_DURING_TH = 5,
    #[doc = "6: CRCError: The CRC checksum was incorrect in the message received."]
    CRCERROR_THE_CRC_CH = 6,
    #[doc = "7: Unused: No CAN bus event was detected (written by the CPU)."]
    UNUSED_NO_CAN_BUS_E = 7,
}
impl From<LEC_A> for u8 {
    #[inline(always)]
    fn from(variant: LEC_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `LEC`"]
pub type LEC_R = crate::R<u8, LEC_A>;
impl LEC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> LEC_A {
        match self.bits {
            0 => LEC_A::NO_ERROR,
            1 => LEC_A::STUFF_ERROR_MORE_TH,
            2 => LEC_A::FORM_ERROR_A_FIXED,
            3 => LEC_A::ACKERROR_THE_MESSAG,
            4 => LEC_A::BIT1ERROR_DURING_TH,
            5 => LEC_A::BIT0ERROR_DURING_TH,
            6 => LEC_A::CRCERROR_THE_CRC_CH,
            7 => LEC_A::UNUSED_NO_CAN_BUS_E,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `NO_ERROR`"]
    #[inline(always)]
    pub fn is_no_error(&self) -> bool {
        *self == LEC_A::NO_ERROR
    }
    #[doc = "Checks if the value of the field is `STUFF_ERROR_MORE_TH`"]
    #[inline(always)]
    pub fn is_stuff_error_more_th(&self) -> bool {
        *self == LEC_A::STUFF_ERROR_MORE_TH
    }
    #[doc = "Checks if the value of the field is `FORM_ERROR_A_FIXED`"]
    #[inline(always)]
    pub fn is_form_error_a_fixed(&self) -> bool {
        *self == LEC_A::FORM_ERROR_A_FIXED
    }
    #[doc = "Checks if the value of the field is `ACKERROR_THE_MESSAG`"]
    #[inline(always)]
    pub fn is_ackerror_the_messag(&self) -> bool {
        *self == LEC_A::ACKERROR_THE_MESSAG
    }
    #[doc = "Checks if the value of the field is `BIT1ERROR_DURING_TH`"]
    #[inline(always)]
    pub fn is_bit1error_during_th(&self) -> bool {
        *self == LEC_A::BIT1ERROR_DURING_TH
    }
    #[doc = "Checks if the value of the field is `BIT0ERROR_DURING_TH`"]
    #[inline(always)]
    pub fn is_bit0error_during_th(&self) -> bool {
        *self == LEC_A::BIT0ERROR_DURING_TH
    }
    #[doc = "Checks if the value of the field is `CRCERROR_THE_CRC_CH`"]
    #[inline(always)]
    pub fn is_crcerror_the_crc_ch(&self) -> bool {
        *self == LEC_A::CRCERROR_THE_CRC_CH
    }
    #[doc = "Checks if the value of the field is `UNUSED_NO_CAN_BUS_E`"]
    #[inline(always)]
    pub fn is_unused_no_can_bus_e(&self) -> bool {
        *self == LEC_A::UNUSED_NO_CAN_BUS_E
    }
}
#[doc = "Write proxy for field `LEC`"]
pub struct LEC_W<'a> {
    w: &'a mut W,
}
impl<'a> LEC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: LEC_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "No error."]
    #[inline(always)]
    pub fn no_error(self) -> &'a mut W {
        self.variant(LEC_A::NO_ERROR)
    }
    #[doc = "Stuff error: More than 5 equal bits in a sequence have occurred in a part of a received message where this is not allowed."]
    #[inline(always)]
    pub fn stuff_error_more_th(self) -> &'a mut W {
        self.variant(LEC_A::STUFF_ERROR_MORE_TH)
    }
    #[doc = "Form error: A fixed format part of a received frame has the wrong format."]
    #[inline(always)]
    pub fn form_error_a_fixed(self) -> &'a mut W {
        self.variant(LEC_A::FORM_ERROR_A_FIXED)
    }
    #[doc = "AckError: The message this CAN core transmitted was not acknowledged."]
    #[inline(always)]
    pub fn ackerror_the_messag(self) -> &'a mut W {
        self.variant(LEC_A::ACKERROR_THE_MESSAG)
    }
    #[doc = "Bit1Error: During the transmission of a message (with the exception of the arbitration field), the device wanted to send a HIGH/recessive level (bit of logical value 1), but the monitored bus value was LOW/dominant."]
    #[inline(always)]
    pub fn bit1error_during_th(self) -> &'a mut W {
        self.variant(LEC_A::BIT1ERROR_DURING_TH)
    }
    #[doc = "Bit0Error: During the transmission of a message (or acknowledge bit, or active error flag, or overload flag), the device wanted to send a LOW/dominant level (data or identifier bit logical value 0), but the monitored Bus value was HIGH/recessive. During busoff recovery this status is set each time a sequence of 11 HIGH/recessive bits has been monitored. This enables the CPU to monitor the proceeding of the busoff recovery sequence (indicating the bus is not stuck at LOW/dominant or continuously disturbed)."]
    #[inline(always)]
    pub fn bit0error_during_th(self) -> &'a mut W {
        self.variant(LEC_A::BIT0ERROR_DURING_TH)
    }
    #[doc = "CRCError: The CRC checksum was incorrect in the message received."]
    #[inline(always)]
    pub fn crcerror_the_crc_ch(self) -> &'a mut W {
        self.variant(LEC_A::CRCERROR_THE_CRC_CH)
    }
    #[doc = "Unused: No CAN bus event was detected (written by the CPU)."]
    #[inline(always)]
    pub fn unused_no_can_bus_e(self) -> &'a mut W {
        self.variant(LEC_A::UNUSED_NO_CAN_BUS_E)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x07) | ((value as u32) & 0x07);
        self.w
    }
}
#[doc = "Transmitted a message successfully This bit is reset by the CPU. It is never reset by the CAN controller.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXOK_A {
    #[doc = "1: Since this bit was last reset by the CPU, a message has been successfully transmitted (error free and acknowledged by at least one other node)."]
    MSGTRANSFER = 1,
    #[doc = "0: Since this bit was reset by the CPU, no message has been successfully transmitted."]
    NOMSGTRANSFER = 0,
}
impl From<TXOK_A> for bool {
    #[inline(always)]
    fn from(variant: TXOK_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TXOK`"]
pub type TXOK_R = crate::R<bool, TXOK_A>;
impl TXOK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXOK_A {
        match self.bits {
            true => TXOK_A::MSGTRANSFER,
            false => TXOK_A::NOMSGTRANSFER,
        }
    }
    #[doc = "Checks if the value of the field is `MSGTRANSFER`"]
    #[inline(always)]
    pub fn is_msgtransfer(&self) -> bool {
        *self == TXOK_A::MSGTRANSFER
    }
    #[doc = "Checks if the value of the field is `NOMSGTRANSFER`"]
    #[inline(always)]
    pub fn is_nomsgtransfer(&self) -> bool {
        *self == TXOK_A::NOMSGTRANSFER
    }
}
#[doc = "Write proxy for field `TXOK`"]
pub struct TXOK_W<'a> {
    w: &'a mut W,
}
impl<'a> TXOK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXOK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Since this bit was last reset by the CPU, a message has been successfully transmitted (error free and acknowledged by at least one other node)."]
    #[inline(always)]
    pub fn msgtransfer(self) -> &'a mut W {
        self.variant(TXOK_A::MSGTRANSFER)
    }
    #[doc = "Since this bit was reset by the CPU, no message has been successfully transmitted."]
    #[inline(always)]
    pub fn nomsgtransfer(self) -> &'a mut W {
        self.variant(TXOK_A::NOMSGTRANSFER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Received a message successfully This bit is reset by the CPU. It is never reset by the CAN controller.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RXOK_A {
    #[doc = "1: Since this bit was last set to zero by the CPU, a message has been successfully received independent of the result of acceptance filtering."]
    MSGTRANSFER = 1,
    #[doc = "0: Since this bit was last reset by the CPU, no message has been successfully transmitted."]
    NOMSGTRANSFER = 0,
}
impl From<RXOK_A> for bool {
    #[inline(always)]
    fn from(variant: RXOK_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `RXOK`"]
pub type RXOK_R = crate::R<bool, RXOK_A>;
impl RXOK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RXOK_A {
        match self.bits {
            true => RXOK_A::MSGTRANSFER,
            false => RXOK_A::NOMSGTRANSFER,
        }
    }
    #[doc = "Checks if the value of the field is `MSGTRANSFER`"]
    #[inline(always)]
    pub fn is_msgtransfer(&self) -> bool {
        *self == RXOK_A::MSGTRANSFER
    }
    #[doc = "Checks if the value of the field is `NOMSGTRANSFER`"]
    #[inline(always)]
    pub fn is_nomsgtransfer(&self) -> bool {
        *self == RXOK_A::NOMSGTRANSFER
    }
}
#[doc = "Write proxy for field `RXOK`"]
pub struct RXOK_W<'a> {
    w: &'a mut W,
}
impl<'a> RXOK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RXOK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Since this bit was last set to zero by the CPU, a message has been successfully received independent of the result of acceptance filtering."]
    #[inline(always)]
    pub fn msgtransfer(self) -> &'a mut W {
        self.variant(RXOK_A::MSGTRANSFER)
    }
    #[doc = "Since this bit was last reset by the CPU, no message has been successfully transmitted."]
    #[inline(always)]
    pub fn nomsgtransfer(self) -> &'a mut W {
        self.variant(RXOK_A::NOMSGTRANSFER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Error passive\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EPASS_A {
    #[doc = "1: The CAN controller is in the error passive state as defined in the  CAN 2.0 specification."]
    PASSIVE = 1,
    #[doc = "0: The CAN controller is in the error active state."]
    ACTIVE = 0,
}
impl From<EPASS_A> for bool {
    #[inline(always)]
    fn from(variant: EPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EPASS`"]
pub type EPASS_R = crate::R<bool, EPASS_A>;
impl EPASS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EPASS_A {
        match self.bits {
            true => EPASS_A::PASSIVE,
            false => EPASS_A::ACTIVE,
        }
    }
    #[doc = "Checks if the value of the field is `PASSIVE`"]
    #[inline(always)]
    pub fn is_passive(&self) -> bool {
        *self == EPASS_A::PASSIVE
    }
    #[doc = "Checks if the value of the field is `ACTIVE`"]
    #[inline(always)]
    pub fn is_active(&self) -> bool {
        *self == EPASS_A::ACTIVE
    }
}
#[doc = "Write proxy for field `EPASS`"]
pub struct EPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> EPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EPASS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The CAN controller is in the error passive state as defined in the CAN 2.0 specification."]
    #[inline(always)]
    pub fn passive(self) -> &'a mut W {
        self.variant(EPASS_A::PASSIVE)
    }
    #[doc = "The CAN controller is in the error active state."]
    #[inline(always)]
    pub fn active(self) -> &'a mut W {
        self.variant(EPASS_A::ACTIVE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Warning status\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EWARN_A {
    #[doc = "1: At least one of the error counters in the EML has reached the error warning limit of 96."]
    AT_LEAST_ONE_OF_THE = 1,
    #[doc = "0: Both error counters are below the error warning limit of 96."]
    BOTH_ERROR_COUNTERS = 0,
}
impl From<EWARN_A> for bool {
    #[inline(always)]
    fn from(variant: EWARN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EWARN`"]
pub type EWARN_R = crate::R<bool, EWARN_A>;
impl EWARN_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EWARN_A {
        match self.bits {
            true => EWARN_A::AT_LEAST_ONE_OF_THE,
            false => EWARN_A::BOTH_ERROR_COUNTERS,
        }
    }
    #[doc = "Checks if the value of the field is `AT_LEAST_ONE_OF_THE`"]
    #[inline(always)]
    pub fn is_at_least_one_of_the(&self) -> bool {
        *self == EWARN_A::AT_LEAST_ONE_OF_THE
    }
    #[doc = "Checks if the value of the field is `BOTH_ERROR_COUNTERS`"]
    #[inline(always)]
    pub fn is_both_error_counters(&self) -> bool {
        *self == EWARN_A::BOTH_ERROR_COUNTERS
    }
}
#[doc = "Write proxy for field `EWARN`"]
pub struct EWARN_W<'a> {
    w: &'a mut W,
}
impl<'a> EWARN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EWARN_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "At least one of the error counters in the EML has reached the error warning limit of 96."]
    #[inline(always)]
    pub fn at_least_one_of_the(self) -> &'a mut W {
        self.variant(EWARN_A::AT_LEAST_ONE_OF_THE)
    }
    #[doc = "Both error counters are below the error warning limit of 96."]
    #[inline(always)]
    pub fn both_error_counters(self) -> &'a mut W {
        self.variant(EWARN_A::BOTH_ERROR_COUNTERS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Busoff status\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BOFF_A {
    #[doc = "1: The CAN controller is in busoff state."]
    BUSOFF = 1,
    #[doc = "0: The CAN module is not in busoff."]
    NOBUSOFF = 0,
}
impl From<BOFF_A> for bool {
    #[inline(always)]
    fn from(variant: BOFF_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `BOFF`"]
pub type BOFF_R = crate::R<bool, BOFF_A>;
impl BOFF_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BOFF_A {
        match self.bits {
            true => BOFF_A::BUSOFF,
            false => BOFF_A::NOBUSOFF,
        }
    }
    #[doc = "Checks if the value of the field is `BUSOFF`"]
    #[inline(always)]
    pub fn is_busoff(&self) -> bool {
        *self == BOFF_A::BUSOFF
    }
    #[doc = "Checks if the value of the field is `NOBUSOFF`"]
    #[inline(always)]
    pub fn is_nobusoff(&self) -> bool {
        *self == BOFF_A::NOBUSOFF
    }
}
#[doc = "Write proxy for field `BOFF`"]
pub struct BOFF_W<'a> {
    w: &'a mut W,
}
impl<'a> BOFF_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BOFF_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The CAN controller is in busoff state."]
    #[inline(always)]
    pub fn busoff(self) -> &'a mut W {
        self.variant(BOFF_A::BUSOFF)
    }
    #[doc = "The CAN module is not in busoff."]
    #[inline(always)]
    pub fn nobusoff(self) -> &'a mut W {
        self.variant(BOFF_A::NOBUSOFF)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:2 - Last error code Type of the last error to occur on the CAN bus.The LEC field holds a code which indicates the type of the last error to occur on the CAN bus. This field will be cleared to 0 when a message has been transferred (reception or transmission) without error. The unused code 111 may be written by the CPU to check for updates."]
    #[inline(always)]
    pub fn lec(&self) -> LEC_R {
        LEC_R::new((self.bits & 0x07) as u8)
    }
    #[doc = "Bit 3 - Transmitted a message successfully This bit is reset by the CPU. It is never reset by the CAN controller."]
    #[inline(always)]
    pub fn txok(&self) -> TXOK_R {
        TXOK_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Received a message successfully This bit is reset by the CPU. It is never reset by the CAN controller."]
    #[inline(always)]
    pub fn rxok(&self) -> RXOK_R {
        RXOK_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Error passive"]
    #[inline(always)]
    pub fn epass(&self) -> EPASS_R {
        EPASS_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Warning status"]
    #[inline(always)]
    pub fn ewarn(&self) -> EWARN_R {
        EWARN_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Busoff status"]
    #[inline(always)]
    pub fn boff(&self) -> BOFF_R {
        BOFF_R::new(((self.bits >> 7) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:2 - Last error code Type of the last error to occur on the CAN bus.The LEC field holds a code which indicates the type of the last error to occur on the CAN bus. This field will be cleared to 0 when a message has been transferred (reception or transmission) without error. The unused code 111 may be written by the CPU to check for updates."]
    #[inline(always)]
    pub fn lec(&mut self) -> LEC_W {
        LEC_W { w: self }
    }
    #[doc = "Bit 3 - Transmitted a message successfully This bit is reset by the CPU. It is never reset by the CAN controller."]
    #[inline(always)]
    pub fn txok(&mut self) -> TXOK_W {
        TXOK_W { w: self }
    }
    #[doc = "Bit 4 - Received a message successfully This bit is reset by the CPU. It is never reset by the CAN controller."]
    #[inline(always)]
    pub fn rxok(&mut self) -> RXOK_W {
        RXOK_W { w: self }
    }
    #[doc = "Bit 5 - Error passive"]
    #[inline(always)]
    pub fn epass(&mut self) -> EPASS_W {
        EPASS_W { w: self }
    }
    #[doc = "Bit 6 - Warning status"]
    #[inline(always)]
    pub fn ewarn(&mut self) -> EWARN_W {
        EWARN_W { w: self }
    }
    #[doc = "Bit 7 - Busoff status"]
    #[inline(always)]
    pub fn boff(&mut self) -> BOFF_W {
        BOFF_W { w: self }
    }
}
