#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - CCU1 power mode register"]
    pub pm: PM,
    #[doc = "0x04 - CCU1 base clocks status register"]
    pub base_stat: BASE_STAT,
    _reserved2: [u8; 248usize],
    #[doc = "0x100 - CLK_APB3_BUS clock configuration register"]
    pub clk_apb3_bus_cfg: CLK_APB3_BUS_CFG,
    #[doc = "0x104 - CLK_APB3_BUS clock status register"]
    pub clk_apb3_bus_stat: CLK_APB3_BUS_STAT,
    #[doc = "0x108 - CLK_APB3_I2C1 clock configuration register"]
    pub clk_apb3_i2c1_cfg: CLK_APB3_I2C1_CFG,
    #[doc = "0x10c - CLK_APB3_I2C1 clock status register"]
    pub clk_apb3_i2c1_stat: CLK_APB3_I2C1_STAT,
    #[doc = "0x110 - CLK_APB3_DAC clock configuration register"]
    pub clk_apb3_dac_cfg: CLK_APB3_DAC_CFG,
    #[doc = "0x114 - CLK_APB3_DAC clock status register"]
    pub clk_apb3_dac_stat: CLK_APB3_DAC_STAT,
    #[doc = "0x118 - CLK_APB3_ADC0 clock configuration register"]
    pub clk_apb3_adc0_cfg: CLK_APB3_ADC0_CFG,
    #[doc = "0x11c - CLK_APB3_ADC0 clock status register"]
    pub clk_apb3_adc0_stat: CLK_APB3_ADC0_STAT,
    #[doc = "0x120 - CLK_APB3_ADC1 clock configuration register"]
    pub clk_apb3_adc1_cfg: CLK_APB3_ADC1_CFG,
    #[doc = "0x124 - CLK_APB3_ADC1 clock status register"]
    pub clk_apb3_adc1_stat: CLK_APB3_ADC1_STAT,
    #[doc = "0x128 - CLK_APB3_CAN0 clock configuration register"]
    pub clk_apb3_can0_cfg: CLK_APB3_CAN0_CFG,
    #[doc = "0x12c - CLK_APB3_CAN0 clock status register"]
    pub clk_apb3_can0_stat: CLK_APB3_CAN0_STAT,
    _reserved14: [u8; 208usize],
    #[doc = "0x200 - CLK_APB1_BUS clock configuration register"]
    pub clk_apb1_bus_cfg: CLK_APB1_BUS_CFG,
    #[doc = "0x204 - CLK_APB1_BUS clock status register"]
    pub clk_apb1_bus_stat: CLK_APB1_BUS_STAT,
    #[doc = "0x208 - CLK_APB1_MOTOCONPWM clock configuration register"]
    pub clk_apb1_motoconpwm_cfg: CLK_APB1_MOTOCONPWM_CFG,
    #[doc = "0x20c - CLK_APB1_MOTOCONPWM clock status register"]
    pub clk_apb1_motoconpwm_stat: CLK_APB1_MOTOCONPWM_STAT,
    #[doc = "0x210 - CLK_ABP1_I2C0 clock configuration register"]
    pub clk_apb1_i2c0_cfg: CLK_APB1_I2C0_CFG,
    #[doc = "0x214 - CLK_APB1_I2C0 clock status register"]
    pub clk_apb1_i2c0_stat: CLK_APB1_I2C0_STAT,
    #[doc = "0x218 - CLK_APB1_I2S clock configuration register"]
    pub clk_apb1_i2s_cfg: CLK_APB1_I2S_CFG,
    #[doc = "0x21c - CLK_APB1_I2S clock status register"]
    pub clk_apb1_i2s_stat: CLK_APB1_I2S_STAT,
    #[doc = "0x220 - CLK_APB1_CAN1 clock configuration register"]
    pub clk_apb1_can1_cfg: CLK_APB1_CAN1_CFG,
    #[doc = "0x224 - CLK_APB1_CAN1 clock status register"]
    pub clk_apb1_can1_stat: CLK_APB1_CAN1_STAT,
    _reserved24: [u8; 216usize],
    #[doc = "0x300 - CLK_SPIFI clock configuration register"]
    pub clk_spifi_cfg: CLK_SPIFI_CFG,
    #[doc = "0x304 - CLK_APB1_SPIFI clock status register"]
    pub clk_spifi_stat: CLK_SPIFI_STAT,
    _reserved26: [u8; 248usize],
    #[doc = "0x400 - CLK_M4_BUS clock configuration register"]
    pub clk_m4_bus_cfg: CLK_M4_BUS_CFG,
    #[doc = "0x404 - CLK_M4_BUSclock status register"]
    pub clk_m4_bus_stat: CLK_M4_BUS_STAT,
    #[doc = "0x408 - CLK_M4_SPIFI clock configuration register"]
    pub clk_m4_spifi_cfg: CLK_M4_SPIFI_CFG,
    #[doc = "0x40c - CLK_M4_SPIFI clock status register"]
    pub clk_m4_spifi_stat: CLK_M4_SPIFI_STAT,
    #[doc = "0x410 - CLK_M4_GPIO clock configuration register"]
    pub clk_m4_gpio_cfg: CLK_M4_GPIO_CFG,
    #[doc = "0x414 - CLK_M4_GPIO clock status register"]
    pub clk_m4_gpio_stat: CLK_M4_GPIO_STAT,
    #[doc = "0x418 - CLK_M4_LCD clock configuration register"]
    pub clk_m4_lcd_cfg: CLK_M4_LCD_CFG,
    #[doc = "0x41c - CLK_M4_LCD clock status register"]
    pub clk_m4_lcd_stat: CLK_M4_LCD_STAT,
    #[doc = "0x420 - CLK_M4_ETHERNET clock configuration register"]
    pub clk_m4_ethernet_cfg: CLK_M4_ETHERNET_CFG,
    #[doc = "0x424 - CLK_M4_ETHERNET clock status register"]
    pub clk_m4_ethernet_status: CLK_M4_ETHERNET_STATUS,
    #[doc = "0x428 - CLK_M4_USB0 clock configuration register"]
    pub clk_m4_usb0_cfg: CLK_M4_USB0_CFG,
    #[doc = "0x42c - CLK_M4_USB0 clock status register"]
    pub clk_m4_usb0_stat: CLK_M4_USB0_STAT,
    #[doc = "0x430 - CLK_M4_EMC clock configuration register"]
    pub clk_m4_emc_cfg: CLK_M4_EMC_CFG,
    #[doc = "0x434 - CLK_M4_EMC clock status register"]
    pub clk_m4_emc_stat: CLK_M4_EMC_STAT,
    #[doc = "0x438 - CLK_M4_SDIO clock configuration register"]
    pub clk_m4_sdio_cfg: CLK_M4_SDIO_CFG,
    #[doc = "0x43c - CLK_M4_SDIO clock status register"]
    pub clk_m4_sdio_stat: CLK_M4_SDIO_STAT,
    #[doc = "0x440 - CLK_M4_DMA clock configuration register"]
    pub clk_m4_dma_cfg: CLK_M4_DMA_CFG,
    #[doc = "0x444 - CLK_M4_DMA clock status register"]
    pub clk_m4_dma_stat: CLK_M4_DMA_STAT,
    #[doc = "0x448 - CLK_M4_M4CORE clock configuration register"]
    pub clk_m4_m4core_cfg: CLK_M4_M4CORE_CFG,
    #[doc = "0x44c - CLK_M4_M3CORE clock status register"]
    pub clk_m4_m4core_stat: CLK_M4_M4CORE_STAT,
    _reserved46: [u8; 24usize],
    #[doc = "0x468 - CLK_M4_SCT clock configuration register"]
    pub clk_m4_sct_cfg: CLK_M4_SCT_CFG,
    #[doc = "0x46c - CLK_M4_SCT clock status register"]
    pub clk_m4_sct_stat: CLK_M4_SCT_STAT,
    #[doc = "0x470 - CLK_M4_USB1 clock configuration register"]
    pub clk_m4_usb1_cfg: CLK_M4_USB1_CFG,
    #[doc = "0x474 - CLK_M4_USB1 clock status register"]
    pub clk_m4_usb1_stat: CLK_M4_USB1_STAT,
    #[doc = "0x478 - CLK_M4_EMCDIV clock configuration register"]
    pub clk_m4_emcdiv_cfg: CLK_M4_EMCDIV_CFG,
    #[doc = "0x47c - CLK_M4_EMCDIV clock status register"]
    pub clk_m4_emcdiv_stat: CLK_M4_EMCDIV_STAT,
    #[doc = "0x480 - CLK_M4_FLASHA clock configuration register"]
    pub clk_m4_flasha_cfg: CLK_M4_FLASHA_CFG,
    #[doc = "0x484 - CLK_M4_FLASHA clock status register"]
    pub clk_m4_flasha_stat: CLK_M4_FLASHA_STAT,
    #[doc = "0x488 - CLK_M4_FLASHB clock configuration register"]
    pub clk_m4_flashb_cfg: CLK_M4_FLASHB_CFG,
    #[doc = "0x48c - CLK_M4_FLASHB clock status register"]
    pub clk_m4_flashb_stat: CLK_M4_FLASHB_STAT,
    #[doc = "0x490 - CLK_M0APP_CFG clock configuration register"]
    pub clk_m4_m0app_cfg: CLK_M4_M0APP_CFG,
    #[doc = "0x494 - CLK_M4_MOAPP clock status register"]
    pub clk_m4_m0app_stat: CLK_M4_M0APP_STAT,
    #[doc = "0x498 - CLK_ADCHS_CFG clock configuration register"]
    pub clk_m4_adchs_cfg: CLK_M4_ADCHS_CFG,
    #[doc = "0x49c - CLK_M4_ADCHS clock status register"]
    pub clk_m4_adchs_stat: CLK_M4_ADCHS_STAT,
    #[doc = "0x4a0 - CLK_EEPROM_CFG clock configuration register"]
    pub clk_m4_eeprom_cfg: CLK_M4_EEPROM_CFG,
    #[doc = "0x4a4 - CLK_M4_EEPROM clock status register"]
    pub clk_m4_eeprom_stat: CLK_M4_EEPROM_STAT,
    _reserved62: [u8; 88usize],
    #[doc = "0x500 - CLK_M4_WWDT clock configuration register"]
    pub clk_m4_wwdt_cfg: CLK_M4_WWDT_CFG,
    #[doc = "0x504 - CLK_M4_WWDT clock status register"]
    pub clk_m4_wwdt_stat: CLK_M4_WWDT_STAT,
    #[doc = "0x508 - CLK_M4_USART0 clock configuration register"]
    pub clk_m4_usart0_cfg: CLK_M4_USART0_CFG,
    #[doc = "0x50c - CLK_M4_USART0 clock status register"]
    pub clk_m4_usart0_stat: CLK_M4_USART0_STAT,
    #[doc = "0x510 - CLK_M4_UART1 clock configuration register"]
    pub clk_m4_uart1_cfg: CLK_M4_UART1_CFG,
    #[doc = "0x514 - CLK_M4_UART1 clock status register"]
    pub clk_m4_uart1_stat: CLK_M4_UART1_STAT,
    #[doc = "0x518 - CLK_M4_SSP0 clock configuration register"]
    pub clk_m4_ssp0_cfg: CLK_M4_SSP0_CFG,
    #[doc = "0x51c - CLK_M4_SSP0 clock status register"]
    pub clk_m4_ssp0_stat: CLK_M4_SSP0_STAT,
    #[doc = "0x520 - CLK_M4_TIMER0 clock configuration register"]
    pub clk_m4_timer0_cfg: CLK_M4_TIMER0_CFG,
    #[doc = "0x524 - CLK_M4_TIMER0 clock status register"]
    pub clk_m4_timer0_stat: CLK_M4_TIMER0_STAT,
    #[doc = "0x528 - CLK_M4_TIMER1clock configuration register"]
    pub clk_m4_timer1_cfg: CLK_M4_TIMER1_CFG,
    #[doc = "0x52c - CLK_M4_TIMER1 clock status register"]
    pub clk_m4_timer1_stat: CLK_M4_TIMER1_STAT,
    #[doc = "0x530 - CLK_M4_SCU clock configuration register"]
    pub clk_m4_scu_cfg: CLK_M4_SCU_CFG,
    #[doc = "0x534 - CLK_SCU_XXX clock status register"]
    pub clk_m4_scu_stat: CLK_M4_SCU_STAT,
    #[doc = "0x538 - CLK_M4_CREGclock configuration register"]
    pub clk_m4_creg_cfg: CLK_M4_CREG_CFG,
    #[doc = "0x53c - CLK_M4_CREG clock status register"]
    pub clk_m4_creg_stat: CLK_M4_CREG_STAT,
    _reserved78: [u8; 192usize],
    #[doc = "0x600 - CLK_M4_RITIMER clock configuration register"]
    pub clk_m4_ritimer_cfg: CLK_M4_RITIMER_CFG,
    #[doc = "0x604 - CLK_M4_RITIMER clock status register"]
    pub clk_m4_ritimer_stat: CLK_M4_RITIMER_STAT,
    #[doc = "0x608 - CLK_M4_USART2 clock configuration register"]
    pub clk_m4_usart2_cfg: CLK_M4_USART2_CFG,
    #[doc = "0x60c - CLK_M4_USART2 clock status register"]
    pub clk_m4_usart2_stat: CLK_M4_USART2_STAT,
    #[doc = "0x610 - CLK_M4_USART3 clock configuration register"]
    pub clk_m4_usart3_cfg: CLK_M4_USART3_CFG,
    #[doc = "0x614 - CLK_M4_USART3 clock status register"]
    pub clk_m4_usart3_stat: CLK_M4_USART3_STAT,
    #[doc = "0x618 - CLK_M4_TIMER2 clock configuration register"]
    pub clk_m4_timer2_cfg: CLK_M4_TIMER2_CFG,
    #[doc = "0x61c - CLK_M4_TIMER2 clock status register"]
    pub clk_m4_timer2_stat: CLK_M4_TIMER2_STAT,
    #[doc = "0x620 - CLK_M4_TIMER3 clock configuration register"]
    pub clk_m4_timer3_cfg: CLK_M4_TIMER3_CFG,
    #[doc = "0x624 - CLK_M4_TIMER3 clock status register"]
    pub clk_m4_timer3_stat: CLK_M4_TIMER3_STAT,
    #[doc = "0x628 - CLK_M4_SSP1 clock configuration register"]
    pub clk_m4_ssp1_cfg: CLK_M4_SSP1_CFG,
    #[doc = "0x62c - CLK_M4_SSP1 clock status register"]
    pub clk_m4_ssp1_stat: CLK_M4_SSP1_STAT,
    #[doc = "0x630 - CLK_M4_QEIclock configuration register"]
    pub clk_m4_qei_cfg: CLK_M4_QEI_CFG,
    #[doc = "0x634 - CLK_M4_QEI clock status register"]
    pub clk_m4_qei_stat: CLK_M4_QEI_STAT,
    _reserved92: [u8; 200usize],
    #[doc = "0x700 - CLK_PERIPH_BUS_CFG clock configuration register"]
    pub clk_periph_bus_cfg: CLK_PERIPH_BUS_CFG,
    #[doc = "0x704 - CLK_PERIPH_BUS_STAT clock status register"]
    pub clk_periph_bus_stat: CLK_PERIPH_BUS_STAT,
    _reserved94: [u8; 8usize],
    #[doc = "0x710 - CLK_PERIPH_CORE_CFG clock configuration register"]
    pub clk_periph_core_cfg: CLK_PERIPH_CORE_CFG,
    #[doc = "0x714 - CLK_CORE_BUS_STAT clock status register"]
    pub clk_periph_core_status: CLK_PERIPH_CORE_STATUS,
    #[doc = "0x718 - CLK_PERIPH_SGPIO_CFG clock configuration register"]
    pub clk_periph_sgpio_cfg: CLK_PERIPH_SGPIO_CFG,
    #[doc = "0x71c - CLK_CORE_SGPIO_STAT clock status register"]
    pub clk_periph_sgpio_stat: CLK_PERIPH_SGPIO_STAT,
    _reserved98: [u8; 224usize],
    #[doc = "0x800 - CLK_M4_USB0 clock configuration register"]
    pub clk_usb0_cfg: CLK_USB0_CFG,
    #[doc = "0x804 - CLK_USB0 clock status register"]
    pub clk_usb0_stat: CLK_USB0_STAT,
    _reserved100: [u8; 248usize],
    #[doc = "0x900 - CLK_USB1 clock configuration register"]
    pub clk_usb1_cfg: CLK_USB1_CFG,
    #[doc = "0x904 - CLK_USB1 clock status register"]
    pub clk_usb1_stat: CLK_USB1_STAT,
    _reserved102: [u8; 248usize],
    #[doc = "0xa00 - CLK_SPI clock configuration register"]
    pub clk_spi_cfg: CLK_SPI_CFG,
    #[doc = "0xa04 - CLK_SPI clock status register"]
    pub clk_spi_stat: CLK_SPI_STAT,
    _reserved104: [u8; 248usize],
    #[doc = "0xb00 - CLK_ADCHS clock configuration register"]
    pub clk_adchs_cfg: CLK_ADCHS_CFG,
    #[doc = "0xb04 - CLK_ADCHS clock status register"]
    pub clk_adchs_stat: CLK_ADCHS_STAT,
}
#[doc = "CCU1 power mode register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pm](pm) module"]
pub type PM = crate::Reg<u32, _PM>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PM;
#[doc = "`read()` method returns [pm::R](pm::R) reader structure"]
impl crate::Readable for PM {}
#[doc = "`write(|w| ..)` method takes [pm::W](pm::W) writer structure"]
impl crate::Writable for PM {}
#[doc = "CCU1 power mode register"]
pub mod pm;
#[doc = "CCU1 base clocks status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [base_stat](base_stat) module"]
pub type BASE_STAT = crate::Reg<u32, _BASE_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_STAT;
#[doc = "`read()` method returns [base_stat::R](base_stat::R) reader structure"]
impl crate::Readable for BASE_STAT {}
#[doc = "CCU1 base clocks status register"]
pub mod base_stat;
#[doc = "CLK_APB3_BUS clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_bus_cfg](clk_apb3_bus_cfg) module"]
pub type CLK_APB3_BUS_CFG = crate::Reg<u32, _CLK_APB3_BUS_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_BUS_CFG;
#[doc = "`read()` method returns [clk_apb3_bus_cfg::R](clk_apb3_bus_cfg::R) reader structure"]
impl crate::Readable for CLK_APB3_BUS_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb3_bus_cfg::W](clk_apb3_bus_cfg::W) writer structure"]
impl crate::Writable for CLK_APB3_BUS_CFG {}
#[doc = "CLK_APB3_BUS clock configuration register"]
pub mod clk_apb3_bus_cfg;
#[doc = "CLK_APB3_I2C1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_i2c1_cfg](clk_apb3_i2c1_cfg) module"]
pub type CLK_APB3_I2C1_CFG = crate::Reg<u32, _CLK_APB3_I2C1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_I2C1_CFG;
#[doc = "`read()` method returns [clk_apb3_i2c1_cfg::R](clk_apb3_i2c1_cfg::R) reader structure"]
impl crate::Readable for CLK_APB3_I2C1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb3_i2c1_cfg::W](clk_apb3_i2c1_cfg::W) writer structure"]
impl crate::Writable for CLK_APB3_I2C1_CFG {}
#[doc = "CLK_APB3_I2C1 clock configuration register"]
pub mod clk_apb3_i2c1_cfg;
#[doc = "CLK_APB3_DAC clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_dac_cfg](clk_apb3_dac_cfg) module"]
pub type CLK_APB3_DAC_CFG = crate::Reg<u32, _CLK_APB3_DAC_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_DAC_CFG;
#[doc = "`read()` method returns [clk_apb3_dac_cfg::R](clk_apb3_dac_cfg::R) reader structure"]
impl crate::Readable for CLK_APB3_DAC_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb3_dac_cfg::W](clk_apb3_dac_cfg::W) writer structure"]
impl crate::Writable for CLK_APB3_DAC_CFG {}
#[doc = "CLK_APB3_DAC clock configuration register"]
pub mod clk_apb3_dac_cfg;
#[doc = "CLK_APB3_ADC0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_adc0_cfg](clk_apb3_adc0_cfg) module"]
pub type CLK_APB3_ADC0_CFG = crate::Reg<u32, _CLK_APB3_ADC0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_ADC0_CFG;
#[doc = "`read()` method returns [clk_apb3_adc0_cfg::R](clk_apb3_adc0_cfg::R) reader structure"]
impl crate::Readable for CLK_APB3_ADC0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb3_adc0_cfg::W](clk_apb3_adc0_cfg::W) writer structure"]
impl crate::Writable for CLK_APB3_ADC0_CFG {}
#[doc = "CLK_APB3_ADC0 clock configuration register"]
pub mod clk_apb3_adc0_cfg;
#[doc = "CLK_APB3_ADC1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_adc1_cfg](clk_apb3_adc1_cfg) module"]
pub type CLK_APB3_ADC1_CFG = crate::Reg<u32, _CLK_APB3_ADC1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_ADC1_CFG;
#[doc = "`read()` method returns [clk_apb3_adc1_cfg::R](clk_apb3_adc1_cfg::R) reader structure"]
impl crate::Readable for CLK_APB3_ADC1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb3_adc1_cfg::W](clk_apb3_adc1_cfg::W) writer structure"]
impl crate::Writable for CLK_APB3_ADC1_CFG {}
#[doc = "CLK_APB3_ADC1 clock configuration register"]
pub mod clk_apb3_adc1_cfg;
#[doc = "CLK_APB3_CAN0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_can0_cfg](clk_apb3_can0_cfg) module"]
pub type CLK_APB3_CAN0_CFG = crate::Reg<u32, _CLK_APB3_CAN0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_CAN0_CFG;
#[doc = "`read()` method returns [clk_apb3_can0_cfg::R](clk_apb3_can0_cfg::R) reader structure"]
impl crate::Readable for CLK_APB3_CAN0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb3_can0_cfg::W](clk_apb3_can0_cfg::W) writer structure"]
impl crate::Writable for CLK_APB3_CAN0_CFG {}
#[doc = "CLK_APB3_CAN0 clock configuration register"]
pub mod clk_apb3_can0_cfg;
#[doc = "CLK_APB1_BUS clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_bus_cfg](clk_apb1_bus_cfg) module"]
pub type CLK_APB1_BUS_CFG = crate::Reg<u32, _CLK_APB1_BUS_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_BUS_CFG;
#[doc = "`read()` method returns [clk_apb1_bus_cfg::R](clk_apb1_bus_cfg::R) reader structure"]
impl crate::Readable for CLK_APB1_BUS_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb1_bus_cfg::W](clk_apb1_bus_cfg::W) writer structure"]
impl crate::Writable for CLK_APB1_BUS_CFG {}
#[doc = "CLK_APB1_BUS clock configuration register"]
pub mod clk_apb1_bus_cfg;
#[doc = "CLK_APB1_MOTOCONPWM clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_motoconpwm_cfg](clk_apb1_motoconpwm_cfg) module"]
pub type CLK_APB1_MOTOCONPWM_CFG = crate::Reg<u32, _CLK_APB1_MOTOCONPWM_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_MOTOCONPWM_CFG;
#[doc = "`read()` method returns [clk_apb1_motoconpwm_cfg::R](clk_apb1_motoconpwm_cfg::R) reader structure"]
impl crate::Readable for CLK_APB1_MOTOCONPWM_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb1_motoconpwm_cfg::W](clk_apb1_motoconpwm_cfg::W) writer structure"]
impl crate::Writable for CLK_APB1_MOTOCONPWM_CFG {}
#[doc = "CLK_APB1_MOTOCONPWM clock configuration register"]
pub mod clk_apb1_motoconpwm_cfg;
#[doc = "CLK_ABP1_I2C0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_i2c0_cfg](clk_apb1_i2c0_cfg) module"]
pub type CLK_APB1_I2C0_CFG = crate::Reg<u32, _CLK_APB1_I2C0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_I2C0_CFG;
#[doc = "`read()` method returns [clk_apb1_i2c0_cfg::R](clk_apb1_i2c0_cfg::R) reader structure"]
impl crate::Readable for CLK_APB1_I2C0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb1_i2c0_cfg::W](clk_apb1_i2c0_cfg::W) writer structure"]
impl crate::Writable for CLK_APB1_I2C0_CFG {}
#[doc = "CLK_ABP1_I2C0 clock configuration register"]
pub mod clk_apb1_i2c0_cfg;
#[doc = "CLK_APB1_I2S clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_i2s_cfg](clk_apb1_i2s_cfg) module"]
pub type CLK_APB1_I2S_CFG = crate::Reg<u32, _CLK_APB1_I2S_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_I2S_CFG;
#[doc = "`read()` method returns [clk_apb1_i2s_cfg::R](clk_apb1_i2s_cfg::R) reader structure"]
impl crate::Readable for CLK_APB1_I2S_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb1_i2s_cfg::W](clk_apb1_i2s_cfg::W) writer structure"]
impl crate::Writable for CLK_APB1_I2S_CFG {}
#[doc = "CLK_APB1_I2S clock configuration register"]
pub mod clk_apb1_i2s_cfg;
#[doc = "CLK_APB1_CAN1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_can1_cfg](clk_apb1_can1_cfg) module"]
pub type CLK_APB1_CAN1_CFG = crate::Reg<u32, _CLK_APB1_CAN1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_CAN1_CFG;
#[doc = "`read()` method returns [clk_apb1_can1_cfg::R](clk_apb1_can1_cfg::R) reader structure"]
impl crate::Readable for CLK_APB1_CAN1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb1_can1_cfg::W](clk_apb1_can1_cfg::W) writer structure"]
impl crate::Writable for CLK_APB1_CAN1_CFG {}
#[doc = "CLK_APB1_CAN1 clock configuration register"]
pub mod clk_apb1_can1_cfg;
#[doc = "CLK_SPIFI clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_spifi_cfg](clk_spifi_cfg) module"]
pub type CLK_SPIFI_CFG = crate::Reg<u32, _CLK_SPIFI_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_SPIFI_CFG;
#[doc = "`read()` method returns [clk_spifi_cfg::R](clk_spifi_cfg::R) reader structure"]
impl crate::Readable for CLK_SPIFI_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_spifi_cfg::W](clk_spifi_cfg::W) writer structure"]
impl crate::Writable for CLK_SPIFI_CFG {}
#[doc = "CLK_SPIFI clock configuration register"]
pub mod clk_spifi_cfg;
#[doc = "CLK_M4_BUS clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_bus_cfg](clk_m4_bus_cfg) module"]
pub type CLK_M4_BUS_CFG = crate::Reg<u32, _CLK_M4_BUS_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_BUS_CFG;
#[doc = "`read()` method returns [clk_m4_bus_cfg::R](clk_m4_bus_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_BUS_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_bus_cfg::W](clk_m4_bus_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_BUS_CFG {}
#[doc = "CLK_M4_BUS clock configuration register"]
pub mod clk_m4_bus_cfg;
#[doc = "CLK_M4_SPIFI clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_spifi_cfg](clk_m4_spifi_cfg) module"]
pub type CLK_M4_SPIFI_CFG = crate::Reg<u32, _CLK_M4_SPIFI_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SPIFI_CFG;
#[doc = "`read()` method returns [clk_m4_spifi_cfg::R](clk_m4_spifi_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_SPIFI_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_spifi_cfg::W](clk_m4_spifi_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_SPIFI_CFG {}
#[doc = "CLK_M4_SPIFI clock configuration register"]
pub mod clk_m4_spifi_cfg;
#[doc = "CLK_M4_GPIO clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_gpio_cfg](clk_m4_gpio_cfg) module"]
pub type CLK_M4_GPIO_CFG = crate::Reg<u32, _CLK_M4_GPIO_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_GPIO_CFG;
#[doc = "`read()` method returns [clk_m4_gpio_cfg::R](clk_m4_gpio_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_GPIO_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_gpio_cfg::W](clk_m4_gpio_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_GPIO_CFG {}
#[doc = "CLK_M4_GPIO clock configuration register"]
pub mod clk_m4_gpio_cfg;
#[doc = "CLK_M4_LCD clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_lcd_cfg](clk_m4_lcd_cfg) module"]
pub type CLK_M4_LCD_CFG = crate::Reg<u32, _CLK_M4_LCD_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_LCD_CFG;
#[doc = "`read()` method returns [clk_m4_lcd_cfg::R](clk_m4_lcd_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_LCD_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_lcd_cfg::W](clk_m4_lcd_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_LCD_CFG {}
#[doc = "CLK_M4_LCD clock configuration register"]
pub mod clk_m4_lcd_cfg;
#[doc = "CLK_M4_ETHERNET clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ethernet_cfg](clk_m4_ethernet_cfg) module"]
pub type CLK_M4_ETHERNET_CFG = crate::Reg<u32, _CLK_M4_ETHERNET_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_ETHERNET_CFG;
#[doc = "`read()` method returns [clk_m4_ethernet_cfg::R](clk_m4_ethernet_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_ETHERNET_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_ethernet_cfg::W](clk_m4_ethernet_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_ETHERNET_CFG {}
#[doc = "CLK_M4_ETHERNET clock configuration register"]
pub mod clk_m4_ethernet_cfg;
#[doc = "CLK_M4_USB0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usb0_cfg](clk_m4_usb0_cfg) module"]
pub type CLK_M4_USB0_CFG = crate::Reg<u32, _CLK_M4_USB0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USB0_CFG;
#[doc = "`read()` method returns [clk_m4_usb0_cfg::R](clk_m4_usb0_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_USB0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_usb0_cfg::W](clk_m4_usb0_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_USB0_CFG {}
#[doc = "CLK_M4_USB0 clock configuration register"]
pub mod clk_m4_usb0_cfg;
#[doc = "CLK_M4_EMC clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_emc_cfg](clk_m4_emc_cfg) module"]
pub type CLK_M4_EMC_CFG = crate::Reg<u32, _CLK_M4_EMC_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_EMC_CFG;
#[doc = "`read()` method returns [clk_m4_emc_cfg::R](clk_m4_emc_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_EMC_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_emc_cfg::W](clk_m4_emc_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_EMC_CFG {}
#[doc = "CLK_M4_EMC clock configuration register"]
pub mod clk_m4_emc_cfg;
#[doc = "CLK_M4_SDIO clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_sdio_cfg](clk_m4_sdio_cfg) module"]
pub type CLK_M4_SDIO_CFG = crate::Reg<u32, _CLK_M4_SDIO_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SDIO_CFG;
#[doc = "`read()` method returns [clk_m4_sdio_cfg::R](clk_m4_sdio_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_SDIO_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_sdio_cfg::W](clk_m4_sdio_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_SDIO_CFG {}
#[doc = "CLK_M4_SDIO clock configuration register"]
pub mod clk_m4_sdio_cfg;
#[doc = "CLK_M4_DMA clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_dma_cfg](clk_m4_dma_cfg) module"]
pub type CLK_M4_DMA_CFG = crate::Reg<u32, _CLK_M4_DMA_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_DMA_CFG;
#[doc = "`read()` method returns [clk_m4_dma_cfg::R](clk_m4_dma_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_DMA_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_dma_cfg::W](clk_m4_dma_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_DMA_CFG {}
#[doc = "CLK_M4_DMA clock configuration register"]
pub mod clk_m4_dma_cfg;
#[doc = "CLK_M4_M4CORE clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_m4core_cfg](clk_m4_m4core_cfg) module"]
pub type CLK_M4_M4CORE_CFG = crate::Reg<u32, _CLK_M4_M4CORE_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_M4CORE_CFG;
#[doc = "`read()` method returns [clk_m4_m4core_cfg::R](clk_m4_m4core_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_M4CORE_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_m4core_cfg::W](clk_m4_m4core_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_M4CORE_CFG {}
#[doc = "CLK_M4_M4CORE clock configuration register"]
pub mod clk_m4_m4core_cfg;
#[doc = "CLK_M4_SCT clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_sct_cfg](clk_m4_sct_cfg) module"]
pub type CLK_M4_SCT_CFG = crate::Reg<u32, _CLK_M4_SCT_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SCT_CFG;
#[doc = "`read()` method returns [clk_m4_sct_cfg::R](clk_m4_sct_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_SCT_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_sct_cfg::W](clk_m4_sct_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_SCT_CFG {}
#[doc = "CLK_M4_SCT clock configuration register"]
pub mod clk_m4_sct_cfg;
#[doc = "CLK_M4_USB1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usb1_cfg](clk_m4_usb1_cfg) module"]
pub type CLK_M4_USB1_CFG = crate::Reg<u32, _CLK_M4_USB1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USB1_CFG;
#[doc = "`read()` method returns [clk_m4_usb1_cfg::R](clk_m4_usb1_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_USB1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_usb1_cfg::W](clk_m4_usb1_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_USB1_CFG {}
#[doc = "CLK_M4_USB1 clock configuration register"]
pub mod clk_m4_usb1_cfg;
#[doc = "CLK_M4_EMCDIV clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_emcdiv_cfg](clk_m4_emcdiv_cfg) module"]
pub type CLK_M4_EMCDIV_CFG = crate::Reg<u32, _CLK_M4_EMCDIV_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_EMCDIV_CFG;
#[doc = "`read()` method returns [clk_m4_emcdiv_cfg::R](clk_m4_emcdiv_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_EMCDIV_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_emcdiv_cfg::W](clk_m4_emcdiv_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_EMCDIV_CFG {}
#[doc = "CLK_M4_EMCDIV clock configuration register"]
pub mod clk_m4_emcdiv_cfg;
#[doc = "CLK_M4_FLASHA clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_flasha_cfg](clk_m4_flasha_cfg) module"]
pub type CLK_M4_FLASHA_CFG = crate::Reg<u32, _CLK_M4_FLASHA_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_FLASHA_CFG;
#[doc = "`read()` method returns [clk_m4_flasha_cfg::R](clk_m4_flasha_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_FLASHA_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_flasha_cfg::W](clk_m4_flasha_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_FLASHA_CFG {}
#[doc = "CLK_M4_FLASHA clock configuration register"]
pub mod clk_m4_flasha_cfg;
#[doc = "CLK_M4_FLASHB clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_flashb_cfg](clk_m4_flashb_cfg) module"]
pub type CLK_M4_FLASHB_CFG = crate::Reg<u32, _CLK_M4_FLASHB_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_FLASHB_CFG;
#[doc = "`read()` method returns [clk_m4_flashb_cfg::R](clk_m4_flashb_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_FLASHB_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_flashb_cfg::W](clk_m4_flashb_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_FLASHB_CFG {}
#[doc = "CLK_M4_FLASHB clock configuration register"]
pub mod clk_m4_flashb_cfg;
#[doc = "CLK_M0APP_CFG clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_m0app_cfg](clk_m4_m0app_cfg) module"]
pub type CLK_M4_M0APP_CFG = crate::Reg<u32, _CLK_M4_M0APP_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_M0APP_CFG;
#[doc = "`read()` method returns [clk_m4_m0app_cfg::R](clk_m4_m0app_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_M0APP_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_m0app_cfg::W](clk_m4_m0app_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_M0APP_CFG {}
#[doc = "CLK_M0APP_CFG clock configuration register"]
pub mod clk_m4_m0app_cfg;
#[doc = "CLK_ADCHS_CFG clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_adchs_cfg](clk_m4_adchs_cfg) module"]
pub type CLK_M4_ADCHS_CFG = crate::Reg<u32, _CLK_M4_ADCHS_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_ADCHS_CFG;
#[doc = "`read()` method returns [clk_m4_adchs_cfg::R](clk_m4_adchs_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_ADCHS_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_adchs_cfg::W](clk_m4_adchs_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_ADCHS_CFG {}
#[doc = "CLK_ADCHS_CFG clock configuration register"]
pub mod clk_m4_adchs_cfg;
#[doc = "CLK_EEPROM_CFG clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_eeprom_cfg](clk_m4_eeprom_cfg) module"]
pub type CLK_M4_EEPROM_CFG = crate::Reg<u32, _CLK_M4_EEPROM_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_EEPROM_CFG;
#[doc = "`read()` method returns [clk_m4_eeprom_cfg::R](clk_m4_eeprom_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_EEPROM_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_eeprom_cfg::W](clk_m4_eeprom_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_EEPROM_CFG {}
#[doc = "CLK_EEPROM_CFG clock configuration register"]
pub mod clk_m4_eeprom_cfg;
#[doc = "CLK_M4_WWDT clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_wwdt_cfg](clk_m4_wwdt_cfg) module"]
pub type CLK_M4_WWDT_CFG = crate::Reg<u32, _CLK_M4_WWDT_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_WWDT_CFG;
#[doc = "`read()` method returns [clk_m4_wwdt_cfg::R](clk_m4_wwdt_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_WWDT_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_wwdt_cfg::W](clk_m4_wwdt_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_WWDT_CFG {}
#[doc = "CLK_M4_WWDT clock configuration register"]
pub mod clk_m4_wwdt_cfg;
#[doc = "CLK_M4_USART0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usart0_cfg](clk_m4_usart0_cfg) module"]
pub type CLK_M4_USART0_CFG = crate::Reg<u32, _CLK_M4_USART0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USART0_CFG;
#[doc = "`read()` method returns [clk_m4_usart0_cfg::R](clk_m4_usart0_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_USART0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_usart0_cfg::W](clk_m4_usart0_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_USART0_CFG {}
#[doc = "CLK_M4_USART0 clock configuration register"]
pub mod clk_m4_usart0_cfg;
#[doc = "CLK_M4_UART1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_uart1_cfg](clk_m4_uart1_cfg) module"]
pub type CLK_M4_UART1_CFG = crate::Reg<u32, _CLK_M4_UART1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_UART1_CFG;
#[doc = "`read()` method returns [clk_m4_uart1_cfg::R](clk_m4_uart1_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_UART1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_uart1_cfg::W](clk_m4_uart1_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_UART1_CFG {}
#[doc = "CLK_M4_UART1 clock configuration register"]
pub mod clk_m4_uart1_cfg;
#[doc = "CLK_M4_SSP0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ssp0_cfg](clk_m4_ssp0_cfg) module"]
pub type CLK_M4_SSP0_CFG = crate::Reg<u32, _CLK_M4_SSP0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SSP0_CFG;
#[doc = "`read()` method returns [clk_m4_ssp0_cfg::R](clk_m4_ssp0_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_SSP0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_ssp0_cfg::W](clk_m4_ssp0_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_SSP0_CFG {}
#[doc = "CLK_M4_SSP0 clock configuration register"]
pub mod clk_m4_ssp0_cfg;
#[doc = "CLK_M4_TIMER0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer0_cfg](clk_m4_timer0_cfg) module"]
pub type CLK_M4_TIMER0_CFG = crate::Reg<u32, _CLK_M4_TIMER0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER0_CFG;
#[doc = "`read()` method returns [clk_m4_timer0_cfg::R](clk_m4_timer0_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_timer0_cfg::W](clk_m4_timer0_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_TIMER0_CFG {}
#[doc = "CLK_M4_TIMER0 clock configuration register"]
pub mod clk_m4_timer0_cfg;
#[doc = "CLK_M4_TIMER1clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer1_cfg](clk_m4_timer1_cfg) module"]
pub type CLK_M4_TIMER1_CFG = crate::Reg<u32, _CLK_M4_TIMER1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER1_CFG;
#[doc = "`read()` method returns [clk_m4_timer1_cfg::R](clk_m4_timer1_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_timer1_cfg::W](clk_m4_timer1_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_TIMER1_CFG {}
#[doc = "CLK_M4_TIMER1clock configuration register"]
pub mod clk_m4_timer1_cfg;
#[doc = "CLK_M4_SCU clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_scu_cfg](clk_m4_scu_cfg) module"]
pub type CLK_M4_SCU_CFG = crate::Reg<u32, _CLK_M4_SCU_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SCU_CFG;
#[doc = "`read()` method returns [clk_m4_scu_cfg::R](clk_m4_scu_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_SCU_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_scu_cfg::W](clk_m4_scu_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_SCU_CFG {}
#[doc = "CLK_M4_SCU clock configuration register"]
pub mod clk_m4_scu_cfg;
#[doc = "CLK_M4_CREGclock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_creg_cfg](clk_m4_creg_cfg) module"]
pub type CLK_M4_CREG_CFG = crate::Reg<u32, _CLK_M4_CREG_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_CREG_CFG;
#[doc = "`read()` method returns [clk_m4_creg_cfg::R](clk_m4_creg_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_CREG_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_creg_cfg::W](clk_m4_creg_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_CREG_CFG {}
#[doc = "CLK_M4_CREGclock configuration register"]
pub mod clk_m4_creg_cfg;
#[doc = "CLK_M4_RITIMER clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ritimer_cfg](clk_m4_ritimer_cfg) module"]
pub type CLK_M4_RITIMER_CFG = crate::Reg<u32, _CLK_M4_RITIMER_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_RITIMER_CFG;
#[doc = "`read()` method returns [clk_m4_ritimer_cfg::R](clk_m4_ritimer_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_RITIMER_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_ritimer_cfg::W](clk_m4_ritimer_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_RITIMER_CFG {}
#[doc = "CLK_M4_RITIMER clock configuration register"]
pub mod clk_m4_ritimer_cfg;
#[doc = "CLK_M4_USART2 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usart2_cfg](clk_m4_usart2_cfg) module"]
pub type CLK_M4_USART2_CFG = crate::Reg<u32, _CLK_M4_USART2_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USART2_CFG;
#[doc = "`read()` method returns [clk_m4_usart2_cfg::R](clk_m4_usart2_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_USART2_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_usart2_cfg::W](clk_m4_usart2_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_USART2_CFG {}
#[doc = "CLK_M4_USART2 clock configuration register"]
pub mod clk_m4_usart2_cfg;
#[doc = "CLK_M4_USART3 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usart3_cfg](clk_m4_usart3_cfg) module"]
pub type CLK_M4_USART3_CFG = crate::Reg<u32, _CLK_M4_USART3_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USART3_CFG;
#[doc = "`read()` method returns [clk_m4_usart3_cfg::R](clk_m4_usart3_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_USART3_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_usart3_cfg::W](clk_m4_usart3_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_USART3_CFG {}
#[doc = "CLK_M4_USART3 clock configuration register"]
pub mod clk_m4_usart3_cfg;
#[doc = "CLK_M4_TIMER2 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer2_cfg](clk_m4_timer2_cfg) module"]
pub type CLK_M4_TIMER2_CFG = crate::Reg<u32, _CLK_M4_TIMER2_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER2_CFG;
#[doc = "`read()` method returns [clk_m4_timer2_cfg::R](clk_m4_timer2_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER2_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_timer2_cfg::W](clk_m4_timer2_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_TIMER2_CFG {}
#[doc = "CLK_M4_TIMER2 clock configuration register"]
pub mod clk_m4_timer2_cfg;
#[doc = "CLK_M4_TIMER3 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer3_cfg](clk_m4_timer3_cfg) module"]
pub type CLK_M4_TIMER3_CFG = crate::Reg<u32, _CLK_M4_TIMER3_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER3_CFG;
#[doc = "`read()` method returns [clk_m4_timer3_cfg::R](clk_m4_timer3_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER3_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_timer3_cfg::W](clk_m4_timer3_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_TIMER3_CFG {}
#[doc = "CLK_M4_TIMER3 clock configuration register"]
pub mod clk_m4_timer3_cfg;
#[doc = "CLK_M4_SSP1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ssp1_cfg](clk_m4_ssp1_cfg) module"]
pub type CLK_M4_SSP1_CFG = crate::Reg<u32, _CLK_M4_SSP1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SSP1_CFG;
#[doc = "`read()` method returns [clk_m4_ssp1_cfg::R](clk_m4_ssp1_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_SSP1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_ssp1_cfg::W](clk_m4_ssp1_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_SSP1_CFG {}
#[doc = "CLK_M4_SSP1 clock configuration register"]
pub mod clk_m4_ssp1_cfg;
#[doc = "CLK_M4_QEIclock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_qei_cfg](clk_m4_qei_cfg) module"]
pub type CLK_M4_QEI_CFG = crate::Reg<u32, _CLK_M4_QEI_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_QEI_CFG;
#[doc = "`read()` method returns [clk_m4_qei_cfg::R](clk_m4_qei_cfg::R) reader structure"]
impl crate::Readable for CLK_M4_QEI_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_m4_qei_cfg::W](clk_m4_qei_cfg::W) writer structure"]
impl crate::Writable for CLK_M4_QEI_CFG {}
#[doc = "CLK_M4_QEIclock configuration register"]
pub mod clk_m4_qei_cfg;
#[doc = "CLK_PERIPH_BUS_CFG clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_periph_bus_cfg](clk_periph_bus_cfg) module"]
pub type CLK_PERIPH_BUS_CFG = crate::Reg<u32, _CLK_PERIPH_BUS_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_PERIPH_BUS_CFG;
#[doc = "`read()` method returns [clk_periph_bus_cfg::R](clk_periph_bus_cfg::R) reader structure"]
impl crate::Readable for CLK_PERIPH_BUS_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_periph_bus_cfg::W](clk_periph_bus_cfg::W) writer structure"]
impl crate::Writable for CLK_PERIPH_BUS_CFG {}
#[doc = "CLK_PERIPH_BUS_CFG clock configuration register"]
pub mod clk_periph_bus_cfg;
#[doc = "CLK_PERIPH_CORE_CFG clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_periph_core_cfg](clk_periph_core_cfg) module"]
pub type CLK_PERIPH_CORE_CFG = crate::Reg<u32, _CLK_PERIPH_CORE_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_PERIPH_CORE_CFG;
#[doc = "`read()` method returns [clk_periph_core_cfg::R](clk_periph_core_cfg::R) reader structure"]
impl crate::Readable for CLK_PERIPH_CORE_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_periph_core_cfg::W](clk_periph_core_cfg::W) writer structure"]
impl crate::Writable for CLK_PERIPH_CORE_CFG {}
#[doc = "CLK_PERIPH_CORE_CFG clock configuration register"]
pub mod clk_periph_core_cfg;
#[doc = "CLK_PERIPH_SGPIO_CFG clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_periph_sgpio_cfg](clk_periph_sgpio_cfg) module"]
pub type CLK_PERIPH_SGPIO_CFG = crate::Reg<u32, _CLK_PERIPH_SGPIO_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_PERIPH_SGPIO_CFG;
#[doc = "`read()` method returns [clk_periph_sgpio_cfg::R](clk_periph_sgpio_cfg::R) reader structure"]
impl crate::Readable for CLK_PERIPH_SGPIO_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_periph_sgpio_cfg::W](clk_periph_sgpio_cfg::W) writer structure"]
impl crate::Writable for CLK_PERIPH_SGPIO_CFG {}
#[doc = "CLK_PERIPH_SGPIO_CFG clock configuration register"]
pub mod clk_periph_sgpio_cfg;
#[doc = "CLK_M4_USB0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_usb0_cfg](clk_usb0_cfg) module"]
pub type CLK_USB0_CFG = crate::Reg<u32, _CLK_USB0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_USB0_CFG;
#[doc = "`read()` method returns [clk_usb0_cfg::R](clk_usb0_cfg::R) reader structure"]
impl crate::Readable for CLK_USB0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_usb0_cfg::W](clk_usb0_cfg::W) writer structure"]
impl crate::Writable for CLK_USB0_CFG {}
#[doc = "CLK_M4_USB0 clock configuration register"]
pub mod clk_usb0_cfg;
#[doc = "CLK_USB1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_usb1_cfg](clk_usb1_cfg) module"]
pub type CLK_USB1_CFG = crate::Reg<u32, _CLK_USB1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_USB1_CFG;
#[doc = "`read()` method returns [clk_usb1_cfg::R](clk_usb1_cfg::R) reader structure"]
impl crate::Readable for CLK_USB1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_usb1_cfg::W](clk_usb1_cfg::W) writer structure"]
impl crate::Writable for CLK_USB1_CFG {}
#[doc = "CLK_USB1 clock configuration register"]
pub mod clk_usb1_cfg;
#[doc = "CLK_SPI clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_spi_cfg](clk_spi_cfg) module"]
pub type CLK_SPI_CFG = crate::Reg<u32, _CLK_SPI_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_SPI_CFG;
#[doc = "`read()` method returns [clk_spi_cfg::R](clk_spi_cfg::R) reader structure"]
impl crate::Readable for CLK_SPI_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_spi_cfg::W](clk_spi_cfg::W) writer structure"]
impl crate::Writable for CLK_SPI_CFG {}
#[doc = "CLK_SPI clock configuration register"]
pub mod clk_spi_cfg;
#[doc = "CLK_ADCHS clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_adchs_cfg](clk_adchs_cfg) module"]
pub type CLK_ADCHS_CFG = crate::Reg<u32, _CLK_ADCHS_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_ADCHS_CFG;
#[doc = "`read()` method returns [clk_adchs_cfg::R](clk_adchs_cfg::R) reader structure"]
impl crate::Readable for CLK_ADCHS_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_adchs_cfg::W](clk_adchs_cfg::W) writer structure"]
impl crate::Writable for CLK_ADCHS_CFG {}
#[doc = "CLK_ADCHS clock configuration register"]
pub mod clk_adchs_cfg;
#[doc = "CLK_APB3_BUS clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_bus_stat](clk_apb3_bus_stat) module"]
pub type CLK_APB3_BUS_STAT = crate::Reg<u32, _CLK_APB3_BUS_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_BUS_STAT;
#[doc = "`read()` method returns [clk_apb3_bus_stat::R](clk_apb3_bus_stat::R) reader structure"]
impl crate::Readable for CLK_APB3_BUS_STAT {}
#[doc = "CLK_APB3_BUS clock status register"]
pub mod clk_apb3_bus_stat;
#[doc = "CLK_APB3_I2C1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_i2c1_stat](clk_apb3_i2c1_stat) module"]
pub type CLK_APB3_I2C1_STAT = crate::Reg<u32, _CLK_APB3_I2C1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_I2C1_STAT;
#[doc = "`read()` method returns [clk_apb3_i2c1_stat::R](clk_apb3_i2c1_stat::R) reader structure"]
impl crate::Readable for CLK_APB3_I2C1_STAT {}
#[doc = "CLK_APB3_I2C1 clock status register"]
pub mod clk_apb3_i2c1_stat;
#[doc = "CLK_APB3_DAC clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_dac_stat](clk_apb3_dac_stat) module"]
pub type CLK_APB3_DAC_STAT = crate::Reg<u32, _CLK_APB3_DAC_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_DAC_STAT;
#[doc = "`read()` method returns [clk_apb3_dac_stat::R](clk_apb3_dac_stat::R) reader structure"]
impl crate::Readable for CLK_APB3_DAC_STAT {}
#[doc = "CLK_APB3_DAC clock status register"]
pub mod clk_apb3_dac_stat;
#[doc = "CLK_APB3_ADC0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_adc0_stat](clk_apb3_adc0_stat) module"]
pub type CLK_APB3_ADC0_STAT = crate::Reg<u32, _CLK_APB3_ADC0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_ADC0_STAT;
#[doc = "`read()` method returns [clk_apb3_adc0_stat::R](clk_apb3_adc0_stat::R) reader structure"]
impl crate::Readable for CLK_APB3_ADC0_STAT {}
#[doc = "CLK_APB3_ADC0 clock status register"]
pub mod clk_apb3_adc0_stat;
#[doc = "CLK_APB3_ADC1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_adc1_stat](clk_apb3_adc1_stat) module"]
pub type CLK_APB3_ADC1_STAT = crate::Reg<u32, _CLK_APB3_ADC1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_ADC1_STAT;
#[doc = "`read()` method returns [clk_apb3_adc1_stat::R](clk_apb3_adc1_stat::R) reader structure"]
impl crate::Readable for CLK_APB3_ADC1_STAT {}
#[doc = "CLK_APB3_ADC1 clock status register"]
pub mod clk_apb3_adc1_stat;
#[doc = "CLK_APB3_CAN0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb3_can0_stat](clk_apb3_can0_stat) module"]
pub type CLK_APB3_CAN0_STAT = crate::Reg<u32, _CLK_APB3_CAN0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB3_CAN0_STAT;
#[doc = "`read()` method returns [clk_apb3_can0_stat::R](clk_apb3_can0_stat::R) reader structure"]
impl crate::Readable for CLK_APB3_CAN0_STAT {}
#[doc = "CLK_APB3_CAN0 clock status register"]
pub mod clk_apb3_can0_stat;
#[doc = "CLK_APB1_BUS clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_bus_stat](clk_apb1_bus_stat) module"]
pub type CLK_APB1_BUS_STAT = crate::Reg<u32, _CLK_APB1_BUS_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_BUS_STAT;
#[doc = "`read()` method returns [clk_apb1_bus_stat::R](clk_apb1_bus_stat::R) reader structure"]
impl crate::Readable for CLK_APB1_BUS_STAT {}
#[doc = "CLK_APB1_BUS clock status register"]
pub mod clk_apb1_bus_stat;
#[doc = "CLK_APB1_MOTOCONPWM clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_motoconpwm_stat](clk_apb1_motoconpwm_stat) module"]
pub type CLK_APB1_MOTOCONPWM_STAT = crate::Reg<u32, _CLK_APB1_MOTOCONPWM_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_MOTOCONPWM_STAT;
#[doc = "`read()` method returns [clk_apb1_motoconpwm_stat::R](clk_apb1_motoconpwm_stat::R) reader structure"]
impl crate::Readable for CLK_APB1_MOTOCONPWM_STAT {}
#[doc = "CLK_APB1_MOTOCONPWM clock status register"]
pub mod clk_apb1_motoconpwm_stat;
#[doc = "CLK_APB1_I2C0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_i2c0_stat](clk_apb1_i2c0_stat) module"]
pub type CLK_APB1_I2C0_STAT = crate::Reg<u32, _CLK_APB1_I2C0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_I2C0_STAT;
#[doc = "`read()` method returns [clk_apb1_i2c0_stat::R](clk_apb1_i2c0_stat::R) reader structure"]
impl crate::Readable for CLK_APB1_I2C0_STAT {}
#[doc = "CLK_APB1_I2C0 clock status register"]
pub mod clk_apb1_i2c0_stat;
#[doc = "CLK_APB1_I2S clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_i2s_stat](clk_apb1_i2s_stat) module"]
pub type CLK_APB1_I2S_STAT = crate::Reg<u32, _CLK_APB1_I2S_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_I2S_STAT;
#[doc = "`read()` method returns [clk_apb1_i2s_stat::R](clk_apb1_i2s_stat::R) reader structure"]
impl crate::Readable for CLK_APB1_I2S_STAT {}
#[doc = "CLK_APB1_I2S clock status register"]
pub mod clk_apb1_i2s_stat;
#[doc = "CLK_APB1_CAN1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_apb1_can1_stat](clk_apb1_can1_stat) module"]
pub type CLK_APB1_CAN1_STAT = crate::Reg<u32, _CLK_APB1_CAN1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB1_CAN1_STAT;
#[doc = "`read()` method returns [clk_apb1_can1_stat::R](clk_apb1_can1_stat::R) reader structure"]
impl crate::Readable for CLK_APB1_CAN1_STAT {}
#[doc = "CLK_APB1_CAN1 clock status register"]
pub mod clk_apb1_can1_stat;
#[doc = "CLK_APB1_SPIFI clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_spifi_stat](clk_spifi_stat) module"]
pub type CLK_SPIFI_STAT = crate::Reg<u32, _CLK_SPIFI_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_SPIFI_STAT;
#[doc = "`read()` method returns [clk_spifi_stat::R](clk_spifi_stat::R) reader structure"]
impl crate::Readable for CLK_SPIFI_STAT {}
#[doc = "CLK_APB1_SPIFI clock status register"]
pub mod clk_spifi_stat;
#[doc = "CLK_M4_BUSclock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_bus_stat](clk_m4_bus_stat) module"]
pub type CLK_M4_BUS_STAT = crate::Reg<u32, _CLK_M4_BUS_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_BUS_STAT;
#[doc = "`read()` method returns [clk_m4_bus_stat::R](clk_m4_bus_stat::R) reader structure"]
impl crate::Readable for CLK_M4_BUS_STAT {}
#[doc = "CLK_M4_BUSclock status register"]
pub mod clk_m4_bus_stat;
#[doc = "CLK_M4_SPIFI clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_spifi_stat](clk_m4_spifi_stat) module"]
pub type CLK_M4_SPIFI_STAT = crate::Reg<u32, _CLK_M4_SPIFI_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SPIFI_STAT;
#[doc = "`read()` method returns [clk_m4_spifi_stat::R](clk_m4_spifi_stat::R) reader structure"]
impl crate::Readable for CLK_M4_SPIFI_STAT {}
#[doc = "CLK_M4_SPIFI clock status register"]
pub mod clk_m4_spifi_stat;
#[doc = "CLK_M4_GPIO clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_gpio_stat](clk_m4_gpio_stat) module"]
pub type CLK_M4_GPIO_STAT = crate::Reg<u32, _CLK_M4_GPIO_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_GPIO_STAT;
#[doc = "`read()` method returns [clk_m4_gpio_stat::R](clk_m4_gpio_stat::R) reader structure"]
impl crate::Readable for CLK_M4_GPIO_STAT {}
#[doc = "CLK_M4_GPIO clock status register"]
pub mod clk_m4_gpio_stat;
#[doc = "CLK_M4_LCD clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_lcd_stat](clk_m4_lcd_stat) module"]
pub type CLK_M4_LCD_STAT = crate::Reg<u32, _CLK_M4_LCD_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_LCD_STAT;
#[doc = "`read()` method returns [clk_m4_lcd_stat::R](clk_m4_lcd_stat::R) reader structure"]
impl crate::Readable for CLK_M4_LCD_STAT {}
#[doc = "CLK_M4_LCD clock status register"]
pub mod clk_m4_lcd_stat;
#[doc = "CLK_M4_ETHERNET clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ethernet_status](clk_m4_ethernet_status) module"]
pub type CLK_M4_ETHERNET_STATUS = crate::Reg<u32, _CLK_M4_ETHERNET_STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_ETHERNET_STATUS;
#[doc = "`read()` method returns [clk_m4_ethernet_status::R](clk_m4_ethernet_status::R) reader structure"]
impl crate::Readable for CLK_M4_ETHERNET_STATUS {}
#[doc = "CLK_M4_ETHERNET clock status register"]
pub mod clk_m4_ethernet_status;
#[doc = "CLK_M4_USB0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usb0_stat](clk_m4_usb0_stat) module"]
pub type CLK_M4_USB0_STAT = crate::Reg<u32, _CLK_M4_USB0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USB0_STAT;
#[doc = "`read()` method returns [clk_m4_usb0_stat::R](clk_m4_usb0_stat::R) reader structure"]
impl crate::Readable for CLK_M4_USB0_STAT {}
#[doc = "CLK_M4_USB0 clock status register"]
pub mod clk_m4_usb0_stat;
#[doc = "CLK_M4_EMC clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_emc_stat](clk_m4_emc_stat) module"]
pub type CLK_M4_EMC_STAT = crate::Reg<u32, _CLK_M4_EMC_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_EMC_STAT;
#[doc = "`read()` method returns [clk_m4_emc_stat::R](clk_m4_emc_stat::R) reader structure"]
impl crate::Readable for CLK_M4_EMC_STAT {}
#[doc = "CLK_M4_EMC clock status register"]
pub mod clk_m4_emc_stat;
#[doc = "CLK_M4_SDIO clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_sdio_stat](clk_m4_sdio_stat) module"]
pub type CLK_M4_SDIO_STAT = crate::Reg<u32, _CLK_M4_SDIO_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SDIO_STAT;
#[doc = "`read()` method returns [clk_m4_sdio_stat::R](clk_m4_sdio_stat::R) reader structure"]
impl crate::Readable for CLK_M4_SDIO_STAT {}
#[doc = "CLK_M4_SDIO clock status register"]
pub mod clk_m4_sdio_stat;
#[doc = "CLK_M4_DMA clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_dma_stat](clk_m4_dma_stat) module"]
pub type CLK_M4_DMA_STAT = crate::Reg<u32, _CLK_M4_DMA_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_DMA_STAT;
#[doc = "`read()` method returns [clk_m4_dma_stat::R](clk_m4_dma_stat::R) reader structure"]
impl crate::Readable for CLK_M4_DMA_STAT {}
#[doc = "CLK_M4_DMA clock status register"]
pub mod clk_m4_dma_stat;
#[doc = "CLK_M4_M3CORE clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_m4core_stat](clk_m4_m4core_stat) module"]
pub type CLK_M4_M4CORE_STAT = crate::Reg<u32, _CLK_M4_M4CORE_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_M4CORE_STAT;
#[doc = "`read()` method returns [clk_m4_m4core_stat::R](clk_m4_m4core_stat::R) reader structure"]
impl crate::Readable for CLK_M4_M4CORE_STAT {}
#[doc = "CLK_M4_M3CORE clock status register"]
pub mod clk_m4_m4core_stat;
#[doc = "CLK_M4_SCT clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_sct_stat](clk_m4_sct_stat) module"]
pub type CLK_M4_SCT_STAT = crate::Reg<u32, _CLK_M4_SCT_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SCT_STAT;
#[doc = "`read()` method returns [clk_m4_sct_stat::R](clk_m4_sct_stat::R) reader structure"]
impl crate::Readable for CLK_M4_SCT_STAT {}
#[doc = "CLK_M4_SCT clock status register"]
pub mod clk_m4_sct_stat;
#[doc = "CLK_M4_USB1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usb1_stat](clk_m4_usb1_stat) module"]
pub type CLK_M4_USB1_STAT = crate::Reg<u32, _CLK_M4_USB1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USB1_STAT;
#[doc = "`read()` method returns [clk_m4_usb1_stat::R](clk_m4_usb1_stat::R) reader structure"]
impl crate::Readable for CLK_M4_USB1_STAT {}
#[doc = "CLK_M4_USB1 clock status register"]
pub mod clk_m4_usb1_stat;
#[doc = "CLK_M4_EMCDIV clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_emcdiv_stat](clk_m4_emcdiv_stat) module"]
pub type CLK_M4_EMCDIV_STAT = crate::Reg<u32, _CLK_M4_EMCDIV_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_EMCDIV_STAT;
#[doc = "`read()` method returns [clk_m4_emcdiv_stat::R](clk_m4_emcdiv_stat::R) reader structure"]
impl crate::Readable for CLK_M4_EMCDIV_STAT {}
#[doc = "CLK_M4_EMCDIV clock status register"]
pub mod clk_m4_emcdiv_stat;
#[doc = "CLK_M4_FLASHA clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_flasha_stat](clk_m4_flasha_stat) module"]
pub type CLK_M4_FLASHA_STAT = crate::Reg<u32, _CLK_M4_FLASHA_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_FLASHA_STAT;
#[doc = "`read()` method returns [clk_m4_flasha_stat::R](clk_m4_flasha_stat::R) reader structure"]
impl crate::Readable for CLK_M4_FLASHA_STAT {}
#[doc = "CLK_M4_FLASHA clock status register"]
pub mod clk_m4_flasha_stat;
#[doc = "CLK_M4_FLASHB clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_flashb_stat](clk_m4_flashb_stat) module"]
pub type CLK_M4_FLASHB_STAT = crate::Reg<u32, _CLK_M4_FLASHB_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_FLASHB_STAT;
#[doc = "`read()` method returns [clk_m4_flashb_stat::R](clk_m4_flashb_stat::R) reader structure"]
impl crate::Readable for CLK_M4_FLASHB_STAT {}
#[doc = "CLK_M4_FLASHB clock status register"]
pub mod clk_m4_flashb_stat;
#[doc = "CLK_M4_MOAPP clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_m0app_stat](clk_m4_m0app_stat) module"]
pub type CLK_M4_M0APP_STAT = crate::Reg<u32, _CLK_M4_M0APP_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_M0APP_STAT;
#[doc = "`read()` method returns [clk_m4_m0app_stat::R](clk_m4_m0app_stat::R) reader structure"]
impl crate::Readable for CLK_M4_M0APP_STAT {}
#[doc = "CLK_M4_MOAPP clock status register"]
pub mod clk_m4_m0app_stat;
#[doc = "CLK_M4_ADCHS clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_adchs_stat](clk_m4_adchs_stat) module"]
pub type CLK_M4_ADCHS_STAT = crate::Reg<u32, _CLK_M4_ADCHS_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_ADCHS_STAT;
#[doc = "`read()` method returns [clk_m4_adchs_stat::R](clk_m4_adchs_stat::R) reader structure"]
impl crate::Readable for CLK_M4_ADCHS_STAT {}
#[doc = "CLK_M4_ADCHS clock status register"]
pub mod clk_m4_adchs_stat;
#[doc = "CLK_M4_EEPROM clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_eeprom_stat](clk_m4_eeprom_stat) module"]
pub type CLK_M4_EEPROM_STAT = crate::Reg<u32, _CLK_M4_EEPROM_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_EEPROM_STAT;
#[doc = "`read()` method returns [clk_m4_eeprom_stat::R](clk_m4_eeprom_stat::R) reader structure"]
impl crate::Readable for CLK_M4_EEPROM_STAT {}
#[doc = "CLK_M4_EEPROM clock status register"]
pub mod clk_m4_eeprom_stat;
#[doc = "CLK_M4_WWDT clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_wwdt_stat](clk_m4_wwdt_stat) module"]
pub type CLK_M4_WWDT_STAT = crate::Reg<u32, _CLK_M4_WWDT_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_WWDT_STAT;
#[doc = "`read()` method returns [clk_m4_wwdt_stat::R](clk_m4_wwdt_stat::R) reader structure"]
impl crate::Readable for CLK_M4_WWDT_STAT {}
#[doc = "CLK_M4_WWDT clock status register"]
pub mod clk_m4_wwdt_stat;
#[doc = "CLK_M4_USART0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usart0_stat](clk_m4_usart0_stat) module"]
pub type CLK_M4_USART0_STAT = crate::Reg<u32, _CLK_M4_USART0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USART0_STAT;
#[doc = "`read()` method returns [clk_m4_usart0_stat::R](clk_m4_usart0_stat::R) reader structure"]
impl crate::Readable for CLK_M4_USART0_STAT {}
#[doc = "CLK_M4_USART0 clock status register"]
pub mod clk_m4_usart0_stat;
#[doc = "CLK_M4_UART1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_uart1_stat](clk_m4_uart1_stat) module"]
pub type CLK_M4_UART1_STAT = crate::Reg<u32, _CLK_M4_UART1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_UART1_STAT;
#[doc = "`read()` method returns [clk_m4_uart1_stat::R](clk_m4_uart1_stat::R) reader structure"]
impl crate::Readable for CLK_M4_UART1_STAT {}
#[doc = "CLK_M4_UART1 clock status register"]
pub mod clk_m4_uart1_stat;
#[doc = "CLK_M4_SSP0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ssp0_stat](clk_m4_ssp0_stat) module"]
pub type CLK_M4_SSP0_STAT = crate::Reg<u32, _CLK_M4_SSP0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SSP0_STAT;
#[doc = "`read()` method returns [clk_m4_ssp0_stat::R](clk_m4_ssp0_stat::R) reader structure"]
impl crate::Readable for CLK_M4_SSP0_STAT {}
#[doc = "CLK_M4_SSP0 clock status register"]
pub mod clk_m4_ssp0_stat;
#[doc = "CLK_M4_TIMER0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer0_stat](clk_m4_timer0_stat) module"]
pub type CLK_M4_TIMER0_STAT = crate::Reg<u32, _CLK_M4_TIMER0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER0_STAT;
#[doc = "`read()` method returns [clk_m4_timer0_stat::R](clk_m4_timer0_stat::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER0_STAT {}
#[doc = "CLK_M4_TIMER0 clock status register"]
pub mod clk_m4_timer0_stat;
#[doc = "CLK_M4_TIMER1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer1_stat](clk_m4_timer1_stat) module"]
pub type CLK_M4_TIMER1_STAT = crate::Reg<u32, _CLK_M4_TIMER1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER1_STAT;
#[doc = "`read()` method returns [clk_m4_timer1_stat::R](clk_m4_timer1_stat::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER1_STAT {}
#[doc = "CLK_M4_TIMER1 clock status register"]
pub mod clk_m4_timer1_stat;
#[doc = "CLK_SCU_XXX clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_scu_stat](clk_m4_scu_stat) module"]
pub type CLK_M4_SCU_STAT = crate::Reg<u32, _CLK_M4_SCU_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SCU_STAT;
#[doc = "`read()` method returns [clk_m4_scu_stat::R](clk_m4_scu_stat::R) reader structure"]
impl crate::Readable for CLK_M4_SCU_STAT {}
#[doc = "CLK_SCU_XXX clock status register"]
pub mod clk_m4_scu_stat;
#[doc = "CLK_M4_CREG clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_creg_stat](clk_m4_creg_stat) module"]
pub type CLK_M4_CREG_STAT = crate::Reg<u32, _CLK_M4_CREG_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_CREG_STAT;
#[doc = "`read()` method returns [clk_m4_creg_stat::R](clk_m4_creg_stat::R) reader structure"]
impl crate::Readable for CLK_M4_CREG_STAT {}
#[doc = "CLK_M4_CREG clock status register"]
pub mod clk_m4_creg_stat;
#[doc = "CLK_M4_RITIMER clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ritimer_stat](clk_m4_ritimer_stat) module"]
pub type CLK_M4_RITIMER_STAT = crate::Reg<u32, _CLK_M4_RITIMER_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_RITIMER_STAT;
#[doc = "`read()` method returns [clk_m4_ritimer_stat::R](clk_m4_ritimer_stat::R) reader structure"]
impl crate::Readable for CLK_M4_RITIMER_STAT {}
#[doc = "CLK_M4_RITIMER clock status register"]
pub mod clk_m4_ritimer_stat;
#[doc = "CLK_M4_USART2 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usart2_stat](clk_m4_usart2_stat) module"]
pub type CLK_M4_USART2_STAT = crate::Reg<u32, _CLK_M4_USART2_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USART2_STAT;
#[doc = "`read()` method returns [clk_m4_usart2_stat::R](clk_m4_usart2_stat::R) reader structure"]
impl crate::Readable for CLK_M4_USART2_STAT {}
#[doc = "CLK_M4_USART2 clock status register"]
pub mod clk_m4_usart2_stat;
#[doc = "CLK_M4_USART3 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_usart3_stat](clk_m4_usart3_stat) module"]
pub type CLK_M4_USART3_STAT = crate::Reg<u32, _CLK_M4_USART3_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_USART3_STAT;
#[doc = "`read()` method returns [clk_m4_usart3_stat::R](clk_m4_usart3_stat::R) reader structure"]
impl crate::Readable for CLK_M4_USART3_STAT {}
#[doc = "CLK_M4_USART3 clock status register"]
pub mod clk_m4_usart3_stat;
#[doc = "CLK_M4_TIMER2 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer2_stat](clk_m4_timer2_stat) module"]
pub type CLK_M4_TIMER2_STAT = crate::Reg<u32, _CLK_M4_TIMER2_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER2_STAT;
#[doc = "`read()` method returns [clk_m4_timer2_stat::R](clk_m4_timer2_stat::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER2_STAT {}
#[doc = "CLK_M4_TIMER2 clock status register"]
pub mod clk_m4_timer2_stat;
#[doc = "CLK_M4_TIMER3 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_timer3_stat](clk_m4_timer3_stat) module"]
pub type CLK_M4_TIMER3_STAT = crate::Reg<u32, _CLK_M4_TIMER3_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_TIMER3_STAT;
#[doc = "`read()` method returns [clk_m4_timer3_stat::R](clk_m4_timer3_stat::R) reader structure"]
impl crate::Readable for CLK_M4_TIMER3_STAT {}
#[doc = "CLK_M4_TIMER3 clock status register"]
pub mod clk_m4_timer3_stat;
#[doc = "CLK_M4_SSP1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_ssp1_stat](clk_m4_ssp1_stat) module"]
pub type CLK_M4_SSP1_STAT = crate::Reg<u32, _CLK_M4_SSP1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_SSP1_STAT;
#[doc = "`read()` method returns [clk_m4_ssp1_stat::R](clk_m4_ssp1_stat::R) reader structure"]
impl crate::Readable for CLK_M4_SSP1_STAT {}
#[doc = "CLK_M4_SSP1 clock status register"]
pub mod clk_m4_ssp1_stat;
#[doc = "CLK_M4_QEI clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_m4_qei_stat](clk_m4_qei_stat) module"]
pub type CLK_M4_QEI_STAT = crate::Reg<u32, _CLK_M4_QEI_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_M4_QEI_STAT;
#[doc = "`read()` method returns [clk_m4_qei_stat::R](clk_m4_qei_stat::R) reader structure"]
impl crate::Readable for CLK_M4_QEI_STAT {}
#[doc = "CLK_M4_QEI clock status register"]
pub mod clk_m4_qei_stat;
#[doc = "CLK_PERIPH_BUS_STAT clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_periph_bus_stat](clk_periph_bus_stat) module"]
pub type CLK_PERIPH_BUS_STAT = crate::Reg<u32, _CLK_PERIPH_BUS_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_PERIPH_BUS_STAT;
#[doc = "`read()` method returns [clk_periph_bus_stat::R](clk_periph_bus_stat::R) reader structure"]
impl crate::Readable for CLK_PERIPH_BUS_STAT {}
#[doc = "CLK_PERIPH_BUS_STAT clock status register"]
pub mod clk_periph_bus_stat;
#[doc = "CLK_CORE_BUS_STAT clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_periph_core_status](clk_periph_core_status) module"]
pub type CLK_PERIPH_CORE_STATUS = crate::Reg<u32, _CLK_PERIPH_CORE_STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_PERIPH_CORE_STATUS;
#[doc = "`read()` method returns [clk_periph_core_status::R](clk_periph_core_status::R) reader structure"]
impl crate::Readable for CLK_PERIPH_CORE_STATUS {}
#[doc = "CLK_CORE_BUS_STAT clock status register"]
pub mod clk_periph_core_status;
#[doc = "CLK_CORE_SGPIO_STAT clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_periph_sgpio_stat](clk_periph_sgpio_stat) module"]
pub type CLK_PERIPH_SGPIO_STAT = crate::Reg<u32, _CLK_PERIPH_SGPIO_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_PERIPH_SGPIO_STAT;
#[doc = "`read()` method returns [clk_periph_sgpio_stat::R](clk_periph_sgpio_stat::R) reader structure"]
impl crate::Readable for CLK_PERIPH_SGPIO_STAT {}
#[doc = "CLK_CORE_SGPIO_STAT clock status register"]
pub mod clk_periph_sgpio_stat;
#[doc = "CLK_USB0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_usb0_stat](clk_usb0_stat) module"]
pub type CLK_USB0_STAT = crate::Reg<u32, _CLK_USB0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_USB0_STAT;
#[doc = "`read()` method returns [clk_usb0_stat::R](clk_usb0_stat::R) reader structure"]
impl crate::Readable for CLK_USB0_STAT {}
#[doc = "CLK_USB0 clock status register"]
pub mod clk_usb0_stat;
#[doc = "CLK_USB1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_usb1_stat](clk_usb1_stat) module"]
pub type CLK_USB1_STAT = crate::Reg<u32, _CLK_USB1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_USB1_STAT;
#[doc = "`read()` method returns [clk_usb1_stat::R](clk_usb1_stat::R) reader structure"]
impl crate::Readable for CLK_USB1_STAT {}
#[doc = "CLK_USB1 clock status register"]
pub mod clk_usb1_stat;
#[doc = "CLK_SPI clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_spi_stat](clk_spi_stat) module"]
pub type CLK_SPI_STAT = crate::Reg<u32, _CLK_SPI_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_SPI_STAT;
#[doc = "`read()` method returns [clk_spi_stat::R](clk_spi_stat::R) reader structure"]
impl crate::Readable for CLK_SPI_STAT {}
#[doc = "CLK_SPI clock status register"]
pub mod clk_spi_stat;
#[doc = "CLK_ADCHS clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_adchs_stat](clk_adchs_stat) module"]
pub type CLK_ADCHS_STAT = crate::Reg<u32, _CLK_ADCHS_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_ADCHS_STAT;
#[doc = "`read()` method returns [clk_adchs_stat::R](clk_adchs_stat::R) reader structure"]
impl crate::Readable for CLK_ADCHS_STAT {}
#[doc = "CLK_ADCHS clock status register"]
pub mod clk_adchs_stat;
