#[doc = "Reader of register PM"]
pub type R = crate::R<u32, super::PM>;
#[doc = "Writer for register PM"]
pub type W = crate::W<u32, super::PM>;
#[doc = "Register PM `reset()`'s with value 0"]
impl crate::ResetValue for super::PM {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Initiate power-down mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PD_A {
    #[doc = "0: Normal operation."]
    NORMAL_OPERATION = 0,
    #[doc = "1: Clocks with wake-up mode enabled (W = 1) are disabled."]
    CLOCKS_WITH_WAKE_UP = 1,
}
impl From<PD_A> for bool {
    #[inline(always)]
    fn from(variant: PD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PD`"]
pub type PD_R = crate::R<bool, PD_A>;
impl PD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PD_A {
        match self.bits {
            false => PD_A::NORMAL_OPERATION,
            true => PD_A::CLOCKS_WITH_WAKE_UP,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL_OPERATION`"]
    #[inline(always)]
    pub fn is_normal_operation(&self) -> bool {
        *self == PD_A::NORMAL_OPERATION
    }
    #[doc = "Checks if the value of the field is `CLOCKS_WITH_WAKE_UP`"]
    #[inline(always)]
    pub fn is_clocks_with_wake_up(&self) -> bool {
        *self == PD_A::CLOCKS_WITH_WAKE_UP
    }
}
#[doc = "Write proxy for field `PD`"]
pub struct PD_W<'a> {
    w: &'a mut W,
}
impl<'a> PD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Normal operation."]
    #[inline(always)]
    pub fn normal_operation(self) -> &'a mut W {
        self.variant(PD_A::NORMAL_OPERATION)
    }
    #[doc = "Clocks with wake-up mode enabled (W = 1) are disabled."]
    #[inline(always)]
    pub fn clocks_with_wake_up(self) -> &'a mut W {
        self.variant(PD_A::CLOCKS_WITH_WAKE_UP)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Initiate power-down mode"]
    #[inline(always)]
    pub fn pd(&self) -> PD_R {
        PD_R::new((self.bits & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Initiate power-down mode"]
    #[inline(always)]
    pub fn pd(&mut self) -> PD_W {
        PD_W { w: self }
    }
}
