#[doc = "Reader of register FREQ_MON"]
pub type R = crate::R<u32, super::FREQ_MON>;
#[doc = "Writer for register FREQ_MON"]
pub type W = crate::W<u32, super::FREQ_MON>;
#[doc = "Register FREQ_MON `reset()`'s with value 0"]
impl crate::ResetValue for super::FREQ_MON {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `RCNT`"]
pub type RCNT_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `RCNT`"]
pub struct RCNT_W<'a> {
    w: &'a mut W,
}
impl<'a> RCNT_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01ff) | ((value as u32) & 0x01ff);
        self.w
    }
}
#[doc = "Reader of field `FCNT`"]
pub type FCNT_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `FCNT`"]
pub struct FCNT_W<'a> {
    w: &'a mut W,
}
impl<'a> FCNT_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x3fff << 9)) | (((value as u32) & 0x3fff) << 9);
        self.w
    }
}
#[doc = "Measure frequency\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MEAS_A {
    #[doc = "0: RCNT and FCNT disabled"]
    RCNT_AND_FCNT_DISABLED = 0,
    #[doc = "1: Frequency counters started"]
    FREQUENCY_COUNTERS_STARTED = 1,
}
impl From<MEAS_A> for bool {
    #[inline(always)]
    fn from(variant: MEAS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `MEAS`"]
pub type MEAS_R = crate::R<bool, MEAS_A>;
impl MEAS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MEAS_A {
        match self.bits {
            false => MEAS_A::RCNT_AND_FCNT_DISABLED,
            true => MEAS_A::FREQUENCY_COUNTERS_STARTED,
        }
    }
    #[doc = "Checks if the value of the field is `RCNT_AND_FCNT_DISABLED`"]
    #[inline(always)]
    pub fn is_rcnt_and_fcnt_disabled(&self) -> bool {
        *self == MEAS_A::RCNT_AND_FCNT_DISABLED
    }
    #[doc = "Checks if the value of the field is `FREQUENCY_COUNTERS_STARTED`"]
    #[inline(always)]
    pub fn is_frequency_counters_started(&self) -> bool {
        *self == MEAS_A::FREQUENCY_COUNTERS_STARTED
    }
}
#[doc = "Write proxy for field `MEAS`"]
pub struct MEAS_W<'a> {
    w: &'a mut W,
}
impl<'a> MEAS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MEAS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "RCNT and FCNT disabled"]
    #[inline(always)]
    pub fn rcnt_and_fcnt_disabled(self) -> &'a mut W {
        self.variant(MEAS_A::RCNT_AND_FCNT_DISABLED)
    }
    #[doc = "Frequency counters started"]
    #[inline(always)]
    pub fn frequency_counters_started(self) -> &'a mut W {
        self.variant(MEAS_A::FREQUENCY_COUNTERS_STARTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 23)) | (((value as u32) & 0x01) << 23);
        self.w
    }
}
#[doc = "Clock-source selection for the clock to be measured. All other values are reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CLK_SEL_A {
    #[doc = "0: 32 kHz oscillator (default)"]
    _32_KHZ_OSCILLATOR_D = 0,
    #[doc = "1: IRC"]
    IRC = 1,
    #[doc = "2: ENET_RX_CLK"]
    ENET_RX_CLK = 2,
    #[doc = "3: ENET_TX_CLK"]
    ENET_TX_CLK = 3,
    #[doc = "4: GP_CLKIN"]
    GP_CLKIN = 4,
    #[doc = "6: Crystal oscillator"]
    CRYSTAL_OSCILLATOR = 6,
    #[doc = "7: PLL0USB"]
    PLL0USB = 7,
    #[doc = "8: PLL0AUDIO"]
    PLL0AUDIO = 8,
    #[doc = "9: PLL1"]
    PLL1 = 9,
    #[doc = "12: IDIVA"]
    IDIVA = 12,
    #[doc = "13: IDIVB"]
    IDIVB = 13,
    #[doc = "14: IDIVC"]
    IDIVC = 14,
    #[doc = "15: IDIVD"]
    IDIVD = 15,
    #[doc = "16: IDIVE"]
    IDIVE = 16,
}
impl From<CLK_SEL_A> for u8 {
    #[inline(always)]
    fn from(variant: CLK_SEL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CLK_SEL`"]
pub type CLK_SEL_R = crate::R<u8, CLK_SEL_A>;
impl CLK_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, CLK_SEL_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(CLK_SEL_A::_32_KHZ_OSCILLATOR_D),
            1 => Val(CLK_SEL_A::IRC),
            2 => Val(CLK_SEL_A::ENET_RX_CLK),
            3 => Val(CLK_SEL_A::ENET_TX_CLK),
            4 => Val(CLK_SEL_A::GP_CLKIN),
            6 => Val(CLK_SEL_A::CRYSTAL_OSCILLATOR),
            7 => Val(CLK_SEL_A::PLL0USB),
            8 => Val(CLK_SEL_A::PLL0AUDIO),
            9 => Val(CLK_SEL_A::PLL1),
            12 => Val(CLK_SEL_A::IDIVA),
            13 => Val(CLK_SEL_A::IDIVB),
            14 => Val(CLK_SEL_A::IDIVC),
            15 => Val(CLK_SEL_A::IDIVD),
            16 => Val(CLK_SEL_A::IDIVE),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `_32_KHZ_OSCILLATOR_D`"]
    #[inline(always)]
    pub fn is_32_khz_oscillator_d(&self) -> bool {
        *self == CLK_SEL_A::_32_KHZ_OSCILLATOR_D
    }
    #[doc = "Checks if the value of the field is `IRC`"]
    #[inline(always)]
    pub fn is_irc(&self) -> bool {
        *self == CLK_SEL_A::IRC
    }
    #[doc = "Checks if the value of the field is `ENET_RX_CLK`"]
    #[inline(always)]
    pub fn is_enet_rx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_RX_CLK
    }
    #[doc = "Checks if the value of the field is `ENET_TX_CLK`"]
    #[inline(always)]
    pub fn is_enet_tx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_TX_CLK
    }
    #[doc = "Checks if the value of the field is `GP_CLKIN`"]
    #[inline(always)]
    pub fn is_gp_clkin(&self) -> bool {
        *self == CLK_SEL_A::GP_CLKIN
    }
    #[doc = "Checks if the value of the field is `CRYSTAL_OSCILLATOR`"]
    #[inline(always)]
    pub fn is_crystal_oscillator(&self) -> bool {
        *self == CLK_SEL_A::CRYSTAL_OSCILLATOR
    }
    #[doc = "Checks if the value of the field is `PLL0USB`"]
    #[inline(always)]
    pub fn is_pll0usb(&self) -> bool {
        *self == CLK_SEL_A::PLL0USB
    }
    #[doc = "Checks if the value of the field is `PLL0AUDIO`"]
    #[inline(always)]
    pub fn is_pll0audio(&self) -> bool {
        *self == CLK_SEL_A::PLL0AUDIO
    }
    #[doc = "Checks if the value of the field is `PLL1`"]
    #[inline(always)]
    pub fn is_pll1(&self) -> bool {
        *self == CLK_SEL_A::PLL1
    }
    #[doc = "Checks if the value of the field is `IDIVA`"]
    #[inline(always)]
    pub fn is_idiva(&self) -> bool {
        *self == CLK_SEL_A::IDIVA
    }
    #[doc = "Checks if the value of the field is `IDIVB`"]
    #[inline(always)]
    pub fn is_idivb(&self) -> bool {
        *self == CLK_SEL_A::IDIVB
    }
    #[doc = "Checks if the value of the field is `IDIVC`"]
    #[inline(always)]
    pub fn is_idivc(&self) -> bool {
        *self == CLK_SEL_A::IDIVC
    }
    #[doc = "Checks if the value of the field is `IDIVD`"]
    #[inline(always)]
    pub fn is_idivd(&self) -> bool {
        *self == CLK_SEL_A::IDIVD
    }
    #[doc = "Checks if the value of the field is `IDIVE`"]
    #[inline(always)]
    pub fn is_idive(&self) -> bool {
        *self == CLK_SEL_A::IDIVE
    }
}
#[doc = "Write proxy for field `CLK_SEL`"]
pub struct CLK_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_SEL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "32 kHz oscillator (default)"]
    #[inline(always)]
    pub fn _32_khz_oscillator_d(self) -> &'a mut W {
        self.variant(CLK_SEL_A::_32_KHZ_OSCILLATOR_D)
    }
    #[doc = "IRC"]
    #[inline(always)]
    pub fn irc(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IRC)
    }
    #[doc = "ENET_RX_CLK"]
    #[inline(always)]
    pub fn enet_rx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_RX_CLK)
    }
    #[doc = "ENET_TX_CLK"]
    #[inline(always)]
    pub fn enet_tx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_TX_CLK)
    }
    #[doc = "GP_CLKIN"]
    #[inline(always)]
    pub fn gp_clkin(self) -> &'a mut W {
        self.variant(CLK_SEL_A::GP_CLKIN)
    }
    #[doc = "Crystal oscillator"]
    #[inline(always)]
    pub fn crystal_oscillator(self) -> &'a mut W {
        self.variant(CLK_SEL_A::CRYSTAL_OSCILLATOR)
    }
    #[doc = "PLL0USB"]
    #[inline(always)]
    pub fn pll0usb(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL0USB)
    }
    #[doc = "PLL0AUDIO"]
    #[inline(always)]
    pub fn pll0audio(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL0AUDIO)
    }
    #[doc = "PLL1"]
    #[inline(always)]
    pub fn pll1(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL1)
    }
    #[doc = "IDIVA"]
    #[inline(always)]
    pub fn idiva(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVA)
    }
    #[doc = "IDIVB"]
    #[inline(always)]
    pub fn idivb(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVB)
    }
    #[doc = "IDIVC"]
    #[inline(always)]
    pub fn idivc(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVC)
    }
    #[doc = "IDIVD"]
    #[inline(always)]
    pub fn idivd(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVD)
    }
    #[doc = "IDIVE"]
    #[inline(always)]
    pub fn idive(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 24)) | (((value as u32) & 0x1f) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:8 - 9-bit reference clock-counter value"]
    #[inline(always)]
    pub fn rcnt(&self) -> RCNT_R {
        RCNT_R::new((self.bits & 0x01ff) as u16)
    }
    #[doc = "Bits 9:22 - 14-bit selected clock-counter value"]
    #[inline(always)]
    pub fn fcnt(&self) -> FCNT_R {
        FCNT_R::new(((self.bits >> 9) & 0x3fff) as u16)
    }
    #[doc = "Bit 23 - Measure frequency"]
    #[inline(always)]
    pub fn meas(&self) -> MEAS_R {
        MEAS_R::new(((self.bits >> 23) & 0x01) != 0)
    }
    #[doc = "Bits 24:28 - Clock-source selection for the clock to be measured. All other values are reserved."]
    #[inline(always)]
    pub fn clk_sel(&self) -> CLK_SEL_R {
        CLK_SEL_R::new(((self.bits >> 24) & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:8 - 9-bit reference clock-counter value"]
    #[inline(always)]
    pub fn rcnt(&mut self) -> RCNT_W {
        RCNT_W { w: self }
    }
    #[doc = "Bits 9:22 - 14-bit selected clock-counter value"]
    #[inline(always)]
    pub fn fcnt(&mut self) -> FCNT_W {
        FCNT_W { w: self }
    }
    #[doc = "Bit 23 - Measure frequency"]
    #[inline(always)]
    pub fn meas(&mut self) -> MEAS_W {
        MEAS_W { w: self }
    }
    #[doc = "Bits 24:28 - Clock-source selection for the clock to be measured. All other values are reserved."]
    #[inline(always)]
    pub fn clk_sel(&mut self) -> CLK_SEL_W {
        CLK_SEL_W { w: self }
    }
}
