#[doc = "Reader of register PLL0AUDIO_CTRL"]
pub type R = crate::R<u32, super::PLL0AUDIO_CTRL>;
#[doc = "Writer for register PLL0AUDIO_CTRL"]
pub type W = crate::W<u32, super::PLL0AUDIO_CTRL>;
#[doc = "Register PLL0AUDIO_CTRL `reset()`'s with value 0x0100_4003"]
impl crate::ResetValue for super::PLL0AUDIO_CTRL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0100_4003
    }
}
#[doc = "PLL0 power down\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PD_A {
    #[doc = "0: PLL0 enabled"]
    PLL0_ENABLED = 0,
    #[doc = "1: PLL0 powered down"]
    PLL0_POWERED_DOWN = 1,
}
impl From<PD_A> for bool {
    #[inline(always)]
    fn from(variant: PD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PD`"]
pub type PD_R = crate::R<bool, PD_A>;
impl PD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PD_A {
        match self.bits {
            false => PD_A::PLL0_ENABLED,
            true => PD_A::PLL0_POWERED_DOWN,
        }
    }
    #[doc = "Checks if the value of the field is `PLL0_ENABLED`"]
    #[inline(always)]
    pub fn is_pll0_enabled(&self) -> bool {
        *self == PD_A::PLL0_ENABLED
    }
    #[doc = "Checks if the value of the field is `PLL0_POWERED_DOWN`"]
    #[inline(always)]
    pub fn is_pll0_powered_down(&self) -> bool {
        *self == PD_A::PLL0_POWERED_DOWN
    }
}
#[doc = "Write proxy for field `PD`"]
pub struct PD_W<'a> {
    w: &'a mut W,
}
impl<'a> PD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "PLL0 enabled"]
    #[inline(always)]
    pub fn pll0_enabled(self) -> &'a mut W {
        self.variant(PD_A::PLL0_ENABLED)
    }
    #[doc = "PLL0 powered down"]
    #[inline(always)]
    pub fn pll0_powered_down(self) -> &'a mut W {
        self.variant(PD_A::PLL0_POWERED_DOWN)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Input clock bypass control\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BYPASS_A {
    #[doc = "0: CCO clock sent to post-dividers. Use this in normal operation."]
    CCO_CLOCK_SENT_TO_POST_DIVIDERS = 0,
    #[doc = "1: PLL0 input clock sent to post-dividers (default)."]
    PLL0_INPUT_CLOCK_SENT_TO_POST_DIVIDERS = 1,
}
impl From<BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `BYPASS`"]
pub type BYPASS_R = crate::R<bool, BYPASS_A>;
impl BYPASS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BYPASS_A {
        match self.bits {
            false => BYPASS_A::CCO_CLOCK_SENT_TO_POST_DIVIDERS,
            true => BYPASS_A::PLL0_INPUT_CLOCK_SENT_TO_POST_DIVIDERS,
        }
    }
    #[doc = "Checks if the value of the field is `CCO_CLOCK_SENT_TO_POST_DIVIDERS`"]
    #[inline(always)]
    pub fn is_cco_clock_sent_to_post_dividers(&self) -> bool {
        *self == BYPASS_A::CCO_CLOCK_SENT_TO_POST_DIVIDERS
    }
    #[doc = "Checks if the value of the field is `PLL0_INPUT_CLOCK_SENT_TO_POST_DIVIDERS`"]
    #[inline(always)]
    pub fn is_pll0_input_clock_sent_to_post_dividers(&self) -> bool {
        *self == BYPASS_A::PLL0_INPUT_CLOCK_SENT_TO_POST_DIVIDERS
    }
}
#[doc = "Write proxy for field `BYPASS`"]
pub struct BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BYPASS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "CCO clock sent to post-dividers. Use this in normal operation."]
    #[inline(always)]
    pub fn cco_clock_sent_to_post_dividers(self) -> &'a mut W {
        self.variant(BYPASS_A::CCO_CLOCK_SENT_TO_POST_DIVIDERS)
    }
    #[doc = "PLL0 input clock sent to post-dividers (default)."]
    #[inline(always)]
    pub fn pll0_input_clock_sent_to_post_dividers(self) -> &'a mut W {
        self.variant(BYPASS_A::PLL0_INPUT_CLOCK_SENT_TO_POST_DIVIDERS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Reader of field `DIRECTI`"]
pub type DIRECTI_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DIRECTI`"]
pub struct DIRECTI_W<'a> {
    w: &'a mut W,
}
impl<'a> DIRECTI_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Reader of field `DIRECTO`"]
pub type DIRECTO_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DIRECTO`"]
pub struct DIRECTO_W<'a> {
    w: &'a mut W,
}
impl<'a> DIRECTO_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Reader of field `CLKEN`"]
pub type CLKEN_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `CLKEN`"]
pub struct CLKEN_W<'a> {
    w: &'a mut W,
}
impl<'a> CLKEN_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Reader of field `FRM`"]
pub type FRM_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `FRM`"]
pub struct FRM_W<'a> {
    w: &'a mut W,
}
impl<'a> FRM_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Block clock automatically during frequency change\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AUTOBLOCK_A {
    #[doc = "0: Disabled. Autoblocking disabled"]
    DISABLED = 0,
    #[doc = "1: Enabled. Autoblocking enabled"]
    ENABLED = 1,
}
impl From<AUTOBLOCK_A> for bool {
    #[inline(always)]
    fn from(variant: AUTOBLOCK_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `AUTOBLOCK`"]
pub type AUTOBLOCK_R = crate::R<bool, AUTOBLOCK_A>;
impl AUTOBLOCK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> AUTOBLOCK_A {
        match self.bits {
            false => AUTOBLOCK_A::DISABLED,
            true => AUTOBLOCK_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == AUTOBLOCK_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == AUTOBLOCK_A::ENABLED
    }
}
#[doc = "Write proxy for field `AUTOBLOCK`"]
pub struct AUTOBLOCK_W<'a> {
    w: &'a mut W,
}
impl<'a> AUTOBLOCK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: AUTOBLOCK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Autoblocking disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::DISABLED)
    }
    #[doc = "Enabled. Autoblocking enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Reader of field `PLLFRACT_REQ`"]
pub type PLLFRACT_REQ_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `PLLFRACT_REQ`"]
pub struct PLLFRACT_REQ_W<'a> {
    w: &'a mut W,
}
impl<'a> PLLFRACT_REQ_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Select fractional divider.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SEL_EXT_A {
    #[doc = "0: FRAC Enabled. Enable fractional divider."]
    FRAC_ENABLED = 0,
    #[doc = "1: MDEC enabled. Fractional divider not used."]
    MDEC_ENABLED = 1,
}
impl From<SEL_EXT_A> for bool {
    #[inline(always)]
    fn from(variant: SEL_EXT_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SEL_EXT`"]
pub type SEL_EXT_R = crate::R<bool, SEL_EXT_A>;
impl SEL_EXT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SEL_EXT_A {
        match self.bits {
            false => SEL_EXT_A::FRAC_ENABLED,
            true => SEL_EXT_A::MDEC_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `FRAC_ENABLED`"]
    #[inline(always)]
    pub fn is_frac_enabled(&self) -> bool {
        *self == SEL_EXT_A::FRAC_ENABLED
    }
    #[doc = "Checks if the value of the field is `MDEC_ENABLED`"]
    #[inline(always)]
    pub fn is_mdec_enabled(&self) -> bool {
        *self == SEL_EXT_A::MDEC_ENABLED
    }
}
#[doc = "Write proxy for field `SEL_EXT`"]
pub struct SEL_EXT_W<'a> {
    w: &'a mut W,
}
impl<'a> SEL_EXT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SEL_EXT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "FRAC Enabled. Enable fractional divider."]
    #[inline(always)]
    pub fn frac_enabled(self) -> &'a mut W {
        self.variant(SEL_EXT_A::FRAC_ENABLED)
    }
    #[doc = "MDEC enabled. Fractional divider not used."]
    #[inline(always)]
    pub fn mdec_enabled(self) -> &'a mut W {
        self.variant(SEL_EXT_A::MDEC_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Sigma-Delta modulator power-down\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MOD_PD_A {
    #[doc = "0: Enabled. Sigma-Delta modulator enabled"]
    ENABLED = 0,
    #[doc = "1: Disabled. Sigma-Delta modulator powered down"]
    DISABLED = 1,
}
impl From<MOD_PD_A> for bool {
    #[inline(always)]
    fn from(variant: MOD_PD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `MOD_PD`"]
pub type MOD_PD_R = crate::R<bool, MOD_PD_A>;
impl MOD_PD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MOD_PD_A {
        match self.bits {
            false => MOD_PD_A::ENABLED,
            true => MOD_PD_A::DISABLED,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == MOD_PD_A::ENABLED
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == MOD_PD_A::DISABLED
    }
}
#[doc = "Write proxy for field `MOD_PD`"]
pub struct MOD_PD_W<'a> {
    w: &'a mut W,
}
impl<'a> MOD_PD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MOD_PD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enabled. Sigma-Delta modulator enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(MOD_PD_A::ENABLED)
    }
    #[doc = "Disabled. Sigma-Delta modulator powered down"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(MOD_PD_A::DISABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Clock source selection. All other values are reserved.\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CLK_SEL_A {
    #[doc = "0: 32 kHz oscillator"]
    _32_KHZ_OSCILLATOR = 0,
    #[doc = "1: IRC (default)"]
    IRC_DEFAULT = 1,
    #[doc = "2: ENET_RX_CLK"]
    ENET_RX_CLK = 2,
    #[doc = "3: ENET_TX_CLK"]
    ENET_TX_CLK = 3,
    #[doc = "4: GP_CLKIN"]
    GP_CLKIN = 4,
    #[doc = "6: Crystal oscillator"]
    CRYSTAL_OSCILLATOR = 6,
    #[doc = "9: PLL1"]
    PLL1 = 9,
    #[doc = "12: IDIVA"]
    IDIVA = 12,
    #[doc = "13: IDIVB"]
    IDIVB = 13,
    #[doc = "14: IDIVC"]
    IDIVC = 14,
    #[doc = "15: IDIVD"]
    IDIVD = 15,
    #[doc = "16: IDIVE"]
    IDIVE = 16,
}
impl From<CLK_SEL_A> for u8 {
    #[inline(always)]
    fn from(variant: CLK_SEL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CLK_SEL`"]
pub type CLK_SEL_R = crate::R<u8, CLK_SEL_A>;
impl CLK_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, CLK_SEL_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(CLK_SEL_A::_32_KHZ_OSCILLATOR),
            1 => Val(CLK_SEL_A::IRC_DEFAULT),
            2 => Val(CLK_SEL_A::ENET_RX_CLK),
            3 => Val(CLK_SEL_A::ENET_TX_CLK),
            4 => Val(CLK_SEL_A::GP_CLKIN),
            6 => Val(CLK_SEL_A::CRYSTAL_OSCILLATOR),
            9 => Val(CLK_SEL_A::PLL1),
            12 => Val(CLK_SEL_A::IDIVA),
            13 => Val(CLK_SEL_A::IDIVB),
            14 => Val(CLK_SEL_A::IDIVC),
            15 => Val(CLK_SEL_A::IDIVD),
            16 => Val(CLK_SEL_A::IDIVE),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `_32_KHZ_OSCILLATOR`"]
    #[inline(always)]
    pub fn is_32_khz_oscillator(&self) -> bool {
        *self == CLK_SEL_A::_32_KHZ_OSCILLATOR
    }
    #[doc = "Checks if the value of the field is `IRC_DEFAULT`"]
    #[inline(always)]
    pub fn is_irc_default(&self) -> bool {
        *self == CLK_SEL_A::IRC_DEFAULT
    }
    #[doc = "Checks if the value of the field is `ENET_RX_CLK`"]
    #[inline(always)]
    pub fn is_enet_rx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_RX_CLK
    }
    #[doc = "Checks if the value of the field is `ENET_TX_CLK`"]
    #[inline(always)]
    pub fn is_enet_tx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_TX_CLK
    }
    #[doc = "Checks if the value of the field is `GP_CLKIN`"]
    #[inline(always)]
    pub fn is_gp_clkin(&self) -> bool {
        *self == CLK_SEL_A::GP_CLKIN
    }
    #[doc = "Checks if the value of the field is `CRYSTAL_OSCILLATOR`"]
    #[inline(always)]
    pub fn is_crystal_oscillator(&self) -> bool {
        *self == CLK_SEL_A::CRYSTAL_OSCILLATOR
    }
    #[doc = "Checks if the value of the field is `PLL1`"]
    #[inline(always)]
    pub fn is_pll1(&self) -> bool {
        *self == CLK_SEL_A::PLL1
    }
    #[doc = "Checks if the value of the field is `IDIVA`"]
    #[inline(always)]
    pub fn is_idiva(&self) -> bool {
        *self == CLK_SEL_A::IDIVA
    }
    #[doc = "Checks if the value of the field is `IDIVB`"]
    #[inline(always)]
    pub fn is_idivb(&self) -> bool {
        *self == CLK_SEL_A::IDIVB
    }
    #[doc = "Checks if the value of the field is `IDIVC`"]
    #[inline(always)]
    pub fn is_idivc(&self) -> bool {
        *self == CLK_SEL_A::IDIVC
    }
    #[doc = "Checks if the value of the field is `IDIVD`"]
    #[inline(always)]
    pub fn is_idivd(&self) -> bool {
        *self == CLK_SEL_A::IDIVD
    }
    #[doc = "Checks if the value of the field is `IDIVE`"]
    #[inline(always)]
    pub fn is_idive(&self) -> bool {
        *self == CLK_SEL_A::IDIVE
    }
}
#[doc = "Write proxy for field `CLK_SEL`"]
pub struct CLK_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_SEL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "32 kHz oscillator"]
    #[inline(always)]
    pub fn _32_khz_oscillator(self) -> &'a mut W {
        self.variant(CLK_SEL_A::_32_KHZ_OSCILLATOR)
    }
    #[doc = "IRC (default)"]
    #[inline(always)]
    pub fn irc_default(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IRC_DEFAULT)
    }
    #[doc = "ENET_RX_CLK"]
    #[inline(always)]
    pub fn enet_rx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_RX_CLK)
    }
    #[doc = "ENET_TX_CLK"]
    #[inline(always)]
    pub fn enet_tx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_TX_CLK)
    }
    #[doc = "GP_CLKIN"]
    #[inline(always)]
    pub fn gp_clkin(self) -> &'a mut W {
        self.variant(CLK_SEL_A::GP_CLKIN)
    }
    #[doc = "Crystal oscillator"]
    #[inline(always)]
    pub fn crystal_oscillator(self) -> &'a mut W {
        self.variant(CLK_SEL_A::CRYSTAL_OSCILLATOR)
    }
    #[doc = "PLL1"]
    #[inline(always)]
    pub fn pll1(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL1)
    }
    #[doc = "IDIVA"]
    #[inline(always)]
    pub fn idiva(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVA)
    }
    #[doc = "IDIVB"]
    #[inline(always)]
    pub fn idivb(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVB)
    }
    #[doc = "IDIVC"]
    #[inline(always)]
    pub fn idivc(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVC)
    }
    #[doc = "IDIVD"]
    #[inline(always)]
    pub fn idivd(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVD)
    }
    #[doc = "IDIVE"]
    #[inline(always)]
    pub fn idive(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 24)) | (((value as u32) & 0x1f) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - PLL0 power down"]
    #[inline(always)]
    pub fn pd(&self) -> PD_R {
        PD_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Input clock bypass control"]
    #[inline(always)]
    pub fn bypass(&self) -> BYPASS_R {
        BYPASS_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - PLL0 direct input"]
    #[inline(always)]
    pub fn directi(&self) -> DIRECTI_R {
        DIRECTI_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - PLL0 direct output"]
    #[inline(always)]
    pub fn directo(&self) -> DIRECTO_R {
        DIRECTO_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - PLL0 clock enable"]
    #[inline(always)]
    pub fn clken(&self) -> CLKEN_R {
        CLKEN_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Free running mode"]
    #[inline(always)]
    pub fn frm(&self) -> FRM_R {
        FRM_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&self) -> AUTOBLOCK_R {
        AUTOBLOCK_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Fractional PLL word write request. Set this bit to 1 if the fractional divider is enabled in the SEL_EXT bit."]
    #[inline(always)]
    pub fn pllfract_req(&self) -> PLLFRACT_REQ_R {
        PLLFRACT_REQ_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Select fractional divider."]
    #[inline(always)]
    pub fn sel_ext(&self) -> SEL_EXT_R {
        SEL_EXT_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Sigma-Delta modulator power-down"]
    #[inline(always)]
    pub fn mod_pd(&self) -> MOD_PD_R {
        MOD_PD_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bits 24:28 - Clock source selection. All other values are reserved."]
    #[inline(always)]
    pub fn clk_sel(&self) -> CLK_SEL_R {
        CLK_SEL_R::new(((self.bits >> 24) & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - PLL0 power down"]
    #[inline(always)]
    pub fn pd(&mut self) -> PD_W {
        PD_W { w: self }
    }
    #[doc = "Bit 1 - Input clock bypass control"]
    #[inline(always)]
    pub fn bypass(&mut self) -> BYPASS_W {
        BYPASS_W { w: self }
    }
    #[doc = "Bit 2 - PLL0 direct input"]
    #[inline(always)]
    pub fn directi(&mut self) -> DIRECTI_W {
        DIRECTI_W { w: self }
    }
    #[doc = "Bit 3 - PLL0 direct output"]
    #[inline(always)]
    pub fn directo(&mut self) -> DIRECTO_W {
        DIRECTO_W { w: self }
    }
    #[doc = "Bit 4 - PLL0 clock enable"]
    #[inline(always)]
    pub fn clken(&mut self) -> CLKEN_W {
        CLKEN_W { w: self }
    }
    #[doc = "Bit 6 - Free running mode"]
    #[inline(always)]
    pub fn frm(&mut self) -> FRM_W {
        FRM_W { w: self }
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&mut self) -> AUTOBLOCK_W {
        AUTOBLOCK_W { w: self }
    }
    #[doc = "Bit 12 - Fractional PLL word write request. Set this bit to 1 if the fractional divider is enabled in the SEL_EXT bit."]
    #[inline(always)]
    pub fn pllfract_req(&mut self) -> PLLFRACT_REQ_W {
        PLLFRACT_REQ_W { w: self }
    }
    #[doc = "Bit 13 - Select fractional divider."]
    #[inline(always)]
    pub fn sel_ext(&mut self) -> SEL_EXT_W {
        SEL_EXT_W { w: self }
    }
    #[doc = "Bit 14 - Sigma-Delta modulator power-down"]
    #[inline(always)]
    pub fn mod_pd(&mut self) -> MOD_PD_W {
        MOD_PD_W { w: self }
    }
    #[doc = "Bits 24:28 - Clock source selection. All other values are reserved."]
    #[inline(always)]
    pub fn clk_sel(&mut self) -> CLK_SEL_W {
        CLK_SEL_W { w: self }
    }
}
