#[doc = "Reader of register PLL1_CTRL"]
pub type R = crate::R<u32, super::PLL1_CTRL>;
#[doc = "Writer for register PLL1_CTRL"]
pub type W = crate::W<u32, super::PLL1_CTRL>;
#[doc = "Register PLL1_CTRL `reset()`'s with value 0x0100_0003"]
impl crate::ResetValue for super::PLL1_CTRL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0100_0003
    }
}
#[doc = "PLL1 power down\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PD_A {
    #[doc = "0: PLL1 enabled"]
    PLL1_ENABLED = 0,
    #[doc = "1: PLL1 powered down"]
    PLL1_POWERED_DOWN = 1,
}
impl From<PD_A> for bool {
    #[inline(always)]
    fn from(variant: PD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PD`"]
pub type PD_R = crate::R<bool, PD_A>;
impl PD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PD_A {
        match self.bits {
            false => PD_A::PLL1_ENABLED,
            true => PD_A::PLL1_POWERED_DOWN,
        }
    }
    #[doc = "Checks if the value of the field is `PLL1_ENABLED`"]
    #[inline(always)]
    pub fn is_pll1_enabled(&self) -> bool {
        *self == PD_A::PLL1_ENABLED
    }
    #[doc = "Checks if the value of the field is `PLL1_POWERED_DOWN`"]
    #[inline(always)]
    pub fn is_pll1_powered_down(&self) -> bool {
        *self == PD_A::PLL1_POWERED_DOWN
    }
}
#[doc = "Write proxy for field `PD`"]
pub struct PD_W<'a> {
    w: &'a mut W,
}
impl<'a> PD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "PLL1 enabled"]
    #[inline(always)]
    pub fn pll1_enabled(self) -> &'a mut W {
        self.variant(PD_A::PLL1_ENABLED)
    }
    #[doc = "PLL1 powered down"]
    #[inline(always)]
    pub fn pll1_powered_down(self) -> &'a mut W {
        self.variant(PD_A::PLL1_POWERED_DOWN)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Input clock bypass control\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BYPASS_A {
    #[doc = "0: Normal. CCO clock sent to post-dividers. Use for normal operation."]
    NORMAL = 0,
    #[doc = "1: Input clock. PLL1 input clock sent to post-dividers (default)."]
    INPUT_CLOCK = 1,
}
impl From<BYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: BYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `BYPASS`"]
pub type BYPASS_R = crate::R<bool, BYPASS_A>;
impl BYPASS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BYPASS_A {
        match self.bits {
            false => BYPASS_A::NORMAL,
            true => BYPASS_A::INPUT_CLOCK,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        *self == BYPASS_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `INPUT_CLOCK`"]
    #[inline(always)]
    pub fn is_input_clock(&self) -> bool {
        *self == BYPASS_A::INPUT_CLOCK
    }
}
#[doc = "Write proxy for field `BYPASS`"]
pub struct BYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> BYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BYPASS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Normal. CCO clock sent to post-dividers. Use for normal operation."]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(BYPASS_A::NORMAL)
    }
    #[doc = "Input clock. PLL1 input clock sent to post-dividers (default)."]
    #[inline(always)]
    pub fn input_clock(self) -> &'a mut W {
        self.variant(BYPASS_A::INPUT_CLOCK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "PLL feedback select.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FBSEL_A {
    #[doc = "0: CCO out. CCO output is used as feedback divider input clock."]
    CCO_OUT = 0,
    #[doc = "1: PLL out. PLL output clock (clkout) is used as feedback divider input clock. Use for normal operation."]
    PLL_OUT = 1,
}
impl From<FBSEL_A> for bool {
    #[inline(always)]
    fn from(variant: FBSEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `FBSEL`"]
pub type FBSEL_R = crate::R<bool, FBSEL_A>;
impl FBSEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FBSEL_A {
        match self.bits {
            false => FBSEL_A::CCO_OUT,
            true => FBSEL_A::PLL_OUT,
        }
    }
    #[doc = "Checks if the value of the field is `CCO_OUT`"]
    #[inline(always)]
    pub fn is_cco_out(&self) -> bool {
        *self == FBSEL_A::CCO_OUT
    }
    #[doc = "Checks if the value of the field is `PLL_OUT`"]
    #[inline(always)]
    pub fn is_pll_out(&self) -> bool {
        *self == FBSEL_A::PLL_OUT
    }
}
#[doc = "Write proxy for field `FBSEL`"]
pub struct FBSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> FBSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FBSEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "CCO out. CCO output is used as feedback divider input clock."]
    #[inline(always)]
    pub fn cco_out(self) -> &'a mut W {
        self.variant(FBSEL_A::CCO_OUT)
    }
    #[doc = "PLL out. PLL output clock (clkout) is used as feedback divider input clock. Use for normal operation."]
    #[inline(always)]
    pub fn pll_out(self) -> &'a mut W {
        self.variant(FBSEL_A::PLL_OUT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "PLL direct CCO output\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DIRECT_A {
    #[doc = "0: Disabled"]
    DISABLED = 0,
    #[doc = "1: Enabled"]
    ENABLED = 1,
}
impl From<DIRECT_A> for bool {
    #[inline(always)]
    fn from(variant: DIRECT_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `DIRECT`"]
pub type DIRECT_R = crate::R<bool, DIRECT_A>;
impl DIRECT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DIRECT_A {
        match self.bits {
            false => DIRECT_A::DISABLED,
            true => DIRECT_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == DIRECT_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == DIRECT_A::ENABLED
    }
}
#[doc = "Write proxy for field `DIRECT`"]
pub struct DIRECT_W<'a> {
    w: &'a mut W,
}
impl<'a> DIRECT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DIRECT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(DIRECT_A::DISABLED)
    }
    #[doc = "Enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(DIRECT_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Post-divider division ratio P. The value applied is 2xP.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PSEL_A {
    #[doc = "0: 1"]
    _1 = 0,
    #[doc = "1: 2 (default)"]
    PEQ2 = 1,
    #[doc = "2: 4"]
    PEQ4 = 2,
    #[doc = "3: 8"]
    _8 = 3,
}
impl From<PSEL_A> for u8 {
    #[inline(always)]
    fn from(variant: PSEL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PSEL`"]
pub type PSEL_R = crate::R<u8, PSEL_A>;
impl PSEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PSEL_A {
        match self.bits {
            0 => PSEL_A::_1,
            1 => PSEL_A::PEQ2,
            2 => PSEL_A::PEQ4,
            3 => PSEL_A::_8,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `_1`"]
    #[inline(always)]
    pub fn is_1(&self) -> bool {
        *self == PSEL_A::_1
    }
    #[doc = "Checks if the value of the field is `PEQ2`"]
    #[inline(always)]
    pub fn is_peq2(&self) -> bool {
        *self == PSEL_A::PEQ2
    }
    #[doc = "Checks if the value of the field is `PEQ4`"]
    #[inline(always)]
    pub fn is_peq4(&self) -> bool {
        *self == PSEL_A::PEQ4
    }
    #[doc = "Checks if the value of the field is `_8`"]
    #[inline(always)]
    pub fn is_8(&self) -> bool {
        *self == PSEL_A::_8
    }
}
#[doc = "Write proxy for field `PSEL`"]
pub struct PSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> PSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PSEL_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "1"]
    #[inline(always)]
    pub fn _1(self) -> &'a mut W {
        self.variant(PSEL_A::_1)
    }
    #[doc = "2 (default)"]
    #[inline(always)]
    pub fn peq2(self) -> &'a mut W {
        self.variant(PSEL_A::PEQ2)
    }
    #[doc = "4"]
    #[inline(always)]
    pub fn peq4(self) -> &'a mut W {
        self.variant(PSEL_A::PEQ4)
    }
    #[doc = "8"]
    #[inline(always)]
    pub fn _8(self) -> &'a mut W {
        self.variant(PSEL_A::_8)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 8)) | (((value as u32) & 0x03) << 8);
        self.w
    }
}
#[doc = "Block clock automatically during frequency change\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AUTOBLOCK_A {
    #[doc = "0: Disabled. Autoblocking disabled"]
    DISABLED = 0,
    #[doc = "1: Enabled. Autoblocking enabled"]
    ENABLED = 1,
}
impl From<AUTOBLOCK_A> for bool {
    #[inline(always)]
    fn from(variant: AUTOBLOCK_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `AUTOBLOCK`"]
pub type AUTOBLOCK_R = crate::R<bool, AUTOBLOCK_A>;
impl AUTOBLOCK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> AUTOBLOCK_A {
        match self.bits {
            false => AUTOBLOCK_A::DISABLED,
            true => AUTOBLOCK_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == AUTOBLOCK_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == AUTOBLOCK_A::ENABLED
    }
}
#[doc = "Write proxy for field `AUTOBLOCK`"]
pub struct AUTOBLOCK_W<'a> {
    w: &'a mut W,
}
impl<'a> AUTOBLOCK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: AUTOBLOCK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Autoblocking disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::DISABLED)
    }
    #[doc = "Enabled. Autoblocking enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Pre-divider division ratio N\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum NSEL_A {
    #[doc = "0: 1"]
    _1 = 0,
    #[doc = "1: 2"]
    NEQ2 = 1,
    #[doc = "2: 3 (default)"]
    NEQ3 = 2,
    #[doc = "3: 4"]
    _4 = 3,
}
impl From<NSEL_A> for u8 {
    #[inline(always)]
    fn from(variant: NSEL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `NSEL`"]
pub type NSEL_R = crate::R<u8, NSEL_A>;
impl NSEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> NSEL_A {
        match self.bits {
            0 => NSEL_A::_1,
            1 => NSEL_A::NEQ2,
            2 => NSEL_A::NEQ3,
            3 => NSEL_A::_4,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `_1`"]
    #[inline(always)]
    pub fn is_1(&self) -> bool {
        *self == NSEL_A::_1
    }
    #[doc = "Checks if the value of the field is `NEQ2`"]
    #[inline(always)]
    pub fn is_neq2(&self) -> bool {
        *self == NSEL_A::NEQ2
    }
    #[doc = "Checks if the value of the field is `NEQ3`"]
    #[inline(always)]
    pub fn is_neq3(&self) -> bool {
        *self == NSEL_A::NEQ3
    }
    #[doc = "Checks if the value of the field is `_4`"]
    #[inline(always)]
    pub fn is_4(&self) -> bool {
        *self == NSEL_A::_4
    }
}
#[doc = "Write proxy for field `NSEL`"]
pub struct NSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> NSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: NSEL_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "1"]
    #[inline(always)]
    pub fn _1(self) -> &'a mut W {
        self.variant(NSEL_A::_1)
    }
    #[doc = "2"]
    #[inline(always)]
    pub fn neq2(self) -> &'a mut W {
        self.variant(NSEL_A::NEQ2)
    }
    #[doc = "3 (default)"]
    #[inline(always)]
    pub fn neq3(self) -> &'a mut W {
        self.variant(NSEL_A::NEQ3)
    }
    #[doc = "4"]
    #[inline(always)]
    pub fn _4(self) -> &'a mut W {
        self.variant(NSEL_A::_4)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 12)) | (((value as u32) & 0x03) << 12);
        self.w
    }
}
#[doc = "Reader of field `MSEL`"]
pub type MSEL_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `MSEL`"]
pub struct MSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> MSEL_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 16)) | (((value as u32) & 0xff) << 16);
        self.w
    }
}
#[doc = "Clock-source selection.\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CLK_SEL_A {
    #[doc = "0: 32 kHz oscillator"]
    _32_KHZ_OSCILLATOR = 0,
    #[doc = "1: IRC (default)"]
    IRC_DEFAULT = 1,
    #[doc = "2: ENET_RX_CLK"]
    ENET_RX_CLK = 2,
    #[doc = "3: ENET_TX_CLK"]
    ENET_TX_CLK = 3,
    #[doc = "4: GP_CLKIN"]
    GP_CLKIN = 4,
    #[doc = "6: Crystal oscillator"]
    CRYSTAL_OSCILLATOR = 6,
    #[doc = "7: PLL0USB"]
    PLL0USB = 7,
    #[doc = "8: PLL0AUDIO"]
    PLL0AUDIO = 8,
    #[doc = "12: IDIVA"]
    IDIVA = 12,
    #[doc = "13: IDIVB"]
    IDIVB = 13,
    #[doc = "14: IDIVC"]
    IDIVC = 14,
    #[doc = "15: IDIVD"]
    IDIVD = 15,
    #[doc = "16: IDIVE"]
    IDIVE = 16,
}
impl From<CLK_SEL_A> for u8 {
    #[inline(always)]
    fn from(variant: CLK_SEL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CLK_SEL`"]
pub type CLK_SEL_R = crate::R<u8, CLK_SEL_A>;
impl CLK_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, CLK_SEL_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(CLK_SEL_A::_32_KHZ_OSCILLATOR),
            1 => Val(CLK_SEL_A::IRC_DEFAULT),
            2 => Val(CLK_SEL_A::ENET_RX_CLK),
            3 => Val(CLK_SEL_A::ENET_TX_CLK),
            4 => Val(CLK_SEL_A::GP_CLKIN),
            6 => Val(CLK_SEL_A::CRYSTAL_OSCILLATOR),
            7 => Val(CLK_SEL_A::PLL0USB),
            8 => Val(CLK_SEL_A::PLL0AUDIO),
            12 => Val(CLK_SEL_A::IDIVA),
            13 => Val(CLK_SEL_A::IDIVB),
            14 => Val(CLK_SEL_A::IDIVC),
            15 => Val(CLK_SEL_A::IDIVD),
            16 => Val(CLK_SEL_A::IDIVE),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `_32_KHZ_OSCILLATOR`"]
    #[inline(always)]
    pub fn is_32_khz_oscillator(&self) -> bool {
        *self == CLK_SEL_A::_32_KHZ_OSCILLATOR
    }
    #[doc = "Checks if the value of the field is `IRC_DEFAULT`"]
    #[inline(always)]
    pub fn is_irc_default(&self) -> bool {
        *self == CLK_SEL_A::IRC_DEFAULT
    }
    #[doc = "Checks if the value of the field is `ENET_RX_CLK`"]
    #[inline(always)]
    pub fn is_enet_rx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_RX_CLK
    }
    #[doc = "Checks if the value of the field is `ENET_TX_CLK`"]
    #[inline(always)]
    pub fn is_enet_tx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_TX_CLK
    }
    #[doc = "Checks if the value of the field is `GP_CLKIN`"]
    #[inline(always)]
    pub fn is_gp_clkin(&self) -> bool {
        *self == CLK_SEL_A::GP_CLKIN
    }
    #[doc = "Checks if the value of the field is `CRYSTAL_OSCILLATOR`"]
    #[inline(always)]
    pub fn is_crystal_oscillator(&self) -> bool {
        *self == CLK_SEL_A::CRYSTAL_OSCILLATOR
    }
    #[doc = "Checks if the value of the field is `PLL0USB`"]
    #[inline(always)]
    pub fn is_pll0usb(&self) -> bool {
        *self == CLK_SEL_A::PLL0USB
    }
    #[doc = "Checks if the value of the field is `PLL0AUDIO`"]
    #[inline(always)]
    pub fn is_pll0audio(&self) -> bool {
        *self == CLK_SEL_A::PLL0AUDIO
    }
    #[doc = "Checks if the value of the field is `IDIVA`"]
    #[inline(always)]
    pub fn is_idiva(&self) -> bool {
        *self == CLK_SEL_A::IDIVA
    }
    #[doc = "Checks if the value of the field is `IDIVB`"]
    #[inline(always)]
    pub fn is_idivb(&self) -> bool {
        *self == CLK_SEL_A::IDIVB
    }
    #[doc = "Checks if the value of the field is `IDIVC`"]
    #[inline(always)]
    pub fn is_idivc(&self) -> bool {
        *self == CLK_SEL_A::IDIVC
    }
    #[doc = "Checks if the value of the field is `IDIVD`"]
    #[inline(always)]
    pub fn is_idivd(&self) -> bool {
        *self == CLK_SEL_A::IDIVD
    }
    #[doc = "Checks if the value of the field is `IDIVE`"]
    #[inline(always)]
    pub fn is_idive(&self) -> bool {
        *self == CLK_SEL_A::IDIVE
    }
}
#[doc = "Write proxy for field `CLK_SEL`"]
pub struct CLK_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_SEL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "32 kHz oscillator"]
    #[inline(always)]
    pub fn _32_khz_oscillator(self) -> &'a mut W {
        self.variant(CLK_SEL_A::_32_KHZ_OSCILLATOR)
    }
    #[doc = "IRC (default)"]
    #[inline(always)]
    pub fn irc_default(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IRC_DEFAULT)
    }
    #[doc = "ENET_RX_CLK"]
    #[inline(always)]
    pub fn enet_rx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_RX_CLK)
    }
    #[doc = "ENET_TX_CLK"]
    #[inline(always)]
    pub fn enet_tx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_TX_CLK)
    }
    #[doc = "GP_CLKIN"]
    #[inline(always)]
    pub fn gp_clkin(self) -> &'a mut W {
        self.variant(CLK_SEL_A::GP_CLKIN)
    }
    #[doc = "Crystal oscillator"]
    #[inline(always)]
    pub fn crystal_oscillator(self) -> &'a mut W {
        self.variant(CLK_SEL_A::CRYSTAL_OSCILLATOR)
    }
    #[doc = "PLL0USB"]
    #[inline(always)]
    pub fn pll0usb(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL0USB)
    }
    #[doc = "PLL0AUDIO"]
    #[inline(always)]
    pub fn pll0audio(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL0AUDIO)
    }
    #[doc = "IDIVA"]
    #[inline(always)]
    pub fn idiva(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVA)
    }
    #[doc = "IDIVB"]
    #[inline(always)]
    pub fn idivb(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVB)
    }
    #[doc = "IDIVC"]
    #[inline(always)]
    pub fn idivc(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVC)
    }
    #[doc = "IDIVD"]
    #[inline(always)]
    pub fn idivd(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVD)
    }
    #[doc = "IDIVE"]
    #[inline(always)]
    pub fn idive(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 24)) | (((value as u32) & 0x1f) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - PLL1 power down"]
    #[inline(always)]
    pub fn pd(&self) -> PD_R {
        PD_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Input clock bypass control"]
    #[inline(always)]
    pub fn bypass(&self) -> BYPASS_R {
        BYPASS_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 6 - PLL feedback select."]
    #[inline(always)]
    pub fn fbsel(&self) -> FBSEL_R {
        FBSEL_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - PLL direct CCO output"]
    #[inline(always)]
    pub fn direct(&self) -> DIRECT_R {
        DIRECT_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bits 8:9 - Post-divider division ratio P. The value applied is 2xP."]
    #[inline(always)]
    pub fn psel(&self) -> PSEL_R {
        PSEL_R::new(((self.bits >> 8) & 0x03) as u8)
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&self) -> AUTOBLOCK_R {
        AUTOBLOCK_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bits 12:13 - Pre-divider division ratio N"]
    #[inline(always)]
    pub fn nsel(&self) -> NSEL_R {
        NSEL_R::new(((self.bits >> 12) & 0x03) as u8)
    }
    #[doc = "Bits 16:23 - Feedback-divider division ratio (M) 00000000 = 1 00000001 = 2 ... 11111111 = 256"]
    #[inline(always)]
    pub fn msel(&self) -> MSEL_R {
        MSEL_R::new(((self.bits >> 16) & 0xff) as u8)
    }
    #[doc = "Bits 24:28 - Clock-source selection."]
    #[inline(always)]
    pub fn clk_sel(&self) -> CLK_SEL_R {
        CLK_SEL_R::new(((self.bits >> 24) & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - PLL1 power down"]
    #[inline(always)]
    pub fn pd(&mut self) -> PD_W {
        PD_W { w: self }
    }
    #[doc = "Bit 1 - Input clock bypass control"]
    #[inline(always)]
    pub fn bypass(&mut self) -> BYPASS_W {
        BYPASS_W { w: self }
    }
    #[doc = "Bit 6 - PLL feedback select."]
    #[inline(always)]
    pub fn fbsel(&mut self) -> FBSEL_W {
        FBSEL_W { w: self }
    }
    #[doc = "Bit 7 - PLL direct CCO output"]
    #[inline(always)]
    pub fn direct(&mut self) -> DIRECT_W {
        DIRECT_W { w: self }
    }
    #[doc = "Bits 8:9 - Post-divider division ratio P. The value applied is 2xP."]
    #[inline(always)]
    pub fn psel(&mut self) -> PSEL_W {
        PSEL_W { w: self }
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&mut self) -> AUTOBLOCK_W {
        AUTOBLOCK_W { w: self }
    }
    #[doc = "Bits 12:13 - Pre-divider division ratio N"]
    #[inline(always)]
    pub fn nsel(&mut self) -> NSEL_W {
        NSEL_W { w: self }
    }
    #[doc = "Bits 16:23 - Feedback-divider division ratio (M) 00000000 = 1 00000001 = 2 ... 11111111 = 256"]
    #[inline(always)]
    pub fn msel(&mut self) -> MSEL_W {
        MSEL_W { w: self }
    }
    #[doc = "Bits 24:28 - Clock-source selection."]
    #[inline(always)]
    pub fn clk_sel(&mut self) -> CLK_SEL_W {
        CLK_SEL_W { w: self }
    }
}
