#[doc = "Reader of register CREG0"]
pub type R = crate::R<u32, super::CREG0>;
#[doc = "Writer for register CREG0"]
pub type W = crate::W<u32, super::CREG0>;
#[doc = "Register CREG0 `reset()`'s with value 0"]
impl crate::ResetValue for super::CREG0 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Enable 1 kHz output.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EN1KHZ_A {
    #[doc = "0: 1 kHz output disabled."]
    _1_KHZ_OUTPUT_DISABLED = 0,
    #[doc = "1: 1 kHz output enabled."]
    _1_KHZ_OUTPUT_ENABLED = 1,
}
impl From<EN1KHZ_A> for bool {
    #[inline(always)]
    fn from(variant: EN1KHZ_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EN1KHZ`"]
pub type EN1KHZ_R = crate::R<bool, EN1KHZ_A>;
impl EN1KHZ_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EN1KHZ_A {
        match self.bits {
            false => EN1KHZ_A::_1_KHZ_OUTPUT_DISABLED,
            true => EN1KHZ_A::_1_KHZ_OUTPUT_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `_1_KHZ_OUTPUT_DISABLED`"]
    #[inline(always)]
    pub fn is_1_khz_output_disabled(&self) -> bool {
        *self == EN1KHZ_A::_1_KHZ_OUTPUT_DISABLED
    }
    #[doc = "Checks if the value of the field is `_1_KHZ_OUTPUT_ENABLED`"]
    #[inline(always)]
    pub fn is_1_khz_output_enabled(&self) -> bool {
        *self == EN1KHZ_A::_1_KHZ_OUTPUT_ENABLED
    }
}
#[doc = "Write proxy for field `EN1KHZ`"]
pub struct EN1KHZ_W<'a> {
    w: &'a mut W,
}
impl<'a> EN1KHZ_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EN1KHZ_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "1 kHz output disabled."]
    #[inline(always)]
    pub fn _1_khz_output_disabled(self) -> &'a mut W {
        self.variant(EN1KHZ_A::_1_KHZ_OUTPUT_DISABLED)
    }
    #[doc = "1 kHz output enabled."]
    #[inline(always)]
    pub fn _1_khz_output_enabled(self) -> &'a mut W {
        self.variant(EN1KHZ_A::_1_KHZ_OUTPUT_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Enable 32 kHz output\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EN32KHZ_A {
    #[doc = "0: 32 kHz output disabled."]
    _32_KHZ_OUTPUT_DISABLED = 0,
    #[doc = "1: 32 kHz output enabled."]
    _32_KHZ_OUTPUT_ENABLED = 1,
}
impl From<EN32KHZ_A> for bool {
    #[inline(always)]
    fn from(variant: EN32KHZ_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EN32KHZ`"]
pub type EN32KHZ_R = crate::R<bool, EN32KHZ_A>;
impl EN32KHZ_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EN32KHZ_A {
        match self.bits {
            false => EN32KHZ_A::_32_KHZ_OUTPUT_DISABLED,
            true => EN32KHZ_A::_32_KHZ_OUTPUT_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `_32_KHZ_OUTPUT_DISABLED`"]
    #[inline(always)]
    pub fn is_32_khz_output_disabled(&self) -> bool {
        *self == EN32KHZ_A::_32_KHZ_OUTPUT_DISABLED
    }
    #[doc = "Checks if the value of the field is `_32_KHZ_OUTPUT_ENABLED`"]
    #[inline(always)]
    pub fn is_32_khz_output_enabled(&self) -> bool {
        *self == EN32KHZ_A::_32_KHZ_OUTPUT_ENABLED
    }
}
#[doc = "Write proxy for field `EN32KHZ`"]
pub struct EN32KHZ_W<'a> {
    w: &'a mut W,
}
impl<'a> EN32KHZ_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EN32KHZ_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "32 kHz output disabled."]
    #[inline(always)]
    pub fn _32_khz_output_disabled(self) -> &'a mut W {
        self.variant(EN32KHZ_A::_32_KHZ_OUTPUT_DISABLED)
    }
    #[doc = "32 kHz output enabled."]
    #[inline(always)]
    pub fn _32_khz_output_enabled(self) -> &'a mut W {
        self.variant(EN32KHZ_A::_32_KHZ_OUTPUT_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "32 kHz oscillator reset\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RESET32KHZ_A {
    #[doc = "0: Clear reset."]
    CLEAR_RESET = 0,
    #[doc = "1: Reset active."]
    RESET_ACTIVE = 1,
}
impl From<RESET32KHZ_A> for bool {
    #[inline(always)]
    fn from(variant: RESET32KHZ_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `RESET32KHZ`"]
pub type RESET32KHZ_R = crate::R<bool, RESET32KHZ_A>;
impl RESET32KHZ_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RESET32KHZ_A {
        match self.bits {
            false => RESET32KHZ_A::CLEAR_RESET,
            true => RESET32KHZ_A::RESET_ACTIVE,
        }
    }
    #[doc = "Checks if the value of the field is `CLEAR_RESET`"]
    #[inline(always)]
    pub fn is_clear_reset(&self) -> bool {
        *self == RESET32KHZ_A::CLEAR_RESET
    }
    #[doc = "Checks if the value of the field is `RESET_ACTIVE`"]
    #[inline(always)]
    pub fn is_reset_active(&self) -> bool {
        *self == RESET32KHZ_A::RESET_ACTIVE
    }
}
#[doc = "Write proxy for field `RESET32KHZ`"]
pub struct RESET32KHZ_W<'a> {
    w: &'a mut W,
}
impl<'a> RESET32KHZ_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RESET32KHZ_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Clear reset."]
    #[inline(always)]
    pub fn clear_reset(self) -> &'a mut W {
        self.variant(RESET32KHZ_A::CLEAR_RESET)
    }
    #[doc = "Reset active."]
    #[inline(always)]
    pub fn reset_active(self) -> &'a mut W {
        self.variant(RESET32KHZ_A::RESET_ACTIVE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "32 kHz power control.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PD32KHZ_A {
    #[doc = "0: Powered."]
    POWERED = 0,
    #[doc = "1: Powered-down."]
    POWERED_DOWN = 1,
}
impl From<PD32KHZ_A> for bool {
    #[inline(always)]
    fn from(variant: PD32KHZ_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PD32KHZ`"]
pub type PD32KHZ_R = crate::R<bool, PD32KHZ_A>;
impl PD32KHZ_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PD32KHZ_A {
        match self.bits {
            false => PD32KHZ_A::POWERED,
            true => PD32KHZ_A::POWERED_DOWN,
        }
    }
    #[doc = "Checks if the value of the field is `POWERED`"]
    #[inline(always)]
    pub fn is_powered(&self) -> bool {
        *self == PD32KHZ_A::POWERED
    }
    #[doc = "Checks if the value of the field is `POWERED_DOWN`"]
    #[inline(always)]
    pub fn is_powered_down(&self) -> bool {
        *self == PD32KHZ_A::POWERED_DOWN
    }
}
#[doc = "Write proxy for field `PD32KHZ`"]
pub struct PD32KHZ_W<'a> {
    w: &'a mut W,
}
impl<'a> PD32KHZ_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PD32KHZ_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Powered."]
    #[inline(always)]
    pub fn powered(self) -> &'a mut W {
        self.variant(PD32KHZ_A::POWERED)
    }
    #[doc = "Powered-down."]
    #[inline(always)]
    pub fn powered_down(self) -> &'a mut W {
        self.variant(PD32KHZ_A::POWERED_DOWN)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "USB0 PHY power control.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB0PHY_A {
    #[doc = "0: Enable USB0 PHY power."]
    ENABLE_USB0_PHY_POWER = 0,
    #[doc = "1: Disable USB0 PHY. PHY powered down."]
    DISABLE_USB0_PHY = 1,
}
impl From<USB0PHY_A> for bool {
    #[inline(always)]
    fn from(variant: USB0PHY_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `USB0PHY`"]
pub type USB0PHY_R = crate::R<bool, USB0PHY_A>;
impl USB0PHY_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB0PHY_A {
        match self.bits {
            false => USB0PHY_A::ENABLE_USB0_PHY_POWER,
            true => USB0PHY_A::DISABLE_USB0_PHY,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_USB0_PHY_POWER`"]
    #[inline(always)]
    pub fn is_enable_usb0_phy_power(&self) -> bool {
        *self == USB0PHY_A::ENABLE_USB0_PHY_POWER
    }
    #[doc = "Checks if the value of the field is `DISABLE_USB0_PHY`"]
    #[inline(always)]
    pub fn is_disable_usb0_phy(&self) -> bool {
        *self == USB0PHY_A::DISABLE_USB0_PHY
    }
}
#[doc = "Write proxy for field `USB0PHY`"]
pub struct USB0PHY_W<'a> {
    w: &'a mut W,
}
impl<'a> USB0PHY_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB0PHY_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable USB0 PHY power."]
    #[inline(always)]
    pub fn enable_usb0_phy_power(self) -> &'a mut W {
        self.variant(USB0PHY_A::ENABLE_USB0_PHY_POWER)
    }
    #[doc = "Disable USB0 PHY. PHY powered down."]
    #[inline(always)]
    pub fn disable_usb0_phy(self) -> &'a mut W {
        self.variant(USB0PHY_A::DISABLE_USB0_PHY)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "RTC_ALARM pin output control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum ALARMCTRL_A {
    #[doc = "0: RTC alarm."]
    RTC_ALARM = 0,
    #[doc = "1: Event router event."]
    EVENT_ROUTER_EVENT = 1,
    #[doc = "3: Inactive."]
    INACTIVE = 3,
}
impl From<ALARMCTRL_A> for u8 {
    #[inline(always)]
    fn from(variant: ALARMCTRL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `ALARMCTRL`"]
pub type ALARMCTRL_R = crate::R<u8, ALARMCTRL_A>;
impl ALARMCTRL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ALARMCTRL_A {
        match self.bits {
            0 => ALARMCTRL_A::RTC_ALARM,
            1 => ALARMCTRL_A::EVENT_ROUTER_EVENT,
            3 => ALARMCTRL_A::INACTIVE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `RTC_ALARM`"]
    #[inline(always)]
    pub fn is_rtc_alarm(&self) -> bool {
        *self == ALARMCTRL_A::RTC_ALARM
    }
    #[doc = "Checks if the value of the field is `EVENT_ROUTER_EVENT`"]
    #[inline(always)]
    pub fn is_event_router_event(&self) -> bool {
        *self == ALARMCTRL_A::EVENT_ROUTER_EVENT
    }
    #[doc = "Checks if the value of the field is `INACTIVE`"]
    #[inline(always)]
    pub fn is_inactive(&self) -> bool {
        *self == ALARMCTRL_A::INACTIVE
    }
}
#[doc = "Write proxy for field `ALARMCTRL`"]
pub struct ALARMCTRL_W<'a> {
    w: &'a mut W,
}
impl<'a> ALARMCTRL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ALARMCTRL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "RTC alarm."]
    #[inline(always)]
    pub fn rtc_alarm(self) -> &'a mut W {
        self.variant(ALARMCTRL_A::RTC_ALARM)
    }
    #[doc = "Event router event."]
    #[inline(always)]
    pub fn event_router_event(self) -> &'a mut W {
        self.variant(ALARMCTRL_A::EVENT_ROUTER_EVENT)
    }
    #[doc = "Inactive."]
    #[inline(always)]
    pub fn inactive(self) -> &'a mut W {
        self.variant(ALARMCTRL_A::INACTIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 6)) | (((value as u32) & 0x03) << 6);
        self.w
    }
}
#[doc = "BOD trip level to generate an interrupt. See the LPC43xx data sheets for the trip values.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum BODLVL1_A {
    #[doc = "0: Level 0 interrupt"]
    LEVEL_0_INTERRUPT = 0,
    #[doc = "1: Level 1 interrupt"]
    LEVEL_1_INTERRUPT = 1,
    #[doc = "2: Level 2 interrupt"]
    LEVEL_2_INTERRUPT = 2,
    #[doc = "3: Level 3 interrupt"]
    LEVEL_3_INTERRUPT = 3,
}
impl From<BODLVL1_A> for u8 {
    #[inline(always)]
    fn from(variant: BODLVL1_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `BODLVL1`"]
pub type BODLVL1_R = crate::R<u8, BODLVL1_A>;
impl BODLVL1_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BODLVL1_A {
        match self.bits {
            0 => BODLVL1_A::LEVEL_0_INTERRUPT,
            1 => BODLVL1_A::LEVEL_1_INTERRUPT,
            2 => BODLVL1_A::LEVEL_2_INTERRUPT,
            3 => BODLVL1_A::LEVEL_3_INTERRUPT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_0_INTERRUPT`"]
    #[inline(always)]
    pub fn is_level_0_interrupt(&self) -> bool {
        *self == BODLVL1_A::LEVEL_0_INTERRUPT
    }
    #[doc = "Checks if the value of the field is `LEVEL_1_INTERRUPT`"]
    #[inline(always)]
    pub fn is_level_1_interrupt(&self) -> bool {
        *self == BODLVL1_A::LEVEL_1_INTERRUPT
    }
    #[doc = "Checks if the value of the field is `LEVEL_2_INTERRUPT`"]
    #[inline(always)]
    pub fn is_level_2_interrupt(&self) -> bool {
        *self == BODLVL1_A::LEVEL_2_INTERRUPT
    }
    #[doc = "Checks if the value of the field is `LEVEL_3_INTERRUPT`"]
    #[inline(always)]
    pub fn is_level_3_interrupt(&self) -> bool {
        *self == BODLVL1_A::LEVEL_3_INTERRUPT
    }
}
#[doc = "Write proxy for field `BODLVL1`"]
pub struct BODLVL1_W<'a> {
    w: &'a mut W,
}
impl<'a> BODLVL1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BODLVL1_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Level 0 interrupt"]
    #[inline(always)]
    pub fn level_0_interrupt(self) -> &'a mut W {
        self.variant(BODLVL1_A::LEVEL_0_INTERRUPT)
    }
    #[doc = "Level 1 interrupt"]
    #[inline(always)]
    pub fn level_1_interrupt(self) -> &'a mut W {
        self.variant(BODLVL1_A::LEVEL_1_INTERRUPT)
    }
    #[doc = "Level 2 interrupt"]
    #[inline(always)]
    pub fn level_2_interrupt(self) -> &'a mut W {
        self.variant(BODLVL1_A::LEVEL_2_INTERRUPT)
    }
    #[doc = "Level 3 interrupt"]
    #[inline(always)]
    pub fn level_3_interrupt(self) -> &'a mut W {
        self.variant(BODLVL1_A::LEVEL_3_INTERRUPT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 8)) | (((value as u32) & 0x03) << 8);
        self.w
    }
}
#[doc = "BOD trip level to generate a reset. See the LPC43xx data sheets for the trip values.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum BODLVL2_A {
    #[doc = "0: Level 0 reset"]
    LEVEL_0_RESET = 0,
    #[doc = "1: Level 1 reset"]
    LEVEL_1_RESET = 1,
    #[doc = "2: Level 2 reset"]
    LEVEL_2_RESET = 2,
    #[doc = "3: Level 3 reset"]
    LEVEL_3_RESET = 3,
}
impl From<BODLVL2_A> for u8 {
    #[inline(always)]
    fn from(variant: BODLVL2_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `BODLVL2`"]
pub type BODLVL2_R = crate::R<u8, BODLVL2_A>;
impl BODLVL2_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BODLVL2_A {
        match self.bits {
            0 => BODLVL2_A::LEVEL_0_RESET,
            1 => BODLVL2_A::LEVEL_1_RESET,
            2 => BODLVL2_A::LEVEL_2_RESET,
            3 => BODLVL2_A::LEVEL_3_RESET,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_0_RESET`"]
    #[inline(always)]
    pub fn is_level_0_reset(&self) -> bool {
        *self == BODLVL2_A::LEVEL_0_RESET
    }
    #[doc = "Checks if the value of the field is `LEVEL_1_RESET`"]
    #[inline(always)]
    pub fn is_level_1_reset(&self) -> bool {
        *self == BODLVL2_A::LEVEL_1_RESET
    }
    #[doc = "Checks if the value of the field is `LEVEL_2_RESET`"]
    #[inline(always)]
    pub fn is_level_2_reset(&self) -> bool {
        *self == BODLVL2_A::LEVEL_2_RESET
    }
    #[doc = "Checks if the value of the field is `LEVEL_3_RESET`"]
    #[inline(always)]
    pub fn is_level_3_reset(&self) -> bool {
        *self == BODLVL2_A::LEVEL_3_RESET
    }
}
#[doc = "Write proxy for field `BODLVL2`"]
pub struct BODLVL2_W<'a> {
    w: &'a mut W,
}
impl<'a> BODLVL2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BODLVL2_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Level 0 reset"]
    #[inline(always)]
    pub fn level_0_reset(self) -> &'a mut W {
        self.variant(BODLVL2_A::LEVEL_0_RESET)
    }
    #[doc = "Level 1 reset"]
    #[inline(always)]
    pub fn level_1_reset(self) -> &'a mut W {
        self.variant(BODLVL2_A::LEVEL_1_RESET)
    }
    #[doc = "Level 2 reset"]
    #[inline(always)]
    pub fn level_2_reset(self) -> &'a mut W {
        self.variant(BODLVL2_A::LEVEL_2_RESET)
    }
    #[doc = "Level 3 reset"]
    #[inline(always)]
    pub fn level_3_reset(self) -> &'a mut W {
        self.variant(BODLVL2_A::LEVEL_3_RESET)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 10)) | (((value as u32) & 0x03) << 10);
        self.w
    }
}
#[doc = "SAMPLE pin input/output control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum SAMPLECTRL_A {
    #[doc = "1: Sample output from the event monitor/recorder."]
    SAMPLE_OUTPUT_FROM_EVENT_MONITOR_RECORDER = 1,
    #[doc = "2: Output from the event router."]
    OUTPUT_FROM_THE_EVENT_ROUTER = 2,
}
impl From<SAMPLECTRL_A> for u8 {
    #[inline(always)]
    fn from(variant: SAMPLECTRL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `SAMPLECTRL`"]
pub type SAMPLECTRL_R = crate::R<u8, SAMPLECTRL_A>;
impl SAMPLECTRL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SAMPLECTRL_A {
        match self.bits {
            1 => SAMPLECTRL_A::SAMPLE_OUTPUT_FROM_EVENT_MONITOR_RECORDER,
            2 => SAMPLECTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SAMPLE_OUTPUT_FROM_EVENT_MONITOR_RECORDER`"]
    #[inline(always)]
    pub fn is_sample_output_from_event_monitor_recorder(&self) -> bool {
        *self == SAMPLECTRL_A::SAMPLE_OUTPUT_FROM_EVENT_MONITOR_RECORDER
    }
    #[doc = "Checks if the value of the field is `OUTPUT_FROM_THE_EVENT_ROUTER`"]
    #[inline(always)]
    pub fn is_output_from_the_event_router(&self) -> bool {
        *self == SAMPLECTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER
    }
}
#[doc = "Write proxy for field `SAMPLECTRL`"]
pub struct SAMPLECTRL_W<'a> {
    w: &'a mut W,
}
impl<'a> SAMPLECTRL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SAMPLECTRL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Sample output from the event monitor/recorder."]
    #[inline(always)]
    pub fn sample_output_from_event_monitor_recorder(self) -> &'a mut W {
        self.variant(SAMPLECTRL_A::SAMPLE_OUTPUT_FROM_EVENT_MONITOR_RECORDER)
    }
    #[doc = "Output from the event router."]
    #[inline(always)]
    pub fn output_from_the_event_router(self) -> &'a mut W {
        self.variant(SAMPLECTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 12)) | (((value as u32) & 0x03) << 12);
        self.w
    }
}
#[doc = "WAKEUP0 pin input/output control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum WAKEUP0CTRL_A {
    #[doc = "0: Input to the event router."]
    INPUT_TO_THE_EVENT_ROUTER_0 = 0,
    #[doc = "1: Output from the event router."]
    OUTPUT_FROM_THE_EVENT_ROUTER = 1,
    #[doc = "3: Input to the event router."]
    INPUT_TO_THE_EVENT_ROUTER_3 = 3,
}
impl From<WAKEUP0CTRL_A> for u8 {
    #[inline(always)]
    fn from(variant: WAKEUP0CTRL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `WAKEUP0CTRL`"]
pub type WAKEUP0CTRL_R = crate::R<u8, WAKEUP0CTRL_A>;
impl WAKEUP0CTRL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP0CTRL_A {
        match self.bits {
            0 => WAKEUP0CTRL_A::INPUT_TO_THE_EVENT_ROUTER_0,
            1 => WAKEUP0CTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER,
            3 => WAKEUP0CTRL_A::INPUT_TO_THE_EVENT_ROUTER_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `INPUT_TO_THE_EVENT_ROUTER_0`"]
    #[inline(always)]
    pub fn is_input_to_the_event_router_0(&self) -> bool {
        *self == WAKEUP0CTRL_A::INPUT_TO_THE_EVENT_ROUTER_0
    }
    #[doc = "Checks if the value of the field is `OUTPUT_FROM_THE_EVENT_ROUTER`"]
    #[inline(always)]
    pub fn is_output_from_the_event_router(&self) -> bool {
        *self == WAKEUP0CTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER
    }
    #[doc = "Checks if the value of the field is `INPUT_TO_THE_EVENT_ROUTER_3`"]
    #[inline(always)]
    pub fn is_input_to_the_event_router_3(&self) -> bool {
        *self == WAKEUP0CTRL_A::INPUT_TO_THE_EVENT_ROUTER_3
    }
}
#[doc = "Write proxy for field `WAKEUP0CTRL`"]
pub struct WAKEUP0CTRL_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP0CTRL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP0CTRL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Input to the event router."]
    #[inline(always)]
    pub fn input_to_the_event_router_0(self) -> &'a mut W {
        self.variant(WAKEUP0CTRL_A::INPUT_TO_THE_EVENT_ROUTER_0)
    }
    #[doc = "Output from the event router."]
    #[inline(always)]
    pub fn output_from_the_event_router(self) -> &'a mut W {
        self.variant(WAKEUP0CTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER)
    }
    #[doc = "Input to the event router."]
    #[inline(always)]
    pub fn input_to_the_event_router_3(self) -> &'a mut W {
        self.variant(WAKEUP0CTRL_A::INPUT_TO_THE_EVENT_ROUTER_3)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 14)) | (((value as u32) & 0x03) << 14);
        self.w
    }
}
#[doc = "WAKEUP1 pin input/output control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum WAKEUP1CTRL_A {
    #[doc = "0: Input to event router."]
    INPUT_TO_EVENT_ROUTER_0 = 0,
    #[doc = "1: Output from the event router."]
    OUTPUT_FROM_THE_EVENT_ROUTER = 1,
    #[doc = "3: Input to event router."]
    INPUT_TO_EVENT_ROUTER_3 = 3,
}
impl From<WAKEUP1CTRL_A> for u8 {
    #[inline(always)]
    fn from(variant: WAKEUP1CTRL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `WAKEUP1CTRL`"]
pub type WAKEUP1CTRL_R = crate::R<u8, WAKEUP1CTRL_A>;
impl WAKEUP1CTRL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP1CTRL_A {
        match self.bits {
            0 => WAKEUP1CTRL_A::INPUT_TO_EVENT_ROUTER_0,
            1 => WAKEUP1CTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER,
            3 => WAKEUP1CTRL_A::INPUT_TO_EVENT_ROUTER_3,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `INPUT_TO_EVENT_ROUTER_0`"]
    #[inline(always)]
    pub fn is_input_to_event_router_0(&self) -> bool {
        *self == WAKEUP1CTRL_A::INPUT_TO_EVENT_ROUTER_0
    }
    #[doc = "Checks if the value of the field is `OUTPUT_FROM_THE_EVENT_ROUTER`"]
    #[inline(always)]
    pub fn is_output_from_the_event_router(&self) -> bool {
        *self == WAKEUP1CTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER
    }
    #[doc = "Checks if the value of the field is `INPUT_TO_EVENT_ROUTER_3`"]
    #[inline(always)]
    pub fn is_input_to_event_router_3(&self) -> bool {
        *self == WAKEUP1CTRL_A::INPUT_TO_EVENT_ROUTER_3
    }
}
#[doc = "Write proxy for field `WAKEUP1CTRL`"]
pub struct WAKEUP1CTRL_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP1CTRL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP1CTRL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Input to event router."]
    #[inline(always)]
    pub fn input_to_event_router_0(self) -> &'a mut W {
        self.variant(WAKEUP1CTRL_A::INPUT_TO_EVENT_ROUTER_0)
    }
    #[doc = "Output from the event router."]
    #[inline(always)]
    pub fn output_from_the_event_router(self) -> &'a mut W {
        self.variant(WAKEUP1CTRL_A::OUTPUT_FROM_THE_EVENT_ROUTER)
    }
    #[doc = "Input to event router."]
    #[inline(always)]
    pub fn input_to_event_router_3(self) -> &'a mut W {
        self.variant(WAKEUP1CTRL_A::INPUT_TO_EVENT_ROUTER_3)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 16)) | (((value as u32) & 0x03) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Enable 1 kHz output."]
    #[inline(always)]
    pub fn en1khz(&self) -> EN1KHZ_R {
        EN1KHZ_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Enable 32 kHz output"]
    #[inline(always)]
    pub fn en32khz(&self) -> EN32KHZ_R {
        EN32KHZ_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - 32 kHz oscillator reset"]
    #[inline(always)]
    pub fn reset32khz(&self) -> RESET32KHZ_R {
        RESET32KHZ_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - 32 kHz power control."]
    #[inline(always)]
    pub fn pd32khz(&self) -> PD32KHZ_R {
        PD32KHZ_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 5 - USB0 PHY power control."]
    #[inline(always)]
    pub fn usb0phy(&self) -> USB0PHY_R {
        USB0PHY_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bits 6:7 - RTC_ALARM pin output control"]
    #[inline(always)]
    pub fn alarmctrl(&self) -> ALARMCTRL_R {
        ALARMCTRL_R::new(((self.bits >> 6) & 0x03) as u8)
    }
    #[doc = "Bits 8:9 - BOD trip level to generate an interrupt. See the LPC43xx data sheets for the trip values."]
    #[inline(always)]
    pub fn bodlvl1(&self) -> BODLVL1_R {
        BODLVL1_R::new(((self.bits >> 8) & 0x03) as u8)
    }
    #[doc = "Bits 10:11 - BOD trip level to generate a reset. See the LPC43xx data sheets for the trip values."]
    #[inline(always)]
    pub fn bodlvl2(&self) -> BODLVL2_R {
        BODLVL2_R::new(((self.bits >> 10) & 0x03) as u8)
    }
    #[doc = "Bits 12:13 - SAMPLE pin input/output control"]
    #[inline(always)]
    pub fn samplectrl(&self) -> SAMPLECTRL_R {
        SAMPLECTRL_R::new(((self.bits >> 12) & 0x03) as u8)
    }
    #[doc = "Bits 14:15 - WAKEUP0 pin input/output control"]
    #[inline(always)]
    pub fn wakeup0ctrl(&self) -> WAKEUP0CTRL_R {
        WAKEUP0CTRL_R::new(((self.bits >> 14) & 0x03) as u8)
    }
    #[doc = "Bits 16:17 - WAKEUP1 pin input/output control"]
    #[inline(always)]
    pub fn wakeup1ctrl(&self) -> WAKEUP1CTRL_R {
        WAKEUP1CTRL_R::new(((self.bits >> 16) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Enable 1 kHz output."]
    #[inline(always)]
    pub fn en1khz(&mut self) -> EN1KHZ_W {
        EN1KHZ_W { w: self }
    }
    #[doc = "Bit 1 - Enable 32 kHz output"]
    #[inline(always)]
    pub fn en32khz(&mut self) -> EN32KHZ_W {
        EN32KHZ_W { w: self }
    }
    #[doc = "Bit 2 - 32 kHz oscillator reset"]
    #[inline(always)]
    pub fn reset32khz(&mut self) -> RESET32KHZ_W {
        RESET32KHZ_W { w: self }
    }
    #[doc = "Bit 3 - 32 kHz power control."]
    #[inline(always)]
    pub fn pd32khz(&mut self) -> PD32KHZ_W {
        PD32KHZ_W { w: self }
    }
    #[doc = "Bit 5 - USB0 PHY power control."]
    #[inline(always)]
    pub fn usb0phy(&mut self) -> USB0PHY_W {
        USB0PHY_W { w: self }
    }
    #[doc = "Bits 6:7 - RTC_ALARM pin output control"]
    #[inline(always)]
    pub fn alarmctrl(&mut self) -> ALARMCTRL_W {
        ALARMCTRL_W { w: self }
    }
    #[doc = "Bits 8:9 - BOD trip level to generate an interrupt. See the LPC43xx data sheets for the trip values."]
    #[inline(always)]
    pub fn bodlvl1(&mut self) -> BODLVL1_W {
        BODLVL1_W { w: self }
    }
    #[doc = "Bits 10:11 - BOD trip level to generate a reset. See the LPC43xx data sheets for the trip values."]
    #[inline(always)]
    pub fn bodlvl2(&mut self) -> BODLVL2_W {
        BODLVL2_W { w: self }
    }
    #[doc = "Bits 12:13 - SAMPLE pin input/output control"]
    #[inline(always)]
    pub fn samplectrl(&mut self) -> SAMPLECTRL_W {
        SAMPLECTRL_W { w: self }
    }
    #[doc = "Bits 14:15 - WAKEUP0 pin input/output control"]
    #[inline(always)]
    pub fn wakeup0ctrl(&mut self) -> WAKEUP0CTRL_W {
        WAKEUP0CTRL_W { w: self }
    }
    #[doc = "Bits 16:17 - WAKEUP1 pin input/output control"]
    #[inline(always)]
    pub fn wakeup1ctrl(&mut self) -> WAKEUP1CTRL_W {
        WAKEUP1CTRL_W { w: self }
    }
}
