#[doc = "Reader of register CREG5"]
pub type R = crate::R<u32, super::CREG5>;
#[doc = "Writer for register CREG5"]
pub type W = crate::W<u32, super::CREG5>;
#[doc = "Register CREG5 `reset()`'s with value 0"]
impl crate::ResetValue for super::CREG5 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "JTAG debug disable for M0SUB co-processor. If this bit is set to 1, it can be changed to 0 only through a chip reset.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum M0SUBTAPSEL_A {
    #[doc = "0: No effect."]
    NO_EFFECT = 0,
    #[doc = "1: Disable JTAG debug. Once JTAG is disabled, JTAG access remains disabled until the chip is reset by any source."]
    DISABLE_JTAG_DEBUG = 1,
}
impl From<M0SUBTAPSEL_A> for bool {
    #[inline(always)]
    fn from(variant: M0SUBTAPSEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `M0SUBTAPSEL`"]
pub type M0SUBTAPSEL_R = crate::R<bool, M0SUBTAPSEL_A>;
impl M0SUBTAPSEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> M0SUBTAPSEL_A {
        match self.bits {
            false => M0SUBTAPSEL_A::NO_EFFECT,
            true => M0SUBTAPSEL_A::DISABLE_JTAG_DEBUG,
        }
    }
    #[doc = "Checks if the value of the field is `NO_EFFECT`"]
    #[inline(always)]
    pub fn is_no_effect(&self) -> bool {
        *self == M0SUBTAPSEL_A::NO_EFFECT
    }
    #[doc = "Checks if the value of the field is `DISABLE_JTAG_DEBUG`"]
    #[inline(always)]
    pub fn is_disable_jtag_debug(&self) -> bool {
        *self == M0SUBTAPSEL_A::DISABLE_JTAG_DEBUG
    }
}
#[doc = "Write proxy for field `M0SUBTAPSEL`"]
pub struct M0SUBTAPSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> M0SUBTAPSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: M0SUBTAPSEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No effect."]
    #[inline(always)]
    pub fn no_effect(self) -> &'a mut W {
        self.variant(M0SUBTAPSEL_A::NO_EFFECT)
    }
    #[doc = "Disable JTAG debug. Once JTAG is disabled, JTAG access remains disabled until the chip is reset by any source."]
    #[inline(always)]
    pub fn disable_jtag_debug(self) -> &'a mut W {
        self.variant(M0SUBTAPSEL_A::DISABLE_JTAG_DEBUG)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "JTAG debug disable for M4 main processor. If this bit is set to 1, it can be changed to 0 only through a chip reset.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum M4TAPSEL_A {
    #[doc = "0: No effect."]
    NO_EFFECT = 0,
    #[doc = "1: Disable JTAG debug. Once JTAG is disabled, JTAG access remains disabled until the chip is reset by any source."]
    DISABLE_JTAG_DEBUG = 1,
}
impl From<M4TAPSEL_A> for bool {
    #[inline(always)]
    fn from(variant: M4TAPSEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `M4TAPSEL`"]
pub type M4TAPSEL_R = crate::R<bool, M4TAPSEL_A>;
impl M4TAPSEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> M4TAPSEL_A {
        match self.bits {
            false => M4TAPSEL_A::NO_EFFECT,
            true => M4TAPSEL_A::DISABLE_JTAG_DEBUG,
        }
    }
    #[doc = "Checks if the value of the field is `NO_EFFECT`"]
    #[inline(always)]
    pub fn is_no_effect(&self) -> bool {
        *self == M4TAPSEL_A::NO_EFFECT
    }
    #[doc = "Checks if the value of the field is `DISABLE_JTAG_DEBUG`"]
    #[inline(always)]
    pub fn is_disable_jtag_debug(&self) -> bool {
        *self == M4TAPSEL_A::DISABLE_JTAG_DEBUG
    }
}
#[doc = "Write proxy for field `M4TAPSEL`"]
pub struct M4TAPSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> M4TAPSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: M4TAPSEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No effect."]
    #[inline(always)]
    pub fn no_effect(self) -> &'a mut W {
        self.variant(M4TAPSEL_A::NO_EFFECT)
    }
    #[doc = "Disable JTAG debug. Once JTAG is disabled, JTAG access remains disabled until the chip is reset by any source."]
    #[inline(always)]
    pub fn disable_jtag_debug(self) -> &'a mut W {
        self.variant(M4TAPSEL_A::DISABLE_JTAG_DEBUG)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "JTAG debug disable for M0APPco-processor. If this bit is set to 1, it can be changed to 0 only through a chip reset.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum M0APPTAPSEL_A {
    #[doc = "0: No effect."]
    NO_EFFECT = 0,
    #[doc = "1: Disable JTAG debug. Once JTAG is disabled, JTAG access remains disabled until the chip is reset by any source."]
    DISABLE_JTAG_DEBUG = 1,
}
impl From<M0APPTAPSEL_A> for bool {
    #[inline(always)]
    fn from(variant: M0APPTAPSEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `M0APPTAPSEL`"]
pub type M0APPTAPSEL_R = crate::R<bool, M0APPTAPSEL_A>;
impl M0APPTAPSEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> M0APPTAPSEL_A {
        match self.bits {
            false => M0APPTAPSEL_A::NO_EFFECT,
            true => M0APPTAPSEL_A::DISABLE_JTAG_DEBUG,
        }
    }
    #[doc = "Checks if the value of the field is `NO_EFFECT`"]
    #[inline(always)]
    pub fn is_no_effect(&self) -> bool {
        *self == M0APPTAPSEL_A::NO_EFFECT
    }
    #[doc = "Checks if the value of the field is `DISABLE_JTAG_DEBUG`"]
    #[inline(always)]
    pub fn is_disable_jtag_debug(&self) -> bool {
        *self == M0APPTAPSEL_A::DISABLE_JTAG_DEBUG
    }
}
#[doc = "Write proxy for field `M0APPTAPSEL`"]
pub struct M0APPTAPSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> M0APPTAPSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: M0APPTAPSEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No effect."]
    #[inline(always)]
    pub fn no_effect(self) -> &'a mut W {
        self.variant(M0APPTAPSEL_A::NO_EFFECT)
    }
    #[doc = "Disable JTAG debug. Once JTAG is disabled, JTAG access remains disabled until the chip is reset by any source."]
    #[inline(always)]
    pub fn disable_jtag_debug(self) -> &'a mut W {
        self.variant(M0APPTAPSEL_A::DISABLE_JTAG_DEBUG)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
impl R {
    #[doc = "Bit 10 - JTAG debug disable for M0SUB co-processor. If this bit is set to 1, it can be changed to 0 only through a chip reset."]
    #[inline(always)]
    pub fn m0subtapsel(&self) -> M0SUBTAPSEL_R {
        M0SUBTAPSEL_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - JTAG debug disable for M4 main processor. If this bit is set to 1, it can be changed to 0 only through a chip reset."]
    #[inline(always)]
    pub fn m4tapsel(&self) -> M4TAPSEL_R {
        M4TAPSEL_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - JTAG debug disable for M0APPco-processor. If this bit is set to 1, it can be changed to 0 only through a chip reset."]
    #[inline(always)]
    pub fn m0apptapsel(&self) -> M0APPTAPSEL_R {
        M0APPTAPSEL_R::new(((self.bits >> 12) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 10 - JTAG debug disable for M0SUB co-processor. If this bit is set to 1, it can be changed to 0 only through a chip reset."]
    #[inline(always)]
    pub fn m0subtapsel(&mut self) -> M0SUBTAPSEL_W {
        M0SUBTAPSEL_W { w: self }
    }
    #[doc = "Bit 11 - JTAG debug disable for M4 main processor. If this bit is set to 1, it can be changed to 0 only through a chip reset."]
    #[inline(always)]
    pub fn m4tapsel(&mut self) -> M4TAPSEL_W {
        M4TAPSEL_W { w: self }
    }
    #[doc = "Bit 12 - JTAG debug disable for M0APPco-processor. If this bit is set to 1, it can be changed to 0 only through a chip reset."]
    #[inline(always)]
    pub fn m0apptapsel(&mut self) -> M0APPTAPSEL_W {
        M0APPTAPSEL_W { w: self }
    }
}
