#[doc = "Reader of register CREG6"]
pub type R = crate::R<u32, super::CREG6>;
#[doc = "Writer for register CREG6"]
pub type W = crate::W<u32, super::CREG6>;
#[doc = "Register CREG6 `reset()`'s with value 0"]
impl crate::ResetValue for super::CREG6 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Selects the Ethernet mode. Reset the ethernet after changing the PHY interface. All other settings are reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum ETHMODE_A {
    #[doc = "0: MII"]
    MII = 0,
    #[doc = "4: RMII"]
    RMII = 4,
}
impl From<ETHMODE_A> for u8 {
    #[inline(always)]
    fn from(variant: ETHMODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `ETHMODE`"]
pub type ETHMODE_R = crate::R<u8, ETHMODE_A>;
impl ETHMODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, ETHMODE_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(ETHMODE_A::MII),
            4 => Val(ETHMODE_A::RMII),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `MII`"]
    #[inline(always)]
    pub fn is_mii(&self) -> bool {
        *self == ETHMODE_A::MII
    }
    #[doc = "Checks if the value of the field is `RMII`"]
    #[inline(always)]
    pub fn is_rmii(&self) -> bool {
        *self == ETHMODE_A::RMII
    }
}
#[doc = "Write proxy for field `ETHMODE`"]
pub struct ETHMODE_W<'a> {
    w: &'a mut W,
}
impl<'a> ETHMODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ETHMODE_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "MII"]
    #[inline(always)]
    pub fn mii(self) -> &'a mut W {
        self.variant(ETHMODE_A::MII)
    }
    #[doc = "RMII"]
    #[inline(always)]
    pub fn rmii(self) -> &'a mut W {
        self.variant(ETHMODE_A::RMII)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x07) | ((value as u32) & 0x07);
        self.w
    }
}
#[doc = "Selects the functionality of the SCT outputs.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CTOUTCTRL_A {
    #[doc = "0: Combine SCT and timer match outputs. SCT outputs are Red with timer outputs."]
    COMBINE_SCT_AND_TIMER_MATCH = 0,
    #[doc = "1: SCT outputs only. SCT outputs are used without timer match outputs."]
    SCT_OUTPUTS_ONLY = 1,
}
impl From<CTOUTCTRL_A> for bool {
    #[inline(always)]
    fn from(variant: CTOUTCTRL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CTOUTCTRL`"]
pub type CTOUTCTRL_R = crate::R<bool, CTOUTCTRL_A>;
impl CTOUTCTRL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CTOUTCTRL_A {
        match self.bits {
            false => CTOUTCTRL_A::COMBINE_SCT_AND_TIMER_MATCH,
            true => CTOUTCTRL_A::SCT_OUTPUTS_ONLY,
        }
    }
    #[doc = "Checks if the value of the field is `COMBINE_SCT_AND_TIMER_MATCH`"]
    #[inline(always)]
    pub fn is_combine_sct_and_timer_match(&self) -> bool {
        *self == CTOUTCTRL_A::COMBINE_SCT_AND_TIMER_MATCH
    }
    #[doc = "Checks if the value of the field is `SCT_OUTPUTS_ONLY`"]
    #[inline(always)]
    pub fn is_sct_outputs_only(&self) -> bool {
        *self == CTOUTCTRL_A::SCT_OUTPUTS_ONLY
    }
}
#[doc = "Write proxy for field `CTOUTCTRL`"]
pub struct CTOUTCTRL_W<'a> {
    w: &'a mut W,
}
impl<'a> CTOUTCTRL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CTOUTCTRL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Combine SCT and timer match outputs. SCT outputs are Red with timer outputs."]
    #[inline(always)]
    pub fn combine_sct_and_timer_match(self) -> &'a mut W {
        self.variant(CTOUTCTRL_A::COMBINE_SCT_AND_TIMER_MATCH)
    }
    #[doc = "SCT outputs only. SCT outputs are used without timer match outputs."]
    #[inline(always)]
    pub fn sct_outputs_only(self) -> &'a mut W {
        self.variant(CTOUTCTRL_A::SCT_OUTPUTS_ONLY)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "I2S0_TX_SCK input select\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2S0_TX_SCK_IN_SEL_A {
    #[doc = "0: I2S Register. I2S clock selected as defined by the I2S transmit mode register Table 960."]
    I2S_REGISTER = 0,
    #[doc = "1: BASE_AUDIO_CLK for I2S transmit clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    BASE_AUDIO_CLK_FOR_I2S_TX_CLK = 1,
}
impl From<I2S0_TX_SCK_IN_SEL_A> for bool {
    #[inline(always)]
    fn from(variant: I2S0_TX_SCK_IN_SEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `I2S0_TX_SCK_IN_SEL`"]
pub type I2S0_TX_SCK_IN_SEL_R = crate::R<bool, I2S0_TX_SCK_IN_SEL_A>;
impl I2S0_TX_SCK_IN_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> I2S0_TX_SCK_IN_SEL_A {
        match self.bits {
            false => I2S0_TX_SCK_IN_SEL_A::I2S_REGISTER,
            true => I2S0_TX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_TX_CLK,
        }
    }
    #[doc = "Checks if the value of the field is `I2S_REGISTER`"]
    #[inline(always)]
    pub fn is_i2s_register(&self) -> bool {
        *self == I2S0_TX_SCK_IN_SEL_A::I2S_REGISTER
    }
    #[doc = "Checks if the value of the field is `BASE_AUDIO_CLK_FOR_I2S_TX_CLK`"]
    #[inline(always)]
    pub fn is_base_audio_clk_for_i2s_tx_clk(&self) -> bool {
        *self == I2S0_TX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_TX_CLK
    }
}
#[doc = "Write proxy for field `I2S0_TX_SCK_IN_SEL`"]
pub struct I2S0_TX_SCK_IN_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> I2S0_TX_SCK_IN_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: I2S0_TX_SCK_IN_SEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "I2S Register. I2S clock selected as defined by the I2S transmit mode register Table 960."]
    #[inline(always)]
    pub fn i2s_register(self) -> &'a mut W {
        self.variant(I2S0_TX_SCK_IN_SEL_A::I2S_REGISTER)
    }
    #[doc = "BASE_AUDIO_CLK for I2S transmit clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    #[inline(always)]
    pub fn base_audio_clk_for_i2s_tx_clk(self) -> &'a mut W {
        self.variant(I2S0_TX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_TX_CLK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "I2S0_RX_SCK input select\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2S0_RX_SCK_IN_SEL_A {
    #[doc = "0: I2S Register. I2S clock selected as defined by the I2S receive mode register Table 961."]
    I2S_REGISTER = 0,
    #[doc = "1: BASE_AUDIO_CLK for I2S receive clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    BASE_AUDIO_CLK_FOR_I2S_RX_CLK = 1,
}
impl From<I2S0_RX_SCK_IN_SEL_A> for bool {
    #[inline(always)]
    fn from(variant: I2S0_RX_SCK_IN_SEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `I2S0_RX_SCK_IN_SEL`"]
pub type I2S0_RX_SCK_IN_SEL_R = crate::R<bool, I2S0_RX_SCK_IN_SEL_A>;
impl I2S0_RX_SCK_IN_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> I2S0_RX_SCK_IN_SEL_A {
        match self.bits {
            false => I2S0_RX_SCK_IN_SEL_A::I2S_REGISTER,
            true => I2S0_RX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_RX_CLK,
        }
    }
    #[doc = "Checks if the value of the field is `I2S_REGISTER`"]
    #[inline(always)]
    pub fn is_i2s_register(&self) -> bool {
        *self == I2S0_RX_SCK_IN_SEL_A::I2S_REGISTER
    }
    #[doc = "Checks if the value of the field is `BASE_AUDIO_CLK_FOR_I2S_RX_CLK`"]
    #[inline(always)]
    pub fn is_base_audio_clk_for_i2s_rx_clk(&self) -> bool {
        *self == I2S0_RX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_RX_CLK
    }
}
#[doc = "Write proxy for field `I2S0_RX_SCK_IN_SEL`"]
pub struct I2S0_RX_SCK_IN_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> I2S0_RX_SCK_IN_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: I2S0_RX_SCK_IN_SEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "I2S Register. I2S clock selected as defined by the I2S receive mode register Table 961."]
    #[inline(always)]
    pub fn i2s_register(self) -> &'a mut W {
        self.variant(I2S0_RX_SCK_IN_SEL_A::I2S_REGISTER)
    }
    #[doc = "BASE_AUDIO_CLK for I2S receive clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    #[inline(always)]
    pub fn base_audio_clk_for_i2s_rx_clk(self) -> &'a mut W {
        self.variant(I2S0_RX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_RX_CLK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "I2S1_TX_SCK input select\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2S1_TX_SCK_IN_SEL_A {
    #[doc = "0: I2S register. I2S clock selected as defined by the I2S transmit mode register Table 960."]
    I2S_REGISTER = 0,
    #[doc = "1: BASE_AUDIO_CLK for I2S transmit clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    BASE_AUDIO_CLK_FOR_I2S_TX_CLK = 1,
}
impl From<I2S1_TX_SCK_IN_SEL_A> for bool {
    #[inline(always)]
    fn from(variant: I2S1_TX_SCK_IN_SEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `I2S1_TX_SCK_IN_SEL`"]
pub type I2S1_TX_SCK_IN_SEL_R = crate::R<bool, I2S1_TX_SCK_IN_SEL_A>;
impl I2S1_TX_SCK_IN_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> I2S1_TX_SCK_IN_SEL_A {
        match self.bits {
            false => I2S1_TX_SCK_IN_SEL_A::I2S_REGISTER,
            true => I2S1_TX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_TX_CLK,
        }
    }
    #[doc = "Checks if the value of the field is `I2S_REGISTER`"]
    #[inline(always)]
    pub fn is_i2s_register(&self) -> bool {
        *self == I2S1_TX_SCK_IN_SEL_A::I2S_REGISTER
    }
    #[doc = "Checks if the value of the field is `BASE_AUDIO_CLK_FOR_I2S_TX_CLK`"]
    #[inline(always)]
    pub fn is_base_audio_clk_for_i2s_tx_clk(&self) -> bool {
        *self == I2S1_TX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_TX_CLK
    }
}
#[doc = "Write proxy for field `I2S1_TX_SCK_IN_SEL`"]
pub struct I2S1_TX_SCK_IN_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> I2S1_TX_SCK_IN_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: I2S1_TX_SCK_IN_SEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "I2S register. I2S clock selected as defined by the I2S transmit mode register Table 960."]
    #[inline(always)]
    pub fn i2s_register(self) -> &'a mut W {
        self.variant(I2S1_TX_SCK_IN_SEL_A::I2S_REGISTER)
    }
    #[doc = "BASE_AUDIO_CLK for I2S transmit clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    #[inline(always)]
    pub fn base_audio_clk_for_i2s_tx_clk(self) -> &'a mut W {
        self.variant(I2S1_TX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_TX_CLK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "I2S1_RX_SCK input select\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2S1_RX_SCK_IN_SEL_A {
    #[doc = "0: I2S register. I2S clock selected as defined by the I2S receive mode register Table 961."]
    I2S_REGISTER = 0,
    #[doc = "1: BASE_AUDIO_CLK for I2S receive clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    BASE_AUDIO_CLK_FOR_I2S_RX_CLK = 1,
}
impl From<I2S1_RX_SCK_IN_SEL_A> for bool {
    #[inline(always)]
    fn from(variant: I2S1_RX_SCK_IN_SEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `I2S1_RX_SCK_IN_SEL`"]
pub type I2S1_RX_SCK_IN_SEL_R = crate::R<bool, I2S1_RX_SCK_IN_SEL_A>;
impl I2S1_RX_SCK_IN_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> I2S1_RX_SCK_IN_SEL_A {
        match self.bits {
            false => I2S1_RX_SCK_IN_SEL_A::I2S_REGISTER,
            true => I2S1_RX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_RX_CLK,
        }
    }
    #[doc = "Checks if the value of the field is `I2S_REGISTER`"]
    #[inline(always)]
    pub fn is_i2s_register(&self) -> bool {
        *self == I2S1_RX_SCK_IN_SEL_A::I2S_REGISTER
    }
    #[doc = "Checks if the value of the field is `BASE_AUDIO_CLK_FOR_I2S_RX_CLK`"]
    #[inline(always)]
    pub fn is_base_audio_clk_for_i2s_rx_clk(&self) -> bool {
        *self == I2S1_RX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_RX_CLK
    }
}
#[doc = "Write proxy for field `I2S1_RX_SCK_IN_SEL`"]
pub struct I2S1_RX_SCK_IN_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> I2S1_RX_SCK_IN_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: I2S1_RX_SCK_IN_SEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "I2S register. I2S clock selected as defined by the I2S receive mode register Table 961."]
    #[inline(always)]
    pub fn i2s_register(self) -> &'a mut W {
        self.variant(I2S1_RX_SCK_IN_SEL_A::I2S_REGISTER)
    }
    #[doc = "BASE_AUDIO_CLK for I2S receive clock MCLK input and MCLK output. The I2S must be configured in slave mode."]
    #[inline(always)]
    pub fn base_audio_clk_for_i2s_rx_clk(self) -> &'a mut W {
        self.variant(I2S1_RX_SCK_IN_SEL_A::BASE_AUDIO_CLK_FOR_I2S_RX_CLK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
#[doc = "EMC_CLK divided clock select (see Section 21.1).\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EMC_CLK_SEL_A {
    #[doc = "0: Divide by 1. EMC_CLK_DIV not divided."]
    DIVIDE_BY_1 = 0,
    #[doc = "1: Divide by 2. EMC_CLK_DIV divided by 2."]
    DIVIDE_BY_2 = 1,
}
impl From<EMC_CLK_SEL_A> for bool {
    #[inline(always)]
    fn from(variant: EMC_CLK_SEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EMC_CLK_SEL`"]
pub type EMC_CLK_SEL_R = crate::R<bool, EMC_CLK_SEL_A>;
impl EMC_CLK_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EMC_CLK_SEL_A {
        match self.bits {
            false => EMC_CLK_SEL_A::DIVIDE_BY_1,
            true => EMC_CLK_SEL_A::DIVIDE_BY_2,
        }
    }
    #[doc = "Checks if the value of the field is `DIVIDE_BY_1`"]
    #[inline(always)]
    pub fn is_divide_by_1(&self) -> bool {
        *self == EMC_CLK_SEL_A::DIVIDE_BY_1
    }
    #[doc = "Checks if the value of the field is `DIVIDE_BY_2`"]
    #[inline(always)]
    pub fn is_divide_by_2(&self) -> bool {
        *self == EMC_CLK_SEL_A::DIVIDE_BY_2
    }
}
#[doc = "Write proxy for field `EMC_CLK_SEL`"]
pub struct EMC_CLK_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> EMC_CLK_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EMC_CLK_SEL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Divide by 1. EMC_CLK_DIV not divided."]
    #[inline(always)]
    pub fn divide_by_1(self) -> &'a mut W {
        self.variant(EMC_CLK_SEL_A::DIVIDE_BY_1)
    }
    #[doc = "Divide by 2. EMC_CLK_DIV divided by 2."]
    #[inline(always)]
    pub fn divide_by_2(self) -> &'a mut W {
        self.variant(EMC_CLK_SEL_A::DIVIDE_BY_2)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:2 - Selects the Ethernet mode. Reset the ethernet after changing the PHY interface. All other settings are reserved."]
    #[inline(always)]
    pub fn ethmode(&self) -> ETHMODE_R {
        ETHMODE_R::new((self.bits & 0x07) as u8)
    }
    #[doc = "Bit 4 - Selects the functionality of the SCT outputs."]
    #[inline(always)]
    pub fn ctoutctrl(&self) -> CTOUTCTRL_R {
        CTOUTCTRL_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 12 - I2S0_TX_SCK input select"]
    #[inline(always)]
    pub fn i2s0_tx_sck_in_sel(&self) -> I2S0_TX_SCK_IN_SEL_R {
        I2S0_TX_SCK_IN_SEL_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - I2S0_RX_SCK input select"]
    #[inline(always)]
    pub fn i2s0_rx_sck_in_sel(&self) -> I2S0_RX_SCK_IN_SEL_R {
        I2S0_RX_SCK_IN_SEL_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - I2S1_TX_SCK input select"]
    #[inline(always)]
    pub fn i2s1_tx_sck_in_sel(&self) -> I2S1_TX_SCK_IN_SEL_R {
        I2S1_TX_SCK_IN_SEL_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - I2S1_RX_SCK input select"]
    #[inline(always)]
    pub fn i2s1_rx_sck_in_sel(&self) -> I2S1_RX_SCK_IN_SEL_R {
        I2S1_RX_SCK_IN_SEL_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - EMC_CLK divided clock select (see Section 21.1)."]
    #[inline(always)]
    pub fn emc_clk_sel(&self) -> EMC_CLK_SEL_R {
        EMC_CLK_SEL_R::new(((self.bits >> 16) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:2 - Selects the Ethernet mode. Reset the ethernet after changing the PHY interface. All other settings are reserved."]
    #[inline(always)]
    pub fn ethmode(&mut self) -> ETHMODE_W {
        ETHMODE_W { w: self }
    }
    #[doc = "Bit 4 - Selects the functionality of the SCT outputs."]
    #[inline(always)]
    pub fn ctoutctrl(&mut self) -> CTOUTCTRL_W {
        CTOUTCTRL_W { w: self }
    }
    #[doc = "Bit 12 - I2S0_TX_SCK input select"]
    #[inline(always)]
    pub fn i2s0_tx_sck_in_sel(&mut self) -> I2S0_TX_SCK_IN_SEL_W {
        I2S0_TX_SCK_IN_SEL_W { w: self }
    }
    #[doc = "Bit 13 - I2S0_RX_SCK input select"]
    #[inline(always)]
    pub fn i2s0_rx_sck_in_sel(&mut self) -> I2S0_RX_SCK_IN_SEL_W {
        I2S0_RX_SCK_IN_SEL_W { w: self }
    }
    #[doc = "Bit 14 - I2S1_TX_SCK input select"]
    #[inline(always)]
    pub fn i2s1_tx_sck_in_sel(&mut self) -> I2S1_TX_SCK_IN_SEL_W {
        I2S1_TX_SCK_IN_SEL_W { w: self }
    }
    #[doc = "Bit 15 - I2S1_RX_SCK input select"]
    #[inline(always)]
    pub fn i2s1_rx_sck_in_sel(&mut self) -> I2S1_RX_SCK_IN_SEL_W {
        I2S1_RX_SCK_IN_SEL_W { w: self }
    }
    #[doc = "Bit 16 - EMC_CLK divided clock select (see Section 21.1)."]
    #[inline(always)]
    pub fn emc_clk_sel(&mut self) -> EMC_CLK_SEL_W {
        EMC_CLK_SEL_W { w: self }
    }
}
