#[doc = "Reader of register M0SUBTXEVENT"]
pub type R = crate::R<u32, super::M0SUBTXEVENT>;
#[doc = "Writer for register M0SUBTXEVENT"]
pub type W = crate::W<u32, super::M0SUBTXEVENT>;
#[doc = "Register M0SUBTXEVENT `reset()`'s with value 0"]
impl crate::ResetValue for super::M0SUBTXEVENT {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Cortex-M0SUB TXEV event handling.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXEVCLR_A {
    #[doc = "0: Clear the TXEV event."]
    CLEAR_THE_TXEV_EVENT = 0,
    #[doc = "1: No effect."]
    NO_EFFECT = 1,
}
impl From<TXEVCLR_A> for bool {
    #[inline(always)]
    fn from(variant: TXEVCLR_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TXEVCLR`"]
pub type TXEVCLR_R = crate::R<bool, TXEVCLR_A>;
impl TXEVCLR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXEVCLR_A {
        match self.bits {
            false => TXEVCLR_A::CLEAR_THE_TXEV_EVENT,
            true => TXEVCLR_A::NO_EFFECT,
        }
    }
    #[doc = "Checks if the value of the field is `CLEAR_THE_TXEV_EVENT`"]
    #[inline(always)]
    pub fn is_clear_the_txev_event(&self) -> bool {
        *self == TXEVCLR_A::CLEAR_THE_TXEV_EVENT
    }
    #[doc = "Checks if the value of the field is `NO_EFFECT`"]
    #[inline(always)]
    pub fn is_no_effect(&self) -> bool {
        *self == TXEVCLR_A::NO_EFFECT
    }
}
#[doc = "Write proxy for field `TXEVCLR`"]
pub struct TXEVCLR_W<'a> {
    w: &'a mut W,
}
impl<'a> TXEVCLR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXEVCLR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Clear the TXEV event."]
    #[inline(always)]
    pub fn clear_the_txev_event(self) -> &'a mut W {
        self.variant(TXEVCLR_A::CLEAR_THE_TXEV_EVENT)
    }
    #[doc = "No effect."]
    #[inline(always)]
    pub fn no_effect(self) -> &'a mut W {
        self.variant(TXEVCLR_A::NO_EFFECT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Cortex-M0SUB TXEV event handling."]
    #[inline(always)]
    pub fn txevclr(&self) -> TXEVCLR_R {
        TXEVCLR_R::new((self.bits & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Cortex-M0SUB TXEV event handling."]
    #[inline(always)]
    pub fn txevclr(&mut self) -> TXEVCLR_W {
        TXEVCLR_W { w: self }
    }
}
