#[doc = "Reader of register CONFIG"]
pub type R = crate::R<u32, super::CONFIG>;
#[doc = "Writer for register CONFIG"]
pub type W = crate::W<u32, super::CONFIG>;
#[doc = "Register CONFIG `reset()`'s with value 0"]
impl crate::ResetValue for super::CONFIG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Endian mode.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EM_A {
    #[doc = "0: Little-endian mode. (POR reset value.)"]
    LITTLE_ENDIAN_MODE = 0,
    #[doc = "1: Big-endian mode."]
    BIG_ENDIAN_MODE = 1,
}
impl From<EM_A> for bool {
    #[inline(always)]
    fn from(variant: EM_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EM`"]
pub type EM_R = crate::R<bool, EM_A>;
impl EM_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EM_A {
        match self.bits {
            false => EM_A::LITTLE_ENDIAN_MODE,
            true => EM_A::BIG_ENDIAN_MODE,
        }
    }
    #[doc = "Checks if the value of the field is `LITTLE_ENDIAN_MODE`"]
    #[inline(always)]
    pub fn is_little_endian_mode(&self) -> bool {
        *self == EM_A::LITTLE_ENDIAN_MODE
    }
    #[doc = "Checks if the value of the field is `BIG_ENDIAN_MODE`"]
    #[inline(always)]
    pub fn is_big_endian_mode(&self) -> bool {
        *self == EM_A::BIG_ENDIAN_MODE
    }
}
#[doc = "Write proxy for field `EM`"]
pub struct EM_W<'a> {
    w: &'a mut W,
}
impl<'a> EM_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EM_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Little-endian mode. (POR reset value.)"]
    #[inline(always)]
    pub fn little_endian_mode(self) -> &'a mut W {
        self.variant(EM_A::LITTLE_ENDIAN_MODE)
    }
    #[doc = "Big-endian mode."]
    #[inline(always)]
    pub fn big_endian_mode(self) -> &'a mut W {
        self.variant(EM_A::BIG_ENDIAN_MODE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Endian mode."]
    #[inline(always)]
    pub fn em(&self) -> EM_R {
        EM_R::new((self.bits & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Endian mode."]
    #[inline(always)]
    pub fn em(&mut self) -> EM_W {
        EM_W { w: self }
    }
}
