#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Level configuration register"]
    pub hilo: HILO,
    #[doc = "0x04 - Edge configuration"]
    pub edge: EDGE,
    _reserved2: [u8; 4048usize],
    #[doc = "0xfd8 - Clear event enable register"]
    pub clr_en: CLR_EN,
    #[doc = "0xfdc - Set event enable register"]
    pub set_en: SET_EN,
    #[doc = "0xfe0 - Event Status register"]
    pub status: STATUS,
    #[doc = "0xfe4 - Event Enable register"]
    pub enable: ENABLE,
    #[doc = "0xfe8 - Clear event status register"]
    pub clr_stat: CLR_STAT,
    #[doc = "0xfec - Set event status register"]
    pub set_stat: SET_STAT,
}
#[doc = "Level configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [hilo](hilo) module"]
pub type HILO = crate::Reg<u32, _HILO>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _HILO;
#[doc = "`read()` method returns [hilo::R](hilo::R) reader structure"]
impl crate::Readable for HILO {}
#[doc = "`write(|w| ..)` method takes [hilo::W](hilo::W) writer structure"]
impl crate::Writable for HILO {}
#[doc = "Level configuration register"]
pub mod hilo;
#[doc = "Edge configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [edge](edge) module"]
pub type EDGE = crate::Reg<u32, _EDGE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EDGE;
#[doc = "`read()` method returns [edge::R](edge::R) reader structure"]
impl crate::Readable for EDGE {}
#[doc = "`write(|w| ..)` method takes [edge::W](edge::W) writer structure"]
impl crate::Writable for EDGE {}
#[doc = "Edge configuration"]
pub mod edge;
#[doc = "Clear event enable register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clr_en](clr_en) module"]
pub type CLR_EN = crate::Reg<u32, _CLR_EN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLR_EN;
#[doc = "`write(|w| ..)` method takes [clr_en::W](clr_en::W) writer structure"]
impl crate::Writable for CLR_EN {}
#[doc = "Clear event enable register"]
pub mod clr_en;
#[doc = "Set event enable register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [set_en](set_en) module"]
pub type SET_EN = crate::Reg<u32, _SET_EN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SET_EN;
#[doc = "`write(|w| ..)` method takes [set_en::W](set_en::W) writer structure"]
impl crate::Writable for SET_EN {}
#[doc = "Set event enable register"]
pub mod set_en;
#[doc = "Event Status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [status](status) module"]
pub type STATUS = crate::Reg<u32, _STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _STATUS;
#[doc = "`read()` method returns [status::R](status::R) reader structure"]
impl crate::Readable for STATUS {}
#[doc = "Event Status register"]
pub mod status;
#[doc = "Event Enable register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [enable](enable) module"]
pub type ENABLE = crate::Reg<u32, _ENABLE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ENABLE;
#[doc = "`read()` method returns [enable::R](enable::R) reader structure"]
impl crate::Readable for ENABLE {}
#[doc = "Event Enable register"]
pub mod enable;
#[doc = "Clear event status register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clr_stat](clr_stat) module"]
pub type CLR_STAT = crate::Reg<u32, _CLR_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLR_STAT;
#[doc = "`write(|w| ..)` method takes [clr_stat::W](clr_stat::W) writer structure"]
impl crate::Writable for CLR_STAT {}
#[doc = "Clear event status register"]
pub mod clr_stat;
#[doc = "Set event status register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [set_stat](set_stat) module"]
pub type SET_STAT = crate::Reg<u32, _SET_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SET_STAT;
#[doc = "`write(|w| ..)` method takes [set_stat::W](set_stat::W) writer structure"]
impl crate::Writable for SET_STAT {}
#[doc = "Set event status register"]
pub mod set_stat;
