#[doc = "Reader of register HILO"]
pub type R = crate::R<u32, super::HILO>;
#[doc = "Writer for register HILO"]
pub type W = crate::W<u32, super::HILO>;
#[doc = "Register HILO `reset()`'s with value 0"]
impl crate::ResetValue for super::HILO {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Level detect mode for WAKEUP0 event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP0_L_A {
    #[doc = "0: Detect LOW level on the WAKEUP0 pin if bit 0 in the EDGE register is 0. Detect falling edge if bit 0 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level on the WAKEUP0 pin if bit 0 in the EDGE register is 0. Detect rising edge if bit 0 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<WAKEUP0_L_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP0_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `WAKEUP0_L`"]
pub type WAKEUP0_L_R = crate::R<bool, WAKEUP0_L_A>;
impl WAKEUP0_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP0_L_A {
        match self.bits {
            false => WAKEUP0_L_A::DETECT_LOW_LEVEL,
            true => WAKEUP0_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == WAKEUP0_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == WAKEUP0_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `WAKEUP0_L`"]
pub struct WAKEUP0_L_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP0_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP0_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level on the WAKEUP0 pin if bit 0 in the EDGE register is 0. Detect falling edge if bit 0 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(WAKEUP0_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level on the WAKEUP0 pin if bit 0 in the EDGE register is 0. Detect rising edge if bit 0 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(WAKEUP0_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Level detect mode for WAKEUP1 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP1_L_A {
    #[doc = "0: Detect LOW level on the WAKEUP1 pin if bit 1 in the EDGE register is 0."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level on the WAKEUP1 pin if bit 1 in the EDGE register is 0. Detect rising edge if bit 1 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<WAKEUP1_L_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP1_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `WAKEUP1_L`"]
pub type WAKEUP1_L_R = crate::R<bool, WAKEUP1_L_A>;
impl WAKEUP1_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP1_L_A {
        match self.bits {
            false => WAKEUP1_L_A::DETECT_LOW_LEVEL,
            true => WAKEUP1_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == WAKEUP1_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == WAKEUP1_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `WAKEUP1_L`"]
pub struct WAKEUP1_L_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP1_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP1_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level on the WAKEUP1 pin if bit 1 in the EDGE register is 0."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(WAKEUP1_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level on the WAKEUP1 pin if bit 1 in the EDGE register is 0. Detect rising edge if bit 1 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(WAKEUP1_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Level detect mode for WAKEUP2 event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP2_L_A {
    #[doc = "0: Detect LOW level on the WAKEUP2 pin if bit 2 in the EDGE register is 0. Detect falling edge if bit 2 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level on the WAKEUP2 pin if bit 2 in the EDGE register is 0. Detect rising edge if bit 2 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<WAKEUP2_L_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP2_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `WAKEUP2_L`"]
pub type WAKEUP2_L_R = crate::R<bool, WAKEUP2_L_A>;
impl WAKEUP2_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP2_L_A {
        match self.bits {
            false => WAKEUP2_L_A::DETECT_LOW_LEVEL,
            true => WAKEUP2_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == WAKEUP2_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == WAKEUP2_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `WAKEUP2_L`"]
pub struct WAKEUP2_L_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP2_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP2_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level on the WAKEUP2 pin if bit 2 in the EDGE register is 0. Detect falling edge if bit 2 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(WAKEUP2_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level on the WAKEUP2 pin if bit 2 in the EDGE register is 0. Detect rising edge if bit 2 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(WAKEUP2_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Level detect mode for WAKEUP3 event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP3_L_A {
    #[doc = "0: Detect LOW level on the WAKEUP3 pin if bit 3 in the EDGE register is 0. Detect falling edge if bit 3 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level on the WAKEUP3 pin if bit 3 in the EDGE register is 0. Detect rising edge if bit 3 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<WAKEUP3_L_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP3_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `WAKEUP3_L`"]
pub type WAKEUP3_L_R = crate::R<bool, WAKEUP3_L_A>;
impl WAKEUP3_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP3_L_A {
        match self.bits {
            false => WAKEUP3_L_A::DETECT_LOW_LEVEL,
            true => WAKEUP3_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == WAKEUP3_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == WAKEUP3_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `WAKEUP3_L`"]
pub struct WAKEUP3_L_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP3_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP3_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level on the WAKEUP3 pin if bit 3 in the EDGE register is 0. Detect falling edge if bit 3 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(WAKEUP3_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level on the WAKEUP3 pin if bit 3 in the EDGE register is 0. Detect rising edge if bit 3 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(WAKEUP3_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Level detect mode for alarm timer event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ATIMER_L_A {
    #[doc = "0: Detect LOW level of the alarm timer interrupt if bit 4 in the EDGE register is 0. Detect falling edge if bit 4 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the alarm timer interrupt if bit 4 in the EDGE register is 0. Detect rising edge if bit 4 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<ATIMER_L_A> for bool {
    #[inline(always)]
    fn from(variant: ATIMER_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ATIMER_L`"]
pub type ATIMER_L_R = crate::R<bool, ATIMER_L_A>;
impl ATIMER_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ATIMER_L_A {
        match self.bits {
            false => ATIMER_L_A::DETECT_LOW_LEVEL,
            true => ATIMER_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == ATIMER_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == ATIMER_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `ATIMER_L`"]
pub struct ATIMER_L_W<'a> {
    w: &'a mut W,
}
impl<'a> ATIMER_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ATIMER_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the alarm timer interrupt if bit 4 in the EDGE register is 0. Detect falling edge if bit 4 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(ATIMER_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the alarm timer interrupt if bit 4 in the EDGE register is 0. Detect rising edge if bit 4 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(ATIMER_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Level detect mode for RTC event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTC_L_A {
    #[doc = "0: Detect LOW level of the RTC interrupt if bit 5 in the EDGE register is 0. Detect falling edge if bit 5 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the RTC interrupt if bit 5 in the EDGE register is 0. Detect rising edge if bit 5 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<RTC_L_A> for bool {
    #[inline(always)]
    fn from(variant: RTC_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `RTC_L`"]
pub type RTC_L_R = crate::R<bool, RTC_L_A>;
impl RTC_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RTC_L_A {
        match self.bits {
            false => RTC_L_A::DETECT_LOW_LEVEL,
            true => RTC_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == RTC_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == RTC_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `RTC_L`"]
pub struct RTC_L_W<'a> {
    w: &'a mut W,
}
impl<'a> RTC_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RTC_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the RTC interrupt if bit 5 in the EDGE register is 0. Detect falling edge if bit 5 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(RTC_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the RTC interrupt if bit 5 in the EDGE register is 0. Detect rising edge if bit 5 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(RTC_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Level detect mode for BOD event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BOD_L_A {
    #[doc = "0: Detect LOW level of the BOD interrupt if bit 6 in the EDGE register is 0. Detect falling edge if bit 6 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the BOD interrupt if bit 6 in the EDGE register is 0. Detect rising edge if bit 6 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<BOD_L_A> for bool {
    #[inline(always)]
    fn from(variant: BOD_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `BOD_L`"]
pub type BOD_L_R = crate::R<bool, BOD_L_A>;
impl BOD_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BOD_L_A {
        match self.bits {
            false => BOD_L_A::DETECT_LOW_LEVEL,
            true => BOD_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == BOD_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == BOD_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `BOD_L`"]
pub struct BOD_L_W<'a> {
    w: &'a mut W,
}
impl<'a> BOD_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BOD_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the BOD interrupt if bit 6 in the EDGE register is 0. Detect falling edge if bit 6 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(BOD_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the BOD interrupt if bit 6 in the EDGE register is 0. Detect rising edge if bit 6 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(BOD_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Level detect mode for WWDT event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WWDT_L_A {
    #[doc = "0: Detect LOW level of the WWDT interrupt if bit 7 in the EDGE register is 0. Detect falling edge if bit 7 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the WWDT interrupt if bit 7 in the EDGE register is 0. Detect rising edge if bit 7 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<WWDT_L_A> for bool {
    #[inline(always)]
    fn from(variant: WWDT_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `WWDT_L`"]
pub type WWDT_L_R = crate::R<bool, WWDT_L_A>;
impl WWDT_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WWDT_L_A {
        match self.bits {
            false => WWDT_L_A::DETECT_LOW_LEVEL,
            true => WWDT_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == WWDT_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == WWDT_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `WWDT_L`"]
pub struct WWDT_L_W<'a> {
    w: &'a mut W,
}
impl<'a> WWDT_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WWDT_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the WWDT interrupt if bit 7 in the EDGE register is 0. Detect falling edge if bit 7 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(WWDT_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the WWDT interrupt if bit 7 in the EDGE register is 0. Detect rising edge if bit 7 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(WWDT_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Level detect mode for Ethernet event\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ETH_L_A {
    #[doc = "0: Detect LOW level of the Ethernet interrupt if bit 8 in the EDGE register is 0. Detect falling edge if bit 8 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the Ethernet interrupt if bit 8 in the EDGE register is 0. Detect rising edge if bit 8 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<ETH_L_A> for bool {
    #[inline(always)]
    fn from(variant: ETH_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ETH_L`"]
pub type ETH_L_R = crate::R<bool, ETH_L_A>;
impl ETH_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ETH_L_A {
        match self.bits {
            false => ETH_L_A::DETECT_LOW_LEVEL,
            true => ETH_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == ETH_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == ETH_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `ETH_L`"]
pub struct ETH_L_W<'a> {
    w: &'a mut W,
}
impl<'a> ETH_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ETH_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the Ethernet interrupt if bit 8 in the EDGE register is 0. Detect falling edge if bit 8 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(ETH_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the Ethernet interrupt if bit 8 in the EDGE register is 0. Detect rising edge if bit 8 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(ETH_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Level detect mode for USB0 event\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB0_L_A {
    #[doc = "0: Detect LOW level of the USB0 interrupt if bit 9 in the EDGE register is 0. Detect falling edge if bit 9 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the USB0 interrupt if bit 9 in the EDGE register is 0. Detect rising edge if bit 9 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<USB0_L_A> for bool {
    #[inline(always)]
    fn from(variant: USB0_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `USB0_L`"]
pub type USB0_L_R = crate::R<bool, USB0_L_A>;
impl USB0_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB0_L_A {
        match self.bits {
            false => USB0_L_A::DETECT_LOW_LEVEL,
            true => USB0_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == USB0_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == USB0_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `USB0_L`"]
pub struct USB0_L_W<'a> {
    w: &'a mut W,
}
impl<'a> USB0_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB0_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the USB0 interrupt if bit 9 in the EDGE register is 0. Detect falling edge if bit 9 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(USB0_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the USB0 interrupt if bit 9 in the EDGE register is 0. Detect rising edge if bit 9 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(USB0_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "Level detect mode for USB1 event\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB1_L_A {
    #[doc = "0: Detect LOW level of the USB1 interrupt if bit 10 in the EDGE register is 0. Detect falling edge if bit 10 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the USB1 interrupt if bit 10 in the EDGE register is 0. Detect rising edge if bit 10 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<USB1_L_A> for bool {
    #[inline(always)]
    fn from(variant: USB1_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `USB1_L`"]
pub type USB1_L_R = crate::R<bool, USB1_L_A>;
impl USB1_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB1_L_A {
        match self.bits {
            false => USB1_L_A::DETECT_LOW_LEVEL,
            true => USB1_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == USB1_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == USB1_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `USB1_L`"]
pub struct USB1_L_W<'a> {
    w: &'a mut W,
}
impl<'a> USB1_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB1_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the USB1 interrupt if bit 10 in the EDGE register is 0. Detect falling edge if bit 10 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(USB1_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the USB1 interrupt if bit 10 in the EDGE register is 0. Detect rising edge if bit 10 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(USB1_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "Level detect mode for SD/MMC event\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDMMC_L_A {
    #[doc = "0: Detect LOW level of the SD/MMC interrupt if bit 11 in the EDGE register is 0. Detect falling edge if bit 11 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the SD/MMC interrupt if bit 11 in the EDGE register is 0. Detect rising edge if bit 11 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<SDMMC_L_A> for bool {
    #[inline(always)]
    fn from(variant: SDMMC_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SDMMC_L`"]
pub type SDMMC_L_R = crate::R<bool, SDMMC_L_A>;
impl SDMMC_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDMMC_L_A {
        match self.bits {
            false => SDMMC_L_A::DETECT_LOW_LEVEL,
            true => SDMMC_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == SDMMC_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == SDMMC_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `SDMMC_L`"]
pub struct SDMMC_L_W<'a> {
    w: &'a mut W,
}
impl<'a> SDMMC_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDMMC_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the SD/MMC interrupt if bit 11 in the EDGE register is 0. Detect falling edge if bit 11 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(SDMMC_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the SD/MMC interrupt if bit 11 in the EDGE register is 0. Detect rising edge if bit 11 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(SDMMC_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Level detect mode for C_CAN event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAN_L_A {
    #[doc = "0: Detect LOW level of the combined C_CAN interrupt if bit 12 in the EDGE register is 0. Detect falling edge if bit 12 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the combined C_CAN interrupt if bit 12 in the EDGE register is 0. Detect rising edge if bit 12 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<CAN_L_A> for bool {
    #[inline(always)]
    fn from(variant: CAN_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CAN_L`"]
pub type CAN_L_R = crate::R<bool, CAN_L_A>;
impl CAN_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAN_L_A {
        match self.bits {
            false => CAN_L_A::DETECT_LOW_LEVEL,
            true => CAN_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == CAN_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == CAN_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `CAN_L`"]
pub struct CAN_L_W<'a> {
    w: &'a mut W,
}
impl<'a> CAN_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAN_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the combined C_CAN interrupt if bit 12 in the EDGE register is 0. Detect falling edge if bit 12 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(CAN_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the combined C_CAN interrupt if bit 12 in the EDGE register is 0. Detect rising edge if bit 12 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(CAN_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Level detect mode for combined timer output 2 event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIM2_L_A {
    #[doc = "0: Detect LOW level GIMA output 25 if bit 13 in the EDGE register is 0. Detect falling edge if bit 13 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level GIMA output 25 if bit 13 in the EDGE register is 0. Detect rising edge if bit 13 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<TIM2_L_A> for bool {
    #[inline(always)]
    fn from(variant: TIM2_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TIM2_L`"]
pub type TIM2_L_R = crate::R<bool, TIM2_L_A>;
impl TIM2_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TIM2_L_A {
        match self.bits {
            false => TIM2_L_A::DETECT_LOW_LEVEL,
            true => TIM2_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == TIM2_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == TIM2_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `TIM2_L`"]
pub struct TIM2_L_W<'a> {
    w: &'a mut W,
}
impl<'a> TIM2_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TIM2_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level GIMA output 25 if bit 13 in the EDGE register is 0. Detect falling edge if bit 13 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(TIM2_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level GIMA output 25 if bit 13 in the EDGE register is 0. Detect rising edge if bit 13 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(TIM2_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Level detect mode for combined timer output 6 event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIM6_L_A {
    #[doc = "0: Detect LOW level of GIMA output 26 if bit 14 in the EDGE register is 0. Detect falling edge if bit 14 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of GIMA output 26 if bit 14 in the EDGE register is 0. Detect rising edge if bit 14 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<TIM6_L_A> for bool {
    #[inline(always)]
    fn from(variant: TIM6_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TIM6_L`"]
pub type TIM6_L_R = crate::R<bool, TIM6_L_A>;
impl TIM6_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TIM6_L_A {
        match self.bits {
            false => TIM6_L_A::DETECT_LOW_LEVEL,
            true => TIM6_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == TIM6_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == TIM6_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `TIM6_L`"]
pub struct TIM6_L_W<'a> {
    w: &'a mut W,
}
impl<'a> TIM6_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TIM6_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of GIMA output 26 if bit 14 in the EDGE register is 0. Detect falling edge if bit 14 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(TIM6_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of GIMA output 26 if bit 14 in the EDGE register is 0. Detect rising edge if bit 14 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(TIM6_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Level detect mode for QEI event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum QEI_L_A {
    #[doc = "0: Detect LOW level of the QEI interrupt if bit 15 in the EDGE register is 0. Detect falling edge if bit 15 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of the QEI interrupt if bit 15 in the EDGE register is 0. Detect rising edge if bit 15 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<QEI_L_A> for bool {
    #[inline(always)]
    fn from(variant: QEI_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `QEI_L`"]
pub type QEI_L_R = crate::R<bool, QEI_L_A>;
impl QEI_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> QEI_L_A {
        match self.bits {
            false => QEI_L_A::DETECT_LOW_LEVEL,
            true => QEI_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == QEI_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == QEI_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `QEI_L`"]
pub struct QEI_L_W<'a> {
    w: &'a mut W,
}
impl<'a> QEI_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: QEI_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of the QEI interrupt if bit 15 in the EDGE register is 0. Detect falling edge if bit 15 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(QEI_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of the QEI interrupt if bit 15 in the EDGE register is 0. Detect rising edge if bit 15 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(QEI_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
#[doc = "Level detect mode for combined timer output 14 event.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIM14_L_A {
    #[doc = "0: Detect LOW level of GIMA output 27 if bit 16 in the EDGE register is 0. Detect falling edge if bit 16 in the EDGE register is 1."]
    DETECT_LOW_LEVEL = 0,
    #[doc = "1: Detect HIGH level of GIMA output 27 if bit 16 in the EDGE register is 0. Detect rising edge if bit 16 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL = 1,
}
impl From<TIM14_L_A> for bool {
    #[inline(always)]
    fn from(variant: TIM14_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TIM14_L`"]
pub type TIM14_L_R = crate::R<bool, TIM14_L_A>;
impl TIM14_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TIM14_L_A {
        match self.bits {
            false => TIM14_L_A::DETECT_LOW_LEVEL,
            true => TIM14_L_A::DETECT_HIGH_LEVEL,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == TIM14_L_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == TIM14_L_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `TIM14_L`"]
pub struct TIM14_L_W<'a> {
    w: &'a mut W,
}
impl<'a> TIM14_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TIM14_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level of GIMA output 27 if bit 16 in the EDGE register is 0. Detect falling edge if bit 16 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(TIM14_L_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level of GIMA output 27 if bit 16 in the EDGE register is 0. Detect rising edge if bit 16 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(TIM14_L_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Level detect mode for Reset\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RESET_L_A {
    #[doc = "0: Detect LOW level if bit 17 in the EDGE register is 0. Detect falling edge if bit 17 in the EDGE register is 1."]
    DETECT_LOW_LEVEL_IF = 0,
    #[doc = "1: Detect HIGH level if bit 17 in the EDGE register is 0. Detect rising edge if bit 17 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL_IF = 1,
}
impl From<RESET_L_A> for bool {
    #[inline(always)]
    fn from(variant: RESET_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `RESET_L`"]
pub type RESET_L_R = crate::R<bool, RESET_L_A>;
impl RESET_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RESET_L_A {
        match self.bits {
            false => RESET_L_A::DETECT_LOW_LEVEL_IF,
            true => RESET_L_A::DETECT_HIGH_LEVEL_IF,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL_IF`"]
    #[inline(always)]
    pub fn is_detect_low_level_if(&self) -> bool {
        *self == RESET_L_A::DETECT_LOW_LEVEL_IF
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL_IF`"]
    #[inline(always)]
    pub fn is_detect_high_level_if(&self) -> bool {
        *self == RESET_L_A::DETECT_HIGH_LEVEL_IF
    }
}
#[doc = "Write proxy for field `RESET_L`"]
pub struct RESET_L_W<'a> {
    w: &'a mut W,
}
impl<'a> RESET_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RESET_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level if bit 17 in the EDGE register is 0. Detect falling edge if bit 17 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level_if(self) -> &'a mut W {
        self.variant(RESET_L_A::DETECT_LOW_LEVEL_IF)
    }
    #[doc = "Detect HIGH level if bit 17 in the EDGE register is 0. Detect rising edge if bit 17 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level_if(self) -> &'a mut W {
        self.variant(RESET_L_A::DETECT_HIGH_LEVEL_IF)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 19)) | (((value as u32) & 0x01) << 19);
        self.w
    }
}
#[doc = "Level detect mode for BOD Reset\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BODRESET_L_A {
    #[doc = "0: Detect LOW level if bit 20 in the EDGE register is 0. Detect falling edge if bit 20 in the EDGE register is 1."]
    DETECT_LOW_LEVEL_IF = 0,
    #[doc = "1: Detect HIGH level if bit 20 in the EDGE register is 0. Detect rising edge if bit 20 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL_IF = 1,
}
impl From<BODRESET_L_A> for bool {
    #[inline(always)]
    fn from(variant: BODRESET_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `BODRESET_L`"]
pub type BODRESET_L_R = crate::R<bool, BODRESET_L_A>;
impl BODRESET_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BODRESET_L_A {
        match self.bits {
            false => BODRESET_L_A::DETECT_LOW_LEVEL_IF,
            true => BODRESET_L_A::DETECT_HIGH_LEVEL_IF,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL_IF`"]
    #[inline(always)]
    pub fn is_detect_low_level_if(&self) -> bool {
        *self == BODRESET_L_A::DETECT_LOW_LEVEL_IF
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL_IF`"]
    #[inline(always)]
    pub fn is_detect_high_level_if(&self) -> bool {
        *self == BODRESET_L_A::DETECT_HIGH_LEVEL_IF
    }
}
#[doc = "Write proxy for field `BODRESET_L`"]
pub struct BODRESET_L_W<'a> {
    w: &'a mut W,
}
impl<'a> BODRESET_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BODRESET_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level if bit 20 in the EDGE register is 0. Detect falling edge if bit 20 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level_if(self) -> &'a mut W {
        self.variant(BODRESET_L_A::DETECT_LOW_LEVEL_IF)
    }
    #[doc = "Detect HIGH level if bit 20 in the EDGE register is 0. Detect rising edge if bit 20 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level_if(self) -> &'a mut W {
        self.variant(BODRESET_L_A::DETECT_HIGH_LEVEL_IF)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 20)) | (((value as u32) & 0x01) << 20);
        self.w
    }
}
#[doc = "Level detect mode for Deep power-down Reset\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DPDRESET_L_A {
    #[doc = "0: Detect LOW level if bit 21 in the EDGE register is 0. Detect falling edge if bit 21 in the EDGE register is 1."]
    DETECT_LOW_LEVEL_IF = 0,
    #[doc = "1: Detect HIGH level if bit 21 in the EDGE register is 0. Detect rising edge if bit 21 in the EDGE register is 1."]
    DETECT_HIGH_LEVEL_IF = 1,
}
impl From<DPDRESET_L_A> for bool {
    #[inline(always)]
    fn from(variant: DPDRESET_L_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `DPDRESET_L`"]
pub type DPDRESET_L_R = crate::R<bool, DPDRESET_L_A>;
impl DPDRESET_L_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DPDRESET_L_A {
        match self.bits {
            false => DPDRESET_L_A::DETECT_LOW_LEVEL_IF,
            true => DPDRESET_L_A::DETECT_HIGH_LEVEL_IF,
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL_IF`"]
    #[inline(always)]
    pub fn is_detect_low_level_if(&self) -> bool {
        *self == DPDRESET_L_A::DETECT_LOW_LEVEL_IF
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL_IF`"]
    #[inline(always)]
    pub fn is_detect_high_level_if(&self) -> bool {
        *self == DPDRESET_L_A::DETECT_HIGH_LEVEL_IF
    }
}
#[doc = "Write proxy for field `DPDRESET_L`"]
pub struct DPDRESET_L_W<'a> {
    w: &'a mut W,
}
impl<'a> DPDRESET_L_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DPDRESET_L_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Detect LOW level if bit 21 in the EDGE register is 0. Detect falling edge if bit 21 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_low_level_if(self) -> &'a mut W {
        self.variant(DPDRESET_L_A::DETECT_LOW_LEVEL_IF)
    }
    #[doc = "Detect HIGH level if bit 21 in the EDGE register is 0. Detect rising edge if bit 21 in the EDGE register is 1."]
    #[inline(always)]
    pub fn detect_high_level_if(self) -> &'a mut W {
        self.variant(DPDRESET_L_A::DETECT_HIGH_LEVEL_IF)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | (((value as u32) & 0x01) << 21);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Level detect mode for WAKEUP0 event."]
    #[inline(always)]
    pub fn wakeup0_l(&self) -> WAKEUP0_L_R {
        WAKEUP0_L_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Level detect mode for WAKEUP1 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup1_l(&self) -> WAKEUP1_L_R {
        WAKEUP1_L_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Level detect mode for WAKEUP2 event."]
    #[inline(always)]
    pub fn wakeup2_l(&self) -> WAKEUP2_L_R {
        WAKEUP2_L_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Level detect mode for WAKEUP3 event."]
    #[inline(always)]
    pub fn wakeup3_l(&self) -> WAKEUP3_L_R {
        WAKEUP3_L_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Level detect mode for alarm timer event."]
    #[inline(always)]
    pub fn atimer_l(&self) -> ATIMER_L_R {
        ATIMER_L_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Level detect mode for RTC event."]
    #[inline(always)]
    pub fn rtc_l(&self) -> RTC_L_R {
        RTC_L_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Level detect mode for BOD event."]
    #[inline(always)]
    pub fn bod_l(&self) -> BOD_L_R {
        BOD_L_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Level detect mode for WWDT event."]
    #[inline(always)]
    pub fn wwdt_l(&self) -> WWDT_L_R {
        WWDT_L_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Level detect mode for Ethernet event"]
    #[inline(always)]
    pub fn eth_l(&self) -> ETH_L_R {
        ETH_L_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Level detect mode for USB0 event"]
    #[inline(always)]
    pub fn usb0_l(&self) -> USB0_L_R {
        USB0_L_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Level detect mode for USB1 event"]
    #[inline(always)]
    pub fn usb1_l(&self) -> USB1_L_R {
        USB1_L_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Level detect mode for SD/MMC event"]
    #[inline(always)]
    pub fn sdmmc_l(&self) -> SDMMC_L_R {
        SDMMC_L_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Level detect mode for C_CAN event."]
    #[inline(always)]
    pub fn can_l(&self) -> CAN_L_R {
        CAN_L_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Level detect mode for combined timer output 2 event."]
    #[inline(always)]
    pub fn tim2_l(&self) -> TIM2_L_R {
        TIM2_L_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Level detect mode for combined timer output 6 event."]
    #[inline(always)]
    pub fn tim6_l(&self) -> TIM6_L_R {
        TIM6_L_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Level detect mode for QEI event."]
    #[inline(always)]
    pub fn qei_l(&self) -> QEI_L_R {
        QEI_L_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Level detect mode for combined timer output 14 event."]
    #[inline(always)]
    pub fn tim14_l(&self) -> TIM14_L_R {
        TIM14_L_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 19 - Level detect mode for Reset"]
    #[inline(always)]
    pub fn reset_l(&self) -> RESET_L_R {
        RESET_L_R::new(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - Level detect mode for BOD Reset"]
    #[inline(always)]
    pub fn bodreset_l(&self) -> BODRESET_L_R {
        BODRESET_L_R::new(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Level detect mode for Deep power-down Reset"]
    #[inline(always)]
    pub fn dpdreset_l(&self) -> DPDRESET_L_R {
        DPDRESET_L_R::new(((self.bits >> 21) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Level detect mode for WAKEUP0 event."]
    #[inline(always)]
    pub fn wakeup0_l(&mut self) -> WAKEUP0_L_W {
        WAKEUP0_L_W { w: self }
    }
    #[doc = "Bit 1 - Level detect mode for WAKEUP1 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup1_l(&mut self) -> WAKEUP1_L_W {
        WAKEUP1_L_W { w: self }
    }
    #[doc = "Bit 2 - Level detect mode for WAKEUP2 event."]
    #[inline(always)]
    pub fn wakeup2_l(&mut self) -> WAKEUP2_L_W {
        WAKEUP2_L_W { w: self }
    }
    #[doc = "Bit 3 - Level detect mode for WAKEUP3 event."]
    #[inline(always)]
    pub fn wakeup3_l(&mut self) -> WAKEUP3_L_W {
        WAKEUP3_L_W { w: self }
    }
    #[doc = "Bit 4 - Level detect mode for alarm timer event."]
    #[inline(always)]
    pub fn atimer_l(&mut self) -> ATIMER_L_W {
        ATIMER_L_W { w: self }
    }
    #[doc = "Bit 5 - Level detect mode for RTC event."]
    #[inline(always)]
    pub fn rtc_l(&mut self) -> RTC_L_W {
        RTC_L_W { w: self }
    }
    #[doc = "Bit 6 - Level detect mode for BOD event."]
    #[inline(always)]
    pub fn bod_l(&mut self) -> BOD_L_W {
        BOD_L_W { w: self }
    }
    #[doc = "Bit 7 - Level detect mode for WWDT event."]
    #[inline(always)]
    pub fn wwdt_l(&mut self) -> WWDT_L_W {
        WWDT_L_W { w: self }
    }
    #[doc = "Bit 8 - Level detect mode for Ethernet event"]
    #[inline(always)]
    pub fn eth_l(&mut self) -> ETH_L_W {
        ETH_L_W { w: self }
    }
    #[doc = "Bit 9 - Level detect mode for USB0 event"]
    #[inline(always)]
    pub fn usb0_l(&mut self) -> USB0_L_W {
        USB0_L_W { w: self }
    }
    #[doc = "Bit 10 - Level detect mode for USB1 event"]
    #[inline(always)]
    pub fn usb1_l(&mut self) -> USB1_L_W {
        USB1_L_W { w: self }
    }
    #[doc = "Bit 11 - Level detect mode for SD/MMC event"]
    #[inline(always)]
    pub fn sdmmc_l(&mut self) -> SDMMC_L_W {
        SDMMC_L_W { w: self }
    }
    #[doc = "Bit 12 - Level detect mode for C_CAN event."]
    #[inline(always)]
    pub fn can_l(&mut self) -> CAN_L_W {
        CAN_L_W { w: self }
    }
    #[doc = "Bit 13 - Level detect mode for combined timer output 2 event."]
    #[inline(always)]
    pub fn tim2_l(&mut self) -> TIM2_L_W {
        TIM2_L_W { w: self }
    }
    #[doc = "Bit 14 - Level detect mode for combined timer output 6 event."]
    #[inline(always)]
    pub fn tim6_l(&mut self) -> TIM6_L_W {
        TIM6_L_W { w: self }
    }
    #[doc = "Bit 15 - Level detect mode for QEI event."]
    #[inline(always)]
    pub fn qei_l(&mut self) -> QEI_L_W {
        QEI_L_W { w: self }
    }
    #[doc = "Bit 16 - Level detect mode for combined timer output 14 event."]
    #[inline(always)]
    pub fn tim14_l(&mut self) -> TIM14_L_W {
        TIM14_L_W { w: self }
    }
    #[doc = "Bit 19 - Level detect mode for Reset"]
    #[inline(always)]
    pub fn reset_l(&mut self) -> RESET_L_W {
        RESET_L_W { w: self }
    }
    #[doc = "Bit 20 - Level detect mode for BOD Reset"]
    #[inline(always)]
    pub fn bodreset_l(&mut self) -> BODRESET_L_W {
        BODRESET_L_W { w: self }
    }
    #[doc = "Bit 21 - Level detect mode for Deep power-down Reset"]
    #[inline(always)]
    pub fn dpdreset_l(&mut self) -> DPDRESET_L_W {
        DPDRESET_L_W { w: self }
    }
}
