#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Timer 0 CAP0_0 capture input multiplexer (GIMA output 0)"]
    pub cap0_0_in: CAP0_0_IN,
    #[doc = "0x04 - Timer 0 CAP0_1 capture input multiplexer (GIMA output 1)"]
    pub cap0_1_in: CAP0_1_IN,
    #[doc = "0x08 - Timer 0 CAP0_2 capture input multiplexer (GIMA output 2)"]
    pub cap0_2_in: CAP0_2_IN,
    #[doc = "0x0c - Timer 0 CAP0_3 capture input multiplexer (GIMA output 3)"]
    pub cap0_3_in: CAP0_3_IN,
    #[doc = "0x10 - Timer 1 CAP1_0 capture input multiplexer (GIMA output 4)"]
    pub cap1_0_in: CAP1_0_IN,
    #[doc = "0x14 - Timer 1 CAP1_1 capture input multiplexer (GIMA output 5)"]
    pub cap1_1_in: CAP1_1_IN,
    #[doc = "0x18 - Timer 1 CAP1_2 capture input multiplexer (GIMA output 6)"]
    pub cap1_2_in: CAP1_2_IN,
    #[doc = "0x1c - Timer 1 CAP1_3 capture input multiplexer (GIMA output 7)"]
    pub cap1_3_in: CAP1_3_IN,
    #[doc = "0x20 - Timer 2 CAP2_0 capture input multiplexer (GIMA output 8)"]
    pub cap2_0_in: CAP2_0_IN,
    #[doc = "0x24 - Timer 2 CAP2_1 capture input multiplexer (GIMA output 9)"]
    pub cap2_1_in: CAP2_1_IN,
    #[doc = "0x28 - Timer 2 CAP2_2 capture input multiplexer (GIMA output 10)"]
    pub cap2_2_in: CAP2_2_IN,
    #[doc = "0x2c - Timer 2 CAP2_3 capture input multiplexer (GIMA output 11)"]
    pub cap2_3_in: CAP2_3_IN,
    #[doc = "0x30 - Timer 3 CAP3_0 capture input multiplexer (GIMA output 12)"]
    pub cap3_0_in: CAP3_0_IN,
    #[doc = "0x34 - Timer 3 CAP3_1 capture input multiplexer (GIMA output 13)"]
    pub cap3_1_in: CAP3_1_IN,
    #[doc = "0x38 - Timer 3 CAP3_2 capture input multiplexer (GIMA output 14)"]
    pub cap3_2_in: CAP3_2_IN,
    #[doc = "0x3c - Timer 3 CAP3_3 capture input multiplexer (GIMA output 15)"]
    pub cap3_3_in: CAP3_3_IN,
    #[doc = "0x40 - SCT CTIN_0 capture input multiplexer (GIMA output 16)"]
    pub ctin_0_in: CTIN_0_IN,
    #[doc = "0x44 - SCT CTIN_1 capture input multiplexer (GIMA output 17)"]
    pub ctin_1_in: CTIN_1_IN,
    #[doc = "0x48 - SCT CTIN_2 capture input multiplexer (GIMA output 18)"]
    pub ctin_2_in: CTIN_2_IN,
    #[doc = "0x4c - SCT CTIN_3 capture input multiplexer (GIMA output 19)"]
    pub ctin_3_in: CTIN_3_IN,
    #[doc = "0x50 - SCT CTIN_4 capture input multiplexer (GIMA output 20)"]
    pub ctin_4_in: CTIN_4_IN,
    #[doc = "0x54 - SCT CTIN_5 capture input multiplexer (GIMA output 21)"]
    pub ctin_5_in: CTIN_5_IN,
    #[doc = "0x58 - SCT CTIN_6 capture input multiplexer (GIMA output 22)"]
    pub ctin_6_in: CTIN_6_IN,
    #[doc = "0x5c - SCT CTIN_7 capture input multiplexer (GIMA output 23)"]
    pub ctin_7_in: CTIN_7_IN,
    #[doc = "0x60 - ADCHS trigger input multiplexer (GIMA output 24)"]
    pub adchs_trigger_in: ADCHS_TRIGGER_IN,
    #[doc = "0x64 - Event router input 13 multiplexer (GIMA output 25)"]
    pub eventrouter_13_in: EVENTROUTER_13_IN,
    #[doc = "0x68 - Event router input 14 multiplexer (GIMA output 26)"]
    pub eventrouter_14_in: EVENTROUTER_14_IN,
    #[doc = "0x6c - Event router input 16 multiplexer (GIMA output 27)"]
    pub eventrouter_16_in: EVENTROUTER_16_IN,
    #[doc = "0x70 - ADC start0 input multiplexer (GIMA output 28)"]
    pub adcstart0_in: ADCSTART0_IN,
    #[doc = "0x74 - ADC start1 input multiplexer (GIMA output 29)"]
    pub adcstart1_in: ADCSTART1_IN,
}
#[doc = "Timer 0 CAP0_0 capture input multiplexer (GIMA output 0)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap0_0_in](cap0_0_in) module"]
pub type CAP0_0_IN = crate::Reg<u32, _CAP0_0_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP0_0_IN;
#[doc = "`read()` method returns [cap0_0_in::R](cap0_0_in::R) reader structure"]
impl crate::Readable for CAP0_0_IN {}
#[doc = "`write(|w| ..)` method takes [cap0_0_in::W](cap0_0_in::W) writer structure"]
impl crate::Writable for CAP0_0_IN {}
#[doc = "Timer 0 CAP0_0 capture input multiplexer (GIMA output 0)"]
pub mod cap0_0_in;
#[doc = "Timer 0 CAP0_1 capture input multiplexer (GIMA output 1)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap0_1_in](cap0_1_in) module"]
pub type CAP0_1_IN = crate::Reg<u32, _CAP0_1_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP0_1_IN;
#[doc = "`read()` method returns [cap0_1_in::R](cap0_1_in::R) reader structure"]
impl crate::Readable for CAP0_1_IN {}
#[doc = "`write(|w| ..)` method takes [cap0_1_in::W](cap0_1_in::W) writer structure"]
impl crate::Writable for CAP0_1_IN {}
#[doc = "Timer 0 CAP0_1 capture input multiplexer (GIMA output 1)"]
pub mod cap0_1_in;
#[doc = "Timer 0 CAP0_2 capture input multiplexer (GIMA output 2)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap0_2_in](cap0_2_in) module"]
pub type CAP0_2_IN = crate::Reg<u32, _CAP0_2_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP0_2_IN;
#[doc = "`read()` method returns [cap0_2_in::R](cap0_2_in::R) reader structure"]
impl crate::Readable for CAP0_2_IN {}
#[doc = "`write(|w| ..)` method takes [cap0_2_in::W](cap0_2_in::W) writer structure"]
impl crate::Writable for CAP0_2_IN {}
#[doc = "Timer 0 CAP0_2 capture input multiplexer (GIMA output 2)"]
pub mod cap0_2_in;
#[doc = "Timer 0 CAP0_3 capture input multiplexer (GIMA output 3)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap0_3_in](cap0_3_in) module"]
pub type CAP0_3_IN = crate::Reg<u32, _CAP0_3_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP0_3_IN;
#[doc = "`read()` method returns [cap0_3_in::R](cap0_3_in::R) reader structure"]
impl crate::Readable for CAP0_3_IN {}
#[doc = "`write(|w| ..)` method takes [cap0_3_in::W](cap0_3_in::W) writer structure"]
impl crate::Writable for CAP0_3_IN {}
#[doc = "Timer 0 CAP0_3 capture input multiplexer (GIMA output 3)"]
pub mod cap0_3_in;
#[doc = "Timer 1 CAP1_0 capture input multiplexer (GIMA output 4)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap1_0_in](cap1_0_in) module"]
pub type CAP1_0_IN = crate::Reg<u32, _CAP1_0_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP1_0_IN;
#[doc = "`read()` method returns [cap1_0_in::R](cap1_0_in::R) reader structure"]
impl crate::Readable for CAP1_0_IN {}
#[doc = "`write(|w| ..)` method takes [cap1_0_in::W](cap1_0_in::W) writer structure"]
impl crate::Writable for CAP1_0_IN {}
#[doc = "Timer 1 CAP1_0 capture input multiplexer (GIMA output 4)"]
pub mod cap1_0_in;
#[doc = "Timer 1 CAP1_1 capture input multiplexer (GIMA output 5)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap1_1_in](cap1_1_in) module"]
pub type CAP1_1_IN = crate::Reg<u32, _CAP1_1_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP1_1_IN;
#[doc = "`read()` method returns [cap1_1_in::R](cap1_1_in::R) reader structure"]
impl crate::Readable for CAP1_1_IN {}
#[doc = "`write(|w| ..)` method takes [cap1_1_in::W](cap1_1_in::W) writer structure"]
impl crate::Writable for CAP1_1_IN {}
#[doc = "Timer 1 CAP1_1 capture input multiplexer (GIMA output 5)"]
pub mod cap1_1_in;
#[doc = "Timer 1 CAP1_2 capture input multiplexer (GIMA output 6)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap1_2_in](cap1_2_in) module"]
pub type CAP1_2_IN = crate::Reg<u32, _CAP1_2_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP1_2_IN;
#[doc = "`read()` method returns [cap1_2_in::R](cap1_2_in::R) reader structure"]
impl crate::Readable for CAP1_2_IN {}
#[doc = "`write(|w| ..)` method takes [cap1_2_in::W](cap1_2_in::W) writer structure"]
impl crate::Writable for CAP1_2_IN {}
#[doc = "Timer 1 CAP1_2 capture input multiplexer (GIMA output 6)"]
pub mod cap1_2_in;
#[doc = "Timer 1 CAP1_3 capture input multiplexer (GIMA output 7)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap1_3_in](cap1_3_in) module"]
pub type CAP1_3_IN = crate::Reg<u32, _CAP1_3_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP1_3_IN;
#[doc = "`read()` method returns [cap1_3_in::R](cap1_3_in::R) reader structure"]
impl crate::Readable for CAP1_3_IN {}
#[doc = "`write(|w| ..)` method takes [cap1_3_in::W](cap1_3_in::W) writer structure"]
impl crate::Writable for CAP1_3_IN {}
#[doc = "Timer 1 CAP1_3 capture input multiplexer (GIMA output 7)"]
pub mod cap1_3_in;
#[doc = "Timer 2 CAP2_0 capture input multiplexer (GIMA output 8)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap2_0_in](cap2_0_in) module"]
pub type CAP2_0_IN = crate::Reg<u32, _CAP2_0_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP2_0_IN;
#[doc = "`read()` method returns [cap2_0_in::R](cap2_0_in::R) reader structure"]
impl crate::Readable for CAP2_0_IN {}
#[doc = "`write(|w| ..)` method takes [cap2_0_in::W](cap2_0_in::W) writer structure"]
impl crate::Writable for CAP2_0_IN {}
#[doc = "Timer 2 CAP2_0 capture input multiplexer (GIMA output 8)"]
pub mod cap2_0_in;
#[doc = "Timer 2 CAP2_1 capture input multiplexer (GIMA output 9)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap2_1_in](cap2_1_in) module"]
pub type CAP2_1_IN = crate::Reg<u32, _CAP2_1_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP2_1_IN;
#[doc = "`read()` method returns [cap2_1_in::R](cap2_1_in::R) reader structure"]
impl crate::Readable for CAP2_1_IN {}
#[doc = "`write(|w| ..)` method takes [cap2_1_in::W](cap2_1_in::W) writer structure"]
impl crate::Writable for CAP2_1_IN {}
#[doc = "Timer 2 CAP2_1 capture input multiplexer (GIMA output 9)"]
pub mod cap2_1_in;
#[doc = "Timer 2 CAP2_2 capture input multiplexer (GIMA output 10)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap2_2_in](cap2_2_in) module"]
pub type CAP2_2_IN = crate::Reg<u32, _CAP2_2_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP2_2_IN;
#[doc = "`read()` method returns [cap2_2_in::R](cap2_2_in::R) reader structure"]
impl crate::Readable for CAP2_2_IN {}
#[doc = "`write(|w| ..)` method takes [cap2_2_in::W](cap2_2_in::W) writer structure"]
impl crate::Writable for CAP2_2_IN {}
#[doc = "Timer 2 CAP2_2 capture input multiplexer (GIMA output 10)"]
pub mod cap2_2_in;
#[doc = "Timer 2 CAP2_3 capture input multiplexer (GIMA output 11)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap2_3_in](cap2_3_in) module"]
pub type CAP2_3_IN = crate::Reg<u32, _CAP2_3_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP2_3_IN;
#[doc = "`read()` method returns [cap2_3_in::R](cap2_3_in::R) reader structure"]
impl crate::Readable for CAP2_3_IN {}
#[doc = "`write(|w| ..)` method takes [cap2_3_in::W](cap2_3_in::W) writer structure"]
impl crate::Writable for CAP2_3_IN {}
#[doc = "Timer 2 CAP2_3 capture input multiplexer (GIMA output 11)"]
pub mod cap2_3_in;
#[doc = "Timer 3 CAP3_0 capture input multiplexer (GIMA output 12)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap3_0_in](cap3_0_in) module"]
pub type CAP3_0_IN = crate::Reg<u32, _CAP3_0_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP3_0_IN;
#[doc = "`read()` method returns [cap3_0_in::R](cap3_0_in::R) reader structure"]
impl crate::Readable for CAP3_0_IN {}
#[doc = "`write(|w| ..)` method takes [cap3_0_in::W](cap3_0_in::W) writer structure"]
impl crate::Writable for CAP3_0_IN {}
#[doc = "Timer 3 CAP3_0 capture input multiplexer (GIMA output 12)"]
pub mod cap3_0_in;
#[doc = "Timer 3 CAP3_1 capture input multiplexer (GIMA output 13)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap3_1_in](cap3_1_in) module"]
pub type CAP3_1_IN = crate::Reg<u32, _CAP3_1_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP3_1_IN;
#[doc = "`read()` method returns [cap3_1_in::R](cap3_1_in::R) reader structure"]
impl crate::Readable for CAP3_1_IN {}
#[doc = "`write(|w| ..)` method takes [cap3_1_in::W](cap3_1_in::W) writer structure"]
impl crate::Writable for CAP3_1_IN {}
#[doc = "Timer 3 CAP3_1 capture input multiplexer (GIMA output 13)"]
pub mod cap3_1_in;
#[doc = "Timer 3 CAP3_2 capture input multiplexer (GIMA output 14)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap3_2_in](cap3_2_in) module"]
pub type CAP3_2_IN = crate::Reg<u32, _CAP3_2_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP3_2_IN;
#[doc = "`read()` method returns [cap3_2_in::R](cap3_2_in::R) reader structure"]
impl crate::Readable for CAP3_2_IN {}
#[doc = "`write(|w| ..)` method takes [cap3_2_in::W](cap3_2_in::W) writer structure"]
impl crate::Writable for CAP3_2_IN {}
#[doc = "Timer 3 CAP3_2 capture input multiplexer (GIMA output 14)"]
pub mod cap3_2_in;
#[doc = "Timer 3 CAP3_3 capture input multiplexer (GIMA output 15)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cap3_3_in](cap3_3_in) module"]
pub type CAP3_3_IN = crate::Reg<u32, _CAP3_3_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP3_3_IN;
#[doc = "`read()` method returns [cap3_3_in::R](cap3_3_in::R) reader structure"]
impl crate::Readable for CAP3_3_IN {}
#[doc = "`write(|w| ..)` method takes [cap3_3_in::W](cap3_3_in::W) writer structure"]
impl crate::Writable for CAP3_3_IN {}
#[doc = "Timer 3 CAP3_3 capture input multiplexer (GIMA output 15)"]
pub mod cap3_3_in;
#[doc = "SCT CTIN_0 capture input multiplexer (GIMA output 16)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_0_in](ctin_0_in) module"]
pub type CTIN_0_IN = crate::Reg<u32, _CTIN_0_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_0_IN;
#[doc = "`read()` method returns [ctin_0_in::R](ctin_0_in::R) reader structure"]
impl crate::Readable for CTIN_0_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_0_in::W](ctin_0_in::W) writer structure"]
impl crate::Writable for CTIN_0_IN {}
#[doc = "SCT CTIN_0 capture input multiplexer (GIMA output 16)"]
pub mod ctin_0_in;
#[doc = "SCT CTIN_1 capture input multiplexer (GIMA output 17)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_1_in](ctin_1_in) module"]
pub type CTIN_1_IN = crate::Reg<u32, _CTIN_1_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_1_IN;
#[doc = "`read()` method returns [ctin_1_in::R](ctin_1_in::R) reader structure"]
impl crate::Readable for CTIN_1_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_1_in::W](ctin_1_in::W) writer structure"]
impl crate::Writable for CTIN_1_IN {}
#[doc = "SCT CTIN_1 capture input multiplexer (GIMA output 17)"]
pub mod ctin_1_in;
#[doc = "SCT CTIN_2 capture input multiplexer (GIMA output 18)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_2_in](ctin_2_in) module"]
pub type CTIN_2_IN = crate::Reg<u32, _CTIN_2_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_2_IN;
#[doc = "`read()` method returns [ctin_2_in::R](ctin_2_in::R) reader structure"]
impl crate::Readable for CTIN_2_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_2_in::W](ctin_2_in::W) writer structure"]
impl crate::Writable for CTIN_2_IN {}
#[doc = "SCT CTIN_2 capture input multiplexer (GIMA output 18)"]
pub mod ctin_2_in;
#[doc = "SCT CTIN_3 capture input multiplexer (GIMA output 19)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_3_in](ctin_3_in) module"]
pub type CTIN_3_IN = crate::Reg<u32, _CTIN_3_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_3_IN;
#[doc = "`read()` method returns [ctin_3_in::R](ctin_3_in::R) reader structure"]
impl crate::Readable for CTIN_3_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_3_in::W](ctin_3_in::W) writer structure"]
impl crate::Writable for CTIN_3_IN {}
#[doc = "SCT CTIN_3 capture input multiplexer (GIMA output 19)"]
pub mod ctin_3_in;
#[doc = "SCT CTIN_4 capture input multiplexer (GIMA output 20)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_4_in](ctin_4_in) module"]
pub type CTIN_4_IN = crate::Reg<u32, _CTIN_4_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_4_IN;
#[doc = "`read()` method returns [ctin_4_in::R](ctin_4_in::R) reader structure"]
impl crate::Readable for CTIN_4_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_4_in::W](ctin_4_in::W) writer structure"]
impl crate::Writable for CTIN_4_IN {}
#[doc = "SCT CTIN_4 capture input multiplexer (GIMA output 20)"]
pub mod ctin_4_in;
#[doc = "SCT CTIN_5 capture input multiplexer (GIMA output 21)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_5_in](ctin_5_in) module"]
pub type CTIN_5_IN = crate::Reg<u32, _CTIN_5_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_5_IN;
#[doc = "`read()` method returns [ctin_5_in::R](ctin_5_in::R) reader structure"]
impl crate::Readable for CTIN_5_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_5_in::W](ctin_5_in::W) writer structure"]
impl crate::Writable for CTIN_5_IN {}
#[doc = "SCT CTIN_5 capture input multiplexer (GIMA output 21)"]
pub mod ctin_5_in;
#[doc = "SCT CTIN_6 capture input multiplexer (GIMA output 22)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_6_in](ctin_6_in) module"]
pub type CTIN_6_IN = crate::Reg<u32, _CTIN_6_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_6_IN;
#[doc = "`read()` method returns [ctin_6_in::R](ctin_6_in::R) reader structure"]
impl crate::Readable for CTIN_6_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_6_in::W](ctin_6_in::W) writer structure"]
impl crate::Writable for CTIN_6_IN {}
#[doc = "SCT CTIN_6 capture input multiplexer (GIMA output 22)"]
pub mod ctin_6_in;
#[doc = "SCT CTIN_7 capture input multiplexer (GIMA output 23)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctin_7_in](ctin_7_in) module"]
pub type CTIN_7_IN = crate::Reg<u32, _CTIN_7_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTIN_7_IN;
#[doc = "`read()` method returns [ctin_7_in::R](ctin_7_in::R) reader structure"]
impl crate::Readable for CTIN_7_IN {}
#[doc = "`write(|w| ..)` method takes [ctin_7_in::W](ctin_7_in::W) writer structure"]
impl crate::Writable for CTIN_7_IN {}
#[doc = "SCT CTIN_7 capture input multiplexer (GIMA output 23)"]
pub mod ctin_7_in;
#[doc = "ADCHS trigger input multiplexer (GIMA output 24)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [adchs_trigger_in](adchs_trigger_in) module"]
pub type ADCHS_TRIGGER_IN = crate::Reg<u32, _ADCHS_TRIGGER_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ADCHS_TRIGGER_IN;
#[doc = "`read()` method returns [adchs_trigger_in::R](adchs_trigger_in::R) reader structure"]
impl crate::Readable for ADCHS_TRIGGER_IN {}
#[doc = "`write(|w| ..)` method takes [adchs_trigger_in::W](adchs_trigger_in::W) writer structure"]
impl crate::Writable for ADCHS_TRIGGER_IN {}
#[doc = "ADCHS trigger input multiplexer (GIMA output 24)"]
pub mod adchs_trigger_in;
#[doc = "Event router input 13 multiplexer (GIMA output 25)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [eventrouter_13_in](eventrouter_13_in) module"]
pub type EVENTROUTER_13_IN = crate::Reg<u32, _EVENTROUTER_13_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EVENTROUTER_13_IN;
#[doc = "`read()` method returns [eventrouter_13_in::R](eventrouter_13_in::R) reader structure"]
impl crate::Readable for EVENTROUTER_13_IN {}
#[doc = "`write(|w| ..)` method takes [eventrouter_13_in::W](eventrouter_13_in::W) writer structure"]
impl crate::Writable for EVENTROUTER_13_IN {}
#[doc = "Event router input 13 multiplexer (GIMA output 25)"]
pub mod eventrouter_13_in;
#[doc = "Event router input 14 multiplexer (GIMA output 26)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [eventrouter_14_in](eventrouter_14_in) module"]
pub type EVENTROUTER_14_IN = crate::Reg<u32, _EVENTROUTER_14_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EVENTROUTER_14_IN;
#[doc = "`read()` method returns [eventrouter_14_in::R](eventrouter_14_in::R) reader structure"]
impl crate::Readable for EVENTROUTER_14_IN {}
#[doc = "`write(|w| ..)` method takes [eventrouter_14_in::W](eventrouter_14_in::W) writer structure"]
impl crate::Writable for EVENTROUTER_14_IN {}
#[doc = "Event router input 14 multiplexer (GIMA output 26)"]
pub mod eventrouter_14_in;
#[doc = "Event router input 16 multiplexer (GIMA output 27)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [eventrouter_16_in](eventrouter_16_in) module"]
pub type EVENTROUTER_16_IN = crate::Reg<u32, _EVENTROUTER_16_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EVENTROUTER_16_IN;
#[doc = "`read()` method returns [eventrouter_16_in::R](eventrouter_16_in::R) reader structure"]
impl crate::Readable for EVENTROUTER_16_IN {}
#[doc = "`write(|w| ..)` method takes [eventrouter_16_in::W](eventrouter_16_in::W) writer structure"]
impl crate::Writable for EVENTROUTER_16_IN {}
#[doc = "Event router input 16 multiplexer (GIMA output 27)"]
pub mod eventrouter_16_in;
#[doc = "ADC start0 input multiplexer (GIMA output 28)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [adcstart0_in](adcstart0_in) module"]
pub type ADCSTART0_IN = crate::Reg<u32, _ADCSTART0_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ADCSTART0_IN;
#[doc = "`read()` method returns [adcstart0_in::R](adcstart0_in::R) reader structure"]
impl crate::Readable for ADCSTART0_IN {}
#[doc = "`write(|w| ..)` method takes [adcstart0_in::W](adcstart0_in::W) writer structure"]
impl crate::Writable for ADCSTART0_IN {}
#[doc = "ADC start0 input multiplexer (GIMA output 28)"]
pub mod adcstart0_in;
#[doc = "ADC start1 input multiplexer (GIMA output 29)\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [adcstart1_in](adcstart1_in) module"]
pub type ADCSTART1_IN = crate::Reg<u32, _ADCSTART1_IN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ADCSTART1_IN;
#[doc = "`read()` method returns [adcstart1_in::R](adcstart1_in::R) reader structure"]
impl crate::Readable for ADCSTART1_IN {}
#[doc = "`write(|w| ..)` method takes [adcstart1_in::W](adcstart1_in::W) writer structure"]
impl crate::Writable for ADCSTART1_IN {}
#[doc = "ADC start1 input multiplexer (GIMA output 29)"]
pub mod adcstart1_in;
