#[doc = "Reader of register CAP1_1_IN"]
pub type R = crate::R<u32, super::CAP1_1_IN>;
#[doc = "Writer for register CAP1_1_IN"]
pub type W = crate::W<u32, super::CAP1_1_IN>;
#[doc = "Register CAP1_1_IN `reset()`'s with value 0"]
impl crate::ResetValue for super::CAP1_1_IN {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Invert input\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INV_A {
    #[doc = "0: Not inverted."]
    NOT_INVERTED = 0,
    #[doc = "1: Input inverted."]
    INPUT_INVERTED = 1,
}
impl From<INV_A> for bool {
    #[inline(always)]
    fn from(variant: INV_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `INV`"]
pub type INV_R = crate::R<bool, INV_A>;
impl INV_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INV_A {
        match self.bits {
            false => INV_A::NOT_INVERTED,
            true => INV_A::INPUT_INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOT_INVERTED`"]
    #[inline(always)]
    pub fn is_not_inverted(&self) -> bool {
        *self == INV_A::NOT_INVERTED
    }
    #[doc = "Checks if the value of the field is `INPUT_INVERTED`"]
    #[inline(always)]
    pub fn is_input_inverted(&self) -> bool {
        *self == INV_A::INPUT_INVERTED
    }
}
#[doc = "Write proxy for field `INV`"]
pub struct INV_W<'a> {
    w: &'a mut W,
}
impl<'a> INV_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INV_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Not inverted."]
    #[inline(always)]
    pub fn not_inverted(self) -> &'a mut W {
        self.variant(INV_A::NOT_INVERTED)
    }
    #[doc = "Input inverted."]
    #[inline(always)]
    pub fn input_inverted(self) -> &'a mut W {
        self.variant(INV_A::INPUT_INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Enable rising edge detection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EDGE_A {
    #[doc = "0: No edge detection."]
    NO_EDGE_DETECTION = 0,
    #[doc = "1: Rising edge detection enabled."]
    RISING_EDGE_DETECTION_ENABLED = 1,
}
impl From<EDGE_A> for bool {
    #[inline(always)]
    fn from(variant: EDGE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EDGE`"]
pub type EDGE_R = crate::R<bool, EDGE_A>;
impl EDGE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EDGE_A {
        match self.bits {
            false => EDGE_A::NO_EDGE_DETECTION,
            true => EDGE_A::RISING_EDGE_DETECTION_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `NO_EDGE_DETECTION`"]
    #[inline(always)]
    pub fn is_no_edge_detection(&self) -> bool {
        *self == EDGE_A::NO_EDGE_DETECTION
    }
    #[doc = "Checks if the value of the field is `RISING_EDGE_DETECTION_ENABLED`"]
    #[inline(always)]
    pub fn is_rising_edge_detection_enabled(&self) -> bool {
        *self == EDGE_A::RISING_EDGE_DETECTION_ENABLED
    }
}
#[doc = "Write proxy for field `EDGE`"]
pub struct EDGE_W<'a> {
    w: &'a mut W,
}
impl<'a> EDGE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EDGE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No edge detection."]
    #[inline(always)]
    pub fn no_edge_detection(self) -> &'a mut W {
        self.variant(EDGE_A::NO_EDGE_DETECTION)
    }
    #[doc = "Rising edge detection enabled."]
    #[inline(always)]
    pub fn rising_edge_detection_enabled(self) -> &'a mut W {
        self.variant(EDGE_A::RISING_EDGE_DETECTION_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Enable synchronization\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SYNCH_A {
    #[doc = "0: Disable   synchronization."]
    DISABLE_SYNCHRONIZ = 0,
    #[doc = "1: Enable   synchronization."]
    ENABLE_SYNCHRONIZA = 1,
}
impl From<SYNCH_A> for bool {
    #[inline(always)]
    fn from(variant: SYNCH_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SYNCH`"]
pub type SYNCH_R = crate::R<bool, SYNCH_A>;
impl SYNCH_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SYNCH_A {
        match self.bits {
            false => SYNCH_A::DISABLE_SYNCHRONIZ,
            true => SYNCH_A::ENABLE_SYNCHRONIZA,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE_SYNCHRONIZ`"]
    #[inline(always)]
    pub fn is_disable_synchroniz(&self) -> bool {
        *self == SYNCH_A::DISABLE_SYNCHRONIZ
    }
    #[doc = "Checks if the value of the field is `ENABLE_SYNCHRONIZA`"]
    #[inline(always)]
    pub fn is_enable_synchroniza(&self) -> bool {
        *self == SYNCH_A::ENABLE_SYNCHRONIZA
    }
}
#[doc = "Write proxy for field `SYNCH`"]
pub struct SYNCH_W<'a> {
    w: &'a mut W,
}
impl<'a> SYNCH_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SYNCH_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disable synchronization."]
    #[inline(always)]
    pub fn disable_synchroniz(self) -> &'a mut W {
        self.variant(SYNCH_A::DISABLE_SYNCHRONIZ)
    }
    #[doc = "Enable synchronization."]
    #[inline(always)]
    pub fn enable_synchroniza(self) -> &'a mut W {
        self.variant(SYNCH_A::ENABLE_SYNCHRONIZA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Enable single pulse generation.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PULSE_A {
    #[doc = "0: Disable single pulse generation."]
    DISABLE_SINGLE_PULSE_GENERATION = 0,
    #[doc = "1: Enable single pulse generation."]
    ENABLE_SINGLE_PULSE = 1,
}
impl From<PULSE_A> for bool {
    #[inline(always)]
    fn from(variant: PULSE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PULSE`"]
pub type PULSE_R = crate::R<bool, PULSE_A>;
impl PULSE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PULSE_A {
        match self.bits {
            false => PULSE_A::DISABLE_SINGLE_PULSE_GENERATION,
            true => PULSE_A::ENABLE_SINGLE_PULSE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE_SINGLE_PULSE_GENERATION`"]
    #[inline(always)]
    pub fn is_disable_single_pulse_generation(&self) -> bool {
        *self == PULSE_A::DISABLE_SINGLE_PULSE_GENERATION
    }
    #[doc = "Checks if the value of the field is `ENABLE_SINGLE_PULSE`"]
    #[inline(always)]
    pub fn is_enable_single_pulse(&self) -> bool {
        *self == PULSE_A::ENABLE_SINGLE_PULSE
    }
}
#[doc = "Write proxy for field `PULSE`"]
pub struct PULSE_W<'a> {
    w: &'a mut W,
}
impl<'a> PULSE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PULSE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disable single pulse generation."]
    #[inline(always)]
    pub fn disable_single_pulse_generation(self) -> &'a mut W {
        self.variant(PULSE_A::DISABLE_SINGLE_PULSE_GENERATION)
    }
    #[doc = "Enable single pulse generation."]
    #[inline(always)]
    pub fn enable_single_pulse(self) -> &'a mut W {
        self.variant(PULSE_A::ENABLE_SINGLE_PULSE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Select input. Values 0x3 to 0xF are reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum SELECT_A {
    #[doc = "0: CTIN_3"]
    CTIN_3 = 0,
    #[doc = "1: USART0 TX active"]
    USART0_TX_ACTIVE = 1,
    #[doc = "2: T1_CAP1"]
    T1_CAP1 = 2,
}
impl From<SELECT_A> for u8 {
    #[inline(always)]
    fn from(variant: SELECT_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `SELECT`"]
pub type SELECT_R = crate::R<u8, SELECT_A>;
impl SELECT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, SELECT_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(SELECT_A::CTIN_3),
            1 => Val(SELECT_A::USART0_TX_ACTIVE),
            2 => Val(SELECT_A::T1_CAP1),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `CTIN_3`"]
    #[inline(always)]
    pub fn is_ctin_3(&self) -> bool {
        *self == SELECT_A::CTIN_3
    }
    #[doc = "Checks if the value of the field is `USART0_TX_ACTIVE`"]
    #[inline(always)]
    pub fn is_usart0_tx_active(&self) -> bool {
        *self == SELECT_A::USART0_TX_ACTIVE
    }
    #[doc = "Checks if the value of the field is `T1_CAP1`"]
    #[inline(always)]
    pub fn is_t1_cap1(&self) -> bool {
        *self == SELECT_A::T1_CAP1
    }
}
#[doc = "Write proxy for field `SELECT`"]
pub struct SELECT_W<'a> {
    w: &'a mut W,
}
impl<'a> SELECT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SELECT_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "CTIN_3"]
    #[inline(always)]
    pub fn ctin_3(self) -> &'a mut W {
        self.variant(SELECT_A::CTIN_3)
    }
    #[doc = "USART0 TX active"]
    #[inline(always)]
    pub fn usart0_tx_active(self) -> &'a mut W {
        self.variant(SELECT_A::USART0_TX_ACTIVE)
    }
    #[doc = "T1_CAP1"]
    #[inline(always)]
    pub fn t1_cap1(self) -> &'a mut W {
        self.variant(SELECT_A::T1_CAP1)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 4)) | (((value as u32) & 0x0f) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Invert input"]
    #[inline(always)]
    pub fn inv(&self) -> INV_R {
        INV_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Enable rising edge detection"]
    #[inline(always)]
    pub fn edge(&self) -> EDGE_R {
        EDGE_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Enable synchronization"]
    #[inline(always)]
    pub fn synch(&self) -> SYNCH_R {
        SYNCH_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Enable single pulse generation."]
    #[inline(always)]
    pub fn pulse(&self) -> PULSE_R {
        PULSE_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bits 4:7 - Select input. Values 0x3 to 0xF are reserved."]
    #[inline(always)]
    pub fn select(&self) -> SELECT_R {
        SELECT_R::new(((self.bits >> 4) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Invert input"]
    #[inline(always)]
    pub fn inv(&mut self) -> INV_W {
        INV_W { w: self }
    }
    #[doc = "Bit 1 - Enable rising edge detection"]
    #[inline(always)]
    pub fn edge(&mut self) -> EDGE_W {
        EDGE_W { w: self }
    }
    #[doc = "Bit 2 - Enable synchronization"]
    #[inline(always)]
    pub fn synch(&mut self) -> SYNCH_W {
        SYNCH_W { w: self }
    }
    #[doc = "Bit 3 - Enable single pulse generation."]
    #[inline(always)]
    pub fn pulse(&mut self) -> PULSE_W {
        PULSE_W { w: self }
    }
    #[doc = "Bits 4:7 - Select input. Values 0x3 to 0xF are reserved."]
    #[inline(always)]
    pub fn select(&mut self) -> SELECT_W {
        SELECT_W { w: self }
    }
}
