#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - DMA Interrupt Status Register"]
    pub intstat: INTSTAT,
    #[doc = "0x04 - DMA Interrupt Terminal Count Request Status Register"]
    pub inttcstat: INTTCSTAT,
    #[doc = "0x08 - DMA Interrupt Terminal Count Request Clear Register"]
    pub inttcclear: INTTCCLEAR,
    #[doc = "0x0c - DMA Interrupt Error Status Register"]
    pub interrstat: INTERRSTAT,
    #[doc = "0x10 - DMA Interrupt Error Clear Register"]
    pub interrclr: INTERRCLR,
    #[doc = "0x14 - DMA Raw Interrupt Terminal Count Status Register"]
    pub rawinttcstat: RAWINTTCSTAT,
    #[doc = "0x18 - DMA Raw Error Interrupt Status Register"]
    pub rawinterrstat: RAWINTERRSTAT,
    #[doc = "0x1c - DMA Enabled Channel Register"]
    pub enbldchns: ENBLDCHNS,
    #[doc = "0x20 - DMA Software Burst Request Register"]
    pub softbreq: SOFTBREQ,
    #[doc = "0x24 - DMA Software Single Request Register"]
    pub softsreq: SOFTSREQ,
    #[doc = "0x28 - DMA Software Last Burst Request Register"]
    pub softlbreq: SOFTLBREQ,
    #[doc = "0x2c - DMA Software Last Single Request Register"]
    pub softlsreq: SOFTLSREQ,
    #[doc = "0x30 - DMA Configuration Register"]
    pub config: CONFIG,
    #[doc = "0x34 - DMA Synchronization Register"]
    pub sync: SYNC,
    _reserved14: [u8; 200usize],
    #[doc = "0x100 - DMA Channel Source Address Register"]
    pub c0srcaddr: CSRCADDR,
    #[doc = "0x104 - DMA Channel Destination Address Register"]
    pub c0destaddr: CDESTADDR,
    #[doc = "0x108 - DMA Channel Linked List Item Register"]
    pub c0lli: CLLI,
    #[doc = "0x10c - DMA Channel Control Register"]
    pub c0control: CCONTROL,
    #[doc = "0x110 - DMA Channel Configuration Register"]
    pub c0config: CCONFIG,
    _reserved19: [u8; 12usize],
    #[doc = "0x120 - DMA Channel Source Address Register"]
    pub c1srcaddr: CSRCADDR,
    #[doc = "0x124 - DMA Channel Destination Address Register"]
    pub c1destaddr: CDESTADDR,
    #[doc = "0x128 - DMA Channel Linked List Item Register"]
    pub c1lli: CLLI,
    #[doc = "0x12c - DMA Channel Control Register"]
    pub c1control: CCONTROL,
    #[doc = "0x130 - DMA Channel Configuration Register"]
    pub c1config: CCONFIG,
    _reserved24: [u8; 12usize],
    #[doc = "0x140 - DMA Channel Source Address Register"]
    pub c2srcaddr: CSRCADDR,
    #[doc = "0x144 - DMA Channel Destination Address Register"]
    pub c2destaddr: CDESTADDR,
    #[doc = "0x148 - DMA Channel Linked List Item Register"]
    pub c2lli: CLLI,
    #[doc = "0x14c - DMA Channel Control Register"]
    pub c2control: CCONTROL,
    #[doc = "0x150 - DMA Channel Configuration Register"]
    pub c2config: CCONFIG,
    _reserved29: [u8; 12usize],
    #[doc = "0x160 - DMA Channel Source Address Register"]
    pub c3srcaddr: CSRCADDR,
    #[doc = "0x164 - DMA Channel Destination Address Register"]
    pub c3destaddr: CDESTADDR,
    #[doc = "0x168 - DMA Channel Linked List Item Register"]
    pub c3lli: CLLI,
    #[doc = "0x16c - DMA Channel Control Register"]
    pub c3control: CCONTROL,
    #[doc = "0x170 - DMA Channel Configuration Register"]
    pub c3config: CCONFIG,
    _reserved34: [u8; 12usize],
    #[doc = "0x180 - DMA Channel Source Address Register"]
    pub c4srcaddr: CSRCADDR,
    #[doc = "0x184 - DMA Channel Destination Address Register"]
    pub c4destaddr: CDESTADDR,
    #[doc = "0x188 - DMA Channel Linked List Item Register"]
    pub c4lli: CLLI,
    #[doc = "0x18c - DMA Channel Control Register"]
    pub c4control: CCONTROL,
    #[doc = "0x190 - DMA Channel Configuration Register"]
    pub c4config: CCONFIG,
    _reserved39: [u8; 12usize],
    #[doc = "0x1a0 - DMA Channel Source Address Register"]
    pub c5srcaddr: CSRCADDR,
    #[doc = "0x1a4 - DMA Channel Destination Address Register"]
    pub c5destaddr: CDESTADDR,
    #[doc = "0x1a8 - DMA Channel Linked List Item Register"]
    pub c5lli: CLLI,
    #[doc = "0x1ac - DMA Channel Control Register"]
    pub c5control: CCONTROL,
    #[doc = "0x1b0 - DMA Channel Configuration Register"]
    pub c5config: CCONFIG,
    _reserved44: [u8; 12usize],
    #[doc = "0x1c0 - DMA Channel Source Address Register"]
    pub c6srcaddr: CSRCADDR,
    #[doc = "0x1c4 - DMA Channel Destination Address Register"]
    pub c6destaddr: CDESTADDR,
    #[doc = "0x1c8 - DMA Channel Linked List Item Register"]
    pub c6lli: CLLI,
    #[doc = "0x1cc - DMA Channel Control Register"]
    pub c6control: CCONTROL,
    #[doc = "0x1d0 - DMA Channel Configuration Register"]
    pub c6config: CCONFIG,
    _reserved49: [u8; 12usize],
    #[doc = "0x1e0 - DMA Channel Source Address Register"]
    pub c7srcaddr: CSRCADDR,
    #[doc = "0x1e4 - DMA Channel Destination Address Register"]
    pub c7destaddr: CDESTADDR,
    #[doc = "0x1e8 - DMA Channel Linked List Item Register"]
    pub c7lli: CLLI,
    #[doc = "0x1ec - DMA Channel Control Register"]
    pub c7control: CCONTROL,
    #[doc = "0x1f0 - DMA Channel Configuration Register"]
    pub c7config: CCONFIG,
}
#[doc = "DMA Interrupt Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [intstat](intstat) module"]
pub type INTSTAT = crate::Reg<u32, _INTSTAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INTSTAT;
#[doc = "`read()` method returns [intstat::R](intstat::R) reader structure"]
impl crate::Readable for INTSTAT {}
#[doc = "DMA Interrupt Status Register"]
pub mod intstat;
#[doc = "DMA Interrupt Terminal Count Request Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [inttcstat](inttcstat) module"]
pub type INTTCSTAT = crate::Reg<u32, _INTTCSTAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INTTCSTAT;
#[doc = "`read()` method returns [inttcstat::R](inttcstat::R) reader structure"]
impl crate::Readable for INTTCSTAT {}
#[doc = "DMA Interrupt Terminal Count Request Status Register"]
pub mod inttcstat;
#[doc = "DMA Interrupt Terminal Count Request Clear Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [inttcclear](inttcclear) module"]
pub type INTTCCLEAR = crate::Reg<u32, _INTTCCLEAR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INTTCCLEAR;
#[doc = "`write(|w| ..)` method takes [inttcclear::W](inttcclear::W) writer structure"]
impl crate::Writable for INTTCCLEAR {}
#[doc = "DMA Interrupt Terminal Count Request Clear Register"]
pub mod inttcclear;
#[doc = "DMA Interrupt Error Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [interrstat](interrstat) module"]
pub type INTERRSTAT = crate::Reg<u32, _INTERRSTAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INTERRSTAT;
#[doc = "`read()` method returns [interrstat::R](interrstat::R) reader structure"]
impl crate::Readable for INTERRSTAT {}
#[doc = "DMA Interrupt Error Status Register"]
pub mod interrstat;
#[doc = "DMA Interrupt Error Clear Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [interrclr](interrclr) module"]
pub type INTERRCLR = crate::Reg<u32, _INTERRCLR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INTERRCLR;
#[doc = "`write(|w| ..)` method takes [interrclr::W](interrclr::W) writer structure"]
impl crate::Writable for INTERRCLR {}
#[doc = "DMA Interrupt Error Clear Register"]
pub mod interrclr;
#[doc = "DMA Raw Interrupt Terminal Count Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rawinttcstat](rawinttcstat) module"]
pub type RAWINTTCSTAT = crate::Reg<u32, _RAWINTTCSTAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAWINTTCSTAT;
#[doc = "`read()` method returns [rawinttcstat::R](rawinttcstat::R) reader structure"]
impl crate::Readable for RAWINTTCSTAT {}
#[doc = "DMA Raw Interrupt Terminal Count Status Register"]
pub mod rawinttcstat;
#[doc = "DMA Raw Error Interrupt Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rawinterrstat](rawinterrstat) module"]
pub type RAWINTERRSTAT = crate::Reg<u32, _RAWINTERRSTAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RAWINTERRSTAT;
#[doc = "`read()` method returns [rawinterrstat::R](rawinterrstat::R) reader structure"]
impl crate::Readable for RAWINTERRSTAT {}
#[doc = "DMA Raw Error Interrupt Status Register"]
pub mod rawinterrstat;
#[doc = "DMA Enabled Channel Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [enbldchns](enbldchns) module"]
pub type ENBLDCHNS = crate::Reg<u32, _ENBLDCHNS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ENBLDCHNS;
#[doc = "`read()` method returns [enbldchns::R](enbldchns::R) reader structure"]
impl crate::Readable for ENBLDCHNS {}
#[doc = "DMA Enabled Channel Register"]
pub mod enbldchns;
#[doc = "DMA Software Burst Request Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [softbreq](softbreq) module"]
pub type SOFTBREQ = crate::Reg<u32, _SOFTBREQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SOFTBREQ;
#[doc = "`read()` method returns [softbreq::R](softbreq::R) reader structure"]
impl crate::Readable for SOFTBREQ {}
#[doc = "`write(|w| ..)` method takes [softbreq::W](softbreq::W) writer structure"]
impl crate::Writable for SOFTBREQ {}
#[doc = "DMA Software Burst Request Register"]
pub mod softbreq;
#[doc = "DMA Software Single Request Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [softsreq](softsreq) module"]
pub type SOFTSREQ = crate::Reg<u32, _SOFTSREQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SOFTSREQ;
#[doc = "`read()` method returns [softsreq::R](softsreq::R) reader structure"]
impl crate::Readable for SOFTSREQ {}
#[doc = "`write(|w| ..)` method takes [softsreq::W](softsreq::W) writer structure"]
impl crate::Writable for SOFTSREQ {}
#[doc = "DMA Software Single Request Register"]
pub mod softsreq;
#[doc = "DMA Software Last Burst Request Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [softlbreq](softlbreq) module"]
pub type SOFTLBREQ = crate::Reg<u32, _SOFTLBREQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SOFTLBREQ;
#[doc = "`read()` method returns [softlbreq::R](softlbreq::R) reader structure"]
impl crate::Readable for SOFTLBREQ {}
#[doc = "`write(|w| ..)` method takes [softlbreq::W](softlbreq::W) writer structure"]
impl crate::Writable for SOFTLBREQ {}
#[doc = "DMA Software Last Burst Request Register"]
pub mod softlbreq;
#[doc = "DMA Software Last Single Request Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [softlsreq](softlsreq) module"]
pub type SOFTLSREQ = crate::Reg<u32, _SOFTLSREQ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SOFTLSREQ;
#[doc = "`read()` method returns [softlsreq::R](softlsreq::R) reader structure"]
impl crate::Readable for SOFTLSREQ {}
#[doc = "`write(|w| ..)` method takes [softlsreq::W](softlsreq::W) writer structure"]
impl crate::Writable for SOFTLSREQ {}
#[doc = "DMA Software Last Single Request Register"]
pub mod softlsreq;
#[doc = "DMA Configuration Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [config](config) module"]
pub type CONFIG = crate::Reg<u32, _CONFIG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CONFIG;
#[doc = "`read()` method returns [config::R](config::R) reader structure"]
impl crate::Readable for CONFIG {}
#[doc = "`write(|w| ..)` method takes [config::W](config::W) writer structure"]
impl crate::Writable for CONFIG {}
#[doc = "DMA Configuration Register"]
pub mod config;
#[doc = "DMA Synchronization Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [sync](sync) module"]
pub type SYNC = crate::Reg<u32, _SYNC>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SYNC;
#[doc = "`read()` method returns [sync::R](sync::R) reader structure"]
impl crate::Readable for SYNC {}
#[doc = "`write(|w| ..)` method takes [sync::W](sync::W) writer structure"]
impl crate::Writable for SYNC {}
#[doc = "DMA Synchronization Register"]
pub mod sync;
#[doc = "DMA Channel Source Address Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [csrcaddr](csrcaddr) module"]
pub type CSRCADDR = crate::Reg<u32, _CSRCADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CSRCADDR;
#[doc = "`read()` method returns [csrcaddr::R](csrcaddr::R) reader structure"]
impl crate::Readable for CSRCADDR {}
#[doc = "`write(|w| ..)` method takes [csrcaddr::W](csrcaddr::W) writer structure"]
impl crate::Writable for CSRCADDR {}
#[doc = "DMA Channel Source Address Register"]
pub mod csrcaddr;
#[doc = "DMA Channel Destination Address Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cdestaddr](cdestaddr) module"]
pub type CDESTADDR = crate::Reg<u32, _CDESTADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CDESTADDR;
#[doc = "`read()` method returns [cdestaddr::R](cdestaddr::R) reader structure"]
impl crate::Readable for CDESTADDR {}
#[doc = "`write(|w| ..)` method takes [cdestaddr::W](cdestaddr::W) writer structure"]
impl crate::Writable for CDESTADDR {}
#[doc = "DMA Channel Destination Address Register"]
pub mod cdestaddr;
#[doc = "DMA Channel Linked List Item Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clli](clli) module"]
pub type CLLI = crate::Reg<u32, _CLLI>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLLI;
#[doc = "`read()` method returns [clli::R](clli::R) reader structure"]
impl crate::Readable for CLLI {}
#[doc = "`write(|w| ..)` method takes [clli::W](clli::W) writer structure"]
impl crate::Writable for CLLI {}
#[doc = "DMA Channel Linked List Item Register"]
pub mod clli;
#[doc = "DMA Channel Control Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ccontrol](ccontrol) module"]
pub type CCONTROL = crate::Reg<u32, _CCONTROL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CCONTROL;
#[doc = "`read()` method returns [ccontrol::R](ccontrol::R) reader structure"]
impl crate::Readable for CCONTROL {}
#[doc = "`write(|w| ..)` method takes [ccontrol::W](ccontrol::W) writer structure"]
impl crate::Writable for CCONTROL {}
#[doc = "DMA Channel Control Register"]
pub mod ccontrol;
#[doc = "DMA Channel Configuration Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cconfig](cconfig) module"]
pub type CCONFIG = crate::Reg<u32, _CCONFIG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CCONFIG;
#[doc = "`read()` method returns [cconfig::R](cconfig::R) reader structure"]
impl crate::Readable for CCONFIG {}
#[doc = "`write(|w| ..)` method takes [cconfig::W](cconfig::W) writer structure"]
impl crate::Writable for CCONFIG {}
#[doc = "DMA Channel Configuration Register"]
pub mod cconfig;
