#[doc = "Reader of register C%sCONFIG"]
pub type R = crate::R<u32, super::CCONFIG>;
#[doc = "Writer for register C%sCONFIG"]
pub type W = crate::W<u32, super::CCONFIG>;
#[doc = "Register C%sCONFIG `reset()`'s with value 0"]
impl crate::ResetValue for super::CCONFIG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Channel enable. Reading this bit indicates whether a channel is currently enabled or disabled: The Channel Enable bit status can also be found by reading the EnbldChns Register. A channel can be disabled by clearing the Enable bit. This causes the current AHB transfer (if one is in progress) to complete and the channel is then disabled. Any data in the FIFO of the relevant channel is lost. Restarting the channel by setting the Channel Enable bit has unpredictable effects, the channel must be fully re-initialized. The channel is also disabled, and Channel Enable bit cleared, when the last LLI is reached, the DMA transfer is completed, or if a channel error is encountered. If a channel must be disabled without losing data in the FIFO, the Halt bit must be set so that further DMA requests are ignored. The Active bit must then be polled until it reaches 0, indicating that there is no data left in the FIFO. Finally, the Channel Enable bit can be cleared.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum E_A {
    #[doc = "0: Channel disabled."]
    CHANNEL_DISABLED = 0,
    #[doc = "1: Channel enabled."]
    CHANNEL_ENABLED = 1,
}
impl From<E_A> for bool {
    #[inline(always)]
    fn from(variant: E_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `E`"]
pub type E_R = crate::R<bool, E_A>;
impl E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> E_A {
        match self.bits {
            false => E_A::CHANNEL_DISABLED,
            true => E_A::CHANNEL_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `CHANNEL_DISABLED`"]
    #[inline(always)]
    pub fn is_channel_disabled(&self) -> bool {
        *self == E_A::CHANNEL_DISABLED
    }
    #[doc = "Checks if the value of the field is `CHANNEL_ENABLED`"]
    #[inline(always)]
    pub fn is_channel_enabled(&self) -> bool {
        *self == E_A::CHANNEL_ENABLED
    }
}
#[doc = "Write proxy for field `E`"]
pub struct E_W<'a> {
    w: &'a mut W,
}
impl<'a> E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Channel disabled."]
    #[inline(always)]
    pub fn channel_disabled(self) -> &'a mut W {
        self.variant(E_A::CHANNEL_DISABLED)
    }
    #[doc = "Channel enabled."]
    #[inline(always)]
    pub fn channel_enabled(self) -> &'a mut W {
        self.variant(E_A::CHANNEL_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Source peripheral. This value selects the DMA source request peripheral. This field is ignored if the source of the transfer is from memory. See Table 136 for details.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum SRCPERIPHERAL_A {
    #[doc = "0: Source = SPIFI"]
    SOURCE_EQ_SPIFI = 0,
    #[doc = "1: Source = Timer 0 match 0/UART0 transmit"]
    SOURCE_EQ_TIMER_0_MATCH_0_TX = 1,
    #[doc = "2: Source = Timer 0 match 1/UART0 receive"]
    SOURCE_EQ_TIMER_0_MATCH_1_RX = 2,
    #[doc = "3: Source = Timer 1 match 0/UART1 transmit"]
    SOURCE_EQ_TIMER_1_MATCH_0_TX = 3,
    #[doc = "4: Source = Timer 1 match 1/UART 1 receive"]
    SOURCE_EQ_TIMER_1_MATCH_1_RX = 4,
    #[doc = "5: Source = Timer 2 match 0/UART 2 transmit"]
    SOURCE_EQ_TIMER_2_MATCH_0_TX = 5,
    #[doc = "6: Source = Timer 2 match 1/UART 2 receive"]
    SOURCE_EQ_TIMER_2_MATCH_1_RX = 6,
    #[doc = "7: Source = Timer 3 match 0/UART3 transmit/SCT DMA request 0"]
    SOURCE_EQ_TIMER_3_MATCH_0_TX = 7,
    #[doc = "8: Source = Timer 3 match 1/UART3 receive/SCT DMA request 1"]
    SOURCE_EQ_TIMER_3_MATCH_0_RX = 8,
    #[doc = "9: Source = SSP0 receive/I2S channel 0"]
    SOURCE_EQ_SSP0_RECEIVE_I2S_0_RX = 9,
    #[doc = "10: Source = SSP0 transmit/I2S channel 1"]
    SOURCE_EQ_SSP0_TRANSMIT_I2S_1 = 10,
    #[doc = "11: Source = SSP1 receive"]
    SOURCE_EQ_SSP1_RECEIVE = 11,
    #[doc = "12: Source = SSP1 transmit"]
    SOURCE_EQ_SSP1_TRANSMIT = 12,
    #[doc = "13: Source = ADC0"]
    SOURCE_EQ_ADC0 = 13,
    #[doc = "14: Source = ADC1"]
    SOURCE_EQ_ADC1 = 14,
    #[doc = "15: Source = DAC"]
    SOURCE_EQ_DAC = 15,
}
impl From<SRCPERIPHERAL_A> for u8 {
    #[inline(always)]
    fn from(variant: SRCPERIPHERAL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `SRCPERIPHERAL`"]
pub type SRCPERIPHERAL_R = crate::R<u8, SRCPERIPHERAL_A>;
impl SRCPERIPHERAL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, SRCPERIPHERAL_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(SRCPERIPHERAL_A::SOURCE_EQ_SPIFI),
            1 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_0_MATCH_0_TX),
            2 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_0_MATCH_1_RX),
            3 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_1_MATCH_0_TX),
            4 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_1_MATCH_1_RX),
            5 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_2_MATCH_0_TX),
            6 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_2_MATCH_1_RX),
            7 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_3_MATCH_0_TX),
            8 => Val(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_3_MATCH_0_RX),
            9 => Val(SRCPERIPHERAL_A::SOURCE_EQ_SSP0_RECEIVE_I2S_0_RX),
            10 => Val(SRCPERIPHERAL_A::SOURCE_EQ_SSP0_TRANSMIT_I2S_1),
            11 => Val(SRCPERIPHERAL_A::SOURCE_EQ_SSP1_RECEIVE),
            12 => Val(SRCPERIPHERAL_A::SOURCE_EQ_SSP1_TRANSMIT),
            13 => Val(SRCPERIPHERAL_A::SOURCE_EQ_ADC0),
            14 => Val(SRCPERIPHERAL_A::SOURCE_EQ_ADC1),
            15 => Val(SRCPERIPHERAL_A::SOURCE_EQ_DAC),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_SPIFI`"]
    #[inline(always)]
    pub fn is_source_eq_spifi(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_SPIFI
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_0_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_0_match_0_tx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_0_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_0_MATCH_1_RX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_0_match_1_rx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_0_MATCH_1_RX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_1_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_1_match_0_tx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_1_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_1_MATCH_1_RX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_1_match_1_rx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_1_MATCH_1_RX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_2_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_2_match_0_tx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_2_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_2_MATCH_1_RX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_2_match_1_rx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_2_MATCH_1_RX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_3_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_3_match_0_tx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_3_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_TIMER_3_MATCH_0_RX`"]
    #[inline(always)]
    pub fn is_source_eq_timer_3_match_0_rx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_TIMER_3_MATCH_0_RX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_SSP0_RECEIVE_I2S_0_RX`"]
    #[inline(always)]
    pub fn is_source_eq_ssp0_receive_i2s_0_rx(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_SSP0_RECEIVE_I2S_0_RX
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_SSP0_TRANSMIT_I2S_1`"]
    #[inline(always)]
    pub fn is_source_eq_ssp0_transmit_i2s_1(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_SSP0_TRANSMIT_I2S_1
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_SSP1_RECEIVE`"]
    #[inline(always)]
    pub fn is_source_eq_ssp1_receive(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_SSP1_RECEIVE
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_SSP1_TRANSMIT`"]
    #[inline(always)]
    pub fn is_source_eq_ssp1_transmit(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_SSP1_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_ADC0`"]
    #[inline(always)]
    pub fn is_source_eq_adc0(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_ADC0
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_ADC1`"]
    #[inline(always)]
    pub fn is_source_eq_adc1(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_ADC1
    }
    #[doc = "Checks if the value of the field is `SOURCE_EQ_DAC`"]
    #[inline(always)]
    pub fn is_source_eq_dac(&self) -> bool {
        *self == SRCPERIPHERAL_A::SOURCE_EQ_DAC
    }
}
#[doc = "Write proxy for field `SRCPERIPHERAL`"]
pub struct SRCPERIPHERAL_W<'a> {
    w: &'a mut W,
}
impl<'a> SRCPERIPHERAL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SRCPERIPHERAL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Source = SPIFI"]
    #[inline(always)]
    pub fn source_eq_spifi(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_SPIFI)
    }
    #[doc = "Source = Timer 0 match 0/UART0 transmit"]
    #[inline(always)]
    pub fn source_eq_timer_0_match_0_tx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_0_MATCH_0_TX)
    }
    #[doc = "Source = Timer 0 match 1/UART0 receive"]
    #[inline(always)]
    pub fn source_eq_timer_0_match_1_rx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_0_MATCH_1_RX)
    }
    #[doc = "Source = Timer 1 match 0/UART1 transmit"]
    #[inline(always)]
    pub fn source_eq_timer_1_match_0_tx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_1_MATCH_0_TX)
    }
    #[doc = "Source = Timer 1 match 1/UART 1 receive"]
    #[inline(always)]
    pub fn source_eq_timer_1_match_1_rx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_1_MATCH_1_RX)
    }
    #[doc = "Source = Timer 2 match 0/UART 2 transmit"]
    #[inline(always)]
    pub fn source_eq_timer_2_match_0_tx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_2_MATCH_0_TX)
    }
    #[doc = "Source = Timer 2 match 1/UART 2 receive"]
    #[inline(always)]
    pub fn source_eq_timer_2_match_1_rx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_2_MATCH_1_RX)
    }
    #[doc = "Source = Timer 3 match 0/UART3 transmit/SCT DMA request 0"]
    #[inline(always)]
    pub fn source_eq_timer_3_match_0_tx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_3_MATCH_0_TX)
    }
    #[doc = "Source = Timer 3 match 1/UART3 receive/SCT DMA request 1"]
    #[inline(always)]
    pub fn source_eq_timer_3_match_0_rx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_TIMER_3_MATCH_0_RX)
    }
    #[doc = "Source = SSP0 receive/I2S channel 0"]
    #[inline(always)]
    pub fn source_eq_ssp0_receive_i2s_0_rx(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_SSP0_RECEIVE_I2S_0_RX)
    }
    #[doc = "Source = SSP0 transmit/I2S channel 1"]
    #[inline(always)]
    pub fn source_eq_ssp0_transmit_i2s_1(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_SSP0_TRANSMIT_I2S_1)
    }
    #[doc = "Source = SSP1 receive"]
    #[inline(always)]
    pub fn source_eq_ssp1_receive(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_SSP1_RECEIVE)
    }
    #[doc = "Source = SSP1 transmit"]
    #[inline(always)]
    pub fn source_eq_ssp1_transmit(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_SSP1_TRANSMIT)
    }
    #[doc = "Source = ADC0"]
    #[inline(always)]
    pub fn source_eq_adc0(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_ADC0)
    }
    #[doc = "Source = ADC1"]
    #[inline(always)]
    pub fn source_eq_adc1(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_ADC1)
    }
    #[doc = "Source = DAC"]
    #[inline(always)]
    pub fn source_eq_dac(self) -> &'a mut W {
        self.variant(SRCPERIPHERAL_A::SOURCE_EQ_DAC)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 1)) | (((value as u32) & 0x1f) << 1);
        self.w
    }
}
#[doc = "Destination peripheral. This value selects the DMA destination request peripheral. This field is ignored if the destination of the transfer is to memory. See Table 136 for details.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum DESTPERIPHERAL_A {
    #[doc = "0: Destination = SPIFI"]
    DESTINATION_EQ_SPIFI = 0,
    #[doc = "1: Destination = Timer 0 match 0/UART0 transmit"]
    DESTINATION_EQ_TIMER_0_MATCH_0_TX = 1,
    #[doc = "2: Destination = Timer 0 match 1/UART0 receive"]
    DESTINATION_EQ_TIMER_0_MATCH_1_RX = 2,
    #[doc = "3: Destination = Timer 1 match 0/UART1 transmit"]
    DESTINATION_EQ_TIMER_1_MATCH_0_TX = 3,
    #[doc = "4: Destination = Timer 1 match 1/UART 1 receive"]
    DESTINATION_EQ_TIMER_1_MATCH_1_RX = 4,
    #[doc = "5: Destination = Timer 2 match 0/UART 2 transmit"]
    DESTINATION_EQ_TIMER_2_MATCH_0_TX = 5,
    #[doc = "6: Destination = Timer 2 match 1/UART 2 receive"]
    DESTINATION_EQ_TIMER_2_MATCH_1_RX = 6,
    #[doc = "7: Destination = Timer 3 match 0/UART3 transmit/SCT DMA request 0"]
    DESTINATION_EQ_TIMER_3_MATCH_0_TX = 7,
    #[doc = "8: Destination = Timer 3 match 1/UART3 receive/SCT DMA request 1"]
    DESTINATION_EQ_TIMER_3_MATCH_1_RX = 8,
    #[doc = "9: Destination = SSP0 receive/I2S channel 0"]
    DESTINATION_EQ_SSP0_RX = 9,
    #[doc = "10: Destination = SSP0 transmit/I2S channel 1"]
    DESTINATION_EQ_SSP0_TX = 10,
    #[doc = "11: Destination = SSP1 receive"]
    DESTINATION_EQ_SSP1_RX = 11,
    #[doc = "12: Destination = SSP1 transmit"]
    DESTINATION_EQ_SSP1_TX = 12,
    #[doc = "13: Destination = ADC0"]
    DESTINATION_EQ_ADC0 = 13,
    #[doc = "14: Destination = ADC1"]
    DESTINATION_EQ_ADC1 = 14,
    #[doc = "15: Destination = DAC"]
    DESTINATION_EQ_DAC = 15,
}
impl From<DESTPERIPHERAL_A> for u8 {
    #[inline(always)]
    fn from(variant: DESTPERIPHERAL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `DESTPERIPHERAL`"]
pub type DESTPERIPHERAL_R = crate::R<u8, DESTPERIPHERAL_A>;
impl DESTPERIPHERAL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, DESTPERIPHERAL_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_SPIFI),
            1 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_0_MATCH_0_TX),
            2 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_0_MATCH_1_RX),
            3 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_1_MATCH_0_TX),
            4 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_1_MATCH_1_RX),
            5 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_2_MATCH_0_TX),
            6 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_2_MATCH_1_RX),
            7 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_3_MATCH_0_TX),
            8 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_3_MATCH_1_RX),
            9 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_SSP0_RX),
            10 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_SSP0_TX),
            11 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_SSP1_RX),
            12 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_SSP1_TX),
            13 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_ADC0),
            14 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_ADC1),
            15 => Val(DESTPERIPHERAL_A::DESTINATION_EQ_DAC),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_SPIFI`"]
    #[inline(always)]
    pub fn is_destination_eq_spifi(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_SPIFI
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_0_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_0_match_0_tx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_0_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_0_MATCH_1_RX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_0_match_1_rx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_0_MATCH_1_RX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_1_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_1_match_0_tx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_1_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_1_MATCH_1_RX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_1_match_1_rx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_1_MATCH_1_RX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_2_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_2_match_0_tx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_2_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_2_MATCH_1_RX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_2_match_1_rx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_2_MATCH_1_RX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_3_MATCH_0_TX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_3_match_0_tx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_3_MATCH_0_TX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_TIMER_3_MATCH_1_RX`"]
    #[inline(always)]
    pub fn is_destination_eq_timer_3_match_1_rx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_3_MATCH_1_RX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_SSP0_RX`"]
    #[inline(always)]
    pub fn is_destination_eq_ssp0_rx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_SSP0_RX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_SSP0_TX`"]
    #[inline(always)]
    pub fn is_destination_eq_ssp0_tx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_SSP0_TX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_SSP1_RX`"]
    #[inline(always)]
    pub fn is_destination_eq_ssp1_rx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_SSP1_RX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_SSP1_TX`"]
    #[inline(always)]
    pub fn is_destination_eq_ssp1_tx(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_SSP1_TX
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_ADC0`"]
    #[inline(always)]
    pub fn is_destination_eq_adc0(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_ADC0
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_ADC1`"]
    #[inline(always)]
    pub fn is_destination_eq_adc1(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_ADC1
    }
    #[doc = "Checks if the value of the field is `DESTINATION_EQ_DAC`"]
    #[inline(always)]
    pub fn is_destination_eq_dac(&self) -> bool {
        *self == DESTPERIPHERAL_A::DESTINATION_EQ_DAC
    }
}
#[doc = "Write proxy for field `DESTPERIPHERAL`"]
pub struct DESTPERIPHERAL_W<'a> {
    w: &'a mut W,
}
impl<'a> DESTPERIPHERAL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DESTPERIPHERAL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Destination = SPIFI"]
    #[inline(always)]
    pub fn destination_eq_spifi(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_SPIFI)
    }
    #[doc = "Destination = Timer 0 match 0/UART0 transmit"]
    #[inline(always)]
    pub fn destination_eq_timer_0_match_0_tx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_0_MATCH_0_TX)
    }
    #[doc = "Destination = Timer 0 match 1/UART0 receive"]
    #[inline(always)]
    pub fn destination_eq_timer_0_match_1_rx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_0_MATCH_1_RX)
    }
    #[doc = "Destination = Timer 1 match 0/UART1 transmit"]
    #[inline(always)]
    pub fn destination_eq_timer_1_match_0_tx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_1_MATCH_0_TX)
    }
    #[doc = "Destination = Timer 1 match 1/UART 1 receive"]
    #[inline(always)]
    pub fn destination_eq_timer_1_match_1_rx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_1_MATCH_1_RX)
    }
    #[doc = "Destination = Timer 2 match 0/UART 2 transmit"]
    #[inline(always)]
    pub fn destination_eq_timer_2_match_0_tx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_2_MATCH_0_TX)
    }
    #[doc = "Destination = Timer 2 match 1/UART 2 receive"]
    #[inline(always)]
    pub fn destination_eq_timer_2_match_1_rx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_2_MATCH_1_RX)
    }
    #[doc = "Destination = Timer 3 match 0/UART3 transmit/SCT DMA request 0"]
    #[inline(always)]
    pub fn destination_eq_timer_3_match_0_tx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_3_MATCH_0_TX)
    }
    #[doc = "Destination = Timer 3 match 1/UART3 receive/SCT DMA request 1"]
    #[inline(always)]
    pub fn destination_eq_timer_3_match_1_rx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_TIMER_3_MATCH_1_RX)
    }
    #[doc = "Destination = SSP0 receive/I2S channel 0"]
    #[inline(always)]
    pub fn destination_eq_ssp0_rx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_SSP0_RX)
    }
    #[doc = "Destination = SSP0 transmit/I2S channel 1"]
    #[inline(always)]
    pub fn destination_eq_ssp0_tx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_SSP0_TX)
    }
    #[doc = "Destination = SSP1 receive"]
    #[inline(always)]
    pub fn destination_eq_ssp1_rx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_SSP1_RX)
    }
    #[doc = "Destination = SSP1 transmit"]
    #[inline(always)]
    pub fn destination_eq_ssp1_tx(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_SSP1_TX)
    }
    #[doc = "Destination = ADC0"]
    #[inline(always)]
    pub fn destination_eq_adc0(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_ADC0)
    }
    #[doc = "Destination = ADC1"]
    #[inline(always)]
    pub fn destination_eq_adc1(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_ADC1)
    }
    #[doc = "Destination = DAC"]
    #[inline(always)]
    pub fn destination_eq_dac(self) -> &'a mut W {
        self.variant(DESTPERIPHERAL_A::DESTINATION_EQ_DAC)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 6)) | (((value as u32) & 0x1f) << 6);
        self.w
    }
}
#[doc = "Flow control and transfer type. This value indicates the flow controller and transfer type. The flow controller can be the DMA Controller, the source peripheral, or the destination peripheral. The transfer type can be memory-to-memory, memory-to-peripheral, peripheral-to-memory, or peripheral-to-peripheral. Refer to Table 157 for the encoding of this field.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum FLOWCNTRL_A {
    #[doc = "0: Memory to memory (DMA control)"]
    MEMORY_TO_MEMORY_DMACTRL = 0,
    #[doc = "1: Memory to peripheral (DMA control)"]
    MEMORY_TO_PERIPHERAL_DMACTRL = 1,
    #[doc = "2: Peripheral to memory (DMA control)"]
    PERIPHERAL_TO_MEMORY_DMACTRL = 2,
    #[doc = "3: Source peripheral to destination peripheral (DMA control)"]
    SOURCE_PERIPHERAL_TO_DMACTRL = 3,
    #[doc = "4: Source peripheral to destination peripheral (destination control)"]
    SOURCE_PERIPHERAL_TO_DESTCTRL = 4,
    #[doc = "5: Memory to peripheral (peripheral control)"]
    MEMORY_TO_PERIPHERAL_PERIPHCTRL = 5,
    #[doc = "6: Peripheral to memory (peripheral control)"]
    PERIPHERAL_TO_MEMORY_PERIPHCTRL = 6,
    #[doc = "7: Source peripheral to destination peripheral (source control)"]
    SOURCE_PERIPHERAL_TO_SRCCTRL = 7,
}
impl From<FLOWCNTRL_A> for u8 {
    #[inline(always)]
    fn from(variant: FLOWCNTRL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `FLOWCNTRL`"]
pub type FLOWCNTRL_R = crate::R<u8, FLOWCNTRL_A>;
impl FLOWCNTRL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FLOWCNTRL_A {
        match self.bits {
            0 => FLOWCNTRL_A::MEMORY_TO_MEMORY_DMACTRL,
            1 => FLOWCNTRL_A::MEMORY_TO_PERIPHERAL_DMACTRL,
            2 => FLOWCNTRL_A::PERIPHERAL_TO_MEMORY_DMACTRL,
            3 => FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_DMACTRL,
            4 => FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_DESTCTRL,
            5 => FLOWCNTRL_A::MEMORY_TO_PERIPHERAL_PERIPHCTRL,
            6 => FLOWCNTRL_A::PERIPHERAL_TO_MEMORY_PERIPHCTRL,
            7 => FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_SRCCTRL,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `MEMORY_TO_MEMORY_DMACTRL`"]
    #[inline(always)]
    pub fn is_memory_to_memory_dmactrl(&self) -> bool {
        *self == FLOWCNTRL_A::MEMORY_TO_MEMORY_DMACTRL
    }
    #[doc = "Checks if the value of the field is `MEMORY_TO_PERIPHERAL_DMACTRL`"]
    #[inline(always)]
    pub fn is_memory_to_peripheral_dmactrl(&self) -> bool {
        *self == FLOWCNTRL_A::MEMORY_TO_PERIPHERAL_DMACTRL
    }
    #[doc = "Checks if the value of the field is `PERIPHERAL_TO_MEMORY_DMACTRL`"]
    #[inline(always)]
    pub fn is_peripheral_to_memory_dmactrl(&self) -> bool {
        *self == FLOWCNTRL_A::PERIPHERAL_TO_MEMORY_DMACTRL
    }
    #[doc = "Checks if the value of the field is `SOURCE_PERIPHERAL_TO_DMACTRL`"]
    #[inline(always)]
    pub fn is_source_peripheral_to_dmactrl(&self) -> bool {
        *self == FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_DMACTRL
    }
    #[doc = "Checks if the value of the field is `SOURCE_PERIPHERAL_TO_DESTCTRL`"]
    #[inline(always)]
    pub fn is_source_peripheral_to_destctrl(&self) -> bool {
        *self == FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_DESTCTRL
    }
    #[doc = "Checks if the value of the field is `MEMORY_TO_PERIPHERAL_PERIPHCTRL`"]
    #[inline(always)]
    pub fn is_memory_to_peripheral_periphctrl(&self) -> bool {
        *self == FLOWCNTRL_A::MEMORY_TO_PERIPHERAL_PERIPHCTRL
    }
    #[doc = "Checks if the value of the field is `PERIPHERAL_TO_MEMORY_PERIPHCTRL`"]
    #[inline(always)]
    pub fn is_peripheral_to_memory_periphctrl(&self) -> bool {
        *self == FLOWCNTRL_A::PERIPHERAL_TO_MEMORY_PERIPHCTRL
    }
    #[doc = "Checks if the value of the field is `SOURCE_PERIPHERAL_TO_SRCCTRL`"]
    #[inline(always)]
    pub fn is_source_peripheral_to_srcctrl(&self) -> bool {
        *self == FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_SRCCTRL
    }
}
#[doc = "Write proxy for field `FLOWCNTRL`"]
pub struct FLOWCNTRL_W<'a> {
    w: &'a mut W,
}
impl<'a> FLOWCNTRL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FLOWCNTRL_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Memory to memory (DMA control)"]
    #[inline(always)]
    pub fn memory_to_memory_dmactrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::MEMORY_TO_MEMORY_DMACTRL)
    }
    #[doc = "Memory to peripheral (DMA control)"]
    #[inline(always)]
    pub fn memory_to_peripheral_dmactrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::MEMORY_TO_PERIPHERAL_DMACTRL)
    }
    #[doc = "Peripheral to memory (DMA control)"]
    #[inline(always)]
    pub fn peripheral_to_memory_dmactrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::PERIPHERAL_TO_MEMORY_DMACTRL)
    }
    #[doc = "Source peripheral to destination peripheral (DMA control)"]
    #[inline(always)]
    pub fn source_peripheral_to_dmactrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_DMACTRL)
    }
    #[doc = "Source peripheral to destination peripheral (destination control)"]
    #[inline(always)]
    pub fn source_peripheral_to_destctrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_DESTCTRL)
    }
    #[doc = "Memory to peripheral (peripheral control)"]
    #[inline(always)]
    pub fn memory_to_peripheral_periphctrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::MEMORY_TO_PERIPHERAL_PERIPHCTRL)
    }
    #[doc = "Peripheral to memory (peripheral control)"]
    #[inline(always)]
    pub fn peripheral_to_memory_periphctrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::PERIPHERAL_TO_MEMORY_PERIPHCTRL)
    }
    #[doc = "Source peripheral to destination peripheral (source control)"]
    #[inline(always)]
    pub fn source_peripheral_to_srcctrl(self) -> &'a mut W {
        self.variant(FLOWCNTRL_A::SOURCE_PERIPHERAL_TO_SRCCTRL)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 11)) | (((value as u32) & 0x07) << 11);
        self.w
    }
}
#[doc = "Reader of field `IE`"]
pub type IE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `IE`"]
pub struct IE_W<'a> {
    w: &'a mut W,
}
impl<'a> IE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Reader of field `ITC`"]
pub type ITC_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ITC`"]
pub struct ITC_W<'a> {
    w: &'a mut W,
}
impl<'a> ITC_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
#[doc = "Reader of field `L`"]
pub type L_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `L`"]
pub struct L_W<'a> {
    w: &'a mut W,
}
impl<'a> L_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Reader of field `A`"]
pub type A_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `A`"]
pub struct A_W<'a> {
    w: &'a mut W,
}
impl<'a> A_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 17)) | (((value as u32) & 0x01) << 17);
        self.w
    }
}
#[doc = "Halt: 0 = enable DMA requests. 1 = ignore further source DMA requests. The contents of the channel FIFO are drained. This value can be used with the Active and Channel Enable bits to cleanly disable a DMA channel.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum H_A {
    #[doc = "0: Enable DMA requests."]
    ENABLE_DMA_REQUESTS = 0,
    #[doc = "1: Ignore further source DMA requests."]
    IGNORE_FURTHER_SOURCE_DMA_REQUESTS = 1,
}
impl From<H_A> for bool {
    #[inline(always)]
    fn from(variant: H_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `H`"]
pub type H_R = crate::R<bool, H_A>;
impl H_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> H_A {
        match self.bits {
            false => H_A::ENABLE_DMA_REQUESTS,
            true => H_A::IGNORE_FURTHER_SOURCE_DMA_REQUESTS,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_DMA_REQUESTS`"]
    #[inline(always)]
    pub fn is_enable_dma_requests(&self) -> bool {
        *self == H_A::ENABLE_DMA_REQUESTS
    }
    #[doc = "Checks if the value of the field is `IGNORE_FURTHER_SOURCE_DMA_REQUESTS`"]
    #[inline(always)]
    pub fn is_ignore_further_source_dma_requests(&self) -> bool {
        *self == H_A::IGNORE_FURTHER_SOURCE_DMA_REQUESTS
    }
}
#[doc = "Write proxy for field `H`"]
pub struct H_W<'a> {
    w: &'a mut W,
}
impl<'a> H_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: H_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable DMA requests."]
    #[inline(always)]
    pub fn enable_dma_requests(self) -> &'a mut W {
        self.variant(H_A::ENABLE_DMA_REQUESTS)
    }
    #[doc = "Ignore further source DMA requests."]
    #[inline(always)]
    pub fn ignore_further_source_dma_requests(self) -> &'a mut W {
        self.variant(H_A::IGNORE_FURTHER_SOURCE_DMA_REQUESTS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 18)) | (((value as u32) & 0x01) << 18);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Channel enable. Reading this bit indicates whether a channel is currently enabled or disabled: The Channel Enable bit status can also be found by reading the EnbldChns Register. A channel can be disabled by clearing the Enable bit. This causes the current AHB transfer (if one is in progress) to complete and the channel is then disabled. Any data in the FIFO of the relevant channel is lost. Restarting the channel by setting the Channel Enable bit has unpredictable effects, the channel must be fully re-initialized. The channel is also disabled, and Channel Enable bit cleared, when the last LLI is reached, the DMA transfer is completed, or if a channel error is encountered. If a channel must be disabled without losing data in the FIFO, the Halt bit must be set so that further DMA requests are ignored. The Active bit must then be polled until it reaches 0, indicating that there is no data left in the FIFO. Finally, the Channel Enable bit can be cleared."]
    #[inline(always)]
    pub fn e(&self) -> E_R {
        E_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 1:5 - Source peripheral. This value selects the DMA source request peripheral. This field is ignored if the source of the transfer is from memory. See Table 136 for details."]
    #[inline(always)]
    pub fn srcperipheral(&self) -> SRCPERIPHERAL_R {
        SRCPERIPHERAL_R::new(((self.bits >> 1) & 0x1f) as u8)
    }
    #[doc = "Bits 6:10 - Destination peripheral. This value selects the DMA destination request peripheral. This field is ignored if the destination of the transfer is to memory. See Table 136 for details."]
    #[inline(always)]
    pub fn destperipheral(&self) -> DESTPERIPHERAL_R {
        DESTPERIPHERAL_R::new(((self.bits >> 6) & 0x1f) as u8)
    }
    #[doc = "Bits 11:13 - Flow control and transfer type. This value indicates the flow controller and transfer type. The flow controller can be the DMA Controller, the source peripheral, or the destination peripheral. The transfer type can be memory-to-memory, memory-to-peripheral, peripheral-to-memory, or peripheral-to-peripheral. Refer to Table 157 for the encoding of this field."]
    #[inline(always)]
    pub fn flowcntrl(&self) -> FLOWCNTRL_R {
        FLOWCNTRL_R::new(((self.bits >> 11) & 0x07) as u8)
    }
    #[doc = "Bit 14 - Interrupt error mask. When cleared, this bit masks out the error interrupt of the relevant channel."]
    #[inline(always)]
    pub fn ie(&self) -> IE_R {
        IE_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Terminal count interrupt mask. When cleared, this bit masks out the terminal count interrupt of the relevant channel."]
    #[inline(always)]
    pub fn itc(&self) -> ITC_R {
        ITC_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Lock. When set, this bit enables locked transfers."]
    #[inline(always)]
    pub fn l(&self) -> L_R {
        L_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - Active: 0 = there is no data in the FIFO of the channel. 1 = the channel FIFO has data. This value can be used with the Halt and Channel Enable bits to cleanly disable a DMA channel. This is a read-only bit."]
    #[inline(always)]
    pub fn a(&self) -> A_R {
        A_R::new(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - Halt: 0 = enable DMA requests. 1 = ignore further source DMA requests. The contents of the channel FIFO are drained. This value can be used with the Active and Channel Enable bits to cleanly disable a DMA channel."]
    #[inline(always)]
    pub fn h(&self) -> H_R {
        H_R::new(((self.bits >> 18) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Channel enable. Reading this bit indicates whether a channel is currently enabled or disabled: The Channel Enable bit status can also be found by reading the EnbldChns Register. A channel can be disabled by clearing the Enable bit. This causes the current AHB transfer (if one is in progress) to complete and the channel is then disabled. Any data in the FIFO of the relevant channel is lost. Restarting the channel by setting the Channel Enable bit has unpredictable effects, the channel must be fully re-initialized. The channel is also disabled, and Channel Enable bit cleared, when the last LLI is reached, the DMA transfer is completed, or if a channel error is encountered. If a channel must be disabled without losing data in the FIFO, the Halt bit must be set so that further DMA requests are ignored. The Active bit must then be polled until it reaches 0, indicating that there is no data left in the FIFO. Finally, the Channel Enable bit can be cleared."]
    #[inline(always)]
    pub fn e(&mut self) -> E_W {
        E_W { w: self }
    }
    #[doc = "Bits 1:5 - Source peripheral. This value selects the DMA source request peripheral. This field is ignored if the source of the transfer is from memory. See Table 136 for details."]
    #[inline(always)]
    pub fn srcperipheral(&mut self) -> SRCPERIPHERAL_W {
        SRCPERIPHERAL_W { w: self }
    }
    #[doc = "Bits 6:10 - Destination peripheral. This value selects the DMA destination request peripheral. This field is ignored if the destination of the transfer is to memory. See Table 136 for details."]
    #[inline(always)]
    pub fn destperipheral(&mut self) -> DESTPERIPHERAL_W {
        DESTPERIPHERAL_W { w: self }
    }
    #[doc = "Bits 11:13 - Flow control and transfer type. This value indicates the flow controller and transfer type. The flow controller can be the DMA Controller, the source peripheral, or the destination peripheral. The transfer type can be memory-to-memory, memory-to-peripheral, peripheral-to-memory, or peripheral-to-peripheral. Refer to Table 157 for the encoding of this field."]
    #[inline(always)]
    pub fn flowcntrl(&mut self) -> FLOWCNTRL_W {
        FLOWCNTRL_W { w: self }
    }
    #[doc = "Bit 14 - Interrupt error mask. When cleared, this bit masks out the error interrupt of the relevant channel."]
    #[inline(always)]
    pub fn ie(&mut self) -> IE_W {
        IE_W { w: self }
    }
    #[doc = "Bit 15 - Terminal count interrupt mask. When cleared, this bit masks out the terminal count interrupt of the relevant channel."]
    #[inline(always)]
    pub fn itc(&mut self) -> ITC_W {
        ITC_W { w: self }
    }
    #[doc = "Bit 16 - Lock. When set, this bit enables locked transfers."]
    #[inline(always)]
    pub fn l(&mut self) -> L_W {
        L_W { w: self }
    }
    #[doc = "Bit 17 - Active: 0 = there is no data in the FIFO of the channel. 1 = the channel FIFO has data. This value can be used with the Halt and Channel Enable bits to cleanly disable a DMA channel. This is a read-only bit."]
    #[inline(always)]
    pub fn a(&mut self) -> A_W {
        A_W { w: self }
    }
    #[doc = "Bit 18 - Halt: 0 = enable DMA requests. 1 = ignore further source DMA requests. The contents of the channel FIFO are drained. This value can be used with the Active and Channel Enable bits to cleanly disable a DMA channel."]
    #[inline(always)]
    pub fn h(&mut self) -> H_W {
        H_W { w: self }
    }
}
