#[doc = "Reader of register CTRL"]
pub type R = crate::R<u32, super::CTRL>;
#[doc = "Writer for register CTRL"]
pub type W = crate::W<u32, super::CTRL>;
#[doc = "Register CTRL `reset()`'s with value 0"]
impl crate::ResetValue for super::CTRL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Group interrupt status. This bit is cleared by writing a one to it. Writing zero has no effect.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INT_A {
    #[doc = "0: No interrupt request is pending."]
    NO_INTERRUPT_REQUEST_PENDING = 0,
    #[doc = "1: Interrupt request is active."]
    INTERRUPT_REQUEST_IS_ACTIVE = 1,
}
impl From<INT_A> for bool {
    #[inline(always)]
    fn from(variant: INT_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `INT`"]
pub type INT_R = crate::R<bool, INT_A>;
impl INT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INT_A {
        match self.bits {
            false => INT_A::NO_INTERRUPT_REQUEST_PENDING,
            true => INT_A::INTERRUPT_REQUEST_IS_ACTIVE,
        }
    }
    #[doc = "Checks if the value of the field is `NO_INTERRUPT_REQUEST_PENDING`"]
    #[inline(always)]
    pub fn is_no_interrupt_request_pending(&self) -> bool {
        *self == INT_A::NO_INTERRUPT_REQUEST_PENDING
    }
    #[doc = "Checks if the value of the field is `INTERRUPT_REQUEST_IS_ACTIVE`"]
    #[inline(always)]
    pub fn is_interrupt_request_is_active(&self) -> bool {
        *self == INT_A::INTERRUPT_REQUEST_IS_ACTIVE
    }
}
#[doc = "Write proxy for field `INT`"]
pub struct INT_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No interrupt request is pending."]
    #[inline(always)]
    pub fn no_interrupt_request_pending(self) -> &'a mut W {
        self.variant(INT_A::NO_INTERRUPT_REQUEST_PENDING)
    }
    #[doc = "Interrupt request is active."]
    #[inline(always)]
    pub fn interrupt_request_is_active(self) -> &'a mut W {
        self.variant(INT_A::INTERRUPT_REQUEST_IS_ACTIVE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Combine enabled inputs for group interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum COMB_A {
    #[doc = "0: OR functionality: A grouped interrupt is generated when any one of the enabled inputs is active (based on its programmed polarity)."]
    OR_FUNCTIONALITY_A = 0,
    #[doc = "1: AND functionality: An interrupt is generated when all enabled bits are active (based on their programmed polarity)."]
    AND_FUNCTIONALITY_A = 1,
}
impl From<COMB_A> for bool {
    #[inline(always)]
    fn from(variant: COMB_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `COMB`"]
pub type COMB_R = crate::R<bool, COMB_A>;
impl COMB_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> COMB_A {
        match self.bits {
            false => COMB_A::OR_FUNCTIONALITY_A,
            true => COMB_A::AND_FUNCTIONALITY_A,
        }
    }
    #[doc = "Checks if the value of the field is `OR_FUNCTIONALITY_A`"]
    #[inline(always)]
    pub fn is_or_functionality_a(&self) -> bool {
        *self == COMB_A::OR_FUNCTIONALITY_A
    }
    #[doc = "Checks if the value of the field is `AND_FUNCTIONALITY_A`"]
    #[inline(always)]
    pub fn is_and_functionality_a(&self) -> bool {
        *self == COMB_A::AND_FUNCTIONALITY_A
    }
}
#[doc = "Write proxy for field `COMB`"]
pub struct COMB_W<'a> {
    w: &'a mut W,
}
impl<'a> COMB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: COMB_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "OR functionality: A grouped interrupt is generated when any one of the enabled inputs is active (based on its programmed polarity)."]
    #[inline(always)]
    pub fn or_functionality_a(self) -> &'a mut W {
        self.variant(COMB_A::OR_FUNCTIONALITY_A)
    }
    #[doc = "AND functionality: An interrupt is generated when all enabled bits are active (based on their programmed polarity)."]
    #[inline(always)]
    pub fn and_functionality_a(self) -> &'a mut W {
        self.variant(COMB_A::AND_FUNCTIONALITY_A)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Group interrupt trigger\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TRIG_A {
    #[doc = "0: Edge-triggered"]
    EDGE_TRIGGERED = 0,
    #[doc = "1: Level-triggered"]
    LEVEL_TRIGGERED = 1,
}
impl From<TRIG_A> for bool {
    #[inline(always)]
    fn from(variant: TRIG_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TRIG`"]
pub type TRIG_R = crate::R<bool, TRIG_A>;
impl TRIG_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TRIG_A {
        match self.bits {
            false => TRIG_A::EDGE_TRIGGERED,
            true => TRIG_A::LEVEL_TRIGGERED,
        }
    }
    #[doc = "Checks if the value of the field is `EDGE_TRIGGERED`"]
    #[inline(always)]
    pub fn is_edge_triggered(&self) -> bool {
        *self == TRIG_A::EDGE_TRIGGERED
    }
    #[doc = "Checks if the value of the field is `LEVEL_TRIGGERED`"]
    #[inline(always)]
    pub fn is_level_triggered(&self) -> bool {
        *self == TRIG_A::LEVEL_TRIGGERED
    }
}
#[doc = "Write proxy for field `TRIG`"]
pub struct TRIG_W<'a> {
    w: &'a mut W,
}
impl<'a> TRIG_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TRIG_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Edge-triggered"]
    #[inline(always)]
    pub fn edge_triggered(self) -> &'a mut W {
        self.variant(TRIG_A::EDGE_TRIGGERED)
    }
    #[doc = "Level-triggered"]
    #[inline(always)]
    pub fn level_triggered(self) -> &'a mut W {
        self.variant(TRIG_A::LEVEL_TRIGGERED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Group interrupt status. This bit is cleared by writing a one to it. Writing zero has no effect."]
    #[inline(always)]
    pub fn int(&self) -> INT_R {
        INT_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Combine enabled inputs for group interrupt"]
    #[inline(always)]
    pub fn comb(&self) -> COMB_R {
        COMB_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Group interrupt trigger"]
    #[inline(always)]
    pub fn trig(&self) -> TRIG_R {
        TRIG_R::new(((self.bits >> 2) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Group interrupt status. This bit is cleared by writing a one to it. Writing zero has no effect."]
    #[inline(always)]
    pub fn int(&mut self) -> INT_W {
        INT_W { w: self }
    }
    #[doc = "Bit 1 - Combine enabled inputs for group interrupt"]
    #[inline(always)]
    pub fn comb(&mut self) -> COMB_W {
        COMB_W { w: self }
    }
    #[doc = "Bit 2 - Group interrupt trigger"]
    #[inline(always)]
    pub fn trig(&mut self) -> TRIG_W {
        TRIG_W { w: self }
    }
}
