#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Hardware sleep event enable register"]
    pub pd0_sleep0_hw_ena: PD0_SLEEP0_HW_ENA,
    _reserved1: [u8; 24usize],
    #[doc = "0x1c - Sleep power mode register"]
    pub pd0_sleep0_mode: PD0_SLEEP0_MODE,
}
#[doc = "Hardware sleep event enable register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pd0_sleep0_hw_ena](pd0_sleep0_hw_ena) module"]
pub type PD0_SLEEP0_HW_ENA = crate::Reg<u32, _PD0_SLEEP0_HW_ENA>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PD0_SLEEP0_HW_ENA;
#[doc = "`read()` method returns [pd0_sleep0_hw_ena::R](pd0_sleep0_hw_ena::R) reader structure"]
impl crate::Readable for PD0_SLEEP0_HW_ENA {}
#[doc = "`write(|w| ..)` method takes [pd0_sleep0_hw_ena::W](pd0_sleep0_hw_ena::W) writer structure"]
impl crate::Writable for PD0_SLEEP0_HW_ENA {}
#[doc = "Hardware sleep event enable register"]
pub mod pd0_sleep0_hw_ena;
#[doc = "Sleep power mode register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pd0_sleep0_mode](pd0_sleep0_mode) module"]
pub type PD0_SLEEP0_MODE = crate::Reg<u32, _PD0_SLEEP0_MODE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PD0_SLEEP0_MODE;
#[doc = "`read()` method returns [pd0_sleep0_mode::R](pd0_sleep0_mode::R) reader structure"]
impl crate::Readable for PD0_SLEEP0_MODE {}
#[doc = "`write(|w| ..)` method takes [pd0_sleep0_mode::W](pd0_sleep0_mode::W) writer structure"]
impl crate::Writable for PD0_SLEEP0_MODE {}
#[doc = "Sleep power mode register"]
pub mod pd0_sleep0_mode;
