#[doc = "Reader of register CONFIG"]
pub type R = crate::R<u32, super::CONFIG>;
#[doc = "Writer for register CONFIG"]
pub type W = crate::W<u32, super::CONFIG>;
#[doc = "Register CONFIG `reset()`'s with value 0x7e00"]
impl crate::ResetValue for super::CONFIG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x7e00
    }
}
#[doc = "SCT operation\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UNIFY_A {
    #[doc = "0: 16-bit.The SCT operates as two 16-bit counters named L and H."]
    _16_BIT = 0,
    #[doc = "1: 32-bit. The SCT operates as a unified 32-bit counter."]
    _32_BIT = 1,
}
impl From<UNIFY_A> for bool {
    #[inline(always)]
    fn from(variant: UNIFY_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `UNIFY`"]
pub type UNIFY_R = crate::R<bool, UNIFY_A>;
impl UNIFY_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UNIFY_A {
        match self.bits {
            false => UNIFY_A::_16_BIT,
            true => UNIFY_A::_32_BIT,
        }
    }
    #[doc = "Checks if the value of the field is `_16_BIT`"]
    #[inline(always)]
    pub fn is_16_bit(&self) -> bool {
        *self == UNIFY_A::_16_BIT
    }
    #[doc = "Checks if the value of the field is `_32_BIT`"]
    #[inline(always)]
    pub fn is_32_bit(&self) -> bool {
        *self == UNIFY_A::_32_BIT
    }
}
#[doc = "Write proxy for field `UNIFY`"]
pub struct UNIFY_W<'a> {
    w: &'a mut W,
}
impl<'a> UNIFY_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UNIFY_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "16-bit.The SCT operates as two 16-bit counters named L and H."]
    #[inline(always)]
    pub fn _16_bit(self) -> &'a mut W {
        self.variant(UNIFY_A::_16_BIT)
    }
    #[doc = "32-bit. The SCT operates as a unified 32-bit counter."]
    #[inline(always)]
    pub fn _32_bit(self) -> &'a mut W {
        self.variant(UNIFY_A::_32_BIT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "SCT clock mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CLKMODE_A {
    #[doc = "0: Bus clock. The bus clock clocks the SCT and prescalers."]
    BUS_CLOCK = 0,
    #[doc = "1: Prescaled bus clock. The SCT clock is the bus clock, but the prescalers are  enabled to count only when sampling of the input selected by  the CKSEL field finds the selected edge. The minimum pulse  width on the clock input is 1 bus clock period. This mode is the high-performance  sampled-clock mode."]
    PRESCALED_BUS_CLOCK = 1,
    #[doc = "2: SCT Input. The input selected by  CKSEL clocks the SCT and prescalers. The input is synchronized to the bus clock and possibly inverted.  The minimum pulse width on the clock input is 1 bus clock  period. This mode is the low-power sampled-clock mode."]
    SCT_INPUT = 2,
}
impl From<CLKMODE_A> for u8 {
    #[inline(always)]
    fn from(variant: CLKMODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CLKMODE`"]
pub type CLKMODE_R = crate::R<u8, CLKMODE_A>;
impl CLKMODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CLKMODE_A {
        match self.bits {
            0 => CLKMODE_A::BUS_CLOCK,
            1 => CLKMODE_A::PRESCALED_BUS_CLOCK,
            2 => CLKMODE_A::SCT_INPUT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `BUS_CLOCK`"]
    #[inline(always)]
    pub fn is_bus_clock(&self) -> bool {
        *self == CLKMODE_A::BUS_CLOCK
    }
    #[doc = "Checks if the value of the field is `PRESCALED_BUS_CLOCK`"]
    #[inline(always)]
    pub fn is_prescaled_bus_clock(&self) -> bool {
        *self == CLKMODE_A::PRESCALED_BUS_CLOCK
    }
    #[doc = "Checks if the value of the field is `SCT_INPUT`"]
    #[inline(always)]
    pub fn is_sct_input(&self) -> bool {
        *self == CLKMODE_A::SCT_INPUT
    }
}
#[doc = "Write proxy for field `CLKMODE`"]
pub struct CLKMODE_W<'a> {
    w: &'a mut W,
}
impl<'a> CLKMODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLKMODE_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Bus clock. The bus clock clocks the SCT and prescalers."]
    #[inline(always)]
    pub fn bus_clock(self) -> &'a mut W {
        self.variant(CLKMODE_A::BUS_CLOCK)
    }
    #[doc = "Prescaled bus clock. The SCT clock is the bus clock, but the prescalers are enabled to count only when sampling of the input selected by the CKSEL field finds the selected edge. The minimum pulse width on the clock input is 1 bus clock period. This mode is the high-performance sampled-clock mode."]
    #[inline(always)]
    pub fn prescaled_bus_clock(self) -> &'a mut W {
        self.variant(CLKMODE_A::PRESCALED_BUS_CLOCK)
    }
    #[doc = "SCT Input. The input selected by CKSEL clocks the SCT and prescalers. The input is synchronized to the bus clock and possibly inverted. The minimum pulse width on the clock input is 1 bus clock period. This mode is the low-power sampled-clock mode."]
    #[inline(always)]
    pub fn sct_input(self) -> &'a mut W {
        self.variant(CLKMODE_A::SCT_INPUT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 1)) | (((value as u32) & 0x03) << 1);
        self.w
    }
}
#[doc = "SCT clock select\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CKSEL_A {
    #[doc = "0: Rising edges on input 0."]
    RISING_EDGES_ON_INPUT_0 = 0,
    #[doc = "1: Falling edges on input 0."]
    FALLING_EDGES_ON_INPUT_0 = 1,
    #[doc = "2: Rising edges on input 1."]
    RISING_EDGES_ON_INPUT_1 = 2,
    #[doc = "3: Falling edges on input 1."]
    FALLING_EDGES_ON_INPUT_1 = 3,
    #[doc = "4: Rising edges on input 2."]
    RISING_EDGES_ON_INPUT_2 = 4,
    #[doc = "5: Falling edges on input 2."]
    FALLING_EDGES_ON_INPUT_2 = 5,
    #[doc = "6: Rising edges on input 3."]
    RISING_EDGES_ON_INPUT_3 = 6,
    #[doc = "7: Falling edges on input 3."]
    FALLING_EDGES_ON_INPUT_3 = 7,
    #[doc = "8: Rising edges on input 4."]
    RISING_EDGES_ON_INPUT_4 = 8,
    #[doc = "9: Falling edges on input 4."]
    FALLING_EDGES_ON_INPUT_4 = 9,
    #[doc = "10: Rising edges on input 5."]
    RISING_EDGES_ON_INPUT_5 = 10,
    #[doc = "11: Falling edges on input 5."]
    FALLING_EDGES_ON_INPUT_5 = 11,
    #[doc = "12: Rising edges on input 6."]
    RISING_EDGES_ON_INPUT_6 = 12,
    #[doc = "13: Falling edges on input 6."]
    FALLING_EDGES_ON_INPUT_6 = 13,
    #[doc = "14: Rising edges on input 7."]
    RISING_EDGES_ON_INPUT_7 = 14,
    #[doc = "15: Falling edges on input 7."]
    FALLING_EDGES_ON_INPUT_7 = 15,
}
impl From<CKSEL_A> for u8 {
    #[inline(always)]
    fn from(variant: CKSEL_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CKSEL`"]
pub type CKSEL_R = crate::R<u8, CKSEL_A>;
impl CKSEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CKSEL_A {
        match self.bits {
            0 => CKSEL_A::RISING_EDGES_ON_INPUT_0,
            1 => CKSEL_A::FALLING_EDGES_ON_INPUT_0,
            2 => CKSEL_A::RISING_EDGES_ON_INPUT_1,
            3 => CKSEL_A::FALLING_EDGES_ON_INPUT_1,
            4 => CKSEL_A::RISING_EDGES_ON_INPUT_2,
            5 => CKSEL_A::FALLING_EDGES_ON_INPUT_2,
            6 => CKSEL_A::RISING_EDGES_ON_INPUT_3,
            7 => CKSEL_A::FALLING_EDGES_ON_INPUT_3,
            8 => CKSEL_A::RISING_EDGES_ON_INPUT_4,
            9 => CKSEL_A::FALLING_EDGES_ON_INPUT_4,
            10 => CKSEL_A::RISING_EDGES_ON_INPUT_5,
            11 => CKSEL_A::FALLING_EDGES_ON_INPUT_5,
            12 => CKSEL_A::RISING_EDGES_ON_INPUT_6,
            13 => CKSEL_A::FALLING_EDGES_ON_INPUT_6,
            14 => CKSEL_A::RISING_EDGES_ON_INPUT_7,
            15 => CKSEL_A::FALLING_EDGES_ON_INPUT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_0`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_0(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_0
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_0`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_0(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_0
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_1`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_1(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_1
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_1`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_1(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_1
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_2`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_2(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_2
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_2`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_2(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_2
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_3`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_3(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_3
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_3`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_3(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_3
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_4`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_4(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_4
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_4`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_4(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_4
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_5`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_5(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_5
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_5`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_5(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_5
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_6`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_6(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_6
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_6`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_6(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_6
    }
    #[doc = "Checks if the value of the field is `RISING_EDGES_ON_INPUT_7`"]
    #[inline(always)]
    pub fn is_rising_edges_on_input_7(&self) -> bool {
        *self == CKSEL_A::RISING_EDGES_ON_INPUT_7
    }
    #[doc = "Checks if the value of the field is `FALLING_EDGES_ON_INPUT_7`"]
    #[inline(always)]
    pub fn is_falling_edges_on_input_7(&self) -> bool {
        *self == CKSEL_A::FALLING_EDGES_ON_INPUT_7
    }
}
#[doc = "Write proxy for field `CKSEL`"]
pub struct CKSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> CKSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CKSEL_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Rising edges on input 0."]
    #[inline(always)]
    pub fn rising_edges_on_input_0(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_0)
    }
    #[doc = "Falling edges on input 0."]
    #[inline(always)]
    pub fn falling_edges_on_input_0(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_0)
    }
    #[doc = "Rising edges on input 1."]
    #[inline(always)]
    pub fn rising_edges_on_input_1(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_1)
    }
    #[doc = "Falling edges on input 1."]
    #[inline(always)]
    pub fn falling_edges_on_input_1(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_1)
    }
    #[doc = "Rising edges on input 2."]
    #[inline(always)]
    pub fn rising_edges_on_input_2(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_2)
    }
    #[doc = "Falling edges on input 2."]
    #[inline(always)]
    pub fn falling_edges_on_input_2(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_2)
    }
    #[doc = "Rising edges on input 3."]
    #[inline(always)]
    pub fn rising_edges_on_input_3(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_3)
    }
    #[doc = "Falling edges on input 3."]
    #[inline(always)]
    pub fn falling_edges_on_input_3(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_3)
    }
    #[doc = "Rising edges on input 4."]
    #[inline(always)]
    pub fn rising_edges_on_input_4(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_4)
    }
    #[doc = "Falling edges on input 4."]
    #[inline(always)]
    pub fn falling_edges_on_input_4(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_4)
    }
    #[doc = "Rising edges on input 5."]
    #[inline(always)]
    pub fn rising_edges_on_input_5(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_5)
    }
    #[doc = "Falling edges on input 5."]
    #[inline(always)]
    pub fn falling_edges_on_input_5(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_5)
    }
    #[doc = "Rising edges on input 6."]
    #[inline(always)]
    pub fn rising_edges_on_input_6(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_6)
    }
    #[doc = "Falling edges on input 6."]
    #[inline(always)]
    pub fn falling_edges_on_input_6(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_6)
    }
    #[doc = "Rising edges on input 7."]
    #[inline(always)]
    pub fn rising_edges_on_input_7(self) -> &'a mut W {
        self.variant(CKSEL_A::RISING_EDGES_ON_INPUT_7)
    }
    #[doc = "Falling edges on input 7."]
    #[inline(always)]
    pub fn falling_edges_on_input_7(self) -> &'a mut W {
        self.variant(CKSEL_A::FALLING_EDGES_ON_INPUT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 3)) | (((value as u32) & 0x0f) << 3);
        self.w
    }
}
#[doc = "Reader of field `NORELAOD_L`"]
pub type NORELAOD_L_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `NORELAOD_L`"]
pub struct NORELAOD_L_W<'a> {
    w: &'a mut W,
}
impl<'a> NORELAOD_L_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Reader of field `NORELOAD_H`"]
pub type NORELOAD_H_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `NORELOAD_H`"]
pub struct NORELOAD_H_W<'a> {
    w: &'a mut W,
}
impl<'a> NORELOAD_H_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Reader of field `INSYNC`"]
pub type INSYNC_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INSYNC`"]
pub struct INSYNC_W<'a> {
    w: &'a mut W,
}
impl<'a> INSYNC_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 9)) | (((value as u32) & 0xff) << 9);
        self.w
    }
}
#[doc = "Reader of field `AUTOLIMIT_L`"]
pub type AUTOLIMIT_L_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `AUTOLIMIT_L`"]
pub struct AUTOLIMIT_L_W<'a> {
    w: &'a mut W,
}
impl<'a> AUTOLIMIT_L_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 17)) | (((value as u32) & 0x01) << 17);
        self.w
    }
}
#[doc = "Reader of field `AUTOLIMIT_H`"]
pub type AUTOLIMIT_H_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `AUTOLIMIT_H`"]
pub struct AUTOLIMIT_H_W<'a> {
    w: &'a mut W,
}
impl<'a> AUTOLIMIT_H_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 18)) | (((value as u32) & 0x01) << 18);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - SCT operation"]
    #[inline(always)]
    pub fn unify(&self) -> UNIFY_R {
        UNIFY_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 1:2 - SCT clock mode"]
    #[inline(always)]
    pub fn clkmode(&self) -> CLKMODE_R {
        CLKMODE_R::new(((self.bits >> 1) & 0x03) as u8)
    }
    #[doc = "Bits 3:6 - SCT clock select"]
    #[inline(always)]
    pub fn cksel(&self) -> CKSEL_R {
        CKSEL_R::new(((self.bits >> 3) & 0x0f) as u8)
    }
    #[doc = "Bit 7 - A 1 in this bit prevents the lower match and fractional match registers from being reloaded from their respective reload registers. Software can write to set or clear this bit at any time. This bit applies to both the higher and lower registers when the UNIFY bit is set."]
    #[inline(always)]
    pub fn norelaod_l(&self) -> NORELAOD_L_R {
        NORELAOD_L_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - A 1 in this bit prevents the higher match and fractional match registers from being reloaded from their respective reload registers. Software can write to set or clear this bit at any time. This bit is not used when the UNIFY bit is set."]
    #[inline(always)]
    pub fn noreload_h(&self) -> NORELOAD_H_R {
        NORELOAD_H_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bits 9:16 - Synchronization for input n (bit 9 = input 0, bit 10 = input 1,..., bit 16 = input 7). A 1 in one of these bits subjects the corresponding input to synchronization to the SCT clock, before it is used to create an event. If an input is synchronous to the SCT clock, keep its bit 0 for faster response. When the CKMODE field is 1x, the bit in this field, corresponding to the input selected by the CKSEL field, is not used."]
    #[inline(always)]
    pub fn insync(&self) -> INSYNC_R {
        INSYNC_R::new(((self.bits >> 9) & 0xff) as u8)
    }
    #[doc = "Bit 17 - A one in this bit causes a match on match register 0 to be treated as a de-facto LIMIT condition without the need to define an associated event. As with any LIMIT event, this automatic limit causes the counter to be cleared to zero in uni-directional mode or to change the direction of count in bi-directional mode. Software can write to set or clear this bit at any time. This bit applies to both the higher and lower registers when the UNIFY bit is set."]
    #[inline(always)]
    pub fn autolimit_l(&self) -> AUTOLIMIT_L_R {
        AUTOLIMIT_L_R::new(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - A one in this bit will cause a match on match register 0 to be treated as a de-facto LIMIT condition without the need to define an associated event. As with any LIMIT event, this automatic limit causes the counter to be cleared to zero in uni-directional mode or to change the direction of count in bi-directional mode. Software can write to set or clear this bit at any time. This bit is not used when the UNIFY bit is set."]
    #[inline(always)]
    pub fn autolimit_h(&self) -> AUTOLIMIT_H_R {
        AUTOLIMIT_H_R::new(((self.bits >> 18) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - SCT operation"]
    #[inline(always)]
    pub fn unify(&mut self) -> UNIFY_W {
        UNIFY_W { w: self }
    }
    #[doc = "Bits 1:2 - SCT clock mode"]
    #[inline(always)]
    pub fn clkmode(&mut self) -> CLKMODE_W {
        CLKMODE_W { w: self }
    }
    #[doc = "Bits 3:6 - SCT clock select"]
    #[inline(always)]
    pub fn cksel(&mut self) -> CKSEL_W {
        CKSEL_W { w: self }
    }
    #[doc = "Bit 7 - A 1 in this bit prevents the lower match and fractional match registers from being reloaded from their respective reload registers. Software can write to set or clear this bit at any time. This bit applies to both the higher and lower registers when the UNIFY bit is set."]
    #[inline(always)]
    pub fn norelaod_l(&mut self) -> NORELAOD_L_W {
        NORELAOD_L_W { w: self }
    }
    #[doc = "Bit 8 - A 1 in this bit prevents the higher match and fractional match registers from being reloaded from their respective reload registers. Software can write to set or clear this bit at any time. This bit is not used when the UNIFY bit is set."]
    #[inline(always)]
    pub fn noreload_h(&mut self) -> NORELOAD_H_W {
        NORELOAD_H_W { w: self }
    }
    #[doc = "Bits 9:16 - Synchronization for input n (bit 9 = input 0, bit 10 = input 1,..., bit 16 = input 7). A 1 in one of these bits subjects the corresponding input to synchronization to the SCT clock, before it is used to create an event. If an input is synchronous to the SCT clock, keep its bit 0 for faster response. When the CKMODE field is 1x, the bit in this field, corresponding to the input selected by the CKSEL field, is not used."]
    #[inline(always)]
    pub fn insync(&mut self) -> INSYNC_W {
        INSYNC_W { w: self }
    }
    #[doc = "Bit 17 - A one in this bit causes a match on match register 0 to be treated as a de-facto LIMIT condition without the need to define an associated event. As with any LIMIT event, this automatic limit causes the counter to be cleared to zero in uni-directional mode or to change the direction of count in bi-directional mode. Software can write to set or clear this bit at any time. This bit applies to both the higher and lower registers when the UNIFY bit is set."]
    #[inline(always)]
    pub fn autolimit_l(&mut self) -> AUTOLIMIT_L_W {
        AUTOLIMIT_L_W { w: self }
    }
    #[doc = "Bit 18 - A one in this bit will cause a match on match register 0 to be treated as a de-facto LIMIT condition without the need to define an associated event. As with any LIMIT event, this automatic limit causes the counter to be cleared to zero in uni-directional mode or to change the direction of count in bi-directional mode. Software can write to set or clear this bit at any time. This bit is not used when the UNIFY bit is set."]
    #[inline(always)]
    pub fn autolimit_h(&mut self) -> AUTOLIMIT_H_W {
        AUTOLIMIT_H_W { w: self }
    }
}
