#[doc = "Reader of register ENAIO0"]
pub type R = crate::R<u32, super::ENAIO0>;
#[doc = "Writer for register ENAIO0"]
pub type W = crate::W<u32, super::ENAIO0>;
#[doc = "Register ENAIO0 `reset()`'s with value 0"]
impl crate::ResetValue for super::ENAIO0 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Select ADC0_0\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC0_0_A {
    #[doc = "0: Digital function selected on pin P4_3."]
    DIGITAL_FUNCTION_SELECTED = 0,
    #[doc = "1: Analog function ADC0_0 selected on pin P4_3"]
    ANALOG_FUNCTION_ADC0_SELECTED = 1,
}
impl From<ADC0_0_A> for bool {
    #[inline(always)]
    fn from(variant: ADC0_0_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ADC0_0`"]
pub type ADC0_0_R = crate::R<bool, ADC0_0_A>;
impl ADC0_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC0_0_A {
        match self.bits {
            false => ADC0_0_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC0_0_A::ANALOG_FUNCTION_ADC0_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC0_0_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC0_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc0_selected(&self) -> bool {
        *self == ADC0_0_A::ANALOG_FUNCTION_ADC0_SELECTED
    }
}
#[doc = "Write proxy for field `ADC0_0`"]
pub struct ADC0_0_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC0_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC0_0_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin P4_3."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC0_0_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC0_0 selected on pin P4_3"]
    #[inline(always)]
    pub fn analog_function_adc0_selected(self) -> &'a mut W {
        self.variant(ADC0_0_A::ANALOG_FUNCTION_ADC0_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Select ADC0_1\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC0_1_A {
    #[doc = "0: Digital function selected on pin P4_1."]
    DIGITAL_FUNCTION_SELECTED = 0,
    #[doc = "1: Analog function ADC0_1 selected on pin P4_1."]
    ANALOG_FUNCTION_ADC0_SELECTED = 1,
}
impl From<ADC0_1_A> for bool {
    #[inline(always)]
    fn from(variant: ADC0_1_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ADC0_1`"]
pub type ADC0_1_R = crate::R<bool, ADC0_1_A>;
impl ADC0_1_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC0_1_A {
        match self.bits {
            false => ADC0_1_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC0_1_A::ANALOG_FUNCTION_ADC0_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC0_1_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC0_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc0_selected(&self) -> bool {
        *self == ADC0_1_A::ANALOG_FUNCTION_ADC0_SELECTED
    }
}
#[doc = "Write proxy for field `ADC0_1`"]
pub struct ADC0_1_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC0_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC0_1_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin P4_1."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC0_1_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC0_1 selected on pin P4_1."]
    #[inline(always)]
    pub fn analog_function_adc0_selected(self) -> &'a mut W {
        self.variant(ADC0_1_A::ANALOG_FUNCTION_ADC0_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Select ADC0_2\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC0_2_A {
    #[doc = "0: Digital function selected on pin PF_8."]
    DIGITAL_FUNCTION_SELECTED = 0,
    #[doc = "1: Analog function ADC0_2 selected on pin PF_8."]
    ANALOG_FUNCTION_ADC0_SELECTED = 1,
}
impl From<ADC0_2_A> for bool {
    #[inline(always)]
    fn from(variant: ADC0_2_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ADC0_2`"]
pub type ADC0_2_R = crate::R<bool, ADC0_2_A>;
impl ADC0_2_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC0_2_A {
        match self.bits {
            false => ADC0_2_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC0_2_A::ANALOG_FUNCTION_ADC0_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC0_2_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC0_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc0_selected(&self) -> bool {
        *self == ADC0_2_A::ANALOG_FUNCTION_ADC0_SELECTED
    }
}
#[doc = "Write proxy for field `ADC0_2`"]
pub struct ADC0_2_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC0_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC0_2_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_8."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC0_2_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC0_2 selected on pin PF_8."]
    #[inline(always)]
    pub fn analog_function_adc0_selected(self) -> &'a mut W {
        self.variant(ADC0_2_A::ANALOG_FUNCTION_ADC0_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Select ADC0_3\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC0_3_A {
    #[doc = "0: Digital function selected on pin P7_5."]
    DIGITAL_FUNCTION_SELECTED = 0,
    #[doc = "1: Analog function ADC0_3 selected on pin P7_5."]
    ANALOG_FUNCTION_ADC0_SELECTED = 1,
}
impl From<ADC0_3_A> for bool {
    #[inline(always)]
    fn from(variant: ADC0_3_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ADC0_3`"]
pub type ADC0_3_R = crate::R<bool, ADC0_3_A>;
impl ADC0_3_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC0_3_A {
        match self.bits {
            false => ADC0_3_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC0_3_A::ANALOG_FUNCTION_ADC0_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC0_3_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC0_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc0_selected(&self) -> bool {
        *self == ADC0_3_A::ANALOG_FUNCTION_ADC0_SELECTED
    }
}
#[doc = "Write proxy for field `ADC0_3`"]
pub struct ADC0_3_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC0_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC0_3_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin P7_5."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC0_3_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC0_3 selected on pin P7_5."]
    #[inline(always)]
    pub fn analog_function_adc0_selected(self) -> &'a mut W {
        self.variant(ADC0_3_A::ANALOG_FUNCTION_ADC0_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Select ADC0_4\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC0_4_A {
    #[doc = "0: Digital function selected on pin P7_4."]
    DIGITAL_FUNCTION_SELECTED = 0,
    #[doc = "1: Analog function ADC0_4 selected on pin P7_4."]
    ANALOG_FUNCTION_ADC0_SELECTED = 1,
}
impl From<ADC0_4_A> for bool {
    #[inline(always)]
    fn from(variant: ADC0_4_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ADC0_4`"]
pub type ADC0_4_R = crate::R<bool, ADC0_4_A>;
impl ADC0_4_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC0_4_A {
        match self.bits {
            false => ADC0_4_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC0_4_A::ANALOG_FUNCTION_ADC0_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC0_4_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC0_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc0_selected(&self) -> bool {
        *self == ADC0_4_A::ANALOG_FUNCTION_ADC0_SELECTED
    }
}
#[doc = "Write proxy for field `ADC0_4`"]
pub struct ADC0_4_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC0_4_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC0_4_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin P7_4."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC0_4_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC0_4 selected on pin P7_4."]
    #[inline(always)]
    pub fn analog_function_adc0_selected(self) -> &'a mut W {
        self.variant(ADC0_4_A::ANALOG_FUNCTION_ADC0_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Select ADC0_5\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC0_5_A {
    #[doc = "0: Digital function selected on pin PF_10."]
    DIGITAL_FUNCTION_SELECTED = 0,
    #[doc = "1: Analog function ADC0_5 selected on pin PF_10."]
    ANALOG_FUNCTION_ADC0_SELECTED = 1,
}
impl From<ADC0_5_A> for bool {
    #[inline(always)]
    fn from(variant: ADC0_5_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ADC0_5`"]
pub type ADC0_5_R = crate::R<bool, ADC0_5_A>;
impl ADC0_5_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC0_5_A {
        match self.bits {
            false => ADC0_5_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC0_5_A::ANALOG_FUNCTION_ADC0_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC0_5_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC0_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc0_selected(&self) -> bool {
        *self == ADC0_5_A::ANALOG_FUNCTION_ADC0_SELECTED
    }
}
#[doc = "Write proxy for field `ADC0_5`"]
pub struct ADC0_5_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC0_5_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC0_5_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_10."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC0_5_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC0_5 selected on pin PF_10."]
    #[inline(always)]
    pub fn analog_function_adc0_selected(self) -> &'a mut W {
        self.variant(ADC0_5_A::ANALOG_FUNCTION_ADC0_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Select ADC0_6\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC0_6_A {
    #[doc = "0: Digital function selected on pin PB_6."]
    DIGITAL_FUNCTION_SELECTED = 0,
    #[doc = "1: Analog function ADC0_6 selected on pin PB_6."]
    ANALOG_FUNCTION_ADC0_SELECTED = 1,
}
impl From<ADC0_6_A> for bool {
    #[inline(always)]
    fn from(variant: ADC0_6_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ADC0_6`"]
pub type ADC0_6_R = crate::R<bool, ADC0_6_A>;
impl ADC0_6_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC0_6_A {
        match self.bits {
            false => ADC0_6_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC0_6_A::ANALOG_FUNCTION_ADC0_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC0_6_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC0_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc0_selected(&self) -> bool {
        *self == ADC0_6_A::ANALOG_FUNCTION_ADC0_SELECTED
    }
}
#[doc = "Write proxy for field `ADC0_6`"]
pub struct ADC0_6_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC0_6_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC0_6_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PB_6."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC0_6_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC0_6 selected on pin PB_6."]
    #[inline(always)]
    pub fn analog_function_adc0_selected(self) -> &'a mut W {
        self.variant(ADC0_6_A::ANALOG_FUNCTION_ADC0_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Select ADC0_0"]
    #[inline(always)]
    pub fn adc0_0(&self) -> ADC0_0_R {
        ADC0_0_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Select ADC0_1"]
    #[inline(always)]
    pub fn adc0_1(&self) -> ADC0_1_R {
        ADC0_1_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Select ADC0_2"]
    #[inline(always)]
    pub fn adc0_2(&self) -> ADC0_2_R {
        ADC0_2_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Select ADC0_3"]
    #[inline(always)]
    pub fn adc0_3(&self) -> ADC0_3_R {
        ADC0_3_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Select ADC0_4"]
    #[inline(always)]
    pub fn adc0_4(&self) -> ADC0_4_R {
        ADC0_4_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Select ADC0_5"]
    #[inline(always)]
    pub fn adc0_5(&self) -> ADC0_5_R {
        ADC0_5_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Select ADC0_6"]
    #[inline(always)]
    pub fn adc0_6(&self) -> ADC0_6_R {
        ADC0_6_R::new(((self.bits >> 6) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Select ADC0_0"]
    #[inline(always)]
    pub fn adc0_0(&mut self) -> ADC0_0_W {
        ADC0_0_W { w: self }
    }
    #[doc = "Bit 1 - Select ADC0_1"]
    #[inline(always)]
    pub fn adc0_1(&mut self) -> ADC0_1_W {
        ADC0_1_W { w: self }
    }
    #[doc = "Bit 2 - Select ADC0_2"]
    #[inline(always)]
    pub fn adc0_2(&mut self) -> ADC0_2_W {
        ADC0_2_W { w: self }
    }
    #[doc = "Bit 3 - Select ADC0_3"]
    #[inline(always)]
    pub fn adc0_3(&mut self) -> ADC0_3_W {
        ADC0_3_W { w: self }
    }
    #[doc = "Bit 4 - Select ADC0_4"]
    #[inline(always)]
    pub fn adc0_4(&mut self) -> ADC0_4_W {
        ADC0_4_W { w: self }
    }
    #[doc = "Bit 5 - Select ADC0_5"]
    #[inline(always)]
    pub fn adc0_5(&mut self) -> ADC0_5_W {
        ADC0_5_W { w: self }
    }
    #[doc = "Bit 6 - Select ADC0_6"]
    #[inline(always)]
    pub fn adc0_6(&mut self) -> ADC0_6_W {
        ADC0_6_W { w: self }
    }
}
