#[doc = "Reader of register PINTSEL0"]
pub type R = crate::R<u32, super::PINTSEL0>;
#[doc = "Writer for register PINTSEL0"]
pub type W = crate::W<u32, super::PINTSEL0>;
#[doc = "Register PINTSEL0 `reset()`'s with value 0"]
impl crate::ResetValue for super::PINTSEL0 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `INTPIN0`"]
pub type INTPIN0_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN0`"]
pub struct INTPIN0_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x1f) | ((value as u32) & 0x1f);
        self.w
    }
}
#[doc = "Pin interrupt 0: Select the port for the pin number to be selected in the INTPIN0 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL0_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL0_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL0_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL0`"]
pub type PORTSEL0_R = crate::R<u8, PORTSEL0_A>;
impl PORTSEL0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL0_A {
        match self.bits {
            0 => PORTSEL0_A::GPIO_PORT_0,
            1 => PORTSEL0_A::GPIO_PORT_1,
            2 => PORTSEL0_A::GPIO_PORT_2,
            3 => PORTSEL0_A::GPIO_PORT_3,
            4 => PORTSEL0_A::GPIO_PORT_4,
            5 => PORTSEL0_A::GPIO_PORT_5,
            6 => PORTSEL0_A::GPIO_PORT_6,
            7 => PORTSEL0_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL0_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL0`"]
pub struct PORTSEL0_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL0_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL0_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 5)) | (((value as u32) & 0x07) << 5);
        self.w
    }
}
#[doc = "Reader of field `INTPIN1`"]
pub type INTPIN1_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN1`"]
pub struct INTPIN1_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 8)) | (((value as u32) & 0x1f) << 8);
        self.w
    }
}
#[doc = "Pin interrupt 1: Select the port for the pin number to be selected in the INTPIN1 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL1_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL1_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL1_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL1`"]
pub type PORTSEL1_R = crate::R<u8, PORTSEL1_A>;
impl PORTSEL1_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL1_A {
        match self.bits {
            0 => PORTSEL1_A::GPIO_PORT_0,
            1 => PORTSEL1_A::GPIO_PORT_1,
            2 => PORTSEL1_A::GPIO_PORT_2,
            3 => PORTSEL1_A::GPIO_PORT_3,
            4 => PORTSEL1_A::GPIO_PORT_4,
            5 => PORTSEL1_A::GPIO_PORT_5,
            6 => PORTSEL1_A::GPIO_PORT_6,
            7 => PORTSEL1_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL1_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL1`"]
pub struct PORTSEL1_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL1_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL1_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 13)) | (((value as u32) & 0x07) << 13);
        self.w
    }
}
#[doc = "Reader of field `INTPIN2`"]
pub type INTPIN2_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN2`"]
pub struct INTPIN2_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 16)) | (((value as u32) & 0x1f) << 16);
        self.w
    }
}
#[doc = "Pin interrupt 2: Select the port for the pin number to be selected in the INTPIN2 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL2_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL2_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL2_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL2`"]
pub type PORTSEL2_R = crate::R<u8, PORTSEL2_A>;
impl PORTSEL2_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL2_A {
        match self.bits {
            0 => PORTSEL2_A::GPIO_PORT_0,
            1 => PORTSEL2_A::GPIO_PORT_1,
            2 => PORTSEL2_A::GPIO_PORT_2,
            3 => PORTSEL2_A::GPIO_PORT_3,
            4 => PORTSEL2_A::GPIO_PORT_4,
            5 => PORTSEL2_A::GPIO_PORT_5,
            6 => PORTSEL2_A::GPIO_PORT_6,
            7 => PORTSEL2_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL2_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL2`"]
pub struct PORTSEL2_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL2_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL2_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 21)) | (((value as u32) & 0x07) << 21);
        self.w
    }
}
#[doc = "Reader of field `INTPIN3`"]
pub type INTPIN3_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN3`"]
pub struct INTPIN3_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN3_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 24)) | (((value as u32) & 0x1f) << 24);
        self.w
    }
}
#[doc = "Pin interrupt 3: Select the port for the pin number to be selected in the INTPIN3 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL3_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL3_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL3_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL3`"]
pub type PORTSEL3_R = crate::R<u8, PORTSEL3_A>;
impl PORTSEL3_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL3_A {
        match self.bits {
            0 => PORTSEL3_A::GPIO_PORT_0,
            1 => PORTSEL3_A::GPIO_PORT_1,
            2 => PORTSEL3_A::GPIO_PORT_2,
            3 => PORTSEL3_A::GPIO_PORT_3,
            4 => PORTSEL3_A::GPIO_PORT_4,
            5 => PORTSEL3_A::GPIO_PORT_5,
            6 => PORTSEL3_A::GPIO_PORT_6,
            7 => PORTSEL3_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL3_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL3`"]
pub struct PORTSEL3_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL3_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL3_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 29)) | (((value as u32) & 0x07) << 29);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:4 - Pint interrupt 0: Select the pin number within the GPIO port selected by the PORTSEL0 bit in this register."]
    #[inline(always)]
    pub fn intpin0(&self) -> INTPIN0_R {
        INTPIN0_R::new((self.bits & 0x1f) as u8)
    }
    #[doc = "Bits 5:7 - Pin interrupt 0: Select the port for the pin number to be selected in the INTPIN0 bits of this register."]
    #[inline(always)]
    pub fn portsel0(&self) -> PORTSEL0_R {
        PORTSEL0_R::new(((self.bits >> 5) & 0x07) as u8)
    }
    #[doc = "Bits 8:12 - Pint interrupt 1: Select the pin number within the GPIO port selected by the PORTSEL1 bit in this register."]
    #[inline(always)]
    pub fn intpin1(&self) -> INTPIN1_R {
        INTPIN1_R::new(((self.bits >> 8) & 0x1f) as u8)
    }
    #[doc = "Bits 13:15 - Pin interrupt 1: Select the port for the pin number to be selected in the INTPIN1 bits of this register."]
    #[inline(always)]
    pub fn portsel1(&self) -> PORTSEL1_R {
        PORTSEL1_R::new(((self.bits >> 13) & 0x07) as u8)
    }
    #[doc = "Bits 16:20 - Pint interrupt 2: Select the pin number within the GPIO port selected by the PORTSEL2 bit in this register."]
    #[inline(always)]
    pub fn intpin2(&self) -> INTPIN2_R {
        INTPIN2_R::new(((self.bits >> 16) & 0x1f) as u8)
    }
    #[doc = "Bits 21:23 - Pin interrupt 2: Select the port for the pin number to be selected in the INTPIN2 bits of this register."]
    #[inline(always)]
    pub fn portsel2(&self) -> PORTSEL2_R {
        PORTSEL2_R::new(((self.bits >> 21) & 0x07) as u8)
    }
    #[doc = "Bits 24:28 - Pint interrupt 3: Select the pin number within the GPIO port selected by the PORTSEL3 bit in this register."]
    #[inline(always)]
    pub fn intpin3(&self) -> INTPIN3_R {
        INTPIN3_R::new(((self.bits >> 24) & 0x1f) as u8)
    }
    #[doc = "Bits 29:31 - Pin interrupt 3: Select the port for the pin number to be selected in the INTPIN3 bits of this register."]
    #[inline(always)]
    pub fn portsel3(&self) -> PORTSEL3_R {
        PORTSEL3_R::new(((self.bits >> 29) & 0x07) as u8)
    }
}
impl W {
    #[doc = "Bits 0:4 - Pint interrupt 0: Select the pin number within the GPIO port selected by the PORTSEL0 bit in this register."]
    #[inline(always)]
    pub fn intpin0(&mut self) -> INTPIN0_W {
        INTPIN0_W { w: self }
    }
    #[doc = "Bits 5:7 - Pin interrupt 0: Select the port for the pin number to be selected in the INTPIN0 bits of this register."]
    #[inline(always)]
    pub fn portsel0(&mut self) -> PORTSEL0_W {
        PORTSEL0_W { w: self }
    }
    #[doc = "Bits 8:12 - Pint interrupt 1: Select the pin number within the GPIO port selected by the PORTSEL1 bit in this register."]
    #[inline(always)]
    pub fn intpin1(&mut self) -> INTPIN1_W {
        INTPIN1_W { w: self }
    }
    #[doc = "Bits 13:15 - Pin interrupt 1: Select the port for the pin number to be selected in the INTPIN1 bits of this register."]
    #[inline(always)]
    pub fn portsel1(&mut self) -> PORTSEL1_W {
        PORTSEL1_W { w: self }
    }
    #[doc = "Bits 16:20 - Pint interrupt 2: Select the pin number within the GPIO port selected by the PORTSEL2 bit in this register."]
    #[inline(always)]
    pub fn intpin2(&mut self) -> INTPIN2_W {
        INTPIN2_W { w: self }
    }
    #[doc = "Bits 21:23 - Pin interrupt 2: Select the port for the pin number to be selected in the INTPIN2 bits of this register."]
    #[inline(always)]
    pub fn portsel2(&mut self) -> PORTSEL2_W {
        PORTSEL2_W { w: self }
    }
    #[doc = "Bits 24:28 - Pint interrupt 3: Select the pin number within the GPIO port selected by the PORTSEL3 bit in this register."]
    #[inline(always)]
    pub fn intpin3(&mut self) -> INTPIN3_W {
        INTPIN3_W { w: self }
    }
    #[doc = "Bits 29:31 - Pin interrupt 3: Select the port for the pin number to be selected in the INTPIN3 bits of this register."]
    #[inline(always)]
    pub fn portsel3(&mut self) -> PORTSEL3_W {
        PORTSEL3_W { w: self }
    }
}
