#[doc = "Reader of register PINTSEL1"]
pub type R = crate::R<u32, super::PINTSEL1>;
#[doc = "Writer for register PINTSEL1"]
pub type W = crate::W<u32, super::PINTSEL1>;
#[doc = "Register PINTSEL1 `reset()`'s with value 0"]
impl crate::ResetValue for super::PINTSEL1 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `INTPIN4`"]
pub type INTPIN4_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN4`"]
pub struct INTPIN4_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN4_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x1f) | ((value as u32) & 0x1f);
        self.w
    }
}
#[doc = "Pin interrupt 4: Select the port for the pin number to be selected in the INTPIN4 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL4_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL4_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL4_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL4`"]
pub type PORTSEL4_R = crate::R<u8, PORTSEL4_A>;
impl PORTSEL4_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL4_A {
        match self.bits {
            0 => PORTSEL4_A::GPIO_PORT_0,
            1 => PORTSEL4_A::GPIO_PORT_1,
            2 => PORTSEL4_A::GPIO_PORT_2,
            3 => PORTSEL4_A::GPIO_PORT_3,
            4 => PORTSEL4_A::GPIO_PORT_4,
            5 => PORTSEL4_A::GPIO_PORT_5,
            6 => PORTSEL4_A::GPIO_PORT_6,
            7 => PORTSEL4_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL4_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL4`"]
pub struct PORTSEL4_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL4_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL4_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL4_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 5)) | (((value as u32) & 0x07) << 5);
        self.w
    }
}
#[doc = "Reader of field `INTPIN5`"]
pub type INTPIN5_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN5`"]
pub struct INTPIN5_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN5_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 8)) | (((value as u32) & 0x1f) << 8);
        self.w
    }
}
#[doc = "Pin interrupt 5: Select the port for the pin number to be selected in the INTPIN5 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL5_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL5_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL5_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL5`"]
pub type PORTSEL5_R = crate::R<u8, PORTSEL5_A>;
impl PORTSEL5_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL5_A {
        match self.bits {
            0 => PORTSEL5_A::GPIO_PORT_0,
            1 => PORTSEL5_A::GPIO_PORT_1,
            2 => PORTSEL5_A::GPIO_PORT_2,
            3 => PORTSEL5_A::GPIO_PORT_3,
            4 => PORTSEL5_A::GPIO_PORT_4,
            5 => PORTSEL5_A::GPIO_PORT_5,
            6 => PORTSEL5_A::GPIO_PORT_6,
            7 => PORTSEL5_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL5_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL5`"]
pub struct PORTSEL5_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL5_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL5_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL5_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 13)) | (((value as u32) & 0x07) << 13);
        self.w
    }
}
#[doc = "Reader of field `INTPIN6`"]
pub type INTPIN6_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN6`"]
pub struct INTPIN6_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN6_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 16)) | (((value as u32) & 0x1f) << 16);
        self.w
    }
}
#[doc = "Pin interrupt 6: Select the port for the pin number to be selected in the INTPIN6 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL6_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL6_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL6_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL6`"]
pub type PORTSEL6_R = crate::R<u8, PORTSEL6_A>;
impl PORTSEL6_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL6_A {
        match self.bits {
            0 => PORTSEL6_A::GPIO_PORT_0,
            1 => PORTSEL6_A::GPIO_PORT_1,
            2 => PORTSEL6_A::GPIO_PORT_2,
            3 => PORTSEL6_A::GPIO_PORT_3,
            4 => PORTSEL6_A::GPIO_PORT_4,
            5 => PORTSEL6_A::GPIO_PORT_5,
            6 => PORTSEL6_A::GPIO_PORT_6,
            7 => PORTSEL6_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL6_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL6`"]
pub struct PORTSEL6_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL6_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL6_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL6_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 21)) | (((value as u32) & 0x07) << 21);
        self.w
    }
}
#[doc = "Reader of field `INTPIN7`"]
pub type INTPIN7_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `INTPIN7`"]
pub struct INTPIN7_W<'a> {
    w: &'a mut W,
}
impl<'a> INTPIN7_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 24)) | (((value as u32) & 0x1f) << 24);
        self.w
    }
}
#[doc = "Pin interrupt 7: Select the port for the pin number to be selected in the INTPIN7 bits of this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PORTSEL7_A {
    #[doc = "0: GPIO Port 0"]
    GPIO_PORT_0 = 0,
    #[doc = "1: GPIO Port 1"]
    GPIO_PORT_1 = 1,
    #[doc = "2: GPIO Port 2"]
    GPIO_PORT_2 = 2,
    #[doc = "3: GPIO Port 3"]
    GPIO_PORT_3 = 3,
    #[doc = "4: GPIO Port 4"]
    GPIO_PORT_4 = 4,
    #[doc = "5: GPIO Port 5"]
    GPIO_PORT_5 = 5,
    #[doc = "6: GPIO Port 6"]
    GPIO_PORT_6 = 6,
    #[doc = "7: GPIO Port 7"]
    GPIO_PORT_7 = 7,
}
impl From<PORTSEL7_A> for u8 {
    #[inline(always)]
    fn from(variant: PORTSEL7_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PORTSEL7`"]
pub type PORTSEL7_R = crate::R<u8, PORTSEL7_A>;
impl PORTSEL7_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PORTSEL7_A {
        match self.bits {
            0 => PORTSEL7_A::GPIO_PORT_0,
            1 => PORTSEL7_A::GPIO_PORT_1,
            2 => PORTSEL7_A::GPIO_PORT_2,
            3 => PORTSEL7_A::GPIO_PORT_3,
            4 => PORTSEL7_A::GPIO_PORT_4,
            5 => PORTSEL7_A::GPIO_PORT_5,
            6 => PORTSEL7_A::GPIO_PORT_6,
            7 => PORTSEL7_A::GPIO_PORT_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_0`"]
    #[inline(always)]
    pub fn is_gpio_port_0(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_0
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_1`"]
    #[inline(always)]
    pub fn is_gpio_port_1(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_1
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_2`"]
    #[inline(always)]
    pub fn is_gpio_port_2(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_2
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_3`"]
    #[inline(always)]
    pub fn is_gpio_port_3(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_3
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_4`"]
    #[inline(always)]
    pub fn is_gpio_port_4(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_4
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_5`"]
    #[inline(always)]
    pub fn is_gpio_port_5(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_5
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_6`"]
    #[inline(always)]
    pub fn is_gpio_port_6(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_6
    }
    #[doc = "Checks if the value of the field is `GPIO_PORT_7`"]
    #[inline(always)]
    pub fn is_gpio_port_7(&self) -> bool {
        *self == PORTSEL7_A::GPIO_PORT_7
    }
}
#[doc = "Write proxy for field `PORTSEL7`"]
pub struct PORTSEL7_W<'a> {
    w: &'a mut W,
}
impl<'a> PORTSEL7_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PORTSEL7_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "GPIO Port 0"]
    #[inline(always)]
    pub fn gpio_port_0(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_0)
    }
    #[doc = "GPIO Port 1"]
    #[inline(always)]
    pub fn gpio_port_1(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_1)
    }
    #[doc = "GPIO Port 2"]
    #[inline(always)]
    pub fn gpio_port_2(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_2)
    }
    #[doc = "GPIO Port 3"]
    #[inline(always)]
    pub fn gpio_port_3(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_3)
    }
    #[doc = "GPIO Port 4"]
    #[inline(always)]
    pub fn gpio_port_4(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_4)
    }
    #[doc = "GPIO Port 5"]
    #[inline(always)]
    pub fn gpio_port_5(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_5)
    }
    #[doc = "GPIO Port 6"]
    #[inline(always)]
    pub fn gpio_port_6(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_6)
    }
    #[doc = "GPIO Port 7"]
    #[inline(always)]
    pub fn gpio_port_7(self) -> &'a mut W {
        self.variant(PORTSEL7_A::GPIO_PORT_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 29)) | (((value as u32) & 0x07) << 29);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:4 - Pint interrupt 4: Select the pin number within the GPIO port selected by the PORTSEL4 bit in this register."]
    #[inline(always)]
    pub fn intpin4(&self) -> INTPIN4_R {
        INTPIN4_R::new((self.bits & 0x1f) as u8)
    }
    #[doc = "Bits 5:7 - Pin interrupt 4: Select the port for the pin number to be selected in the INTPIN4 bits of this register."]
    #[inline(always)]
    pub fn portsel4(&self) -> PORTSEL4_R {
        PORTSEL4_R::new(((self.bits >> 5) & 0x07) as u8)
    }
    #[doc = "Bits 8:12 - Pint interrupt 5: Select the pin number within the GPIO port selected by the PORTSEL5 bit in this register."]
    #[inline(always)]
    pub fn intpin5(&self) -> INTPIN5_R {
        INTPIN5_R::new(((self.bits >> 8) & 0x1f) as u8)
    }
    #[doc = "Bits 13:15 - Pin interrupt 5: Select the port for the pin number to be selected in the INTPIN5 bits of this register."]
    #[inline(always)]
    pub fn portsel5(&self) -> PORTSEL5_R {
        PORTSEL5_R::new(((self.bits >> 13) & 0x07) as u8)
    }
    #[doc = "Bits 16:20 - Pint interrupt 6: Select the pin number within the GPIO port selected by the PORTSEL6 bit in this register."]
    #[inline(always)]
    pub fn intpin6(&self) -> INTPIN6_R {
        INTPIN6_R::new(((self.bits >> 16) & 0x1f) as u8)
    }
    #[doc = "Bits 21:23 - Pin interrupt 6: Select the port for the pin number to be selected in the INTPIN6 bits of this register."]
    #[inline(always)]
    pub fn portsel6(&self) -> PORTSEL6_R {
        PORTSEL6_R::new(((self.bits >> 21) & 0x07) as u8)
    }
    #[doc = "Bits 24:28 - Pint interrupt 7: Select the pin number within the GPIO port selected by the PORTSEL7 bit in this register."]
    #[inline(always)]
    pub fn intpin7(&self) -> INTPIN7_R {
        INTPIN7_R::new(((self.bits >> 24) & 0x1f) as u8)
    }
    #[doc = "Bits 29:31 - Pin interrupt 7: Select the port for the pin number to be selected in the INTPIN7 bits of this register."]
    #[inline(always)]
    pub fn portsel7(&self) -> PORTSEL7_R {
        PORTSEL7_R::new(((self.bits >> 29) & 0x07) as u8)
    }
}
impl W {
    #[doc = "Bits 0:4 - Pint interrupt 4: Select the pin number within the GPIO port selected by the PORTSEL4 bit in this register."]
    #[inline(always)]
    pub fn intpin4(&mut self) -> INTPIN4_W {
        INTPIN4_W { w: self }
    }
    #[doc = "Bits 5:7 - Pin interrupt 4: Select the port for the pin number to be selected in the INTPIN4 bits of this register."]
    #[inline(always)]
    pub fn portsel4(&mut self) -> PORTSEL4_W {
        PORTSEL4_W { w: self }
    }
    #[doc = "Bits 8:12 - Pint interrupt 5: Select the pin number within the GPIO port selected by the PORTSEL5 bit in this register."]
    #[inline(always)]
    pub fn intpin5(&mut self) -> INTPIN5_W {
        INTPIN5_W { w: self }
    }
    #[doc = "Bits 13:15 - Pin interrupt 5: Select the port for the pin number to be selected in the INTPIN5 bits of this register."]
    #[inline(always)]
    pub fn portsel5(&mut self) -> PORTSEL5_W {
        PORTSEL5_W { w: self }
    }
    #[doc = "Bits 16:20 - Pint interrupt 6: Select the pin number within the GPIO port selected by the PORTSEL6 bit in this register."]
    #[inline(always)]
    pub fn intpin6(&mut self) -> INTPIN6_W {
        INTPIN6_W { w: self }
    }
    #[doc = "Bits 21:23 - Pin interrupt 6: Select the port for the pin number to be selected in the INTPIN6 bits of this register."]
    #[inline(always)]
    pub fn portsel6(&mut self) -> PORTSEL6_W {
        PORTSEL6_W { w: self }
    }
    #[doc = "Bits 24:28 - Pint interrupt 7: Select the pin number within the GPIO port selected by the PORTSEL7 bit in this register."]
    #[inline(always)]
    pub fn intpin7(&mut self) -> INTPIN7_W {
        INTPIN7_W { w: self }
    }
    #[doc = "Bits 29:31 - Pin interrupt 7: Select the port for the pin number to be selected in the INTPIN7 bits of this register."]
    #[inline(always)]
    pub fn portsel7(&mut self) -> PORTSEL7_W {
        PORTSEL7_W { w: self }
    }
}
