#[doc = "Reader of register SFSP3_3"]
pub type R = crate::R<u32, super::SFSP3_3>;
#[doc = "Writer for register SFSP3_3"]
pub type W = crate::W<u32, super::SFSP3_3>;
#[doc = "Register SFSP3_3 `reset()`'s with value 0"]
impl crate::ResetValue for super::SFSP3_3 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Select pin function.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum MODE_A {
    #[doc = "0: Function 0 (default)"]
    FUNCTION_0_DEFAULT = 0,
    #[doc = "1: Function 1"]
    FUNCTION_1 = 1,
    #[doc = "2: Function 2"]
    FUNCTION_2 = 2,
    #[doc = "3: Function 3"]
    FUNCTION_3 = 3,
    #[doc = "4: Function 4"]
    FUNCTION_4 = 4,
    #[doc = "5: Function 5"]
    FUNCTION_5 = 5,
    #[doc = "6: Function 6"]
    FUNCTION_6 = 6,
    #[doc = "7: Function 7"]
    FUNCTION_7 = 7,
}
impl From<MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: MODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `MODE`"]
pub type MODE_R = crate::R<u8, MODE_A>;
impl MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MODE_A {
        match self.bits {
            0 => MODE_A::FUNCTION_0_DEFAULT,
            1 => MODE_A::FUNCTION_1,
            2 => MODE_A::FUNCTION_2,
            3 => MODE_A::FUNCTION_3,
            4 => MODE_A::FUNCTION_4,
            5 => MODE_A::FUNCTION_5,
            6 => MODE_A::FUNCTION_6,
            7 => MODE_A::FUNCTION_7,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `FUNCTION_0_DEFAULT`"]
    #[inline(always)]
    pub fn is_function_0_default(&self) -> bool {
        *self == MODE_A::FUNCTION_0_DEFAULT
    }
    #[doc = "Checks if the value of the field is `FUNCTION_1`"]
    #[inline(always)]
    pub fn is_function_1(&self) -> bool {
        *self == MODE_A::FUNCTION_1
    }
    #[doc = "Checks if the value of the field is `FUNCTION_2`"]
    #[inline(always)]
    pub fn is_function_2(&self) -> bool {
        *self == MODE_A::FUNCTION_2
    }
    #[doc = "Checks if the value of the field is `FUNCTION_3`"]
    #[inline(always)]
    pub fn is_function_3(&self) -> bool {
        *self == MODE_A::FUNCTION_3
    }
    #[doc = "Checks if the value of the field is `FUNCTION_4`"]
    #[inline(always)]
    pub fn is_function_4(&self) -> bool {
        *self == MODE_A::FUNCTION_4
    }
    #[doc = "Checks if the value of the field is `FUNCTION_5`"]
    #[inline(always)]
    pub fn is_function_5(&self) -> bool {
        *self == MODE_A::FUNCTION_5
    }
    #[doc = "Checks if the value of the field is `FUNCTION_6`"]
    #[inline(always)]
    pub fn is_function_6(&self) -> bool {
        *self == MODE_A::FUNCTION_6
    }
    #[doc = "Checks if the value of the field is `FUNCTION_7`"]
    #[inline(always)]
    pub fn is_function_7(&self) -> bool {
        *self == MODE_A::FUNCTION_7
    }
}
#[doc = "Write proxy for field `MODE`"]
pub struct MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Function 0 (default)"]
    #[inline(always)]
    pub fn function_0_default(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_0_DEFAULT)
    }
    #[doc = "Function 1"]
    #[inline(always)]
    pub fn function_1(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_1)
    }
    #[doc = "Function 2"]
    #[inline(always)]
    pub fn function_2(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_2)
    }
    #[doc = "Function 3"]
    #[inline(always)]
    pub fn function_3(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_3)
    }
    #[doc = "Function 4"]
    #[inline(always)]
    pub fn function_4(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_4)
    }
    #[doc = "Function 5"]
    #[inline(always)]
    pub fn function_5(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_5)
    }
    #[doc = "Function 6"]
    #[inline(always)]
    pub fn function_6(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_6)
    }
    #[doc = "Function 7"]
    #[inline(always)]
    pub fn function_7(self) -> &'a mut W {
        self.variant(MODE_A::FUNCTION_7)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x07) | ((value as u32) & 0x07);
        self.w
    }
}
#[doc = "Enable pull-down resistor at pad.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EPD_A {
    #[doc = "0: Disable pull-down."]
    DISABLE_PULL_DOWN = 0,
    #[doc = "1: Enable pull-down. Enable both pull-down resistor and pull-up resistor for repeater mode."]
    ENABLE_PULL_DOWN = 1,
}
impl From<EPD_A> for bool {
    #[inline(always)]
    fn from(variant: EPD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EPD`"]
pub type EPD_R = crate::R<bool, EPD_A>;
impl EPD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EPD_A {
        match self.bits {
            false => EPD_A::DISABLE_PULL_DOWN,
            true => EPD_A::ENABLE_PULL_DOWN,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE_PULL_DOWN`"]
    #[inline(always)]
    pub fn is_disable_pull_down(&self) -> bool {
        *self == EPD_A::DISABLE_PULL_DOWN
    }
    #[doc = "Checks if the value of the field is `ENABLE_PULL_DOWN`"]
    #[inline(always)]
    pub fn is_enable_pull_down(&self) -> bool {
        *self == EPD_A::ENABLE_PULL_DOWN
    }
}
#[doc = "Write proxy for field `EPD`"]
pub struct EPD_W<'a> {
    w: &'a mut W,
}
impl<'a> EPD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EPD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disable pull-down."]
    #[inline(always)]
    pub fn disable_pull_down(self) -> &'a mut W {
        self.variant(EPD_A::DISABLE_PULL_DOWN)
    }
    #[doc = "Enable pull-down. Enable both pull-down resistor and pull-up resistor for repeater mode."]
    #[inline(always)]
    pub fn enable_pull_down(self) -> &'a mut W {
        self.variant(EPD_A::ENABLE_PULL_DOWN)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Disable pull-up resistor at pad. By default, the pull-up resistor is enabled at reset.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EPUN_A {
    #[doc = "0: Enable pull-up. Enable both pull-down resistor and pull-up resistor for repeater mode."]
    ENABLE_PULL_UP = 0,
    #[doc = "1: Disable pull-up."]
    DISABLE_PULL_UP = 1,
}
impl From<EPUN_A> for bool {
    #[inline(always)]
    fn from(variant: EPUN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EPUN`"]
pub type EPUN_R = crate::R<bool, EPUN_A>;
impl EPUN_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EPUN_A {
        match self.bits {
            false => EPUN_A::ENABLE_PULL_UP,
            true => EPUN_A::DISABLE_PULL_UP,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_PULL_UP`"]
    #[inline(always)]
    pub fn is_enable_pull_up(&self) -> bool {
        *self == EPUN_A::ENABLE_PULL_UP
    }
    #[doc = "Checks if the value of the field is `DISABLE_PULL_UP`"]
    #[inline(always)]
    pub fn is_disable_pull_up(&self) -> bool {
        *self == EPUN_A::DISABLE_PULL_UP
    }
}
#[doc = "Write proxy for field `EPUN`"]
pub struct EPUN_W<'a> {
    w: &'a mut W,
}
impl<'a> EPUN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EPUN_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable pull-up. Enable both pull-down resistor and pull-up resistor for repeater mode."]
    #[inline(always)]
    pub fn enable_pull_up(self) -> &'a mut W {
        self.variant(EPUN_A::ENABLE_PULL_UP)
    }
    #[doc = "Disable pull-up."]
    #[inline(always)]
    pub fn disable_pull_up(self) -> &'a mut W {
        self.variant(EPUN_A::DISABLE_PULL_UP)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Slew rate\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EHS_A {
    #[doc = "0: Fast (low noise with fast speed)"]
    FAST_LOW_NOISE_WITH = 0,
    #[doc = "1: High-speed (medium noise with high speed)"]
    HIGH_SPEED_MEDIUM_N = 1,
}
impl From<EHS_A> for bool {
    #[inline(always)]
    fn from(variant: EHS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EHS`"]
pub type EHS_R = crate::R<bool, EHS_A>;
impl EHS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EHS_A {
        match self.bits {
            false => EHS_A::FAST_LOW_NOISE_WITH,
            true => EHS_A::HIGH_SPEED_MEDIUM_N,
        }
    }
    #[doc = "Checks if the value of the field is `FAST_LOW_NOISE_WITH`"]
    #[inline(always)]
    pub fn is_fast_low_noise_with(&self) -> bool {
        *self == EHS_A::FAST_LOW_NOISE_WITH
    }
    #[doc = "Checks if the value of the field is `HIGH_SPEED_MEDIUM_N`"]
    #[inline(always)]
    pub fn is_high_speed_medium_n(&self) -> bool {
        *self == EHS_A::HIGH_SPEED_MEDIUM_N
    }
}
#[doc = "Write proxy for field `EHS`"]
pub struct EHS_W<'a> {
    w: &'a mut W,
}
impl<'a> EHS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EHS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Fast (low noise with fast speed)"]
    #[inline(always)]
    pub fn fast_low_noise_with(self) -> &'a mut W {
        self.variant(EHS_A::FAST_LOW_NOISE_WITH)
    }
    #[doc = "High-speed (medium noise with high speed)"]
    #[inline(always)]
    pub fn high_speed_medium_n(self) -> &'a mut W {
        self.variant(EHS_A::HIGH_SPEED_MEDIUM_N)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Input buffer enable. The input buffer is disabled by default at reset and must be enabled for receiving.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EZI_A {
    #[doc = "0: Disable input buffer"]
    DISABLE_INPUT_BUFFER = 0,
    #[doc = "1: Enable input buffer"]
    ENABLE_INPUT_BUFFER = 1,
}
impl From<EZI_A> for bool {
    #[inline(always)]
    fn from(variant: EZI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EZI`"]
pub type EZI_R = crate::R<bool, EZI_A>;
impl EZI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EZI_A {
        match self.bits {
            false => EZI_A::DISABLE_INPUT_BUFFER,
            true => EZI_A::ENABLE_INPUT_BUFFER,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE_INPUT_BUFFER`"]
    #[inline(always)]
    pub fn is_disable_input_buffer(&self) -> bool {
        *self == EZI_A::DISABLE_INPUT_BUFFER
    }
    #[doc = "Checks if the value of the field is `ENABLE_INPUT_BUFFER`"]
    #[inline(always)]
    pub fn is_enable_input_buffer(&self) -> bool {
        *self == EZI_A::ENABLE_INPUT_BUFFER
    }
}
#[doc = "Write proxy for field `EZI`"]
pub struct EZI_W<'a> {
    w: &'a mut W,
}
impl<'a> EZI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EZI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disable input buffer"]
    #[inline(always)]
    pub fn disable_input_buffer(self) -> &'a mut W {
        self.variant(EZI_A::DISABLE_INPUT_BUFFER)
    }
    #[doc = "Enable input buffer"]
    #[inline(always)]
    pub fn enable_input_buffer(self) -> &'a mut W {
        self.variant(EZI_A::ENABLE_INPUT_BUFFER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Input glitch filter. Disable the input glitch filter for clocking signals higher than 30 MHz.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ZIF_A {
    #[doc = "0: Enable input filter"]
    ENABLE_INPUT_FILTER = 0,
    #[doc = "1: Disable input filter"]
    DISABLE_INPUT_FILTER = 1,
}
impl From<ZIF_A> for bool {
    #[inline(always)]
    fn from(variant: ZIF_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ZIF`"]
pub type ZIF_R = crate::R<bool, ZIF_A>;
impl ZIF_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ZIF_A {
        match self.bits {
            false => ZIF_A::ENABLE_INPUT_FILTER,
            true => ZIF_A::DISABLE_INPUT_FILTER,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_INPUT_FILTER`"]
    #[inline(always)]
    pub fn is_enable_input_filter(&self) -> bool {
        *self == ZIF_A::ENABLE_INPUT_FILTER
    }
    #[doc = "Checks if the value of the field is `DISABLE_INPUT_FILTER`"]
    #[inline(always)]
    pub fn is_disable_input_filter(&self) -> bool {
        *self == ZIF_A::DISABLE_INPUT_FILTER
    }
}
#[doc = "Write proxy for field `ZIF`"]
pub struct ZIF_W<'a> {
    w: &'a mut W,
}
impl<'a> ZIF_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ZIF_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable input filter"]
    #[inline(always)]
    pub fn enable_input_filter(self) -> &'a mut W {
        self.variant(ZIF_A::ENABLE_INPUT_FILTER)
    }
    #[doc = "Disable input filter"]
    #[inline(always)]
    pub fn disable_input_filter(self) -> &'a mut W {
        self.variant(ZIF_A::DISABLE_INPUT_FILTER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:2 - Select pin function."]
    #[inline(always)]
    pub fn mode(&self) -> MODE_R {
        MODE_R::new((self.bits & 0x07) as u8)
    }
    #[doc = "Bit 3 - Enable pull-down resistor at pad."]
    #[inline(always)]
    pub fn epd(&self) -> EPD_R {
        EPD_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Disable pull-up resistor at pad. By default, the pull-up resistor is enabled at reset."]
    #[inline(always)]
    pub fn epun(&self) -> EPUN_R {
        EPUN_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Slew rate"]
    #[inline(always)]
    pub fn ehs(&self) -> EHS_R {
        EHS_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Input buffer enable. The input buffer is disabled by default at reset and must be enabled for receiving."]
    #[inline(always)]
    pub fn ezi(&self) -> EZI_R {
        EZI_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Input glitch filter. Disable the input glitch filter for clocking signals higher than 30 MHz."]
    #[inline(always)]
    pub fn zif(&self) -> ZIF_R {
        ZIF_R::new(((self.bits >> 7) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:2 - Select pin function."]
    #[inline(always)]
    pub fn mode(&mut self) -> MODE_W {
        MODE_W { w: self }
    }
    #[doc = "Bit 3 - Enable pull-down resistor at pad."]
    #[inline(always)]
    pub fn epd(&mut self) -> EPD_W {
        EPD_W { w: self }
    }
    #[doc = "Bit 4 - Disable pull-up resistor at pad. By default, the pull-up resistor is enabled at reset."]
    #[inline(always)]
    pub fn epun(&mut self) -> EPUN_W {
        EPUN_W { w: self }
    }
    #[doc = "Bit 5 - Slew rate"]
    #[inline(always)]
    pub fn ehs(&mut self) -> EHS_W {
        EHS_W { w: self }
    }
    #[doc = "Bit 6 - Input buffer enable. The input buffer is disabled by default at reset and must be enabled for receiving."]
    #[inline(always)]
    pub fn ezi(&mut self) -> EZI_W {
        EZI_W { w: self }
    }
    #[doc = "Bit 7 - Input glitch filter. Disable the input glitch filter for clocking signals higher than 30 MHz."]
    #[inline(always)]
    pub fn zif(&mut self) -> ZIF_W {
        ZIF_W { w: self }
    }
}
