#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Control Register"]
    pub ctrl: CTRL,
    #[doc = "0x04 - Power Enable Register"]
    pub pwren: PWREN,
    #[doc = "0x08 - Clock Divider Register"]
    pub clkdiv: CLKDIV,
    #[doc = "0x0c - SD Clock Source Register"]
    pub clksrc: CLKSRC,
    #[doc = "0x10 - Clock Enable Register"]
    pub clkena: CLKENA,
    #[doc = "0x14 - Time-out Register"]
    pub tmout: TMOUT,
    #[doc = "0x18 - Card Type Register"]
    pub ctype: CTYPE,
    #[doc = "0x1c - Block Size Register"]
    pub blksiz: BLKSIZ,
    #[doc = "0x20 - Byte Count Register"]
    pub bytcnt: BYTCNT,
    #[doc = "0x24 - Interrupt Mask Register"]
    pub intmask: INTMASK,
    #[doc = "0x28 - Command Argument Register"]
    pub cmdarg: CMDARG,
    #[doc = "0x2c - Command Register"]
    pub cmd: CMD,
    #[doc = "0x30 - Response Register 0"]
    pub resp0: RESP0,
    #[doc = "0x34 - Response Register 1"]
    pub resp1: RESP1,
    #[doc = "0x38 - Response Register 2"]
    pub resp2: RESP2,
    #[doc = "0x3c - Response Register 3"]
    pub resp3: RESP3,
    #[doc = "0x40 - Masked Interrupt Status Register"]
    pub mintsts: MINTSTS,
    #[doc = "0x44 - Raw Interrupt Status Register"]
    pub rintsts: RINTSTS,
    #[doc = "0x48 - Status Register"]
    pub status: STATUS,
    #[doc = "0x4c - FIFO Threshold Watermark Register"]
    pub fifoth: FIFOTH,
    #[doc = "0x50 - Card Detect Register"]
    pub cdetect: CDETECT,
    #[doc = "0x54 - Write Protect Register"]
    pub wrtprt: WRTPRT,
    _reserved22: [u8; 4usize],
    #[doc = "0x5c - Transferred CIU Card Byte Count Register"]
    pub tcbcnt: TCBCNT,
    #[doc = "0x60 - Transferred Host to BIU-FIFO Byte Count Register"]
    pub tbbcnt: TBBCNT,
    #[doc = "0x64 - Debounce Count Register"]
    pub debnce: DEBNCE,
    _reserved25: [u8; 16usize],
    #[doc = "0x78 - Hardware Reset"]
    pub rst_n: RST_N,
    _reserved26: [u8; 4usize],
    #[doc = "0x80 - Bus Mode Register"]
    pub bmod: BMOD,
    #[doc = "0x84 - Poll Demand Register"]
    pub pldmnd: PLDMND,
    #[doc = "0x88 - Descriptor List Base Address Register"]
    pub dbaddr: DBADDR,
    #[doc = "0x8c - Internal DMAC Status Register"]
    pub idsts: IDSTS,
    #[doc = "0x90 - Internal DMAC Interrupt Enable Register"]
    pub idinten: IDINTEN,
    #[doc = "0x94 - Current Host Descriptor Address Register"]
    pub dscaddr: DSCADDR,
    #[doc = "0x98 - Current Buffer Descriptor Address Register"]
    pub bufaddr: BUFADDR,
}
#[doc = "Control Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctrl](ctrl) module"]
pub type CTRL = crate::Reg<u32, _CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTRL;
#[doc = "`read()` method returns [ctrl::R](ctrl::R) reader structure"]
impl crate::Readable for CTRL {}
#[doc = "`write(|w| ..)` method takes [ctrl::W](ctrl::W) writer structure"]
impl crate::Writable for CTRL {}
#[doc = "Control Register"]
pub mod ctrl;
#[doc = "Power Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pwren](pwren) module"]
pub type PWREN = crate::Reg<u32, _PWREN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PWREN;
#[doc = "`read()` method returns [pwren::R](pwren::R) reader structure"]
impl crate::Readable for PWREN {}
#[doc = "`write(|w| ..)` method takes [pwren::W](pwren::W) writer structure"]
impl crate::Writable for PWREN {}
#[doc = "Power Enable Register"]
pub mod pwren;
#[doc = "Clock Divider Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clkdiv](clkdiv) module"]
pub type CLKDIV = crate::Reg<u32, _CLKDIV>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLKDIV;
#[doc = "`read()` method returns [clkdiv::R](clkdiv::R) reader structure"]
impl crate::Readable for CLKDIV {}
#[doc = "`write(|w| ..)` method takes [clkdiv::W](clkdiv::W) writer structure"]
impl crate::Writable for CLKDIV {}
#[doc = "Clock Divider Register"]
pub mod clkdiv;
#[doc = "SD Clock Source Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clksrc](clksrc) module"]
pub type CLKSRC = crate::Reg<u32, _CLKSRC>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLKSRC;
#[doc = "`read()` method returns [clksrc::R](clksrc::R) reader structure"]
impl crate::Readable for CLKSRC {}
#[doc = "`write(|w| ..)` method takes [clksrc::W](clksrc::W) writer structure"]
impl crate::Writable for CLKSRC {}
#[doc = "SD Clock Source Register"]
pub mod clksrc;
#[doc = "Clock Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clkena](clkena) module"]
pub type CLKENA = crate::Reg<u32, _CLKENA>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLKENA;
#[doc = "`read()` method returns [clkena::R](clkena::R) reader structure"]
impl crate::Readable for CLKENA {}
#[doc = "`write(|w| ..)` method takes [clkena::W](clkena::W) writer structure"]
impl crate::Writable for CLKENA {}
#[doc = "Clock Enable Register"]
pub mod clkena;
#[doc = "Time-out Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tmout](tmout) module"]
pub type TMOUT = crate::Reg<u32, _TMOUT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TMOUT;
#[doc = "`read()` method returns [tmout::R](tmout::R) reader structure"]
impl crate::Readable for TMOUT {}
#[doc = "`write(|w| ..)` method takes [tmout::W](tmout::W) writer structure"]
impl crate::Writable for TMOUT {}
#[doc = "Time-out Register"]
pub mod tmout;
#[doc = "Card Type Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ctype](ctype) module"]
pub type CTYPE = crate::Reg<u32, _CTYPE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTYPE;
#[doc = "`read()` method returns [ctype::R](ctype::R) reader structure"]
impl crate::Readable for CTYPE {}
#[doc = "`write(|w| ..)` method takes [ctype::W](ctype::W) writer structure"]
impl crate::Writable for CTYPE {}
#[doc = "Card Type Register"]
pub mod ctype;
#[doc = "Block Size Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [blksiz](blksiz) module"]
pub type BLKSIZ = crate::Reg<u32, _BLKSIZ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BLKSIZ;
#[doc = "`read()` method returns [blksiz::R](blksiz::R) reader structure"]
impl crate::Readable for BLKSIZ {}
#[doc = "`write(|w| ..)` method takes [blksiz::W](blksiz::W) writer structure"]
impl crate::Writable for BLKSIZ {}
#[doc = "Block Size Register"]
pub mod blksiz;
#[doc = "Byte Count Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [bytcnt](bytcnt) module"]
pub type BYTCNT = crate::Reg<u32, _BYTCNT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BYTCNT;
#[doc = "`read()` method returns [bytcnt::R](bytcnt::R) reader structure"]
impl crate::Readable for BYTCNT {}
#[doc = "`write(|w| ..)` method takes [bytcnt::W](bytcnt::W) writer structure"]
impl crate::Writable for BYTCNT {}
#[doc = "Byte Count Register"]
pub mod bytcnt;
#[doc = "Interrupt Mask Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [intmask](intmask) module"]
pub type INTMASK = crate::Reg<u32, _INTMASK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INTMASK;
#[doc = "`read()` method returns [intmask::R](intmask::R) reader structure"]
impl crate::Readable for INTMASK {}
#[doc = "`write(|w| ..)` method takes [intmask::W](intmask::W) writer structure"]
impl crate::Writable for INTMASK {}
#[doc = "Interrupt Mask Register"]
pub mod intmask;
#[doc = "Command Argument Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cmdarg](cmdarg) module"]
pub type CMDARG = crate::Reg<u32, _CMDARG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CMDARG;
#[doc = "`read()` method returns [cmdarg::R](cmdarg::R) reader structure"]
impl crate::Readable for CMDARG {}
#[doc = "`write(|w| ..)` method takes [cmdarg::W](cmdarg::W) writer structure"]
impl crate::Writable for CMDARG {}
#[doc = "Command Argument Register"]
pub mod cmdarg;
#[doc = "Command Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cmd](cmd) module"]
pub type CMD = crate::Reg<u32, _CMD>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CMD;
#[doc = "`read()` method returns [cmd::R](cmd::R) reader structure"]
impl crate::Readable for CMD {}
#[doc = "`write(|w| ..)` method takes [cmd::W](cmd::W) writer structure"]
impl crate::Writable for CMD {}
#[doc = "Command Register"]
pub mod cmd;
#[doc = "Response Register 0\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [resp0](resp0) module"]
pub type RESP0 = crate::Reg<u32, _RESP0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESP0;
#[doc = "`read()` method returns [resp0::R](resp0::R) reader structure"]
impl crate::Readable for RESP0 {}
#[doc = "Response Register 0"]
pub mod resp0;
#[doc = "Response Register 1\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [resp1](resp1) module"]
pub type RESP1 = crate::Reg<u32, _RESP1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESP1;
#[doc = "`read()` method returns [resp1::R](resp1::R) reader structure"]
impl crate::Readable for RESP1 {}
#[doc = "Response Register 1"]
pub mod resp1;
#[doc = "Response Register 2\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [resp2](resp2) module"]
pub type RESP2 = crate::Reg<u32, _RESP2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESP2;
#[doc = "`read()` method returns [resp2::R](resp2::R) reader structure"]
impl crate::Readable for RESP2 {}
#[doc = "Response Register 2"]
pub mod resp2;
#[doc = "Response Register 3\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [resp3](resp3) module"]
pub type RESP3 = crate::Reg<u32, _RESP3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESP3;
#[doc = "`read()` method returns [resp3::R](resp3::R) reader structure"]
impl crate::Readable for RESP3 {}
#[doc = "Response Register 3"]
pub mod resp3;
#[doc = "Masked Interrupt Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [mintsts](mintsts) module"]
pub type MINTSTS = crate::Reg<u32, _MINTSTS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MINTSTS;
#[doc = "`read()` method returns [mintsts::R](mintsts::R) reader structure"]
impl crate::Readable for MINTSTS {}
#[doc = "Masked Interrupt Status Register"]
pub mod mintsts;
#[doc = "Raw Interrupt Status Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rintsts](rintsts) module"]
pub type RINTSTS = crate::Reg<u32, _RINTSTS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RINTSTS;
#[doc = "`read()` method returns [rintsts::R](rintsts::R) reader structure"]
impl crate::Readable for RINTSTS {}
#[doc = "`write(|w| ..)` method takes [rintsts::W](rintsts::W) writer structure"]
impl crate::Writable for RINTSTS {}
#[doc = "Raw Interrupt Status Register"]
pub mod rintsts;
#[doc = "Status Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [status](status) module"]
pub type STATUS = crate::Reg<u32, _STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _STATUS;
#[doc = "`read()` method returns [status::R](status::R) reader structure"]
impl crate::Readable for STATUS {}
#[doc = "Status Register"]
pub mod status;
#[doc = "FIFO Threshold Watermark Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [fifoth](fifoth) module"]
pub type FIFOTH = crate::Reg<u32, _FIFOTH>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FIFOTH;
#[doc = "`read()` method returns [fifoth::R](fifoth::R) reader structure"]
impl crate::Readable for FIFOTH {}
#[doc = "`write(|w| ..)` method takes [fifoth::W](fifoth::W) writer structure"]
impl crate::Writable for FIFOTH {}
#[doc = "FIFO Threshold Watermark Register"]
pub mod fifoth;
#[doc = "Card Detect Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cdetect](cdetect) module"]
pub type CDETECT = crate::Reg<u32, _CDETECT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CDETECT;
#[doc = "`read()` method returns [cdetect::R](cdetect::R) reader structure"]
impl crate::Readable for CDETECT {}
#[doc = "Card Detect Register"]
pub mod cdetect;
#[doc = "Write Protect Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [wrtprt](wrtprt) module"]
pub type WRTPRT = crate::Reg<u32, _WRTPRT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _WRTPRT;
#[doc = "`read()` method returns [wrtprt::R](wrtprt::R) reader structure"]
impl crate::Readable for WRTPRT {}
#[doc = "Write Protect Register"]
pub mod wrtprt;
#[doc = "Transferred CIU Card Byte Count Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tcbcnt](tcbcnt) module"]
pub type TCBCNT = crate::Reg<u32, _TCBCNT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TCBCNT;
#[doc = "`read()` method returns [tcbcnt::R](tcbcnt::R) reader structure"]
impl crate::Readable for TCBCNT {}
#[doc = "Transferred CIU Card Byte Count Register"]
pub mod tcbcnt;
#[doc = "Transferred Host to BIU-FIFO Byte Count Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tbbcnt](tbbcnt) module"]
pub type TBBCNT = crate::Reg<u32, _TBBCNT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _TBBCNT;
#[doc = "`read()` method returns [tbbcnt::R](tbbcnt::R) reader structure"]
impl crate::Readable for TBBCNT {}
#[doc = "Transferred Host to BIU-FIFO Byte Count Register"]
pub mod tbbcnt;
#[doc = "Debounce Count Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [debnce](debnce) module"]
pub type DEBNCE = crate::Reg<u32, _DEBNCE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DEBNCE;
#[doc = "`read()` method returns [debnce::R](debnce::R) reader structure"]
impl crate::Readable for DEBNCE {}
#[doc = "`write(|w| ..)` method takes [debnce::W](debnce::W) writer structure"]
impl crate::Writable for DEBNCE {}
#[doc = "Debounce Count Register"]
pub mod debnce;
#[doc = "Hardware Reset\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [rst_n](rst_n) module"]
pub type RST_N = crate::Reg<u32, _RST_N>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RST_N;
#[doc = "`read()` method returns [rst_n::R](rst_n::R) reader structure"]
impl crate::Readable for RST_N {}
#[doc = "`write(|w| ..)` method takes [rst_n::W](rst_n::W) writer structure"]
impl crate::Writable for RST_N {}
#[doc = "Hardware Reset"]
pub mod rst_n;
#[doc = "Bus Mode Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [bmod](bmod) module"]
pub type BMOD = crate::Reg<u32, _BMOD>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BMOD;
#[doc = "`read()` method returns [bmod::R](bmod::R) reader structure"]
impl crate::Readable for BMOD {}
#[doc = "`write(|w| ..)` method takes [bmod::W](bmod::W) writer structure"]
impl crate::Writable for BMOD {}
#[doc = "Bus Mode Register"]
pub mod bmod;
#[doc = "Poll Demand Register\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pldmnd](pldmnd) module"]
pub type PLDMND = crate::Reg<u32, _PLDMND>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLDMND;
#[doc = "`write(|w| ..)` method takes [pldmnd::W](pldmnd::W) writer structure"]
impl crate::Writable for PLDMND {}
#[doc = "Poll Demand Register"]
pub mod pldmnd;
#[doc = "Descriptor List Base Address Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dbaddr](dbaddr) module"]
pub type DBADDR = crate::Reg<u32, _DBADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DBADDR;
#[doc = "`read()` method returns [dbaddr::R](dbaddr::R) reader structure"]
impl crate::Readable for DBADDR {}
#[doc = "`write(|w| ..)` method takes [dbaddr::W](dbaddr::W) writer structure"]
impl crate::Writable for DBADDR {}
#[doc = "Descriptor List Base Address Register"]
pub mod dbaddr;
#[doc = "Internal DMAC Status Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [idsts](idsts) module"]
pub type IDSTS = crate::Reg<u32, _IDSTS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IDSTS;
#[doc = "`read()` method returns [idsts::R](idsts::R) reader structure"]
impl crate::Readable for IDSTS {}
#[doc = "`write(|w| ..)` method takes [idsts::W](idsts::W) writer structure"]
impl crate::Writable for IDSTS {}
#[doc = "Internal DMAC Status Register"]
pub mod idsts;
#[doc = "Internal DMAC Interrupt Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [idinten](idinten) module"]
pub type IDINTEN = crate::Reg<u32, _IDINTEN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IDINTEN;
#[doc = "`read()` method returns [idinten::R](idinten::R) reader structure"]
impl crate::Readable for IDINTEN {}
#[doc = "`write(|w| ..)` method takes [idinten::W](idinten::W) writer structure"]
impl crate::Writable for IDINTEN {}
#[doc = "Internal DMAC Interrupt Enable Register"]
pub mod idinten;
#[doc = "Current Host Descriptor Address Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dscaddr](dscaddr) module"]
pub type DSCADDR = crate::Reg<u32, _DSCADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DSCADDR;
#[doc = "`read()` method returns [dscaddr::R](dscaddr::R) reader structure"]
impl crate::Readable for DSCADDR {}
#[doc = "Current Host Descriptor Address Register"]
pub mod dscaddr;
#[doc = "Current Buffer Descriptor Address Register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [bufaddr](bufaddr) module"]
pub type BUFADDR = crate::Reg<u32, _BUFADDR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BUFADDR;
#[doc = "`read()` method returns [bufaddr::R](bufaddr::R) reader structure"]
impl crate::Readable for BUFADDR {}
#[doc = "Current Buffer Descriptor Address Register"]
pub mod bufaddr;
