#[doc = "Reader of register CTRL"]
pub type R = crate::R<u32, super::CTRL>;
#[doc = "Writer for register CTRL"]
pub type W = crate::W<u32, super::CTRL>;
#[doc = "Register CTRL `reset()`'s with value 0"]
impl crate::ResetValue for super::CTRL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Controller reset. To reset controller, software should set bit to 1. This bit is auto-cleared after two AHB and two cclk_in clock cycles. This resets: - BIU/CIU interface - CIU and state machines - abort_read_data, send_irq_response, and read_wait bits of Control register - start_cmd bit of Command register Does not affect any registers or DMA interface, or FIFO. or host interrupts.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CONTROLLER_RESET_A {
    #[doc = "0: No change."]
    NO_CHANGE = 0,
    #[doc = "1: Reset. Reset SD/MMC controller"]
    RESET = 1,
}
impl From<CONTROLLER_RESET_A> for bool {
    #[inline(always)]
    fn from(variant: CONTROLLER_RESET_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CONTROLLER_RESET`"]
pub type CONTROLLER_RESET_R = crate::R<bool, CONTROLLER_RESET_A>;
impl CONTROLLER_RESET_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CONTROLLER_RESET_A {
        match self.bits {
            false => CONTROLLER_RESET_A::NO_CHANGE,
            true => CONTROLLER_RESET_A::RESET,
        }
    }
    #[doc = "Checks if the value of the field is `NO_CHANGE`"]
    #[inline(always)]
    pub fn is_no_change(&self) -> bool {
        *self == CONTROLLER_RESET_A::NO_CHANGE
    }
    #[doc = "Checks if the value of the field is `RESET`"]
    #[inline(always)]
    pub fn is_reset(&self) -> bool {
        *self == CONTROLLER_RESET_A::RESET
    }
}
#[doc = "Write proxy for field `CONTROLLER_RESET`"]
pub struct CONTROLLER_RESET_W<'a> {
    w: &'a mut W,
}
impl<'a> CONTROLLER_RESET_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CONTROLLER_RESET_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No change."]
    #[inline(always)]
    pub fn no_change(self) -> &'a mut W {
        self.variant(CONTROLLER_RESET_A::NO_CHANGE)
    }
    #[doc = "Reset. Reset SD/MMC controller"]
    #[inline(always)]
    pub fn reset(self) -> &'a mut W {
        self.variant(CONTROLLER_RESET_A::RESET)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Fifo reset. To reset FIFO, software should set bit to 1. This bit is auto-cleared after completion of reset operation. auto-cleared after two AHB clocks.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO_RESET_A {
    #[doc = "0: No change."]
    NO_CHANGE = 0,
    #[doc = "1: Reset. Reset to data FIFO To reset FIFO pointers"]
    RESET = 1,
}
impl From<FIFO_RESET_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO_RESET_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `FIFO_RESET`"]
pub type FIFO_RESET_R = crate::R<bool, FIFO_RESET_A>;
impl FIFO_RESET_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO_RESET_A {
        match self.bits {
            false => FIFO_RESET_A::NO_CHANGE,
            true => FIFO_RESET_A::RESET,
        }
    }
    #[doc = "Checks if the value of the field is `NO_CHANGE`"]
    #[inline(always)]
    pub fn is_no_change(&self) -> bool {
        *self == FIFO_RESET_A::NO_CHANGE
    }
    #[doc = "Checks if the value of the field is `RESET`"]
    #[inline(always)]
    pub fn is_reset(&self) -> bool {
        *self == FIFO_RESET_A::RESET
    }
}
#[doc = "Write proxy for field `FIFO_RESET`"]
pub struct FIFO_RESET_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO_RESET_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO_RESET_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No change."]
    #[inline(always)]
    pub fn no_change(self) -> &'a mut W {
        self.variant(FIFO_RESET_A::NO_CHANGE)
    }
    #[doc = "Reset. Reset to data FIFO To reset FIFO pointers"]
    #[inline(always)]
    pub fn reset(self) -> &'a mut W {
        self.variant(FIFO_RESET_A::RESET)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Dma reset. To reset DMA interface, software should set bit to 1. This bit is auto-cleared after two AHB clocks.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMA_RESET_A {
    #[doc = "0: No change."]
    NO_CHANGE = 0,
    #[doc = "1: Reset. Reset internal DMA interface control logic"]
    RESET = 1,
}
impl From<DMA_RESET_A> for bool {
    #[inline(always)]
    fn from(variant: DMA_RESET_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `DMA_RESET`"]
pub type DMA_RESET_R = crate::R<bool, DMA_RESET_A>;
impl DMA_RESET_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMA_RESET_A {
        match self.bits {
            false => DMA_RESET_A::NO_CHANGE,
            true => DMA_RESET_A::RESET,
        }
    }
    #[doc = "Checks if the value of the field is `NO_CHANGE`"]
    #[inline(always)]
    pub fn is_no_change(&self) -> bool {
        *self == DMA_RESET_A::NO_CHANGE
    }
    #[doc = "Checks if the value of the field is `RESET`"]
    #[inline(always)]
    pub fn is_reset(&self) -> bool {
        *self == DMA_RESET_A::RESET
    }
}
#[doc = "Write proxy for field `DMA_RESET`"]
pub struct DMA_RESET_W<'a> {
    w: &'a mut W,
}
impl<'a> DMA_RESET_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMA_RESET_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No change."]
    #[inline(always)]
    pub fn no_change(self) -> &'a mut W {
        self.variant(DMA_RESET_A::NO_CHANGE)
    }
    #[doc = "Reset. Reset internal DMA interface control logic"]
    #[inline(always)]
    pub fn reset(self) -> &'a mut W {
        self.variant(DMA_RESET_A::RESET)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_0`"]
pub type RESERVED_0_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `RESERVED_0`"]
pub struct RESERVED_0_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_0_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Global interrupt enable/disable bit. The int port is 1 only when this bit is 1 and one or more unmasked interrupts are set.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INT_ENABLE_A {
    #[doc = "0: Disable interrupts"]
    DISABLE_INTERRUPTS = 0,
    #[doc = "1: Enable interrupts"]
    ENABLE_INTERRUPTS = 1,
}
impl From<INT_ENABLE_A> for bool {
    #[inline(always)]
    fn from(variant: INT_ENABLE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `INT_ENABLE`"]
pub type INT_ENABLE_R = crate::R<bool, INT_ENABLE_A>;
impl INT_ENABLE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INT_ENABLE_A {
        match self.bits {
            false => INT_ENABLE_A::DISABLE_INTERRUPTS,
            true => INT_ENABLE_A::ENABLE_INTERRUPTS,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_disable_interrupts(&self) -> bool {
        *self == INT_ENABLE_A::DISABLE_INTERRUPTS
    }
    #[doc = "Checks if the value of the field is `ENABLE_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_enable_interrupts(&self) -> bool {
        *self == INT_ENABLE_A::ENABLE_INTERRUPTS
    }
}
#[doc = "Write proxy for field `INT_ENABLE`"]
pub struct INT_ENABLE_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_ENABLE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INT_ENABLE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disable interrupts"]
    #[inline(always)]
    pub fn disable_interrupts(self) -> &'a mut W {
        self.variant(INT_ENABLE_A::DISABLE_INTERRUPTS)
    }
    #[doc = "Enable interrupts"]
    #[inline(always)]
    pub fn enable_interrupts(self) -> &'a mut W {
        self.variant(INT_ENABLE_A::ENABLE_INTERRUPTS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_1`"]
pub type RESERVED_1_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `RESERVED_1`"]
pub struct RESERVED_1_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_1_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Read/wait. For sending read-wait to SDIO cards.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum READ_WAIT_A {
    #[doc = "0: Clear read wait"]
    CLEAR_READ_WAIT = 0,
    #[doc = "1: Assert read wait"]
    ASSERT_READ_WAIT = 1,
}
impl From<READ_WAIT_A> for bool {
    #[inline(always)]
    fn from(variant: READ_WAIT_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `READ_WAIT`"]
pub type READ_WAIT_R = crate::R<bool, READ_WAIT_A>;
impl READ_WAIT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> READ_WAIT_A {
        match self.bits {
            false => READ_WAIT_A::CLEAR_READ_WAIT,
            true => READ_WAIT_A::ASSERT_READ_WAIT,
        }
    }
    #[doc = "Checks if the value of the field is `CLEAR_READ_WAIT`"]
    #[inline(always)]
    pub fn is_clear_read_wait(&self) -> bool {
        *self == READ_WAIT_A::CLEAR_READ_WAIT
    }
    #[doc = "Checks if the value of the field is `ASSERT_READ_WAIT`"]
    #[inline(always)]
    pub fn is_assert_read_wait(&self) -> bool {
        *self == READ_WAIT_A::ASSERT_READ_WAIT
    }
}
#[doc = "Write proxy for field `READ_WAIT`"]
pub struct READ_WAIT_W<'a> {
    w: &'a mut W,
}
impl<'a> READ_WAIT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: READ_WAIT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Clear read wait"]
    #[inline(always)]
    pub fn clear_read_wait(self) -> &'a mut W {
        self.variant(READ_WAIT_A::CLEAR_READ_WAIT)
    }
    #[doc = "Assert read wait"]
    #[inline(always)]
    pub fn assert_read_wait(self) -> &'a mut W {
        self.variant(READ_WAIT_A::ASSERT_READ_WAIT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Send irq response. This bit automatically clears once response is sent. To wait for MMC card interrupts, the host issues CMD40, and the SD/MMC controller waits for an interrupt response from the MMC card. In the meantime, if the host wants the SD/MMC interface to exit waiting for interrupt state, it can set this bit, at which time the SD/MMC interface command state-machine sends a CMD40 response on the bus and returns to idle state.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SEND_IRQ_RESPONSE_A {
    #[doc = "0: No change"]
    NO_CHANGE = 0,
    #[doc = "1: Send auto IRQ response"]
    SEND_AUTO_IRQ_RESPONSE = 1,
}
impl From<SEND_IRQ_RESPONSE_A> for bool {
    #[inline(always)]
    fn from(variant: SEND_IRQ_RESPONSE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SEND_IRQ_RESPONSE`"]
pub type SEND_IRQ_RESPONSE_R = crate::R<bool, SEND_IRQ_RESPONSE_A>;
impl SEND_IRQ_RESPONSE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SEND_IRQ_RESPONSE_A {
        match self.bits {
            false => SEND_IRQ_RESPONSE_A::NO_CHANGE,
            true => SEND_IRQ_RESPONSE_A::SEND_AUTO_IRQ_RESPONSE,
        }
    }
    #[doc = "Checks if the value of the field is `NO_CHANGE`"]
    #[inline(always)]
    pub fn is_no_change(&self) -> bool {
        *self == SEND_IRQ_RESPONSE_A::NO_CHANGE
    }
    #[doc = "Checks if the value of the field is `SEND_AUTO_IRQ_RESPONSE`"]
    #[inline(always)]
    pub fn is_send_auto_irq_response(&self) -> bool {
        *self == SEND_IRQ_RESPONSE_A::SEND_AUTO_IRQ_RESPONSE
    }
}
#[doc = "Write proxy for field `SEND_IRQ_RESPONSE`"]
pub struct SEND_IRQ_RESPONSE_W<'a> {
    w: &'a mut W,
}
impl<'a> SEND_IRQ_RESPONSE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SEND_IRQ_RESPONSE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No change"]
    #[inline(always)]
    pub fn no_change(self) -> &'a mut W {
        self.variant(SEND_IRQ_RESPONSE_A::NO_CHANGE)
    }
    #[doc = "Send auto IRQ response"]
    #[inline(always)]
    pub fn send_auto_irq_response(self) -> &'a mut W {
        self.variant(SEND_IRQ_RESPONSE_A::SEND_AUTO_IRQ_RESPONSE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Abort read data. Used in SDIO card suspend sequence.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ABORT_READ_DATA_A {
    #[doc = "0: No change"]
    NO_CHANGE = 0,
    #[doc = "1: Abort. After suspend command is issued during read-transfer, software polls card to find when suspend happened. Once suspend occurs, software sets bit to reset data state-machine, which is waiting for next block of data. This bit automatically clears once data state machine resets to idle. Used in SDIO card suspend sequence."]
    ABORT = 1,
}
impl From<ABORT_READ_DATA_A> for bool {
    #[inline(always)]
    fn from(variant: ABORT_READ_DATA_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ABORT_READ_DATA`"]
pub type ABORT_READ_DATA_R = crate::R<bool, ABORT_READ_DATA_A>;
impl ABORT_READ_DATA_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ABORT_READ_DATA_A {
        match self.bits {
            false => ABORT_READ_DATA_A::NO_CHANGE,
            true => ABORT_READ_DATA_A::ABORT,
        }
    }
    #[doc = "Checks if the value of the field is `NO_CHANGE`"]
    #[inline(always)]
    pub fn is_no_change(&self) -> bool {
        *self == ABORT_READ_DATA_A::NO_CHANGE
    }
    #[doc = "Checks if the value of the field is `ABORT`"]
    #[inline(always)]
    pub fn is_abort(&self) -> bool {
        *self == ABORT_READ_DATA_A::ABORT
    }
}
#[doc = "Write proxy for field `ABORT_READ_DATA`"]
pub struct ABORT_READ_DATA_W<'a> {
    w: &'a mut W,
}
impl<'a> ABORT_READ_DATA_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ABORT_READ_DATA_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No change"]
    #[inline(always)]
    pub fn no_change(self) -> &'a mut W {
        self.variant(ABORT_READ_DATA_A::NO_CHANGE)
    }
    #[doc = "Abort. After suspend command is issued during read-transfer, software polls card to find when suspend happened. Once suspend occurs, software sets bit to reset data state-machine, which is waiting for next block of data. This bit automatically clears once data state machine resets to idle. Used in SDIO card suspend sequence."]
    #[inline(always)]
    pub fn abort(self) -> &'a mut W {
        self.variant(ABORT_READ_DATA_A::ABORT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Send ccsd. When set, the SD/MMC controller sends CCSD to the CE-ATA device. Software sets this bit only if current command is expecting CCS (that is, RW_BLK) and interrupts are enabled in CE-ATA device. Once the CCSD pattern is sent to device, the SD/MMC interface automatically clears send_ccsd bit. It also sets Command Done (CD) bit in RINTSTS register and generates interrupt to host if Command Done interrupt is not masked. NOTE: Once send_ccsd bit is set, it takes two card clock cycles to drive the CCSD on the CMD line. Due to this, during the boundary conditions it may happen that CCSD is sent to the CE-ATA device, even if the device signalled CCS.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SEND_CCSD_A {
    #[doc = "0: Clear bit if the SD/MMC controller does not reset the bit."]
    CLEAR_BIT = 0,
    #[doc = "1: Send Command Completion Signal Disable (CCSD) to CE-ATA device"]
    SEND_COMMAND_COMPLETION_SIGNAL = 1,
}
impl From<SEND_CCSD_A> for bool {
    #[inline(always)]
    fn from(variant: SEND_CCSD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SEND_CCSD`"]
pub type SEND_CCSD_R = crate::R<bool, SEND_CCSD_A>;
impl SEND_CCSD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SEND_CCSD_A {
        match self.bits {
            false => SEND_CCSD_A::CLEAR_BIT,
            true => SEND_CCSD_A::SEND_COMMAND_COMPLETION_SIGNAL,
        }
    }
    #[doc = "Checks if the value of the field is `CLEAR_BIT`"]
    #[inline(always)]
    pub fn is_clear_bit_(&self) -> bool {
        *self == SEND_CCSD_A::CLEAR_BIT
    }
    #[doc = "Checks if the value of the field is `SEND_COMMAND_COMPLETION_SIGNAL`"]
    #[inline(always)]
    pub fn is_send_command_completion_signal(&self) -> bool {
        *self == SEND_CCSD_A::SEND_COMMAND_COMPLETION_SIGNAL
    }
}
#[doc = "Write proxy for field `SEND_CCSD`"]
pub struct SEND_CCSD_W<'a> {
    w: &'a mut W,
}
impl<'a> SEND_CCSD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SEND_CCSD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Clear bit if the SD/MMC controller does not reset the bit."]
    #[inline(always)]
    pub fn clear_bit_(self) -> &'a mut W {
        self.variant(SEND_CCSD_A::CLEAR_BIT)
    }
    #[doc = "Send Command Completion Signal Disable (CCSD) to CE-ATA device"]
    #[inline(always)]
    pub fn send_command_completion_signal(self) -> &'a mut W {
        self.variant(SEND_CCSD_A::SEND_COMMAND_COMPLETION_SIGNAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "Send auto stop ccsd. NOTE: Always set send_auto_stop_ccsd and send_ccsd bits together; send_auto_stop_ccsd should not be set independent of send_ccsd. When set, the SD/MMC interface automatically sends internallygenerated STOP command (CMD12) to CE-ATA device. After sending internally-generated STOP command, Auto Command Done (ACD) bit in RINTSTS is set and generates interrupt to host if Auto Command Done interrupt is not masked. After sending the CCSD, the SD/MMC interface automatically clears send_auto_stop_ccsd bit.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SEND_AUTO_STOP_A {
    #[doc = "0: Clear this bit if the SD/MMC controller does not reset the bit."]
    CLEAR_THIS_BIT_IF_THE_SD_MMC_CONTROLLER_DOES_NOT = 0,
    #[doc = "1: Send internally generated STOP after sending CCSD to CE-ATA device."]
    SEND_INTERNALLY_GENERATED_STOP = 1,
}
impl From<SEND_AUTO_STOP_A> for bool {
    #[inline(always)]
    fn from(variant: SEND_AUTO_STOP_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SEND_AUTO_STOP`"]
pub type SEND_AUTO_STOP_R = crate::R<bool, SEND_AUTO_STOP_A>;
impl SEND_AUTO_STOP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SEND_AUTO_STOP_A {
        match self.bits {
            false => SEND_AUTO_STOP_A::CLEAR_THIS_BIT_IF_THE_SD_MMC_CONTROLLER_DOES_NOT,
            true => SEND_AUTO_STOP_A::SEND_INTERNALLY_GENERATED_STOP,
        }
    }
    #[doc = "Checks if the value of the field is `CLEAR_THIS_BIT_IF_THE_SD_MMC_CONTROLLER_DOES_NOT`"]
    #[inline(always)]
    pub fn is_clear_this_bit_if_the_sd_mmc_controller_does_not(&self) -> bool {
        *self == SEND_AUTO_STOP_A::CLEAR_THIS_BIT_IF_THE_SD_MMC_CONTROLLER_DOES_NOT
    }
    #[doc = "Checks if the value of the field is `SEND_INTERNALLY_GENERATED_STOP`"]
    #[inline(always)]
    pub fn is_send_internally_generated_stop(&self) -> bool {
        *self == SEND_AUTO_STOP_A::SEND_INTERNALLY_GENERATED_STOP
    }
}
#[doc = "Write proxy for field `SEND_AUTO_STOP`"]
pub struct SEND_AUTO_STOP_W<'a> {
    w: &'a mut W,
}
impl<'a> SEND_AUTO_STOP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SEND_AUTO_STOP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Clear this bit if the SD/MMC controller does not reset the bit."]
    #[inline(always)]
    pub fn clear_this_bit_if_the_sd_mmc_controller_does_not(self) -> &'a mut W {
        self.variant(SEND_AUTO_STOP_A::CLEAR_THIS_BIT_IF_THE_SD_MMC_CONTROLLER_DOES_NOT)
    }
    #[doc = "Send internally generated STOP after sending CCSD to CE-ATA device."]
    #[inline(always)]
    pub fn send_internally_generated_stop(self) -> &'a mut W {
        self.variant(SEND_AUTO_STOP_A::SEND_INTERNALLY_GENERATED_STOP)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "CEATA device interrupt status. Software should appropriately write to this bit after power-on reset or any other reset to CE-ATA device. After reset, usually CE-ATA device interrupt is disabled (nIEN = 1). If the host enables CE-ATA device interrupt, then software should set this bit.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CEATA_DEVICE_INTERRUPT_STATUS_A {
    #[doc = "0: Disabled. Interrupts not enabled in CE-ATA device (nIEN = 1 in ATA control register)"]
    DISABLED = 0,
    #[doc = "1: Enabled. Interrupts are enabled in CE-ATA device (nIEN = 0 in ATA control register)"]
    ENABLED = 1,
}
impl From<CEATA_DEVICE_INTERRUPT_STATUS_A> for bool {
    #[inline(always)]
    fn from(variant: CEATA_DEVICE_INTERRUPT_STATUS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CEATA_DEVICE_INTERRUPT_STATUS`"]
pub type CEATA_DEVICE_INTERRUPT_STATUS_R = crate::R<bool, CEATA_DEVICE_INTERRUPT_STATUS_A>;
impl CEATA_DEVICE_INTERRUPT_STATUS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CEATA_DEVICE_INTERRUPT_STATUS_A {
        match self.bits {
            false => CEATA_DEVICE_INTERRUPT_STATUS_A::DISABLED,
            true => CEATA_DEVICE_INTERRUPT_STATUS_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CEATA_DEVICE_INTERRUPT_STATUS_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == CEATA_DEVICE_INTERRUPT_STATUS_A::ENABLED
    }
}
#[doc = "Write proxy for field `CEATA_DEVICE_INTERRUPT_STATUS`"]
pub struct CEATA_DEVICE_INTERRUPT_STATUS_W<'a> {
    w: &'a mut W,
}
impl<'a> CEATA_DEVICE_INTERRUPT_STATUS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CEATA_DEVICE_INTERRUPT_STATUS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Interrupts not enabled in CE-ATA device (nIEN = 1 in ATA control register)"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CEATA_DEVICE_INTERRUPT_STATUS_A::DISABLED)
    }
    #[doc = "Enabled. Interrupts are enabled in CE-ATA device (nIEN = 0 in ATA control register)"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(CEATA_DEVICE_INTERRUPT_STATUS_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_2`"]
pub type RESERVED_2_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `RESERVED_2`"]
pub struct RESERVED_2_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 12)) | (((value as u32) & 0x0f) << 12);
        self.w
    }
}
#[doc = "Reader of field `CARD_VOLTAGE_A0`"]
pub type CARD_VOLTAGE_A0_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `CARD_VOLTAGE_A0`"]
pub struct CARD_VOLTAGE_A0_W<'a> {
    w: &'a mut W,
}
impl<'a> CARD_VOLTAGE_A0_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Reader of field `CARD_VOLTAGE_A1`"]
pub type CARD_VOLTAGE_A1_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `CARD_VOLTAGE_A1`"]
pub struct CARD_VOLTAGE_A1_W<'a> {
    w: &'a mut W,
}
impl<'a> CARD_VOLTAGE_A1_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 17)) | (((value as u32) & 0x01) << 17);
        self.w
    }
}
#[doc = "Reader of field `CARD_VOLTAGE_A2`"]
pub type CARD_VOLTAGE_A2_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `CARD_VOLTAGE_A2`"]
pub struct CARD_VOLTAGE_A2_W<'a> {
    w: &'a mut W,
}
impl<'a> CARD_VOLTAGE_A2_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 18)) | (((value as u32) & 0x01) << 18);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_3`"]
pub type RESERVED_3_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `RESERVED_3`"]
pub struct RESERVED_3_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_3_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 19)) | (((value as u32) & 0x1f) << 19);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_4`"]
pub type RESERVED_4_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `RESERVED_4`"]
pub struct RESERVED_4_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_4_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | (((value as u32) & 0x01) << 24);
        self.w
    }
}
#[doc = "SD/MMC DMA use.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USE_INTERNAL_DMAC_A {
    #[doc = "0: Host. The host performs data transfers through the slave interface"]
    HOST = 0,
    #[doc = "1: DMA. Internal DMA used for data transfer"]
    DMA = 1,
}
impl From<USE_INTERNAL_DMAC_A> for bool {
    #[inline(always)]
    fn from(variant: USE_INTERNAL_DMAC_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `USE_INTERNAL_DMAC`"]
pub type USE_INTERNAL_DMAC_R = crate::R<bool, USE_INTERNAL_DMAC_A>;
impl USE_INTERNAL_DMAC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USE_INTERNAL_DMAC_A {
        match self.bits {
            false => USE_INTERNAL_DMAC_A::HOST,
            true => USE_INTERNAL_DMAC_A::DMA,
        }
    }
    #[doc = "Checks if the value of the field is `HOST`"]
    #[inline(always)]
    pub fn is_host(&self) -> bool {
        *self == USE_INTERNAL_DMAC_A::HOST
    }
    #[doc = "Checks if the value of the field is `DMA`"]
    #[inline(always)]
    pub fn is_dma(&self) -> bool {
        *self == USE_INTERNAL_DMAC_A::DMA
    }
}
#[doc = "Write proxy for field `USE_INTERNAL_DMAC`"]
pub struct USE_INTERNAL_DMAC_W<'a> {
    w: &'a mut W,
}
impl<'a> USE_INTERNAL_DMAC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USE_INTERNAL_DMAC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Host. The host performs data transfers through the slave interface"]
    #[inline(always)]
    pub fn host(self) -> &'a mut W {
        self.variant(USE_INTERNAL_DMAC_A::HOST)
    }
    #[doc = "DMA. Internal DMA used for data transfer"]
    #[inline(always)]
    pub fn dma(self) -> &'a mut W {
        self.variant(USE_INTERNAL_DMAC_A::DMA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 25)) | (((value as u32) & 0x01) << 25);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_5`"]
pub type RESERVED_5_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `RESERVED_5`"]
pub struct RESERVED_5_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_5_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x3f << 26)) | (((value as u32) & 0x3f) << 26);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Controller reset. To reset controller, software should set bit to 1. This bit is auto-cleared after two AHB and two cclk_in clock cycles. This resets: - BIU/CIU interface - CIU and state machines - abort_read_data, send_irq_response, and read_wait bits of Control register - start_cmd bit of Command register Does not affect any registers or DMA interface, or FIFO. or host interrupts."]
    #[inline(always)]
    pub fn controller_reset(&self) -> CONTROLLER_RESET_R {
        CONTROLLER_RESET_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Fifo reset. To reset FIFO, software should set bit to 1. This bit is auto-cleared after completion of reset operation. auto-cleared after two AHB clocks."]
    #[inline(always)]
    pub fn fifo_reset(&self) -> FIFO_RESET_R {
        FIFO_RESET_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Dma reset. To reset DMA interface, software should set bit to 1. This bit is auto-cleared after two AHB clocks."]
    #[inline(always)]
    pub fn dma_reset(&self) -> DMA_RESET_R {
        DMA_RESET_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Reserved"]
    #[inline(always)]
    pub fn reserved_0(&self) -> RESERVED_0_R {
        RESERVED_0_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Global interrupt enable/disable bit. The int port is 1 only when this bit is 1 and one or more unmasked interrupts are set."]
    #[inline(always)]
    pub fn int_enable(&self) -> INT_ENABLE_R {
        INT_ENABLE_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Reserved. Always write this bit as 0."]
    #[inline(always)]
    pub fn reserved_1(&self) -> RESERVED_1_R {
        RESERVED_1_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Read/wait. For sending read-wait to SDIO cards."]
    #[inline(always)]
    pub fn read_wait(&self) -> READ_WAIT_R {
        READ_WAIT_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Send irq response. This bit automatically clears once response is sent. To wait for MMC card interrupts, the host issues CMD40, and the SD/MMC controller waits for an interrupt response from the MMC card. In the meantime, if the host wants the SD/MMC interface to exit waiting for interrupt state, it can set this bit, at which time the SD/MMC interface command state-machine sends a CMD40 response on the bus and returns to idle state."]
    #[inline(always)]
    pub fn send_irq_response(&self) -> SEND_IRQ_RESPONSE_R {
        SEND_IRQ_RESPONSE_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Abort read data. Used in SDIO card suspend sequence."]
    #[inline(always)]
    pub fn abort_read_data(&self) -> ABORT_READ_DATA_R {
        ABORT_READ_DATA_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Send ccsd. When set, the SD/MMC controller sends CCSD to the CE-ATA device. Software sets this bit only if current command is expecting CCS (that is, RW_BLK) and interrupts are enabled in CE-ATA device. Once the CCSD pattern is sent to device, the SD/MMC interface automatically clears send_ccsd bit. It also sets Command Done (CD) bit in RINTSTS register and generates interrupt to host if Command Done interrupt is not masked. NOTE: Once send_ccsd bit is set, it takes two card clock cycles to drive the CCSD on the CMD line. Due to this, during the boundary conditions it may happen that CCSD is sent to the CE-ATA device, even if the device signalled CCS."]
    #[inline(always)]
    pub fn send_ccsd(&self) -> SEND_CCSD_R {
        SEND_CCSD_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Send auto stop ccsd. NOTE: Always set send_auto_stop_ccsd and send_ccsd bits together; send_auto_stop_ccsd should not be set independent of send_ccsd. When set, the SD/MMC interface automatically sends internallygenerated STOP command (CMD12) to CE-ATA device. After sending internally-generated STOP command, Auto Command Done (ACD) bit in RINTSTS is set and generates interrupt to host if Auto Command Done interrupt is not masked. After sending the CCSD, the SD/MMC interface automatically clears send_auto_stop_ccsd bit."]
    #[inline(always)]
    pub fn send_auto_stop(&self) -> SEND_AUTO_STOP_R {
        SEND_AUTO_STOP_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - CEATA device interrupt status. Software should appropriately write to this bit after power-on reset or any other reset to CE-ATA device. After reset, usually CE-ATA device interrupt is disabled (nIEN = 1). If the host enables CE-ATA device interrupt, then software should set this bit."]
    #[inline(always)]
    pub fn ceata_device_interrupt_status(&self) -> CEATA_DEVICE_INTERRUPT_STATUS_R {
        CEATA_DEVICE_INTERRUPT_STATUS_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bits 12:15 - Reserved"]
    #[inline(always)]
    pub fn reserved_2(&self) -> RESERVED_2_R {
        RESERVED_2_R::new(((self.bits >> 12) & 0x0f) as u8)
    }
    #[doc = "Bit 16 - Controls the state of the SD_VOLT0 pin. SD/MMC card voltage control is not implemented."]
    #[inline(always)]
    pub fn card_voltage_a0(&self) -> CARD_VOLTAGE_A0_R {
        CARD_VOLTAGE_A0_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - Controls the state of the SD_VOLT1 pin. SD/MMC card voltage control is not implemented."]
    #[inline(always)]
    pub fn card_voltage_a1(&self) -> CARD_VOLTAGE_A1_R {
        CARD_VOLTAGE_A1_R::new(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - Controls the state of the SD_VOLT2 pin. SD/MMC card voltage control is not implemented."]
    #[inline(always)]
    pub fn card_voltage_a2(&self) -> CARD_VOLTAGE_A2_R {
        CARD_VOLTAGE_A2_R::new(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bits 19:23 - Reserved."]
    #[inline(always)]
    pub fn reserved_3(&self) -> RESERVED_3_R {
        RESERVED_3_R::new(((self.bits >> 19) & 0x1f) as u8)
    }
    #[doc = "Bit 24 - Reserved. Always write this bit as 0."]
    #[inline(always)]
    pub fn reserved_4(&self) -> RESERVED_4_R {
        RESERVED_4_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bit 25 - SD/MMC DMA use."]
    #[inline(always)]
    pub fn use_internal_dmac(&self) -> USE_INTERNAL_DMAC_R {
        USE_INTERNAL_DMAC_R::new(((self.bits >> 25) & 0x01) != 0)
    }
    #[doc = "Bits 26:31 - Reserved"]
    #[inline(always)]
    pub fn reserved_5(&self) -> RESERVED_5_R {
        RESERVED_5_R::new(((self.bits >> 26) & 0x3f) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Controller reset. To reset controller, software should set bit to 1. This bit is auto-cleared after two AHB and two cclk_in clock cycles. This resets: - BIU/CIU interface - CIU and state machines - abort_read_data, send_irq_response, and read_wait bits of Control register - start_cmd bit of Command register Does not affect any registers or DMA interface, or FIFO. or host interrupts."]
    #[inline(always)]
    pub fn controller_reset(&mut self) -> CONTROLLER_RESET_W {
        CONTROLLER_RESET_W { w: self }
    }
    #[doc = "Bit 1 - Fifo reset. To reset FIFO, software should set bit to 1. This bit is auto-cleared after completion of reset operation. auto-cleared after two AHB clocks."]
    #[inline(always)]
    pub fn fifo_reset(&mut self) -> FIFO_RESET_W {
        FIFO_RESET_W { w: self }
    }
    #[doc = "Bit 2 - Dma reset. To reset DMA interface, software should set bit to 1. This bit is auto-cleared after two AHB clocks."]
    #[inline(always)]
    pub fn dma_reset(&mut self) -> DMA_RESET_W {
        DMA_RESET_W { w: self }
    }
    #[doc = "Bit 3 - Reserved"]
    #[inline(always)]
    pub fn reserved_0(&mut self) -> RESERVED_0_W {
        RESERVED_0_W { w: self }
    }
    #[doc = "Bit 4 - Global interrupt enable/disable bit. The int port is 1 only when this bit is 1 and one or more unmasked interrupts are set."]
    #[inline(always)]
    pub fn int_enable(&mut self) -> INT_ENABLE_W {
        INT_ENABLE_W { w: self }
    }
    #[doc = "Bit 5 - Reserved. Always write this bit as 0."]
    #[inline(always)]
    pub fn reserved_1(&mut self) -> RESERVED_1_W {
        RESERVED_1_W { w: self }
    }
    #[doc = "Bit 6 - Read/wait. For sending read-wait to SDIO cards."]
    #[inline(always)]
    pub fn read_wait(&mut self) -> READ_WAIT_W {
        READ_WAIT_W { w: self }
    }
    #[doc = "Bit 7 - Send irq response. This bit automatically clears once response is sent. To wait for MMC card interrupts, the host issues CMD40, and the SD/MMC controller waits for an interrupt response from the MMC card. In the meantime, if the host wants the SD/MMC interface to exit waiting for interrupt state, it can set this bit, at which time the SD/MMC interface command state-machine sends a CMD40 response on the bus and returns to idle state."]
    #[inline(always)]
    pub fn send_irq_response(&mut self) -> SEND_IRQ_RESPONSE_W {
        SEND_IRQ_RESPONSE_W { w: self }
    }
    #[doc = "Bit 8 - Abort read data. Used in SDIO card suspend sequence."]
    #[inline(always)]
    pub fn abort_read_data(&mut self) -> ABORT_READ_DATA_W {
        ABORT_READ_DATA_W { w: self }
    }
    #[doc = "Bit 9 - Send ccsd. When set, the SD/MMC controller sends CCSD to the CE-ATA device. Software sets this bit only if current command is expecting CCS (that is, RW_BLK) and interrupts are enabled in CE-ATA device. Once the CCSD pattern is sent to device, the SD/MMC interface automatically clears send_ccsd bit. It also sets Command Done (CD) bit in RINTSTS register and generates interrupt to host if Command Done interrupt is not masked. NOTE: Once send_ccsd bit is set, it takes two card clock cycles to drive the CCSD on the CMD line. Due to this, during the boundary conditions it may happen that CCSD is sent to the CE-ATA device, even if the device signalled CCS."]
    #[inline(always)]
    pub fn send_ccsd(&mut self) -> SEND_CCSD_W {
        SEND_CCSD_W { w: self }
    }
    #[doc = "Bit 10 - Send auto stop ccsd. NOTE: Always set send_auto_stop_ccsd and send_ccsd bits together; send_auto_stop_ccsd should not be set independent of send_ccsd. When set, the SD/MMC interface automatically sends internallygenerated STOP command (CMD12) to CE-ATA device. After sending internally-generated STOP command, Auto Command Done (ACD) bit in RINTSTS is set and generates interrupt to host if Auto Command Done interrupt is not masked. After sending the CCSD, the SD/MMC interface automatically clears send_auto_stop_ccsd bit."]
    #[inline(always)]
    pub fn send_auto_stop(&mut self) -> SEND_AUTO_STOP_W {
        SEND_AUTO_STOP_W { w: self }
    }
    #[doc = "Bit 11 - CEATA device interrupt status. Software should appropriately write to this bit after power-on reset or any other reset to CE-ATA device. After reset, usually CE-ATA device interrupt is disabled (nIEN = 1). If the host enables CE-ATA device interrupt, then software should set this bit."]
    #[inline(always)]
    pub fn ceata_device_interrupt_status(&mut self) -> CEATA_DEVICE_INTERRUPT_STATUS_W {
        CEATA_DEVICE_INTERRUPT_STATUS_W { w: self }
    }
    #[doc = "Bits 12:15 - Reserved"]
    #[inline(always)]
    pub fn reserved_2(&mut self) -> RESERVED_2_W {
        RESERVED_2_W { w: self }
    }
    #[doc = "Bit 16 - Controls the state of the SD_VOLT0 pin. SD/MMC card voltage control is not implemented."]
    #[inline(always)]
    pub fn card_voltage_a0(&mut self) -> CARD_VOLTAGE_A0_W {
        CARD_VOLTAGE_A0_W { w: self }
    }
    #[doc = "Bit 17 - Controls the state of the SD_VOLT1 pin. SD/MMC card voltage control is not implemented."]
    #[inline(always)]
    pub fn card_voltage_a1(&mut self) -> CARD_VOLTAGE_A1_W {
        CARD_VOLTAGE_A1_W { w: self }
    }
    #[doc = "Bit 18 - Controls the state of the SD_VOLT2 pin. SD/MMC card voltage control is not implemented."]
    #[inline(always)]
    pub fn card_voltage_a2(&mut self) -> CARD_VOLTAGE_A2_W {
        CARD_VOLTAGE_A2_W { w: self }
    }
    #[doc = "Bits 19:23 - Reserved."]
    #[inline(always)]
    pub fn reserved_3(&mut self) -> RESERVED_3_W {
        RESERVED_3_W { w: self }
    }
    #[doc = "Bit 24 - Reserved. Always write this bit as 0."]
    #[inline(always)]
    pub fn reserved_4(&mut self) -> RESERVED_4_W {
        RESERVED_4_W { w: self }
    }
    #[doc = "Bit 25 - SD/MMC DMA use."]
    #[inline(always)]
    pub fn use_internal_dmac(&mut self) -> USE_INTERNAL_DMAC_W {
        USE_INTERNAL_DMAC_W { w: self }
    }
    #[doc = "Bits 26:31 - Reserved"]
    #[inline(always)]
    pub fn reserved_5(&mut self) -> RESERVED_5_W {
        RESERVED_5_W { w: self }
    }
}
