#[doc = "Reader of register OUT_MUX_CFG[%s]"]
pub type R = crate::R<u32, super::OUT_MUX_CFG>;
#[doc = "Writer for register OUT_MUX_CFG[%s]"]
pub type W = crate::W<u32, super::OUT_MUX_CFG>;
#[doc = "Register OUT_MUX_CFG[%s]
`reset()`'s with value 0"]
impl crate::ResetValue for super::OUT_MUX_CFG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Output control of output SGPIOn. All other values are reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum P_OUT_CFG_A {
    #[doc = "0: dout_doutm1 (1-bit mode)"]
    DOUT_DOUTM1 = 0,
    #[doc = "1: dout_doutm2a (2-bit mode 2a)"]
    DOUT_DOUTM2A = 1,
    #[doc = "2: dout_doutm2b (2-bit mode 2b)"]
    DOUT_DOUTM2B = 2,
    #[doc = "3: dout_doutm2c (2-bit mode 2c)"]
    DOUT_DOUTM2C = 3,
    #[doc = "4: gpio_out (level set by GPIO_OUTREG)"]
    GPIO_OUT_LEVEL_SET = 4,
    #[doc = "5: dout_doutm4a (4-bit mode 4a)"]
    DOUT_DOUTM4A = 5,
    #[doc = "6: dout_doutm4b (4-bit mode 4b)"]
    DOUT_DOUTM4B = 6,
    #[doc = "7: dout_doutm4c (4-bit mode 4c)"]
    DOUT_DOUTM4C = 7,
    #[doc = "8: clk_out"]
    CLK_OUT = 8,
    #[doc = "9: dout_doutm8a (8-bit mode 8a)"]
    DOUT_DOUTM8A = 9,
    #[doc = "10: dout_doutm8b (8-bit mode 8b)"]
    DOUT_DOUTM8B = 10,
    #[doc = "11: dout_doutm8c (8-bit mode 8c)"]
    DOUT_DOUTM8C = 11,
}
impl From<P_OUT_CFG_A> for u8 {
    #[inline(always)]
    fn from(variant: P_OUT_CFG_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `P_OUT_CFG`"]
pub type P_OUT_CFG_R = crate::R<u8, P_OUT_CFG_A>;
impl P_OUT_CFG_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, P_OUT_CFG_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(P_OUT_CFG_A::DOUT_DOUTM1),
            1 => Val(P_OUT_CFG_A::DOUT_DOUTM2A),
            2 => Val(P_OUT_CFG_A::DOUT_DOUTM2B),
            3 => Val(P_OUT_CFG_A::DOUT_DOUTM2C),
            4 => Val(P_OUT_CFG_A::GPIO_OUT_LEVEL_SET),
            5 => Val(P_OUT_CFG_A::DOUT_DOUTM4A),
            6 => Val(P_OUT_CFG_A::DOUT_DOUTM4B),
            7 => Val(P_OUT_CFG_A::DOUT_DOUTM4C),
            8 => Val(P_OUT_CFG_A::CLK_OUT),
            9 => Val(P_OUT_CFG_A::DOUT_DOUTM8A),
            10 => Val(P_OUT_CFG_A::DOUT_DOUTM8B),
            11 => Val(P_OUT_CFG_A::DOUT_DOUTM8C),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM1`"]
    #[inline(always)]
    pub fn is_dout_doutm1(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM1
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM2A`"]
    #[inline(always)]
    pub fn is_dout_doutm2a(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM2A
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM2B`"]
    #[inline(always)]
    pub fn is_dout_doutm2b(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM2B
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM2C`"]
    #[inline(always)]
    pub fn is_dout_doutm2c(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM2C
    }
    #[doc = "Checks if the value of the field is `GPIO_OUT_LEVEL_SET`"]
    #[inline(always)]
    pub fn is_gpio_out_level_set(&self) -> bool {
        *self == P_OUT_CFG_A::GPIO_OUT_LEVEL_SET
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM4A`"]
    #[inline(always)]
    pub fn is_dout_doutm4a(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM4A
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM4B`"]
    #[inline(always)]
    pub fn is_dout_doutm4b(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM4B
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM4C`"]
    #[inline(always)]
    pub fn is_dout_doutm4c(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM4C
    }
    #[doc = "Checks if the value of the field is `CLK_OUT`"]
    #[inline(always)]
    pub fn is_clk_out(&self) -> bool {
        *self == P_OUT_CFG_A::CLK_OUT
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM8A`"]
    #[inline(always)]
    pub fn is_dout_doutm8a(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM8A
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM8B`"]
    #[inline(always)]
    pub fn is_dout_doutm8b(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM8B
    }
    #[doc = "Checks if the value of the field is `DOUT_DOUTM8C`"]
    #[inline(always)]
    pub fn is_dout_doutm8c(&self) -> bool {
        *self == P_OUT_CFG_A::DOUT_DOUTM8C
    }
}
#[doc = "Write proxy for field `P_OUT_CFG`"]
pub struct P_OUT_CFG_W<'a> {
    w: &'a mut W,
}
impl<'a> P_OUT_CFG_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: P_OUT_CFG_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "dout_doutm1 (1-bit mode)"]
    #[inline(always)]
    pub fn dout_doutm1(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM1)
    }
    #[doc = "dout_doutm2a (2-bit mode 2a)"]
    #[inline(always)]
    pub fn dout_doutm2a(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM2A)
    }
    #[doc = "dout_doutm2b (2-bit mode 2b)"]
    #[inline(always)]
    pub fn dout_doutm2b(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM2B)
    }
    #[doc = "dout_doutm2c (2-bit mode 2c)"]
    #[inline(always)]
    pub fn dout_doutm2c(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM2C)
    }
    #[doc = "gpio_out (level set by GPIO_OUTREG)"]
    #[inline(always)]
    pub fn gpio_out_level_set(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::GPIO_OUT_LEVEL_SET)
    }
    #[doc = "dout_doutm4a (4-bit mode 4a)"]
    #[inline(always)]
    pub fn dout_doutm4a(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM4A)
    }
    #[doc = "dout_doutm4b (4-bit mode 4b)"]
    #[inline(always)]
    pub fn dout_doutm4b(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM4B)
    }
    #[doc = "dout_doutm4c (4-bit mode 4c)"]
    #[inline(always)]
    pub fn dout_doutm4c(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM4C)
    }
    #[doc = "clk_out"]
    #[inline(always)]
    pub fn clk_out(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::CLK_OUT)
    }
    #[doc = "dout_doutm8a (8-bit mode 8a)"]
    #[inline(always)]
    pub fn dout_doutm8a(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM8A)
    }
    #[doc = "dout_doutm8b (8-bit mode 8b)"]
    #[inline(always)]
    pub fn dout_doutm8b(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM8B)
    }
    #[doc = "dout_doutm8c (8-bit mode 8c)"]
    #[inline(always)]
    pub fn dout_doutm8c(self) -> &'a mut W {
        self.variant(P_OUT_CFG_A::DOUT_DOUTM8C)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | ((value as u32) & 0x0f);
        self.w
    }
}
#[doc = "Output enable source. All other values are reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum P_OE_CFG_A {
    #[doc = "0: gpio_oe (state set by GPIO_OEREG)"]
    GPIO_OE_STATE_SET_B = 0,
    #[doc = "4: dout_oem1 (1-bit mode)"]
    DOUT_OEM1_1_BIT_MOD = 4,
    #[doc = "5: dout_oem2 (2-bit mode)"]
    DOUT_OEM2_2_BIT_MOD = 5,
    #[doc = "6: dout_oem4 (4-bit mode)"]
    DOUT_OEM4_4_BIT_MOD = 6,
    #[doc = "7: dout_oem8 (8-bit mode)"]
    DOUT_OEM8_8_BIT_MOD = 7,
}
impl From<P_OE_CFG_A> for u8 {
    #[inline(always)]
    fn from(variant: P_OE_CFG_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `P_OE_CFG`"]
pub type P_OE_CFG_R = crate::R<u8, P_OE_CFG_A>;
impl P_OE_CFG_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, P_OE_CFG_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(P_OE_CFG_A::GPIO_OE_STATE_SET_B),
            4 => Val(P_OE_CFG_A::DOUT_OEM1_1_BIT_MOD),
            5 => Val(P_OE_CFG_A::DOUT_OEM2_2_BIT_MOD),
            6 => Val(P_OE_CFG_A::DOUT_OEM4_4_BIT_MOD),
            7 => Val(P_OE_CFG_A::DOUT_OEM8_8_BIT_MOD),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `GPIO_OE_STATE_SET_B`"]
    #[inline(always)]
    pub fn is_gpio_oe_state_set_b(&self) -> bool {
        *self == P_OE_CFG_A::GPIO_OE_STATE_SET_B
    }
    #[doc = "Checks if the value of the field is `DOUT_OEM1_1_BIT_MOD`"]
    #[inline(always)]
    pub fn is_dout_oem1_1_bit_mod(&self) -> bool {
        *self == P_OE_CFG_A::DOUT_OEM1_1_BIT_MOD
    }
    #[doc = "Checks if the value of the field is `DOUT_OEM2_2_BIT_MOD`"]
    #[inline(always)]
    pub fn is_dout_oem2_2_bit_mod(&self) -> bool {
        *self == P_OE_CFG_A::DOUT_OEM2_2_BIT_MOD
    }
    #[doc = "Checks if the value of the field is `DOUT_OEM4_4_BIT_MOD`"]
    #[inline(always)]
    pub fn is_dout_oem4_4_bit_mod(&self) -> bool {
        *self == P_OE_CFG_A::DOUT_OEM4_4_BIT_MOD
    }
    #[doc = "Checks if the value of the field is `DOUT_OEM8_8_BIT_MOD`"]
    #[inline(always)]
    pub fn is_dout_oem8_8_bit_mod(&self) -> bool {
        *self == P_OE_CFG_A::DOUT_OEM8_8_BIT_MOD
    }
}
#[doc = "Write proxy for field `P_OE_CFG`"]
pub struct P_OE_CFG_W<'a> {
    w: &'a mut W,
}
impl<'a> P_OE_CFG_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: P_OE_CFG_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "gpio_oe (state set by GPIO_OEREG)"]
    #[inline(always)]
    pub fn gpio_oe_state_set_b(self) -> &'a mut W {
        self.variant(P_OE_CFG_A::GPIO_OE_STATE_SET_B)
    }
    #[doc = "dout_oem1 (1-bit mode)"]
    #[inline(always)]
    pub fn dout_oem1_1_bit_mod(self) -> &'a mut W {
        self.variant(P_OE_CFG_A::DOUT_OEM1_1_BIT_MOD)
    }
    #[doc = "dout_oem2 (2-bit mode)"]
    #[inline(always)]
    pub fn dout_oem2_2_bit_mod(self) -> &'a mut W {
        self.variant(P_OE_CFG_A::DOUT_OEM2_2_BIT_MOD)
    }
    #[doc = "dout_oem4 (4-bit mode)"]
    #[inline(always)]
    pub fn dout_oem4_4_bit_mod(self) -> &'a mut W {
        self.variant(P_OE_CFG_A::DOUT_OEM4_4_BIT_MOD)
    }
    #[doc = "dout_oem8 (8-bit mode)"]
    #[inline(always)]
    pub fn dout_oem8_8_bit_mod(self) -> &'a mut W {
        self.variant(P_OE_CFG_A::DOUT_OEM8_8_BIT_MOD)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 4)) | (((value as u32) & 0x07) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - Output control of output SGPIOn. All other values are reserved."]
    #[inline(always)]
    pub fn p_out_cfg(&self) -> P_OUT_CFG_R {
        P_OUT_CFG_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:6 - Output enable source. All other values are reserved."]
    #[inline(always)]
    pub fn p_oe_cfg(&self) -> P_OE_CFG_R {
        P_OE_CFG_R::new(((self.bits >> 4) & 0x07) as u8)
    }
}
impl W {
    #[doc = "Bits 0:3 - Output control of output SGPIOn. All other values are reserved."]
    #[inline(always)]
    pub fn p_out_cfg(&mut self) -> P_OUT_CFG_W {
        P_OUT_CFG_W { w: self }
    }
    #[doc = "Bits 4:6 - Output enable source. All other values are reserved."]
    #[inline(always)]
    pub fn p_oe_cfg(&mut self) -> P_OE_CFG_W {
        P_OE_CFG_W { w: self }
    }
}
