#[doc = "Reader of register SGPIO_MUX_CFG[%s]"]
pub type R = crate::R<u32, super::SGPIO_MUX_CFG>;
#[doc = "Writer for register SGPIO_MUX_CFG[%s]"]
pub type W = crate::W<u32, super::SGPIO_MUX_CFG>;
#[doc = "Register SGPIO_MUX_CFG[%s]
`reset()`'s with value 0"]
impl crate::ResetValue for super::SGPIO_MUX_CFG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Select clock signal.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EXT_CLK_ENABLE_A {
    #[doc = "0: Internal clock signal (slice)"]
    INTERNAL_CLOCK_SIGNAL = 0,
    #[doc = "1: External clock signal (pin)"]
    EXTERNAL_CLOCK_SIGNAL = 1,
}
impl From<EXT_CLK_ENABLE_A> for bool {
    #[inline(always)]
    fn from(variant: EXT_CLK_ENABLE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `EXT_CLK_ENABLE`"]
pub type EXT_CLK_ENABLE_R = crate::R<bool, EXT_CLK_ENABLE_A>;
impl EXT_CLK_ENABLE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EXT_CLK_ENABLE_A {
        match self.bits {
            false => EXT_CLK_ENABLE_A::INTERNAL_CLOCK_SIGNAL,
            true => EXT_CLK_ENABLE_A::EXTERNAL_CLOCK_SIGNAL,
        }
    }
    #[doc = "Checks if the value of the field is `INTERNAL_CLOCK_SIGNAL`"]
    #[inline(always)]
    pub fn is_internal_clock_signal(&self) -> bool {
        *self == EXT_CLK_ENABLE_A::INTERNAL_CLOCK_SIGNAL
    }
    #[doc = "Checks if the value of the field is `EXTERNAL_CLOCK_SIGNAL`"]
    #[inline(always)]
    pub fn is_external_clock_signal(&self) -> bool {
        *self == EXT_CLK_ENABLE_A::EXTERNAL_CLOCK_SIGNAL
    }
}
#[doc = "Write proxy for field `EXT_CLK_ENABLE`"]
pub struct EXT_CLK_ENABLE_W<'a> {
    w: &'a mut W,
}
impl<'a> EXT_CLK_ENABLE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EXT_CLK_ENABLE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Internal clock signal (slice)"]
    #[inline(always)]
    pub fn internal_clock_signal(self) -> &'a mut W {
        self.variant(EXT_CLK_ENABLE_A::INTERNAL_CLOCK_SIGNAL)
    }
    #[doc = "External clock signal (pin)"]
    #[inline(always)]
    pub fn external_clock_signal(self) -> &'a mut W {
        self.variant(EXT_CLK_ENABLE_A::EXTERNAL_CLOCK_SIGNAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Select source clock pin.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CLK_SOURCE_PIN_MODE_A {
    #[doc = "0: SGPIO8"]
    SGPIO8 = 0,
    #[doc = "1: SGPIO9"]
    SGPIO9 = 1,
    #[doc = "2: SGPIO10"]
    SGPIO10 = 2,
    #[doc = "3: SGPIO11"]
    SGPIO11 = 3,
}
impl From<CLK_SOURCE_PIN_MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: CLK_SOURCE_PIN_MODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CLK_SOURCE_PIN_MODE`"]
pub type CLK_SOURCE_PIN_MODE_R = crate::R<u8, CLK_SOURCE_PIN_MODE_A>;
impl CLK_SOURCE_PIN_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CLK_SOURCE_PIN_MODE_A {
        match self.bits {
            0 => CLK_SOURCE_PIN_MODE_A::SGPIO8,
            1 => CLK_SOURCE_PIN_MODE_A::SGPIO9,
            2 => CLK_SOURCE_PIN_MODE_A::SGPIO10,
            3 => CLK_SOURCE_PIN_MODE_A::SGPIO11,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SGPIO8`"]
    #[inline(always)]
    pub fn is_sgpio8(&self) -> bool {
        *self == CLK_SOURCE_PIN_MODE_A::SGPIO8
    }
    #[doc = "Checks if the value of the field is `SGPIO9`"]
    #[inline(always)]
    pub fn is_sgpio9(&self) -> bool {
        *self == CLK_SOURCE_PIN_MODE_A::SGPIO9
    }
    #[doc = "Checks if the value of the field is `SGPIO10`"]
    #[inline(always)]
    pub fn is_sgpio10(&self) -> bool {
        *self == CLK_SOURCE_PIN_MODE_A::SGPIO10
    }
    #[doc = "Checks if the value of the field is `SGPIO11`"]
    #[inline(always)]
    pub fn is_sgpio11(&self) -> bool {
        *self == CLK_SOURCE_PIN_MODE_A::SGPIO11
    }
}
#[doc = "Write proxy for field `CLK_SOURCE_PIN_MODE`"]
pub struct CLK_SOURCE_PIN_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_SOURCE_PIN_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_SOURCE_PIN_MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "SGPIO8"]
    #[inline(always)]
    pub fn sgpio8(self) -> &'a mut W {
        self.variant(CLK_SOURCE_PIN_MODE_A::SGPIO8)
    }
    #[doc = "SGPIO9"]
    #[inline(always)]
    pub fn sgpio9(self) -> &'a mut W {
        self.variant(CLK_SOURCE_PIN_MODE_A::SGPIO9)
    }
    #[doc = "SGPIO10"]
    #[inline(always)]
    pub fn sgpio10(self) -> &'a mut W {
        self.variant(CLK_SOURCE_PIN_MODE_A::SGPIO10)
    }
    #[doc = "SGPIO11"]
    #[inline(always)]
    pub fn sgpio11(self) -> &'a mut W {
        self.variant(CLK_SOURCE_PIN_MODE_A::SGPIO11)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 1)) | (((value as u32) & 0x03) << 1);
        self.w
    }
}
#[doc = "Select clock source slice. Note that slices D, H, O and P do not support this mode.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CLK_SOURCE_SLICE_MODE_A {
    #[doc = "0: Slice D"]
    SLICE_D = 0,
    #[doc = "1: Slice H"]
    SLICE_H = 1,
    #[doc = "2: Slice O"]
    SLICE_O = 2,
    #[doc = "3: Slice P"]
    SLICE_P = 3,
}
impl From<CLK_SOURCE_SLICE_MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: CLK_SOURCE_SLICE_MODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CLK_SOURCE_SLICE_MODE`"]
pub type CLK_SOURCE_SLICE_MODE_R = crate::R<u8, CLK_SOURCE_SLICE_MODE_A>;
impl CLK_SOURCE_SLICE_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CLK_SOURCE_SLICE_MODE_A {
        match self.bits {
            0 => CLK_SOURCE_SLICE_MODE_A::SLICE_D,
            1 => CLK_SOURCE_SLICE_MODE_A::SLICE_H,
            2 => CLK_SOURCE_SLICE_MODE_A::SLICE_O,
            3 => CLK_SOURCE_SLICE_MODE_A::SLICE_P,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SLICE_D`"]
    #[inline(always)]
    pub fn is_slice_d(&self) -> bool {
        *self == CLK_SOURCE_SLICE_MODE_A::SLICE_D
    }
    #[doc = "Checks if the value of the field is `SLICE_H`"]
    #[inline(always)]
    pub fn is_slice_h(&self) -> bool {
        *self == CLK_SOURCE_SLICE_MODE_A::SLICE_H
    }
    #[doc = "Checks if the value of the field is `SLICE_O`"]
    #[inline(always)]
    pub fn is_slice_o(&self) -> bool {
        *self == CLK_SOURCE_SLICE_MODE_A::SLICE_O
    }
    #[doc = "Checks if the value of the field is `SLICE_P`"]
    #[inline(always)]
    pub fn is_slice_p(&self) -> bool {
        *self == CLK_SOURCE_SLICE_MODE_A::SLICE_P
    }
}
#[doc = "Write proxy for field `CLK_SOURCE_SLICE_MODE`"]
pub struct CLK_SOURCE_SLICE_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_SOURCE_SLICE_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_SOURCE_SLICE_MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Slice D"]
    #[inline(always)]
    pub fn slice_d(self) -> &'a mut W {
        self.variant(CLK_SOURCE_SLICE_MODE_A::SLICE_D)
    }
    #[doc = "Slice H"]
    #[inline(always)]
    pub fn slice_h(self) -> &'a mut W {
        self.variant(CLK_SOURCE_SLICE_MODE_A::SLICE_H)
    }
    #[doc = "Slice O"]
    #[inline(always)]
    pub fn slice_o(self) -> &'a mut W {
        self.variant(CLK_SOURCE_SLICE_MODE_A::SLICE_O)
    }
    #[doc = "Slice P"]
    #[inline(always)]
    pub fn slice_p(self) -> &'a mut W {
        self.variant(CLK_SOURCE_SLICE_MODE_A::SLICE_P)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 3)) | (((value as u32) & 0x03) << 3);
        self.w
    }
}
#[doc = "Select qualifier mode.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum QUALIFIER_MODE_A {
    #[doc = "0: Enable"]
    ENABLE = 0,
    #[doc = "1: Disable"]
    DISABLE = 1,
    #[doc = "2: Slice (see bits QUALIFIER_SLICE_MODE in this register)"]
    SLICE_SEE_BITS_QUAL = 2,
    #[doc = "3: External SGPIO pin (SGPIO8, SGPIO9, SGPIO10, or SGPIO11)"]
    EXTERNAL_SGPIO_PIN = 3,
}
impl From<QUALIFIER_MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: QUALIFIER_MODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `QUALIFIER_MODE`"]
pub type QUALIFIER_MODE_R = crate::R<u8, QUALIFIER_MODE_A>;
impl QUALIFIER_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> QUALIFIER_MODE_A {
        match self.bits {
            0 => QUALIFIER_MODE_A::ENABLE,
            1 => QUALIFIER_MODE_A::DISABLE,
            2 => QUALIFIER_MODE_A::SLICE_SEE_BITS_QUAL,
            3 => QUALIFIER_MODE_A::EXTERNAL_SGPIO_PIN,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        *self == QUALIFIER_MODE_A::ENABLE
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        *self == QUALIFIER_MODE_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `SLICE_SEE_BITS_QUAL`"]
    #[inline(always)]
    pub fn is_slice_see_bits_qual(&self) -> bool {
        *self == QUALIFIER_MODE_A::SLICE_SEE_BITS_QUAL
    }
    #[doc = "Checks if the value of the field is `EXTERNAL_SGPIO_PIN`"]
    #[inline(always)]
    pub fn is_external_sgpio_pin(&self) -> bool {
        *self == QUALIFIER_MODE_A::EXTERNAL_SGPIO_PIN
    }
}
#[doc = "Write proxy for field `QUALIFIER_MODE`"]
pub struct QUALIFIER_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> QUALIFIER_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: QUALIFIER_MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Enable"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(QUALIFIER_MODE_A::ENABLE)
    }
    #[doc = "Disable"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(QUALIFIER_MODE_A::DISABLE)
    }
    #[doc = "Slice (see bits QUALIFIER_SLICE_MODE in this register)"]
    #[inline(always)]
    pub fn slice_see_bits_qual(self) -> &'a mut W {
        self.variant(QUALIFIER_MODE_A::SLICE_SEE_BITS_QUAL)
    }
    #[doc = "External SGPIO pin (SGPIO8, SGPIO9, SGPIO10, or SGPIO11)"]
    #[inline(always)]
    pub fn external_sgpio_pin(self) -> &'a mut W {
        self.variant(QUALIFIER_MODE_A::EXTERNAL_SGPIO_PIN)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 5)) | (((value as u32) & 0x03) << 5);
        self.w
    }
}
#[doc = "Select qualifier pin.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum QUALIFIER_PIN_MODE_A {
    #[doc = "0: SGPIO8"]
    SGPIO8 = 0,
    #[doc = "1: SGPIO9"]
    SGPIO9 = 1,
    #[doc = "2: SGPIO10"]
    SGPIO10 = 2,
    #[doc = "3: SGPIO11"]
    SGPIO11 = 3,
}
impl From<QUALIFIER_PIN_MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: QUALIFIER_PIN_MODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `QUALIFIER_PIN_MODE`"]
pub type QUALIFIER_PIN_MODE_R = crate::R<u8, QUALIFIER_PIN_MODE_A>;
impl QUALIFIER_PIN_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> QUALIFIER_PIN_MODE_A {
        match self.bits {
            0 => QUALIFIER_PIN_MODE_A::SGPIO8,
            1 => QUALIFIER_PIN_MODE_A::SGPIO9,
            2 => QUALIFIER_PIN_MODE_A::SGPIO10,
            3 => QUALIFIER_PIN_MODE_A::SGPIO11,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SGPIO8`"]
    #[inline(always)]
    pub fn is_sgpio8(&self) -> bool {
        *self == QUALIFIER_PIN_MODE_A::SGPIO8
    }
    #[doc = "Checks if the value of the field is `SGPIO9`"]
    #[inline(always)]
    pub fn is_sgpio9(&self) -> bool {
        *self == QUALIFIER_PIN_MODE_A::SGPIO9
    }
    #[doc = "Checks if the value of the field is `SGPIO10`"]
    #[inline(always)]
    pub fn is_sgpio10(&self) -> bool {
        *self == QUALIFIER_PIN_MODE_A::SGPIO10
    }
    #[doc = "Checks if the value of the field is `SGPIO11`"]
    #[inline(always)]
    pub fn is_sgpio11(&self) -> bool {
        *self == QUALIFIER_PIN_MODE_A::SGPIO11
    }
}
#[doc = "Write proxy for field `QUALIFIER_PIN_MODE`"]
pub struct QUALIFIER_PIN_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> QUALIFIER_PIN_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: QUALIFIER_PIN_MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "SGPIO8"]
    #[inline(always)]
    pub fn sgpio8(self) -> &'a mut W {
        self.variant(QUALIFIER_PIN_MODE_A::SGPIO8)
    }
    #[doc = "SGPIO9"]
    #[inline(always)]
    pub fn sgpio9(self) -> &'a mut W {
        self.variant(QUALIFIER_PIN_MODE_A::SGPIO9)
    }
    #[doc = "SGPIO10"]
    #[inline(always)]
    pub fn sgpio10(self) -> &'a mut W {
        self.variant(QUALIFIER_PIN_MODE_A::SGPIO10)
    }
    #[doc = "SGPIO11"]
    #[inline(always)]
    pub fn sgpio11(self) -> &'a mut W {
        self.variant(QUALIFIER_PIN_MODE_A::SGPIO11)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 7)) | (((value as u32) & 0x03) << 7);
        self.w
    }
}
#[doc = "Select qualifier slice.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum QUALIFIER_SLICE_MODE_A {
    #[doc = "0: Slice A, but for slice A slice D is used."]
    SLICE_A = 0,
    #[doc = "1: Slice H, but for slice H slice O is used."]
    SLICE_H = 1,
    #[doc = "2: Slice I, but for slice I slice D is used."]
    SLICE_I = 2,
    #[doc = "3: Slice P, but for slice P slice O is used."]
    SLICE_P = 3,
}
impl From<QUALIFIER_SLICE_MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: QUALIFIER_SLICE_MODE_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `QUALIFIER_SLICE_MODE`"]
pub type QUALIFIER_SLICE_MODE_R = crate::R<u8, QUALIFIER_SLICE_MODE_A>;
impl QUALIFIER_SLICE_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> QUALIFIER_SLICE_MODE_A {
        match self.bits {
            0 => QUALIFIER_SLICE_MODE_A::SLICE_A,
            1 => QUALIFIER_SLICE_MODE_A::SLICE_H,
            2 => QUALIFIER_SLICE_MODE_A::SLICE_I,
            3 => QUALIFIER_SLICE_MODE_A::SLICE_P,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SLICE_A`"]
    #[inline(always)]
    pub fn is_slice_a(&self) -> bool {
        *self == QUALIFIER_SLICE_MODE_A::SLICE_A
    }
    #[doc = "Checks if the value of the field is `SLICE_H`"]
    #[inline(always)]
    pub fn is_slice_h(&self) -> bool {
        *self == QUALIFIER_SLICE_MODE_A::SLICE_H
    }
    #[doc = "Checks if the value of the field is `SLICE_I`"]
    #[inline(always)]
    pub fn is_slice_i(&self) -> bool {
        *self == QUALIFIER_SLICE_MODE_A::SLICE_I
    }
    #[doc = "Checks if the value of the field is `SLICE_P`"]
    #[inline(always)]
    pub fn is_slice_p(&self) -> bool {
        *self == QUALIFIER_SLICE_MODE_A::SLICE_P
    }
}
#[doc = "Write proxy for field `QUALIFIER_SLICE_MODE`"]
pub struct QUALIFIER_SLICE_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> QUALIFIER_SLICE_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: QUALIFIER_SLICE_MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Slice A, but for slice A slice D is used."]
    #[inline(always)]
    pub fn slice_a(self) -> &'a mut W {
        self.variant(QUALIFIER_SLICE_MODE_A::SLICE_A)
    }
    #[doc = "Slice H, but for slice H slice O is used."]
    #[inline(always)]
    pub fn slice_h(self) -> &'a mut W {
        self.variant(QUALIFIER_SLICE_MODE_A::SLICE_H)
    }
    #[doc = "Slice I, but for slice I slice D is used."]
    #[inline(always)]
    pub fn slice_i(self) -> &'a mut W {
        self.variant(QUALIFIER_SLICE_MODE_A::SLICE_I)
    }
    #[doc = "Slice P, but for slice P slice O is used."]
    #[inline(always)]
    pub fn slice_p(self) -> &'a mut W {
        self.variant(QUALIFIER_SLICE_MODE_A::SLICE_P)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 9)) | (((value as u32) & 0x03) << 9);
        self.w
    }
}
#[doc = "Enable concatenation.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CONCAT_ENABLE_A {
    #[doc = "0: External data pin"]
    EXTERNAL_DATA_PIN = 0,
    #[doc = "1: Concatenate data"]
    CONCATENATE_DATA = 1,
}
impl From<CONCAT_ENABLE_A> for bool {
    #[inline(always)]
    fn from(variant: CONCAT_ENABLE_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CONCAT_ENABLE`"]
pub type CONCAT_ENABLE_R = crate::R<bool, CONCAT_ENABLE_A>;
impl CONCAT_ENABLE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CONCAT_ENABLE_A {
        match self.bits {
            false => CONCAT_ENABLE_A::EXTERNAL_DATA_PIN,
            true => CONCAT_ENABLE_A::CONCATENATE_DATA,
        }
    }
    #[doc = "Checks if the value of the field is `EXTERNAL_DATA_PIN`"]
    #[inline(always)]
    pub fn is_external_data_pin(&self) -> bool {
        *self == CONCAT_ENABLE_A::EXTERNAL_DATA_PIN
    }
    #[doc = "Checks if the value of the field is `CONCATENATE_DATA`"]
    #[inline(always)]
    pub fn is_concatenate_data(&self) -> bool {
        *self == CONCAT_ENABLE_A::CONCATENATE_DATA
    }
}
#[doc = "Write proxy for field `CONCAT_ENABLE`"]
pub struct CONCAT_ENABLE_W<'a> {
    w: &'a mut W,
}
impl<'a> CONCAT_ENABLE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CONCAT_ENABLE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "External data pin"]
    #[inline(always)]
    pub fn external_data_pin(self) -> &'a mut W {
        self.variant(CONCAT_ENABLE_A::EXTERNAL_DATA_PIN)
    }
    #[doc = "Concatenate data"]
    #[inline(always)]
    pub fn concatenate_data(self) -> &'a mut W {
        self.variant(CONCAT_ENABLE_A::CONCATENATE_DATA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Select concatenation order\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum CONCAT_ORDER_A {
    #[doc = "0: Self-loop"]
    SELF_LOOP = 0,
    #[doc = "1: 2 slices"]
    _2_SLICES = 1,
    #[doc = "2: 4 slices"]
    _4_SLICES = 2,
    #[doc = "3: 8 slices"]
    _8_SLICES = 3,
}
impl From<CONCAT_ORDER_A> for u8 {
    #[inline(always)]
    fn from(variant: CONCAT_ORDER_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `CONCAT_ORDER`"]
pub type CONCAT_ORDER_R = crate::R<u8, CONCAT_ORDER_A>;
impl CONCAT_ORDER_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CONCAT_ORDER_A {
        match self.bits {
            0 => CONCAT_ORDER_A::SELF_LOOP,
            1 => CONCAT_ORDER_A::_2_SLICES,
            2 => CONCAT_ORDER_A::_4_SLICES,
            3 => CONCAT_ORDER_A::_8_SLICES,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SELF_LOOP`"]
    #[inline(always)]
    pub fn is_self_loop(&self) -> bool {
        *self == CONCAT_ORDER_A::SELF_LOOP
    }
    #[doc = "Checks if the value of the field is `_2_SLICES`"]
    #[inline(always)]
    pub fn is_2_slices(&self) -> bool {
        *self == CONCAT_ORDER_A::_2_SLICES
    }
    #[doc = "Checks if the value of the field is `_4_SLICES`"]
    #[inline(always)]
    pub fn is_4_slices(&self) -> bool {
        *self == CONCAT_ORDER_A::_4_SLICES
    }
    #[doc = "Checks if the value of the field is `_8_SLICES`"]
    #[inline(always)]
    pub fn is_8_slices(&self) -> bool {
        *self == CONCAT_ORDER_A::_8_SLICES
    }
}
#[doc = "Write proxy for field `CONCAT_ORDER`"]
pub struct CONCAT_ORDER_W<'a> {
    w: &'a mut W,
}
impl<'a> CONCAT_ORDER_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CONCAT_ORDER_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Self-loop"]
    #[inline(always)]
    pub fn self_loop(self) -> &'a mut W {
        self.variant(CONCAT_ORDER_A::SELF_LOOP)
    }
    #[doc = "2 slices"]
    #[inline(always)]
    pub fn _2_slices(self) -> &'a mut W {
        self.variant(CONCAT_ORDER_A::_2_SLICES)
    }
    #[doc = "4 slices"]
    #[inline(always)]
    pub fn _4_slices(self) -> &'a mut W {
        self.variant(CONCAT_ORDER_A::_4_SLICES)
    }
    #[doc = "8 slices"]
    #[inline(always)]
    pub fn _8_slices(self) -> &'a mut W {
        self.variant(CONCAT_ORDER_A::_8_SLICES)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 12)) | (((value as u32) & 0x03) << 12);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Select clock signal."]
    #[inline(always)]
    pub fn ext_clk_enable(&self) -> EXT_CLK_ENABLE_R {
        EXT_CLK_ENABLE_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 1:2 - Select source clock pin."]
    #[inline(always)]
    pub fn clk_source_pin_mode(&self) -> CLK_SOURCE_PIN_MODE_R {
        CLK_SOURCE_PIN_MODE_R::new(((self.bits >> 1) & 0x03) as u8)
    }
    #[doc = "Bits 3:4 - Select clock source slice. Note that slices D, H, O and P do not support this mode."]
    #[inline(always)]
    pub fn clk_source_slice_mode(&self) -> CLK_SOURCE_SLICE_MODE_R {
        CLK_SOURCE_SLICE_MODE_R::new(((self.bits >> 3) & 0x03) as u8)
    }
    #[doc = "Bits 5:6 - Select qualifier mode."]
    #[inline(always)]
    pub fn qualifier_mode(&self) -> QUALIFIER_MODE_R {
        QUALIFIER_MODE_R::new(((self.bits >> 5) & 0x03) as u8)
    }
    #[doc = "Bits 7:8 - Select qualifier pin."]
    #[inline(always)]
    pub fn qualifier_pin_mode(&self) -> QUALIFIER_PIN_MODE_R {
        QUALIFIER_PIN_MODE_R::new(((self.bits >> 7) & 0x03) as u8)
    }
    #[doc = "Bits 9:10 - Select qualifier slice."]
    #[inline(always)]
    pub fn qualifier_slice_mode(&self) -> QUALIFIER_SLICE_MODE_R {
        QUALIFIER_SLICE_MODE_R::new(((self.bits >> 9) & 0x03) as u8)
    }
    #[doc = "Bit 11 - Enable concatenation."]
    #[inline(always)]
    pub fn concat_enable(&self) -> CONCAT_ENABLE_R {
        CONCAT_ENABLE_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bits 12:13 - Select concatenation order"]
    #[inline(always)]
    pub fn concat_order(&self) -> CONCAT_ORDER_R {
        CONCAT_ORDER_R::new(((self.bits >> 12) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Select clock signal."]
    #[inline(always)]
    pub fn ext_clk_enable(&mut self) -> EXT_CLK_ENABLE_W {
        EXT_CLK_ENABLE_W { w: self }
    }
    #[doc = "Bits 1:2 - Select source clock pin."]
    #[inline(always)]
    pub fn clk_source_pin_mode(&mut self) -> CLK_SOURCE_PIN_MODE_W {
        CLK_SOURCE_PIN_MODE_W { w: self }
    }
    #[doc = "Bits 3:4 - Select clock source slice. Note that slices D, H, O and P do not support this mode."]
    #[inline(always)]
    pub fn clk_source_slice_mode(&mut self) -> CLK_SOURCE_SLICE_MODE_W {
        CLK_SOURCE_SLICE_MODE_W { w: self }
    }
    #[doc = "Bits 5:6 - Select qualifier mode."]
    #[inline(always)]
    pub fn qualifier_mode(&mut self) -> QUALIFIER_MODE_W {
        QUALIFIER_MODE_W { w: self }
    }
    #[doc = "Bits 7:8 - Select qualifier pin."]
    #[inline(always)]
    pub fn qualifier_pin_mode(&mut self) -> QUALIFIER_PIN_MODE_W {
        QUALIFIER_PIN_MODE_W { w: self }
    }
    #[doc = "Bits 9:10 - Select qualifier slice."]
    #[inline(always)]
    pub fn qualifier_slice_mode(&mut self) -> QUALIFIER_SLICE_MODE_W {
        QUALIFIER_SLICE_MODE_W { w: self }
    }
    #[doc = "Bit 11 - Enable concatenation."]
    #[inline(always)]
    pub fn concat_enable(&mut self) -> CONCAT_ENABLE_W {
        CONCAT_ENABLE_W { w: self }
    }
    #[doc = "Bits 12:13 - Select concatenation order"]
    #[inline(always)]
    pub fn concat_order(&mut self) -> CONCAT_ORDER_W {
        CONCAT_ORDER_W { w: self }
    }
}
