#[doc = "Reader of register ICR"]
pub type R = crate::R<u32, super::ICR>;
#[doc = "Writer for register ICR"]
pub type W = crate::W<u32, super::ICR>;
#[doc = "Register ICR `reset()`'s with value 0"]
impl crate::ResetValue for super::ICR {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "IrDA mode enable.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IRDAEN_A {
    #[doc = "0: Disabled. IrDA mode on USART3 is disabled, USART3 acts as a standard USART."]
    DISABLED = 0,
    #[doc = "1: Enabled. IrDA mode on USART3 is enabled."]
    ENABLED = 1,
}
impl From<IRDAEN_A> for bool {
    #[inline(always)]
    fn from(variant: IRDAEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `IRDAEN`"]
pub type IRDAEN_R = crate::R<bool, IRDAEN_A>;
impl IRDAEN_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> IRDAEN_A {
        match self.bits {
            false => IRDAEN_A::DISABLED,
            true => IRDAEN_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == IRDAEN_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == IRDAEN_A::ENABLED
    }
}
#[doc = "Write proxy for field `IRDAEN`"]
pub struct IRDAEN_W<'a> {
    w: &'a mut W,
}
impl<'a> IRDAEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: IRDAEN_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. IrDA mode on USART3 is disabled, USART3 acts as a standard USART."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(IRDAEN_A::DISABLED)
    }
    #[doc = "Enabled. IrDA mode on USART3 is enabled."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(IRDAEN_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Serial input direction.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IRDAINV_A {
    #[doc = "0: Not inverted. The serial input is not inverted."]
    NOT_INVERTED = 0,
    #[doc = "1: Inverted. The serial input is inverted. This has no effect on the serial output."]
    INVERTED = 1,
}
impl From<IRDAINV_A> for bool {
    #[inline(always)]
    fn from(variant: IRDAINV_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `IRDAINV`"]
pub type IRDAINV_R = crate::R<bool, IRDAINV_A>;
impl IRDAINV_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> IRDAINV_A {
        match self.bits {
            false => IRDAINV_A::NOT_INVERTED,
            true => IRDAINV_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOT_INVERTED`"]
    #[inline(always)]
    pub fn is_not_inverted(&self) -> bool {
        *self == IRDAINV_A::NOT_INVERTED
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        *self == IRDAINV_A::INVERTED
    }
}
#[doc = "Write proxy for field `IRDAINV`"]
pub struct IRDAINV_W<'a> {
    w: &'a mut W,
}
impl<'a> IRDAINV_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: IRDAINV_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Not inverted. The serial input is not inverted."]
    #[inline(always)]
    pub fn not_inverted(self) -> &'a mut W {
        self.variant(IRDAINV_A::NOT_INVERTED)
    }
    #[doc = "Inverted. The serial input is inverted. This has no effect on the serial output."]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(IRDAINV_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "IrDA fixed pulse width mode.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIXPULSEEN_A {
    #[doc = "0: Disabled. IrDA fixed pulse width mode disabled."]
    DISABLED = 0,
    #[doc = "1: Enabled. IrDA fixed pulse width mode enabled."]
    ENABLED = 1,
}
impl From<FIXPULSEEN_A> for bool {
    #[inline(always)]
    fn from(variant: FIXPULSEEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `FIXPULSEEN`"]
pub type FIXPULSEEN_R = crate::R<bool, FIXPULSEEN_A>;
impl FIXPULSEEN_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIXPULSEEN_A {
        match self.bits {
            false => FIXPULSEEN_A::DISABLED,
            true => FIXPULSEEN_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == FIXPULSEEN_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == FIXPULSEEN_A::ENABLED
    }
}
#[doc = "Write proxy for field `FIXPULSEEN`"]
pub struct FIXPULSEEN_W<'a> {
    w: &'a mut W,
}
impl<'a> FIXPULSEEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIXPULSEEN_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. IrDA fixed pulse width mode disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(FIXPULSEEN_A::DISABLED)
    }
    #[doc = "Enabled. IrDA fixed pulse width mode enabled."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(FIXPULSEEN_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Reader of field `PULSEDIV`"]
pub type PULSEDIV_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `PULSEDIV`"]
pub struct PULSEDIV_W<'a> {
    w: &'a mut W,
}
impl<'a> PULSEDIV_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 3)) | (((value as u32) & 0x07) << 3);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - IrDA mode enable."]
    #[inline(always)]
    pub fn irdaen(&self) -> IRDAEN_R {
        IRDAEN_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Serial input direction."]
    #[inline(always)]
    pub fn irdainv(&self) -> IRDAINV_R {
        IRDAINV_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - IrDA fixed pulse width mode."]
    #[inline(always)]
    pub fn fixpulseen(&self) -> FIXPULSEEN_R {
        FIXPULSEEN_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bits 3:5 - Configures the pulse when FixPulseEn = 1. See Table 885 for details."]
    #[inline(always)]
    pub fn pulsediv(&self) -> PULSEDIV_R {
        PULSEDIV_R::new(((self.bits >> 3) & 0x07) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - IrDA mode enable."]
    #[inline(always)]
    pub fn irdaen(&mut self) -> IRDAEN_W {
        IRDAEN_W { w: self }
    }
    #[doc = "Bit 1 - Serial input direction."]
    #[inline(always)]
    pub fn irdainv(&mut self) -> IRDAINV_W {
        IRDAINV_W { w: self }
    }
    #[doc = "Bit 2 - IrDA fixed pulse width mode."]
    #[inline(always)]
    pub fn fixpulseen(&mut self) -> FIXPULSEEN_W {
        FIXPULSEEN_W { w: self }
    }
    #[doc = "Bits 3:5 - Configures the pulse when FixPulseEn = 1. See Table 885 for details."]
    #[inline(always)]
    pub fn pulsediv(&mut self) -> PULSEDIV_W {
        PULSEDIV_W { w: self }
    }
}
