#[doc = "Reader of register SYNCCTRL"]
pub type R = crate::R<u32, super::SYNCCTRL>;
#[doc = "Writer for register SYNCCTRL"]
pub type W = crate::W<u32, super::SYNCCTRL>;
#[doc = "Register SYNCCTRL `reset()`'s with value 0"]
impl crate::ResetValue for super::SYNCCTRL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Enables synchronous mode.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SYNC_A {
    #[doc = "0: Disabled."]
    DISABLED = 0,
    #[doc = "1: Enabled."]
    ENABLED = 1,
}
impl From<SYNC_A> for bool {
    #[inline(always)]
    fn from(variant: SYNC_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SYNC`"]
pub type SYNC_R = crate::R<bool, SYNC_A>;
impl SYNC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SYNC_A {
        match self.bits {
            false => SYNC_A::DISABLED,
            true => SYNC_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == SYNC_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == SYNC_A::ENABLED
    }
}
#[doc = "Write proxy for field `SYNC`"]
pub struct SYNC_W<'a> {
    w: &'a mut W,
}
impl<'a> SYNC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SYNC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(SYNC_A::DISABLED)
    }
    #[doc = "Enabled."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(SYNC_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Clock source select.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CSRC_A {
    #[doc = "0: Slave mode. Synchronous slave mode (SCLK in)"]
    SLAVE_MODE = 0,
    #[doc = "1: Master mode. Synchronous master mode (SCLK out)"]
    MASTER_MODE = 1,
}
impl From<CSRC_A> for bool {
    #[inline(always)]
    fn from(variant: CSRC_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CSRC`"]
pub type CSRC_R = crate::R<bool, CSRC_A>;
impl CSRC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CSRC_A {
        match self.bits {
            false => CSRC_A::SLAVE_MODE,
            true => CSRC_A::MASTER_MODE,
        }
    }
    #[doc = "Checks if the value of the field is `SLAVE_MODE`"]
    #[inline(always)]
    pub fn is_slave_mode(&self) -> bool {
        *self == CSRC_A::SLAVE_MODE
    }
    #[doc = "Checks if the value of the field is `MASTER_MODE`"]
    #[inline(always)]
    pub fn is_master_mode(&self) -> bool {
        *self == CSRC_A::MASTER_MODE
    }
}
#[doc = "Write proxy for field `CSRC`"]
pub struct CSRC_W<'a> {
    w: &'a mut W,
}
impl<'a> CSRC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CSRC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Slave mode. Synchronous slave mode (SCLK in)"]
    #[inline(always)]
    pub fn slave_mode(self) -> &'a mut W {
        self.variant(CSRC_A::SLAVE_MODE)
    }
    #[doc = "Master mode. Synchronous master mode (SCLK out)"]
    #[inline(always)]
    pub fn master_mode(self) -> &'a mut W {
        self.variant(CSRC_A::MASTER_MODE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Edge sampling.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FES_A {
    #[doc = "0: Rising. RxD is sampled on the rising edge of SCLK."]
    RISING = 0,
    #[doc = "1: Falling. RxD is sampled on the falling edge of SCLK."]
    FALLING = 1,
}
impl From<FES_A> for bool {
    #[inline(always)]
    fn from(variant: FES_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `FES`"]
pub type FES_R = crate::R<bool, FES_A>;
impl FES_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FES_A {
        match self.bits {
            false => FES_A::RISING,
            true => FES_A::FALLING,
        }
    }
    #[doc = "Checks if the value of the field is `RISING`"]
    #[inline(always)]
    pub fn is_rising(&self) -> bool {
        *self == FES_A::RISING
    }
    #[doc = "Checks if the value of the field is `FALLING`"]
    #[inline(always)]
    pub fn is_falling(&self) -> bool {
        *self == FES_A::FALLING
    }
}
#[doc = "Write proxy for field `FES`"]
pub struct FES_W<'a> {
    w: &'a mut W,
}
impl<'a> FES_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FES_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Rising. RxD is sampled on the rising edge of SCLK."]
    #[inline(always)]
    pub fn rising(self) -> &'a mut W {
        self.variant(FES_A::RISING)
    }
    #[doc = "Falling. RxD is sampled on the falling edge of SCLK."]
    #[inline(always)]
    pub fn falling(self) -> &'a mut W {
        self.variant(FES_A::FALLING)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Transmit synchronization bypass in synchronous slave mode.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TSBYPASS_A {
    #[doc = "0: Synchronized. The input clock is synchronized prior to being used in clock edge detection logic."]
    SYNCHRONIZED = 0,
    #[doc = "1: Not synchronized. The input clock is not synchronized prior to being used in clock edge detection logic. This allows for a high er input clock rate at the expense of potential metastability."]
    NOT_SYNCHRONIZED = 1,
}
impl From<TSBYPASS_A> for bool {
    #[inline(always)]
    fn from(variant: TSBYPASS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `TSBYPASS`"]
pub type TSBYPASS_R = crate::R<bool, TSBYPASS_A>;
impl TSBYPASS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TSBYPASS_A {
        match self.bits {
            false => TSBYPASS_A::SYNCHRONIZED,
            true => TSBYPASS_A::NOT_SYNCHRONIZED,
        }
    }
    #[doc = "Checks if the value of the field is `SYNCHRONIZED`"]
    #[inline(always)]
    pub fn is_synchronized(&self) -> bool {
        *self == TSBYPASS_A::SYNCHRONIZED
    }
    #[doc = "Checks if the value of the field is `NOT_SYNCHRONIZED`"]
    #[inline(always)]
    pub fn is_not_synchronized(&self) -> bool {
        *self == TSBYPASS_A::NOT_SYNCHRONIZED
    }
}
#[doc = "Write proxy for field `TSBYPASS`"]
pub struct TSBYPASS_W<'a> {
    w: &'a mut W,
}
impl<'a> TSBYPASS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TSBYPASS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Synchronized. The input clock is synchronized prior to being used in clock edge detection logic."]
    #[inline(always)]
    pub fn synchronized(self) -> &'a mut W {
        self.variant(TSBYPASS_A::SYNCHRONIZED)
    }
    #[doc = "Not synchronized. The input clock is not synchronized prior to being used in clock edge detection logic. This allows for a high er input clock rate at the expense of potential metastability."]
    #[inline(always)]
    pub fn not_synchronized(self) -> &'a mut W {
        self.variant(TSBYPASS_A::NOT_SYNCHRONIZED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Continuous master clock enable (used only when CSRC is 1)\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CSCEN_A {
    #[doc = "0: On character. SCLK cycles only when characters are being sent on TxD."]
    ON_CHARACTER = 0,
    #[doc = "1: Continuously. SCLK runs continuously (characters can be received on RxD independently from transmission on TxD)."]
    CONTINUOUSLY = 1,
}
impl From<CSCEN_A> for bool {
    #[inline(always)]
    fn from(variant: CSCEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CSCEN`"]
pub type CSCEN_R = crate::R<bool, CSCEN_A>;
impl CSCEN_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CSCEN_A {
        match self.bits {
            false => CSCEN_A::ON_CHARACTER,
            true => CSCEN_A::CONTINUOUSLY,
        }
    }
    #[doc = "Checks if the value of the field is `ON_CHARACTER`"]
    #[inline(always)]
    pub fn is_on_character(&self) -> bool {
        *self == CSCEN_A::ON_CHARACTER
    }
    #[doc = "Checks if the value of the field is `CONTINUOUSLY`"]
    #[inline(always)]
    pub fn is_continuously(&self) -> bool {
        *self == CSCEN_A::CONTINUOUSLY
    }
}
#[doc = "Write proxy for field `CSCEN`"]
pub struct CSCEN_W<'a> {
    w: &'a mut W,
}
impl<'a> CSCEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CSCEN_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "On character. SCLK cycles only when characters are being sent on TxD."]
    #[inline(always)]
    pub fn on_character(self) -> &'a mut W {
        self.variant(CSCEN_A::ON_CHARACTER)
    }
    #[doc = "Continuously. SCLK runs continuously (characters can be received on RxD independently from transmission on TxD)."]
    #[inline(always)]
    pub fn continuously(self) -> &'a mut W {
        self.variant(CSCEN_A::CONTINUOUSLY)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Start/stop bits\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SSSDIS_A {
    #[doc = "0: Send. Send start and stop bits as in other modes."]
    SEND = 0,
    #[doc = "1: Do not send. Do not send start/stop bits."]
    DO_NOT_SEND = 1,
}
impl From<SSSDIS_A> for bool {
    #[inline(always)]
    fn from(variant: SSSDIS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SSSDIS`"]
pub type SSSDIS_R = crate::R<bool, SSSDIS_A>;
impl SSSDIS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SSSDIS_A {
        match self.bits {
            false => SSSDIS_A::SEND,
            true => SSSDIS_A::DO_NOT_SEND,
        }
    }
    #[doc = "Checks if the value of the field is `SEND`"]
    #[inline(always)]
    pub fn is_send(&self) -> bool {
        *self == SSSDIS_A::SEND
    }
    #[doc = "Checks if the value of the field is `DO_NOT_SEND`"]
    #[inline(always)]
    pub fn is_do_not_send(&self) -> bool {
        *self == SSSDIS_A::DO_NOT_SEND
    }
}
#[doc = "Write proxy for field `SSSDIS`"]
pub struct SSSDIS_W<'a> {
    w: &'a mut W,
}
impl<'a> SSSDIS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SSSDIS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Send. Send start and stop bits as in other modes."]
    #[inline(always)]
    pub fn send(self) -> &'a mut W {
        self.variant(SSSDIS_A::SEND)
    }
    #[doc = "Do not send. Do not send start/stop bits."]
    #[inline(always)]
    pub fn do_not_send(self) -> &'a mut W {
        self.variant(SSSDIS_A::DO_NOT_SEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Continuous clock clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CCCLR_A {
    #[doc = "0: Software. CSCEN is under software control."]
    SOFTWARE = 0,
    #[doc = "1: Hardware. Hardware clears CSCEN after each character is received."]
    HARDWARE = 1,
}
impl From<CCCLR_A> for bool {
    #[inline(always)]
    fn from(variant: CCCLR_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CCCLR`"]
pub type CCCLR_R = crate::R<bool, CCCLR_A>;
impl CCCLR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CCCLR_A {
        match self.bits {
            false => CCCLR_A::SOFTWARE,
            true => CCCLR_A::HARDWARE,
        }
    }
    #[doc = "Checks if the value of the field is `SOFTWARE`"]
    #[inline(always)]
    pub fn is_software(&self) -> bool {
        *self == CCCLR_A::SOFTWARE
    }
    #[doc = "Checks if the value of the field is `HARDWARE`"]
    #[inline(always)]
    pub fn is_hardware(&self) -> bool {
        *self == CCCLR_A::HARDWARE
    }
}
#[doc = "Write proxy for field `CCCLR`"]
pub struct CCCLR_W<'a> {
    w: &'a mut W,
}
impl<'a> CCCLR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CCCLR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Software. CSCEN is under software control."]
    #[inline(always)]
    pub fn software(self) -> &'a mut W {
        self.variant(CCCLR_A::SOFTWARE)
    }
    #[doc = "Hardware. Hardware clears CSCEN after each character is received."]
    #[inline(always)]
    pub fn hardware(self) -> &'a mut W {
        self.variant(CCCLR_A::HARDWARE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Enables synchronous mode."]
    #[inline(always)]
    pub fn sync(&self) -> SYNC_R {
        SYNC_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Clock source select."]
    #[inline(always)]
    pub fn csrc(&self) -> CSRC_R {
        CSRC_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Edge sampling."]
    #[inline(always)]
    pub fn fes(&self) -> FES_R {
        FES_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Transmit synchronization bypass in synchronous slave mode."]
    #[inline(always)]
    pub fn tsbypass(&self) -> TSBYPASS_R {
        TSBYPASS_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Continuous master clock enable (used only when CSRC is 1)"]
    #[inline(always)]
    pub fn cscen(&self) -> CSCEN_R {
        CSCEN_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Start/stop bits"]
    #[inline(always)]
    pub fn sssdis(&self) -> SSSDIS_R {
        SSSDIS_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Continuous clock clear"]
    #[inline(always)]
    pub fn ccclr(&self) -> CCCLR_R {
        CCCLR_R::new(((self.bits >> 6) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Enables synchronous mode."]
    #[inline(always)]
    pub fn sync(&mut self) -> SYNC_W {
        SYNC_W { w: self }
    }
    #[doc = "Bit 1 - Clock source select."]
    #[inline(always)]
    pub fn csrc(&mut self) -> CSRC_W {
        CSRC_W { w: self }
    }
    #[doc = "Bit 2 - Edge sampling."]
    #[inline(always)]
    pub fn fes(&mut self) -> FES_W {
        FES_W { w: self }
    }
    #[doc = "Bit 3 - Transmit synchronization bypass in synchronous slave mode."]
    #[inline(always)]
    pub fn tsbypass(&mut self) -> TSBYPASS_W {
        TSBYPASS_W { w: self }
    }
    #[doc = "Bit 4 - Continuous master clock enable (used only when CSRC is 1)"]
    #[inline(always)]
    pub fn cscen(&mut self) -> CSCEN_W {
        CSCEN_W { w: self }
    }
    #[doc = "Bit 5 - Start/stop bits"]
    #[inline(always)]
    pub fn sssdis(&mut self) -> SSSDIS_W {
        SSSDIS_W { w: self }
    }
    #[doc = "Bit 6 - Continuous clock clear"]
    #[inline(always)]
    pub fn ccclr(&mut self) -> CCCLR_W {
        CCCLR_W { w: self }
    }
}
