#[doc = "Reader of register OTGSC"]
pub type R = crate::R<u32, super::OTGSC>;
#[doc = "Writer for register OTGSC"]
pub type W = crate::W<u32, super::OTGSC>;
#[doc = "Register OTGSC `reset()`'s with value 0"]
impl crate::ResetValue for super::OTGSC {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `VD`"]
pub type VD_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `VD`"]
pub struct VD_W<'a> {
    w: &'a mut W,
}
impl<'a> VD_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Reader of field `VC`"]
pub type VC_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `VC`"]
pub struct VC_W<'a> {
    w: &'a mut W,
}
impl<'a> VC_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Hardware assist auto_reset\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HAAR_A {
    #[doc = "0: Disabled"]
    DISABLED = 0,
    #[doc = "1: Enable automatic reset after connect on host port."]
    ENABLE_AUTOMATIC_RESET_AFTER_CONNECT = 1,
}
impl From<HAAR_A> for bool {
    #[inline(always)]
    fn from(variant: HAAR_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `HAAR`"]
pub type HAAR_R = crate::R<bool, HAAR_A>;
impl HAAR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> HAAR_A {
        match self.bits {
            false => HAAR_A::DISABLED,
            true => HAAR_A::ENABLE_AUTOMATIC_RESET_AFTER_CONNECT,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == HAAR_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLE_AUTOMATIC_RESET_AFTER_CONNECT`"]
    #[inline(always)]
    pub fn is_enable_automatic_reset_after_connect(&self) -> bool {
        *self == HAAR_A::ENABLE_AUTOMATIC_RESET_AFTER_CONNECT
    }
}
#[doc = "Write proxy for field `HAAR`"]
pub struct HAAR_W<'a> {
    w: &'a mut W,
}
impl<'a> HAAR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: HAAR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(HAAR_A::DISABLED)
    }
    #[doc = "Enable automatic reset after connect on host port."]
    #[inline(always)]
    pub fn enable_automatic_reset_after_connect(self) -> &'a mut W {
        self.variant(HAAR_A::ENABLE_AUTOMATIC_RESET_AFTER_CONNECT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Reader of field `OT`"]
pub type OT_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `OT`"]
pub struct OT_W<'a> {
    w: &'a mut W,
}
impl<'a> OT_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Reader of field `DP`"]
pub type DP_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DP`"]
pub struct DP_W<'a> {
    w: &'a mut W,
}
impl<'a> DP_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "ID pull-up. This bit provides control over the pull-up resistor.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IDPU_A {
    #[doc = "0: Pull-up off. The ID bit will not be sampled."]
    PULL_UP_OFF_THE_ID = 0,
    #[doc = "1: Pull-up on."]
    PULL_UP_ON = 1,
}
impl From<IDPU_A> for bool {
    #[inline(always)]
    fn from(variant: IDPU_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `IDPU`"]
pub type IDPU_R = crate::R<bool, IDPU_A>;
impl IDPU_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> IDPU_A {
        match self.bits {
            false => IDPU_A::PULL_UP_OFF_THE_ID,
            true => IDPU_A::PULL_UP_ON,
        }
    }
    #[doc = "Checks if the value of the field is `PULL_UP_OFF_THE_ID`"]
    #[inline(always)]
    pub fn is_pull_up_off_the_id(&self) -> bool {
        *self == IDPU_A::PULL_UP_OFF_THE_ID
    }
    #[doc = "Checks if the value of the field is `PULL_UP_ON`"]
    #[inline(always)]
    pub fn is_pull_up_on(&self) -> bool {
        *self == IDPU_A::PULL_UP_ON
    }
}
#[doc = "Write proxy for field `IDPU`"]
pub struct IDPU_W<'a> {
    w: &'a mut W,
}
impl<'a> IDPU_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: IDPU_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Pull-up off. The ID bit will not be sampled."]
    #[inline(always)]
    pub fn pull_up_off_the_id(self) -> &'a mut W {
        self.variant(IDPU_A::PULL_UP_OFF_THE_ID)
    }
    #[doc = "Pull-up on."]
    #[inline(always)]
    pub fn pull_up_on(self) -> &'a mut W {
        self.variant(IDPU_A::PULL_UP_ON)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Reader of field `HADP`"]
pub type HADP_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `HADP`"]
pub struct HADP_W<'a> {
    w: &'a mut W,
}
impl<'a> HADP_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Hardware assist B-disconnect to A-connect\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HABA_A {
    #[doc = "0: Disabled."]
    DISABLED = 0,
    #[doc = "1: Enable automatic B-disconnect to A-connect sequence."]
    ENABLE_AUTOMATIC_B_DISCONNECT = 1,
}
impl From<HABA_A> for bool {
    #[inline(always)]
    fn from(variant: HABA_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `HABA`"]
pub type HABA_R = crate::R<bool, HABA_A>;
impl HABA_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> HABA_A {
        match self.bits {
            false => HABA_A::DISABLED,
            true => HABA_A::ENABLE_AUTOMATIC_B_DISCONNECT,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == HABA_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLE_AUTOMATIC_B_DISCONNECT`"]
    #[inline(always)]
    pub fn is_enable_automatic_b_disconnect(&self) -> bool {
        *self == HABA_A::ENABLE_AUTOMATIC_B_DISCONNECT
    }
}
#[doc = "Write proxy for field `HABA`"]
pub struct HABA_W<'a> {
    w: &'a mut W,
}
impl<'a> HABA_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: HABA_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(HABA_A::DISABLED)
    }
    #[doc = "Enable automatic B-disconnect to A-connect sequence."]
    #[inline(always)]
    pub fn enable_automatic_b_disconnect(self) -> &'a mut W {
        self.variant(HABA_A::ENABLE_AUTOMATIC_B_DISCONNECT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "USB ID\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ID_A {
    #[doc = "0: A-device"]
    A_DEVICE = 0,
    #[doc = "1: B-device"]
    B_DEVICE = 1,
}
impl From<ID_A> for bool {
    #[inline(always)]
    fn from(variant: ID_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ID`"]
pub type ID_R = crate::R<bool, ID_A>;
impl ID_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ID_A {
        match self.bits {
            false => ID_A::A_DEVICE,
            true => ID_A::B_DEVICE,
        }
    }
    #[doc = "Checks if the value of the field is `A_DEVICE`"]
    #[inline(always)]
    pub fn is_a_device(&self) -> bool {
        *self == ID_A::A_DEVICE
    }
    #[doc = "Checks if the value of the field is `B_DEVICE`"]
    #[inline(always)]
    pub fn is_b_device(&self) -> bool {
        *self == ID_A::B_DEVICE
    }
}
#[doc = "Write proxy for field `ID`"]
pub struct ID_W<'a> {
    w: &'a mut W,
}
impl<'a> ID_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ID_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "A-device"]
    #[inline(always)]
    pub fn a_device(self) -> &'a mut W {
        self.variant(ID_A::A_DEVICE)
    }
    #[doc = "B-device"]
    #[inline(always)]
    pub fn b_device(self) -> &'a mut W {
        self.variant(ID_A::B_DEVICE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Reader of field `AVV`"]
pub type AVV_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `AVV`"]
pub struct AVV_W<'a> {
    w: &'a mut W,
}
impl<'a> AVV_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "Reader of field `ASV`"]
pub type ASV_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ASV`"]
pub struct ASV_W<'a> {
    w: &'a mut W,
}
impl<'a> ASV_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "Reader of field `BSV`"]
pub type BSV_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `BSV`"]
pub struct BSV_W<'a> {
    w: &'a mut W,
}
impl<'a> BSV_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Reader of field `BSE`"]
pub type BSE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `BSE`"]
pub struct BSE_W<'a> {
    w: &'a mut W,
}
impl<'a> BSE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Reader of field `MS1T`"]
pub type MS1T_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `MS1T`"]
pub struct MS1T_W<'a> {
    w: &'a mut W,
}
impl<'a> MS1T_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Reader of field `DPS`"]
pub type DPS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DPS`"]
pub struct DPS_W<'a> {
    w: &'a mut W,
}
impl<'a> DPS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Reader of field `IDIS`"]
pub type IDIS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `IDIS`"]
pub struct IDIS_W<'a> {
    w: &'a mut W,
}
impl<'a> IDIS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Reader of field `AVVIS`"]
pub type AVVIS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `AVVIS`"]
pub struct AVVIS_W<'a> {
    w: &'a mut W,
}
impl<'a> AVVIS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 17)) | (((value as u32) & 0x01) << 17);
        self.w
    }
}
#[doc = "Reader of field `ASVIS`"]
pub type ASVIS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ASVIS`"]
pub struct ASVIS_W<'a> {
    w: &'a mut W,
}
impl<'a> ASVIS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 18)) | (((value as u32) & 0x01) << 18);
        self.w
    }
}
#[doc = "Reader of field `BSVIS`"]
pub type BSVIS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `BSVIS`"]
pub struct BSVIS_W<'a> {
    w: &'a mut W,
}
impl<'a> BSVIS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 19)) | (((value as u32) & 0x01) << 19);
        self.w
    }
}
#[doc = "Reader of field `BSEIS`"]
pub type BSEIS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `BSEIS`"]
pub struct BSEIS_W<'a> {
    w: &'a mut W,
}
impl<'a> BSEIS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 20)) | (((value as u32) & 0x01) << 20);
        self.w
    }
}
#[doc = "Reader of field `ms1S`"]
pub type MS1S_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ms1S`"]
pub struct MS1S_W<'a> {
    w: &'a mut W,
}
impl<'a> MS1S_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | (((value as u32) & 0x01) << 21);
        self.w
    }
}
#[doc = "Reader of field `DPIS`"]
pub type DPIS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DPIS`"]
pub struct DPIS_W<'a> {
    w: &'a mut W,
}
impl<'a> DPIS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 22)) | (((value as u32) & 0x01) << 22);
        self.w
    }
}
#[doc = "Reader of field `IDIE`"]
pub type IDIE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `IDIE`"]
pub struct IDIE_W<'a> {
    w: &'a mut W,
}
impl<'a> IDIE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | (((value as u32) & 0x01) << 24);
        self.w
    }
}
#[doc = "Reader of field `AVVIE`"]
pub type AVVIE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `AVVIE`"]
pub struct AVVIE_W<'a> {
    w: &'a mut W,
}
impl<'a> AVVIE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 25)) | (((value as u32) & 0x01) << 25);
        self.w
    }
}
#[doc = "Reader of field `ASVIE`"]
pub type ASVIE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ASVIE`"]
pub struct ASVIE_W<'a> {
    w: &'a mut W,
}
impl<'a> ASVIE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 26)) | (((value as u32) & 0x01) << 26);
        self.w
    }
}
#[doc = "Reader of field `BSVIE`"]
pub type BSVIE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `BSVIE`"]
pub struct BSVIE_W<'a> {
    w: &'a mut W,
}
impl<'a> BSVIE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 27)) | (((value as u32) & 0x01) << 27);
        self.w
    }
}
#[doc = "Reader of field `BSEIE`"]
pub type BSEIE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `BSEIE`"]
pub struct BSEIE_W<'a> {
    w: &'a mut W,
}
impl<'a> BSEIE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 28)) | (((value as u32) & 0x01) << 28);
        self.w
    }
}
#[doc = "Reader of field `MS1E`"]
pub type MS1E_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `MS1E`"]
pub struct MS1E_W<'a> {
    w: &'a mut W,
}
impl<'a> MS1E_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 29)) | (((value as u32) & 0x01) << 29);
        self.w
    }
}
#[doc = "Reader of field `DPIE`"]
pub type DPIE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DPIE`"]
pub struct DPIE_W<'a> {
    w: &'a mut W,
}
impl<'a> DPIE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 30)) | (((value as u32) & 0x01) << 30);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - VBUS_Discharge Setting this bit to 1 causes VBUS to discharge through a resistor."]
    #[inline(always)]
    pub fn vd(&self) -> VD_R {
        VD_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - VBUS_Charge Setting this bit to 1 causes the VBUS line to be charged. This is used for VBUS pulsing during SRP."]
    #[inline(always)]
    pub fn vc(&self) -> VC_R {
        VC_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Hardware assist auto_reset"]
    #[inline(always)]
    pub fn haar(&self) -> HAAR_R {
        HAAR_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - OTG termination This bit must be set to 1 when the OTG controller is in device mode. This controls the pull-down on USB_DM."]
    #[inline(always)]
    pub fn ot(&self) -> OT_R {
        OT_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Data pulsing Setting this bit to 1 causes the pull-up on USB_DP to be asserted for data pulsing during SRP."]
    #[inline(always)]
    pub fn dp(&self) -> DP_R {
        DP_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - ID pull-up. This bit provides control over the pull-up resistor."]
    #[inline(always)]
    pub fn idpu(&self) -> IDPU_R {
        IDPU_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Hardware assist data pulse Write a 1 to start data pulse sequence."]
    #[inline(always)]
    pub fn hadp(&self) -> HADP_R {
        HADP_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Hardware assist B-disconnect to A-connect"]
    #[inline(always)]
    pub fn haba(&self) -> HABA_R {
        HABA_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - USB ID"]
    #[inline(always)]
    pub fn id(&self) -> ID_R {
        ID_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - A-VBUS valid Reading 1 indicates that VBUS is above the A-VBUS valid threshold."]
    #[inline(always)]
    pub fn avv(&self) -> AVV_R {
        AVV_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - A-session valid Reading 1 indicates that VBUS is above the A-session valid threshold."]
    #[inline(always)]
    pub fn asv(&self) -> ASV_R {
        ASV_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - B-session valid Reading 1 indicates that VBUS is above the B-session valid threshold."]
    #[inline(always)]
    pub fn bsv(&self) -> BSV_R {
        BSV_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - B-session end Reading 1 indicates that VBUS is below the B-session end threshold."]
    #[inline(always)]
    pub fn bse(&self) -> BSE_R {
        BSE_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - 1 millisecond timer toggle This bit toggles once per millisecond."]
    #[inline(always)]
    pub fn ms1t(&self) -> MS1T_R {
        MS1T_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Data bus pulsing status Reading a 1 indicates that data bus pulsing is detected on the port."]
    #[inline(always)]
    pub fn dps(&self) -> DPS_R {
        DPS_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 16 - USB ID interrupt status This bit is set when a change on the ID input has been detected. Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn idis(&self) -> IDIS_R {
        IDIS_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - A-VBUS valid interrupt status This bit is set then VBUS has either risen above or fallen below the A-VBUS valid threshold (4.4 V on an A-device). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn avvis(&self) -> AVVIS_R {
        AVVIS_R::new(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - A-Session valid interrupt status This bit is set then VBUS has either risen above or fallen below the A-session valid threshold (0.8 V). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn asvis(&self) -> ASVIS_R {
        ASVIS_R::new(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - B-Session valid interrupt status This bit is set then VBUS has either risen above or fallen below the B-session valid threshold (0.8 V). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn bsvis(&self) -> BSVIS_R {
        BSVIS_R::new(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - B-Session end interrupt status This bit is set then VBUS has fallen below the B-session end threshold. Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn bseis(&self) -> BSEIS_R {
        BSEIS_R::new(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - 1 millisecond timer interrupt status This bit is set once every millisecond. Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn ms1s(&self) -> MS1S_R {
        MS1S_R::new(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Data pulse interrupt status This bit is set when data bus pulsing occurs on DP or DM. Data bus pulsing is only detected when the CM bit in USBMODE = Host (11) and the PortPower bit in PORTSC = Off (0). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn dpis(&self) -> DPIS_R {
        DPIS_R::new(((self.bits >> 22) & 0x01) != 0)
    }
    #[doc = "Bit 24 - USB ID interrupt enable Setting this bit enables the interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn idie(&self) -> IDIE_R {
        IDIE_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bit 25 - A-VBUS valid interrupt enable Setting this bit enables the A-VBUS valid interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn avvie(&self) -> AVVIE_R {
        AVVIE_R::new(((self.bits >> 25) & 0x01) != 0)
    }
    #[doc = "Bit 26 - A-session valid interrupt enable Setting this bit enables the A-session valid interrupt. Writing a 0 disables the interrupt"]
    #[inline(always)]
    pub fn asvie(&self) -> ASVIE_R {
        ASVIE_R::new(((self.bits >> 26) & 0x01) != 0)
    }
    #[doc = "Bit 27 - B-session valid interrupt enable Setting this bit enables the B-session valid interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn bsvie(&self) -> BSVIE_R {
        BSVIE_R::new(((self.bits >> 27) & 0x01) != 0)
    }
    #[doc = "Bit 28 - B-session end interrupt enable Setting this bit enables the B-session end interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn bseie(&self) -> BSEIE_R {
        BSEIE_R::new(((self.bits >> 28) & 0x01) != 0)
    }
    #[doc = "Bit 29 - 1 millisecond timer interrupt enable Setting this bit enables the 1 millisecond timer interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn ms1e(&self) -> MS1E_R {
        MS1E_R::new(((self.bits >> 29) & 0x01) != 0)
    }
    #[doc = "Bit 30 - Data pulse interrupt enable Setting this bit enables the data pulse interrupt. Writing a 0 disables the interrupt"]
    #[inline(always)]
    pub fn dpie(&self) -> DPIE_R {
        DPIE_R::new(((self.bits >> 30) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - VBUS_Discharge Setting this bit to 1 causes VBUS to discharge through a resistor."]
    #[inline(always)]
    pub fn vd(&mut self) -> VD_W {
        VD_W { w: self }
    }
    #[doc = "Bit 1 - VBUS_Charge Setting this bit to 1 causes the VBUS line to be charged. This is used for VBUS pulsing during SRP."]
    #[inline(always)]
    pub fn vc(&mut self) -> VC_W {
        VC_W { w: self }
    }
    #[doc = "Bit 2 - Hardware assist auto_reset"]
    #[inline(always)]
    pub fn haar(&mut self) -> HAAR_W {
        HAAR_W { w: self }
    }
    #[doc = "Bit 3 - OTG termination This bit must be set to 1 when the OTG controller is in device mode. This controls the pull-down on USB_DM."]
    #[inline(always)]
    pub fn ot(&mut self) -> OT_W {
        OT_W { w: self }
    }
    #[doc = "Bit 4 - Data pulsing Setting this bit to 1 causes the pull-up on USB_DP to be asserted for data pulsing during SRP."]
    #[inline(always)]
    pub fn dp(&mut self) -> DP_W {
        DP_W { w: self }
    }
    #[doc = "Bit 5 - ID pull-up. This bit provides control over the pull-up resistor."]
    #[inline(always)]
    pub fn idpu(&mut self) -> IDPU_W {
        IDPU_W { w: self }
    }
    #[doc = "Bit 6 - Hardware assist data pulse Write a 1 to start data pulse sequence."]
    #[inline(always)]
    pub fn hadp(&mut self) -> HADP_W {
        HADP_W { w: self }
    }
    #[doc = "Bit 7 - Hardware assist B-disconnect to A-connect"]
    #[inline(always)]
    pub fn haba(&mut self) -> HABA_W {
        HABA_W { w: self }
    }
    #[doc = "Bit 8 - USB ID"]
    #[inline(always)]
    pub fn id(&mut self) -> ID_W {
        ID_W { w: self }
    }
    #[doc = "Bit 9 - A-VBUS valid Reading 1 indicates that VBUS is above the A-VBUS valid threshold."]
    #[inline(always)]
    pub fn avv(&mut self) -> AVV_W {
        AVV_W { w: self }
    }
    #[doc = "Bit 10 - A-session valid Reading 1 indicates that VBUS is above the A-session valid threshold."]
    #[inline(always)]
    pub fn asv(&mut self) -> ASV_W {
        ASV_W { w: self }
    }
    #[doc = "Bit 11 - B-session valid Reading 1 indicates that VBUS is above the B-session valid threshold."]
    #[inline(always)]
    pub fn bsv(&mut self) -> BSV_W {
        BSV_W { w: self }
    }
    #[doc = "Bit 12 - B-session end Reading 1 indicates that VBUS is below the B-session end threshold."]
    #[inline(always)]
    pub fn bse(&mut self) -> BSE_W {
        BSE_W { w: self }
    }
    #[doc = "Bit 13 - 1 millisecond timer toggle This bit toggles once per millisecond."]
    #[inline(always)]
    pub fn ms1t(&mut self) -> MS1T_W {
        MS1T_W { w: self }
    }
    #[doc = "Bit 14 - Data bus pulsing status Reading a 1 indicates that data bus pulsing is detected on the port."]
    #[inline(always)]
    pub fn dps(&mut self) -> DPS_W {
        DPS_W { w: self }
    }
    #[doc = "Bit 16 - USB ID interrupt status This bit is set when a change on the ID input has been detected. Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn idis(&mut self) -> IDIS_W {
        IDIS_W { w: self }
    }
    #[doc = "Bit 17 - A-VBUS valid interrupt status This bit is set then VBUS has either risen above or fallen below the A-VBUS valid threshold (4.4 V on an A-device). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn avvis(&mut self) -> AVVIS_W {
        AVVIS_W { w: self }
    }
    #[doc = "Bit 18 - A-Session valid interrupt status This bit is set then VBUS has either risen above or fallen below the A-session valid threshold (0.8 V). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn asvis(&mut self) -> ASVIS_W {
        ASVIS_W { w: self }
    }
    #[doc = "Bit 19 - B-Session valid interrupt status This bit is set then VBUS has either risen above or fallen below the B-session valid threshold (0.8 V). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn bsvis(&mut self) -> BSVIS_W {
        BSVIS_W { w: self }
    }
    #[doc = "Bit 20 - B-Session end interrupt status This bit is set then VBUS has fallen below the B-session end threshold. Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn bseis(&mut self) -> BSEIS_W {
        BSEIS_W { w: self }
    }
    #[doc = "Bit 21 - 1 millisecond timer interrupt status This bit is set once every millisecond. Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn ms1s(&mut self) -> MS1S_W {
        MS1S_W { w: self }
    }
    #[doc = "Bit 22 - Data pulse interrupt status This bit is set when data bus pulsing occurs on DP or DM. Data bus pulsing is only detected when the CM bit in USBMODE = Host (11) and the PortPower bit in PORTSC = Off (0). Software must write a 1 to this bit to clear it."]
    #[inline(always)]
    pub fn dpis(&mut self) -> DPIS_W {
        DPIS_W { w: self }
    }
    #[doc = "Bit 24 - USB ID interrupt enable Setting this bit enables the interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn idie(&mut self) -> IDIE_W {
        IDIE_W { w: self }
    }
    #[doc = "Bit 25 - A-VBUS valid interrupt enable Setting this bit enables the A-VBUS valid interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn avvie(&mut self) -> AVVIE_W {
        AVVIE_W { w: self }
    }
    #[doc = "Bit 26 - A-session valid interrupt enable Setting this bit enables the A-session valid interrupt. Writing a 0 disables the interrupt"]
    #[inline(always)]
    pub fn asvie(&mut self) -> ASVIE_W {
        ASVIE_W { w: self }
    }
    #[doc = "Bit 27 - B-session valid interrupt enable Setting this bit enables the B-session valid interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn bsvie(&mut self) -> BSVIE_W {
        BSVIE_W { w: self }
    }
    #[doc = "Bit 28 - B-session end interrupt enable Setting this bit enables the B-session end interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn bseie(&mut self) -> BSEIE_W {
        BSEIE_W { w: self }
    }
    #[doc = "Bit 29 - 1 millisecond timer interrupt enable Setting this bit enables the 1 millisecond timer interrupt. Writing a 0 disables the interrupt."]
    #[inline(always)]
    pub fn ms1e(&mut self) -> MS1E_W {
        MS1E_W { w: self }
    }
    #[doc = "Bit 30 - Data pulse interrupt enable Setting this bit enables the data pulse interrupt. Writing a 0 disables the interrupt"]
    #[inline(always)]
    pub fn dpie(&mut self) -> DPIE_W {
        DPIE_W { w: self }
    }
}
