#[doc = "Reader of register PORTSC1_D"]
pub type R = crate::R<u32, super::PORTSC1_D>;
#[doc = "Writer for register PORTSC1_D"]
pub type W = crate::W<u32, super::PORTSC1_D>;
#[doc = "Register PORTSC1_D `reset()`'s with value 0"]
impl crate::ResetValue for super::PORTSC1_D {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Current connect status\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CCS_A {
    #[doc = "0: Device not attached A zero indicates that the device did not attach successfully or was forcibly disconnected by the software writing a zero to the Run bit in the USBCMD register. It does not state the device being disconnected or suspended."]
    DEVICE_NOT_ATTACHED = 0,
    #[doc = "1: Device attached.  A one indicates that the device successfully attached and is operating in either high-speed mode or full-speed mode as indicated by the High Speed Port bit in this register."]
    DEVICE_ATTACHED_A = 1,
}
impl From<CCS_A> for bool {
    #[inline(always)]
    fn from(variant: CCS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `CCS`"]
pub type CCS_R = crate::R<bool, CCS_A>;
impl CCS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CCS_A {
        match self.bits {
            false => CCS_A::DEVICE_NOT_ATTACHED,
            true => CCS_A::DEVICE_ATTACHED_A,
        }
    }
    #[doc = "Checks if the value of the field is `DEVICE_NOT_ATTACHED`"]
    #[inline(always)]
    pub fn is_device_not_attached(&self) -> bool {
        *self == CCS_A::DEVICE_NOT_ATTACHED
    }
    #[doc = "Checks if the value of the field is `DEVICE_ATTACHED_A`"]
    #[inline(always)]
    pub fn is_device_attached_a(&self) -> bool {
        *self == CCS_A::DEVICE_ATTACHED_A
    }
}
#[doc = "Write proxy for field `CCS`"]
pub struct CCS_W<'a> {
    w: &'a mut W,
}
impl<'a> CCS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CCS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Device not attached A zero indicates that the device did not attach successfully or was forcibly disconnected by the software writing a zero to the Run bit in the USBCMD register. It does not state the device being disconnected or suspended."]
    #[inline(always)]
    pub fn device_not_attached(self) -> &'a mut W {
        self.variant(CCS_A::DEVICE_NOT_ATTACHED)
    }
    #[doc = "Device attached. A one indicates that the device successfully attached and is operating in either high-speed mode or full-speed mode as indicated by the High Speed Port bit in this register."]
    #[inline(always)]
    pub fn device_attached_a(self) -> &'a mut W {
        self.variant(CCS_A::DEVICE_ATTACHED_A)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Reader of field `PE`"]
pub type PE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `PE`"]
pub struct PE_W<'a> {
    w: &'a mut W,
}
impl<'a> PE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Reader of field `PEC`"]
pub type PEC_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `PEC`"]
pub struct PEC_W<'a> {
    w: &'a mut W,
}
impl<'a> PEC_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Force port resume After the device has been in Suspend State for 5 ms or more, software must set this bit to one to drive resume signaling before clearing. The Device Controller will set this bit to one if a J-to-K transition is detected while the port is in the Suspend state. The bit will be cleared when the device returns to normal operation. When this bit transitions to a one because a J-to-K transition detected, the Port Change Detect bit in the USBSTS register is set to one as well.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FPR_A {
    #[doc = "0: No resume (K-state) detected/driven on port."]
    NO_RESUME = 0,
    #[doc = "1: Resume detected/driven on port."]
    RESUME_DETECTED = 1,
}
impl From<FPR_A> for bool {
    #[inline(always)]
    fn from(variant: FPR_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `FPR`"]
pub type FPR_R = crate::R<bool, FPR_A>;
impl FPR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FPR_A {
        match self.bits {
            false => FPR_A::NO_RESUME,
            true => FPR_A::RESUME_DETECTED,
        }
    }
    #[doc = "Checks if the value of the field is `NO_RESUME`"]
    #[inline(always)]
    pub fn is_no_resume(&self) -> bool {
        *self == FPR_A::NO_RESUME
    }
    #[doc = "Checks if the value of the field is `RESUME_DETECTED`"]
    #[inline(always)]
    pub fn is_resume_detected(&self) -> bool {
        *self == FPR_A::RESUME_DETECTED
    }
}
#[doc = "Write proxy for field `FPR`"]
pub struct FPR_W<'a> {
    w: &'a mut W,
}
impl<'a> FPR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FPR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No resume (K-state) detected/driven on port."]
    #[inline(always)]
    pub fn no_resume(self) -> &'a mut W {
        self.variant(FPR_A::NO_RESUME)
    }
    #[doc = "Resume detected/driven on port."]
    #[inline(always)]
    pub fn resume_detected(self) -> &'a mut W {
        self.variant(FPR_A::RESUME_DETECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Suspend In device mode, this is a read-only status bit .\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SUSP_A {
    #[doc = "0: Port not in suspend state"]
    PORT_NOT_IN_SUSPEND = 0,
    #[doc = "1: Port in suspend state"]
    PORT_IN_SUSPEND_STATE = 1,
}
impl From<SUSP_A> for bool {
    #[inline(always)]
    fn from(variant: SUSP_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SUSP`"]
pub type SUSP_R = crate::R<bool, SUSP_A>;
impl SUSP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SUSP_A {
        match self.bits {
            false => SUSP_A::PORT_NOT_IN_SUSPEND,
            true => SUSP_A::PORT_IN_SUSPEND_STATE,
        }
    }
    #[doc = "Checks if the value of the field is `PORT_NOT_IN_SUSPEND`"]
    #[inline(always)]
    pub fn is_port_not_in_suspend(&self) -> bool {
        *self == SUSP_A::PORT_NOT_IN_SUSPEND
    }
    #[doc = "Checks if the value of the field is `PORT_IN_SUSPEND_STATE`"]
    #[inline(always)]
    pub fn is_port_in_suspend_state(&self) -> bool {
        *self == SUSP_A::PORT_IN_SUSPEND_STATE
    }
}
#[doc = "Write proxy for field `SUSP`"]
pub struct SUSP_W<'a> {
    w: &'a mut W,
}
impl<'a> SUSP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SUSP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port not in suspend state"]
    #[inline(always)]
    pub fn port_not_in_suspend(self) -> &'a mut W {
        self.variant(SUSP_A::PORT_NOT_IN_SUSPEND)
    }
    #[doc = "Port in suspend state"]
    #[inline(always)]
    pub fn port_in_suspend_state(self) -> &'a mut W {
        self.variant(SUSP_A::PORT_IN_SUSPEND_STATE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Port reset In device mode, this is a read-only status bit. A device reset from the USB bus is also indicated in the USBSTS register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PR_A {
    #[doc = "0: Port is not in the reset state."]
    PORT_IS_NOT_IN_THE_RESET_STATE = 0,
    #[doc = "1: Port is in the reset state."]
    PORT_IS_IN_THE_RESET_STATE = 1,
}
impl From<PR_A> for bool {
    #[inline(always)]
    fn from(variant: PR_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PR`"]
pub type PR_R = crate::R<bool, PR_A>;
impl PR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PR_A {
        match self.bits {
            false => PR_A::PORT_IS_NOT_IN_THE_RESET_STATE,
            true => PR_A::PORT_IS_IN_THE_RESET_STATE,
        }
    }
    #[doc = "Checks if the value of the field is `PORT_IS_NOT_IN_THE_RESET_STATE`"]
    #[inline(always)]
    pub fn is_port_is_not_in_the_reset_state(&self) -> bool {
        *self == PR_A::PORT_IS_NOT_IN_THE_RESET_STATE
    }
    #[doc = "Checks if the value of the field is `PORT_IS_IN_THE_RESET_STATE`"]
    #[inline(always)]
    pub fn is_port_is_in_the_reset_state(&self) -> bool {
        *self == PR_A::PORT_IS_IN_THE_RESET_STATE
    }
}
#[doc = "Write proxy for field `PR`"]
pub struct PR_W<'a> {
    w: &'a mut W,
}
impl<'a> PR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port is not in the reset state."]
    #[inline(always)]
    pub fn port_is_not_in_the_reset_state(self) -> &'a mut W {
        self.variant(PR_A::PORT_IS_NOT_IN_THE_RESET_STATE)
    }
    #[doc = "Port is in the reset state."]
    #[inline(always)]
    pub fn port_is_in_the_reset_state(self) -> &'a mut W {
        self.variant(PR_A::PORT_IS_IN_THE_RESET_STATE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "High-speed status This bit is redundant with bits 27:26 (PSPD) in this register. It is implemented for compatibility reasons.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HSP_A {
    #[doc = "0: Host/device connected to the port is not in High-speed mode."]
    NOT_HIGHSSPEED = 0,
    #[doc = "1: Host/device connected to the port is in High-speed mode."]
    HIGHSPEED = 1,
}
impl From<HSP_A> for bool {
    #[inline(always)]
    fn from(variant: HSP_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `HSP`"]
pub type HSP_R = crate::R<bool, HSP_A>;
impl HSP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> HSP_A {
        match self.bits {
            false => HSP_A::NOT_HIGHSSPEED,
            true => HSP_A::HIGHSPEED,
        }
    }
    #[doc = "Checks if the value of the field is `NOT_HIGHSSPEED`"]
    #[inline(always)]
    pub fn is_not_highsspeed(&self) -> bool {
        *self == HSP_A::NOT_HIGHSSPEED
    }
    #[doc = "Checks if the value of the field is `HIGHSPEED`"]
    #[inline(always)]
    pub fn is_highspeed(&self) -> bool {
        *self == HSP_A::HIGHSPEED
    }
}
#[doc = "Write proxy for field `HSP`"]
pub struct HSP_W<'a> {
    w: &'a mut W,
}
impl<'a> HSP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: HSP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Host/device connected to the port is not in High-speed mode."]
    #[inline(always)]
    pub fn not_highsspeed(self) -> &'a mut W {
        self.variant(HSP_A::NOT_HIGHSSPEED)
    }
    #[doc = "Host/device connected to the port is in High-speed mode."]
    #[inline(always)]
    pub fn highspeed(self) -> &'a mut W {
        self.variant(HSP_A::HIGHSPEED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "Port indicator control Writing to this field effects the value of the USB0_IND\\[1:0\\]
pins.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PIC1_0_A {
    #[doc = "0: Port indicators are off."]
    OFF = 0,
    #[doc = "1: amber"]
    AMBER = 1,
    #[doc = "2: green"]
    GREEN = 2,
    #[doc = "3: undefined"]
    UNDEFINED = 3,
}
impl From<PIC1_0_A> for u8 {
    #[inline(always)]
    fn from(variant: PIC1_0_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PIC1_0`"]
pub type PIC1_0_R = crate::R<u8, PIC1_0_A>;
impl PIC1_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PIC1_0_A {
        match self.bits {
            0 => PIC1_0_A::OFF,
            1 => PIC1_0_A::AMBER,
            2 => PIC1_0_A::GREEN,
            3 => PIC1_0_A::UNDEFINED,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `OFF`"]
    #[inline(always)]
    pub fn is_off(&self) -> bool {
        *self == PIC1_0_A::OFF
    }
    #[doc = "Checks if the value of the field is `AMBER`"]
    #[inline(always)]
    pub fn is_amber(&self) -> bool {
        *self == PIC1_0_A::AMBER
    }
    #[doc = "Checks if the value of the field is `GREEN`"]
    #[inline(always)]
    pub fn is_green(&self) -> bool {
        *self == PIC1_0_A::GREEN
    }
    #[doc = "Checks if the value of the field is `UNDEFINED`"]
    #[inline(always)]
    pub fn is_undefined(&self) -> bool {
        *self == PIC1_0_A::UNDEFINED
    }
}
#[doc = "Write proxy for field `PIC1_0`"]
pub struct PIC1_0_W<'a> {
    w: &'a mut W,
}
impl<'a> PIC1_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PIC1_0_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Port indicators are off."]
    #[inline(always)]
    pub fn off(self) -> &'a mut W {
        self.variant(PIC1_0_A::OFF)
    }
    #[doc = "amber"]
    #[inline(always)]
    pub fn amber(self) -> &'a mut W {
        self.variant(PIC1_0_A::AMBER)
    }
    #[doc = "green"]
    #[inline(always)]
    pub fn green(self) -> &'a mut W {
        self.variant(PIC1_0_A::GREEN)
    }
    #[doc = "undefined"]
    #[inline(always)]
    pub fn undefined(self) -> &'a mut W {
        self.variant(PIC1_0_A::UNDEFINED)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 14)) | (((value as u32) & 0x03) << 14);
        self.w
    }
}
#[doc = "Port test control Any value other than 0000 indicates that the port is operating in test mode. The FORCE_ENABLE_FS and FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI specification. Writing the PTC field to any of the FORCE_ENABLE_HS/FS/LS values will force the port into the connected and enabled state at the selected speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state machines to progress normally from that point. Values 0111 to 1111 are not valid.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PTC3_0_A {
    #[doc = "0: TEST_MODE_DISABLE"]
    TEST_MODE_DISABLE = 0,
    #[doc = "1: J_STATE"]
    J_STATE = 1,
    #[doc = "2: K_STATE"]
    K_STATE = 2,
    #[doc = "3: SE0 (host)/NAK (device)"]
    SE0_NAK = 3,
    #[doc = "4: Packet"]
    PACKET = 4,
    #[doc = "5: FORCE_ENABLE_HS"]
    FORCE_ENABLE_HS = 5,
    #[doc = "6: FORCE_ENABLE_FS"]
    FORCE_ENABLE_FS = 6,
}
impl From<PTC3_0_A> for u8 {
    #[inline(always)]
    fn from(variant: PTC3_0_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PTC3_0`"]
pub type PTC3_0_R = crate::R<u8, PTC3_0_A>;
impl PTC3_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, PTC3_0_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(PTC3_0_A::TEST_MODE_DISABLE),
            1 => Val(PTC3_0_A::J_STATE),
            2 => Val(PTC3_0_A::K_STATE),
            3 => Val(PTC3_0_A::SE0_NAK),
            4 => Val(PTC3_0_A::PACKET),
            5 => Val(PTC3_0_A::FORCE_ENABLE_HS),
            6 => Val(PTC3_0_A::FORCE_ENABLE_FS),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `TEST_MODE_DISABLE`"]
    #[inline(always)]
    pub fn is_test_mode_disable(&self) -> bool {
        *self == PTC3_0_A::TEST_MODE_DISABLE
    }
    #[doc = "Checks if the value of the field is `J_STATE`"]
    #[inline(always)]
    pub fn is_j_state(&self) -> bool {
        *self == PTC3_0_A::J_STATE
    }
    #[doc = "Checks if the value of the field is `K_STATE`"]
    #[inline(always)]
    pub fn is_k_state(&self) -> bool {
        *self == PTC3_0_A::K_STATE
    }
    #[doc = "Checks if the value of the field is `SE0_NAK`"]
    #[inline(always)]
    pub fn is_se0_nak(&self) -> bool {
        *self == PTC3_0_A::SE0_NAK
    }
    #[doc = "Checks if the value of the field is `PACKET`"]
    #[inline(always)]
    pub fn is_packet(&self) -> bool {
        *self == PTC3_0_A::PACKET
    }
    #[doc = "Checks if the value of the field is `FORCE_ENABLE_HS`"]
    #[inline(always)]
    pub fn is_force_enable_hs(&self) -> bool {
        *self == PTC3_0_A::FORCE_ENABLE_HS
    }
    #[doc = "Checks if the value of the field is `FORCE_ENABLE_FS`"]
    #[inline(always)]
    pub fn is_force_enable_fs(&self) -> bool {
        *self == PTC3_0_A::FORCE_ENABLE_FS
    }
}
#[doc = "Write proxy for field `PTC3_0`"]
pub struct PTC3_0_W<'a> {
    w: &'a mut W,
}
impl<'a> PTC3_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PTC3_0_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "TEST_MODE_DISABLE"]
    #[inline(always)]
    pub fn test_mode_disable(self) -> &'a mut W {
        self.variant(PTC3_0_A::TEST_MODE_DISABLE)
    }
    #[doc = "J_STATE"]
    #[inline(always)]
    pub fn j_state(self) -> &'a mut W {
        self.variant(PTC3_0_A::J_STATE)
    }
    #[doc = "K_STATE"]
    #[inline(always)]
    pub fn k_state(self) -> &'a mut W {
        self.variant(PTC3_0_A::K_STATE)
    }
    #[doc = "SE0 (host)/NAK (device)"]
    #[inline(always)]
    pub fn se0_nak(self) -> &'a mut W {
        self.variant(PTC3_0_A::SE0_NAK)
    }
    #[doc = "Packet"]
    #[inline(always)]
    pub fn packet(self) -> &'a mut W {
        self.variant(PTC3_0_A::PACKET)
    }
    #[doc = "FORCE_ENABLE_HS"]
    #[inline(always)]
    pub fn force_enable_hs(self) -> &'a mut W {
        self.variant(PTC3_0_A::FORCE_ENABLE_HS)
    }
    #[doc = "FORCE_ENABLE_FS"]
    #[inline(always)]
    pub fn force_enable_fs(self) -> &'a mut W {
        self.variant(PTC3_0_A::FORCE_ENABLE_FS)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 16)) | (((value as u32) & 0x0f) << 16);
        self.w
    }
}
#[doc = "PHY low power suspend - clock disable (PLPSCD) In device mode, The PHY can be put into Low Power Suspend - Clock Disable when the device is not running (USBCMD Run/Stop = 0) or the host has signaled suspend (PORTSC SUSPEND = 1). Low power suspend will be cleared automatically when the host has signaled resume. Before forcing a resume from the device, the device controller driver must clear this bit.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PHCD_A {
    #[doc = "0: Writing a 0 enables the PHY clock. Reading a 0 indicates the status of the PHY clock (enabled)."]
    ENABLE = 0,
    #[doc = "1: Writing a 1 disables the PHY clock. Reading a 1 indicates the status of the PHY clock (disabled)."]
    DISABLE = 1,
}
impl From<PHCD_A> for bool {
    #[inline(always)]
    fn from(variant: PHCD_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PHCD`"]
pub type PHCD_R = crate::R<bool, PHCD_A>;
impl PHCD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PHCD_A {
        match self.bits {
            false => PHCD_A::ENABLE,
            true => PHCD_A::DISABLE,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        *self == PHCD_A::ENABLE
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        *self == PHCD_A::DISABLE
    }
}
#[doc = "Write proxy for field `PHCD`"]
pub struct PHCD_W<'a> {
    w: &'a mut W,
}
impl<'a> PHCD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PHCD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Writing a 0 enables the PHY clock. Reading a 0 indicates the status of the PHY clock (enabled)."]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PHCD_A::ENABLE)
    }
    #[doc = "Writing a 1 disables the PHY clock. Reading a 1 indicates the status of the PHY clock (disabled)."]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PHCD_A::DISABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 23)) | (((value as u32) & 0x01) << 23);
        self.w
    }
}
#[doc = "Port force full speed connect\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PFSC_A {
    #[doc = "0: Port connects at any speed."]
    ANYSPEED = 0,
    #[doc = "1: Writing this bit to a 1 will force the port to only connect at full speed. It disables the chirp sequence that allows the port to identify itself as High-speed. This is useful for testing FS configurations with a HS host, hub or device."]
    FULLSPEED = 1,
}
impl From<PFSC_A> for bool {
    #[inline(always)]
    fn from(variant: PFSC_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PFSC`"]
pub type PFSC_R = crate::R<bool, PFSC_A>;
impl PFSC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PFSC_A {
        match self.bits {
            false => PFSC_A::ANYSPEED,
            true => PFSC_A::FULLSPEED,
        }
    }
    #[doc = "Checks if the value of the field is `ANYSPEED`"]
    #[inline(always)]
    pub fn is_anyspeed(&self) -> bool {
        *self == PFSC_A::ANYSPEED
    }
    #[doc = "Checks if the value of the field is `FULLSPEED`"]
    #[inline(always)]
    pub fn is_fullspeed(&self) -> bool {
        *self == PFSC_A::FULLSPEED
    }
}
#[doc = "Write proxy for field `PFSC`"]
pub struct PFSC_W<'a> {
    w: &'a mut W,
}
impl<'a> PFSC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PFSC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port connects at any speed."]
    #[inline(always)]
    pub fn anyspeed(self) -> &'a mut W {
        self.variant(PFSC_A::ANYSPEED)
    }
    #[doc = "Writing this bit to a 1 will force the port to only connect at full speed. It disables the chirp sequence that allows the port to identify itself as High-speed. This is useful for testing FS configurations with a HS host, hub or device."]
    #[inline(always)]
    pub fn fullspeed(self) -> &'a mut W {
        self.variant(PFSC_A::FULLSPEED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | (((value as u32) & 0x01) << 24);
        self.w
    }
}
#[doc = "Port speed This register field indicates the speed at which the port is operating.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PSPD_A {
    #[doc = "0: Full-speed"]
    FULL_SPEED = 0,
    #[doc = "1: invalid in device mode"]
    INVALID_IN_DEVICE_MODE = 1,
    #[doc = "2: High-speed"]
    HIGH_SPEED = 2,
}
impl From<PSPD_A> for u8 {
    #[inline(always)]
    fn from(variant: PSPD_A) -> Self {
        variant as _
    }
}
#[doc = "Reader of field `PSPD`"]
pub type PSPD_R = crate::R<u8, PSPD_A>;
impl PSPD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, PSPD_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(PSPD_A::FULL_SPEED),
            1 => Val(PSPD_A::INVALID_IN_DEVICE_MODE),
            2 => Val(PSPD_A::HIGH_SPEED),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `FULL_SPEED`"]
    #[inline(always)]
    pub fn is_full_speed(&self) -> bool {
        *self == PSPD_A::FULL_SPEED
    }
    #[doc = "Checks if the value of the field is `INVALID_IN_DEVICE_MODE`"]
    #[inline(always)]
    pub fn is_invalid_in_device_mode(&self) -> bool {
        *self == PSPD_A::INVALID_IN_DEVICE_MODE
    }
    #[doc = "Checks if the value of the field is `HIGH_SPEED`"]
    #[inline(always)]
    pub fn is_high_speed(&self) -> bool {
        *self == PSPD_A::HIGH_SPEED
    }
}
#[doc = "Write proxy for field `PSPD`"]
pub struct PSPD_W<'a> {
    w: &'a mut W,
}
impl<'a> PSPD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PSPD_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Full-speed"]
    #[inline(always)]
    pub fn full_speed(self) -> &'a mut W {
        self.variant(PSPD_A::FULL_SPEED)
    }
    #[doc = "invalid in device mode"]
    #[inline(always)]
    pub fn invalid_in_device_mode(self) -> &'a mut W {
        self.variant(PSPD_A::INVALID_IN_DEVICE_MODE)
    }
    #[doc = "High-speed"]
    #[inline(always)]
    pub fn high_speed(self) -> &'a mut W {
        self.variant(PSPD_A::HIGH_SPEED)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 26)) | (((value as u32) & 0x03) << 26);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Current connect status"]
    #[inline(always)]
    pub fn ccs(&self) -> CCS_R {
        CCS_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 2 - Port enable. This bit is always 1. The device port is always enabled."]
    #[inline(always)]
    pub fn pe(&self) -> PE_R {
        PE_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Port enable/disable change This bit is always 0. The device port is always enabled."]
    #[inline(always)]
    pub fn pec(&self) -> PEC_R {
        PEC_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Force port resume After the device has been in Suspend State for 5 ms or more, software must set this bit to one to drive resume signaling before clearing. The Device Controller will set this bit to one if a J-to-K transition is detected while the port is in the Suspend state. The bit will be cleared when the device returns to normal operation. When this bit transitions to a one because a J-to-K transition detected, the Port Change Detect bit in the USBSTS register is set to one as well."]
    #[inline(always)]
    pub fn fpr(&self) -> FPR_R {
        FPR_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Suspend In device mode, this is a read-only status bit ."]
    #[inline(always)]
    pub fn susp(&self) -> SUSP_R {
        SUSP_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Port reset In device mode, this is a read-only status bit. A device reset from the USB bus is also indicated in the USBSTS register."]
    #[inline(always)]
    pub fn pr(&self) -> PR_R {
        PR_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - High-speed status This bit is redundant with bits 27:26 (PSPD) in this register. It is implemented for compatibility reasons."]
    #[inline(always)]
    pub fn hsp(&self) -> HSP_R {
        HSP_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bits 14:15 - Port indicator control Writing to this field effects the value of the USB0_IND\\[1:0\\]
pins."]
    #[inline(always)]
    pub fn pic1_0(&self) -> PIC1_0_R {
        PIC1_0_R::new(((self.bits >> 14) & 0x03) as u8)
    }
    #[doc = "Bits 16:19 - Port test control Any value other than 0000 indicates that the port is operating in test mode. The FORCE_ENABLE_FS and FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI specification. Writing the PTC field to any of the FORCE_ENABLE_HS/FS/LS values will force the port into the connected and enabled state at the selected speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state machines to progress normally from that point. Values 0111 to 1111 are not valid."]
    #[inline(always)]
    pub fn ptc3_0(&self) -> PTC3_0_R {
        PTC3_0_R::new(((self.bits >> 16) & 0x0f) as u8)
    }
    #[doc = "Bit 23 - PHY low power suspend - clock disable (PLPSCD) In device mode, The PHY can be put into Low Power Suspend - Clock Disable when the device is not running (USBCMD Run/Stop = 0) or the host has signaled suspend (PORTSC SUSPEND = 1). Low power suspend will be cleared automatically when the host has signaled resume. Before forcing a resume from the device, the device controller driver must clear this bit."]
    #[inline(always)]
    pub fn phcd(&self) -> PHCD_R {
        PHCD_R::new(((self.bits >> 23) & 0x01) != 0)
    }
    #[doc = "Bit 24 - Port force full speed connect"]
    #[inline(always)]
    pub fn pfsc(&self) -> PFSC_R {
        PFSC_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bits 26:27 - Port speed This register field indicates the speed at which the port is operating."]
    #[inline(always)]
    pub fn pspd(&self) -> PSPD_R {
        PSPD_R::new(((self.bits >> 26) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Current connect status"]
    #[inline(always)]
    pub fn ccs(&mut self) -> CCS_W {
        CCS_W { w: self }
    }
    #[doc = "Bit 2 - Port enable. This bit is always 1. The device port is always enabled."]
    #[inline(always)]
    pub fn pe(&mut self) -> PE_W {
        PE_W { w: self }
    }
    #[doc = "Bit 3 - Port enable/disable change This bit is always 0. The device port is always enabled."]
    #[inline(always)]
    pub fn pec(&mut self) -> PEC_W {
        PEC_W { w: self }
    }
    #[doc = "Bit 6 - Force port resume After the device has been in Suspend State for 5 ms or more, software must set this bit to one to drive resume signaling before clearing. The Device Controller will set this bit to one if a J-to-K transition is detected while the port is in the Suspend state. The bit will be cleared when the device returns to normal operation. When this bit transitions to a one because a J-to-K transition detected, the Port Change Detect bit in the USBSTS register is set to one as well."]
    #[inline(always)]
    pub fn fpr(&mut self) -> FPR_W {
        FPR_W { w: self }
    }
    #[doc = "Bit 7 - Suspend In device mode, this is a read-only status bit ."]
    #[inline(always)]
    pub fn susp(&mut self) -> SUSP_W {
        SUSP_W { w: self }
    }
    #[doc = "Bit 8 - Port reset In device mode, this is a read-only status bit. A device reset from the USB bus is also indicated in the USBSTS register."]
    #[inline(always)]
    pub fn pr(&mut self) -> PR_W {
        PR_W { w: self }
    }
    #[doc = "Bit 9 - High-speed status This bit is redundant with bits 27:26 (PSPD) in this register. It is implemented for compatibility reasons."]
    #[inline(always)]
    pub fn hsp(&mut self) -> HSP_W {
        HSP_W { w: self }
    }
    #[doc = "Bits 14:15 - Port indicator control Writing to this field effects the value of the USB0_IND\\[1:0\\]
pins."]
    #[inline(always)]
    pub fn pic1_0(&mut self) -> PIC1_0_W {
        PIC1_0_W { w: self }
    }
    #[doc = "Bits 16:19 - Port test control Any value other than 0000 indicates that the port is operating in test mode. The FORCE_ENABLE_FS and FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI specification. Writing the PTC field to any of the FORCE_ENABLE_HS/FS/LS values will force the port into the connected and enabled state at the selected speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state machines to progress normally from that point. Values 0111 to 1111 are not valid."]
    #[inline(always)]
    pub fn ptc3_0(&mut self) -> PTC3_0_W {
        PTC3_0_W { w: self }
    }
    #[doc = "Bit 23 - PHY low power suspend - clock disable (PLPSCD) In device mode, The PHY can be put into Low Power Suspend - Clock Disable when the device is not running (USBCMD Run/Stop = 0) or the host has signaled suspend (PORTSC SUSPEND = 1). Low power suspend will be cleared automatically when the host has signaled resume. Before forcing a resume from the device, the device controller driver must clear this bit."]
    #[inline(always)]
    pub fn phcd(&mut self) -> PHCD_W {
        PHCD_W { w: self }
    }
    #[doc = "Bit 24 - Port force full speed connect"]
    #[inline(always)]
    pub fn pfsc(&mut self) -> PFSC_W {
        PFSC_W { w: self }
    }
    #[doc = "Bits 26:27 - Port speed This register field indicates the speed at which the port is operating."]
    #[inline(always)]
    pub fn pspd(&mut self) -> PSPD_W {
        PSPD_W { w: self }
    }
}
