#[doc = "Reader of register USBSTS_D"]
pub type R = crate::R<u32, super::USBSTS_D>;
#[doc = "Writer for register USBSTS_D"]
pub type W = crate::W<u32, super::USBSTS_D>;
#[doc = "Register USBSTS_D `reset()`'s with value 0"]
impl crate::ResetValue for super::USBSTS_D {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "USB interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST = 0,
    #[doc = "1: This bit is set by the Host/Device Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit is also set by the Host/Device Controller when a short packet is detected. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    CLEAR = 1,
}
impl From<UI_A> for bool {
    #[inline(always)]
    fn from(variant: UI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `UI`"]
pub type UI_R = crate::R<bool, UI_A>;
impl UI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UI_A {
        match self.bits {
            false => UI_A::ST,
            true => UI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == UI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == UI_A::CLEAR
    }
}
#[doc = "Write proxy for field `UI`"]
pub struct UI_W<'a> {
    w: &'a mut W,
}
impl<'a> UI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(UI_A::ST)
    }
    #[doc = "This bit is set by the Host/Device Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit is also set by the Host/Device Controller when a short packet is detected. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(UI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "USB error interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UEI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST = 0,
    #[doc = "1: When completion of a USB transaction results in an error condition, this bit is set by the Host/Device Controller. This bit is set along with the USBINT bit, if the TD on which the error interrupt occurred also had its interrupt on complete (IOC) bit set. The device controller detects resume signaling only (see  Section 18.10.11.6)."]
    CLEAR = 1,
}
impl From<UEI_A> for bool {
    #[inline(always)]
    fn from(variant: UEI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `UEI`"]
pub type UEI_R = crate::R<bool, UEI_A>;
impl UEI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UEI_A {
        match self.bits {
            false => UEI_A::ST,
            true => UEI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == UEI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == UEI_A::CLEAR
    }
}
#[doc = "Write proxy for field `UEI`"]
pub struct UEI_W<'a> {
    w: &'a mut W,
}
impl<'a> UEI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UEI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(UEI_A::ST)
    }
    #[doc = "When completion of a USB transaction results in an error condition, this bit is set by the Host/Device Controller. This bit is set along with the USBINT bit, if the TD on which the error interrupt occurred also had its interrupt on complete (IOC) bit set. The device controller detects resume signaling only (see Section 18.10.11.6)."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(UEI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Port change detect.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PCI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST = 0,
    #[doc = "1: The Device Controller sets this bit to a one when the port controller enters the full or high-speed operational state. When the port controller exits the full or high-speed operation states due to Reset or Suspend events, the notification mechanisms are the USB Reset Received bit (URI) and the DCSuspend bits (SLI) respectively."]
    CLEAR = 1,
}
impl From<PCI_A> for bool {
    #[inline(always)]
    fn from(variant: PCI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `PCI`"]
pub type PCI_R = crate::R<bool, PCI_A>;
impl PCI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PCI_A {
        match self.bits {
            false => PCI_A::ST,
            true => PCI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == PCI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == PCI_A::CLEAR
    }
}
#[doc = "Write proxy for field `PCI`"]
pub struct PCI_W<'a> {
    w: &'a mut W,
}
impl<'a> PCI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PCI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(PCI_A::ST)
    }
    #[doc = "The Device Controller sets this bit to a one when the port controller enters the full or high-speed operational state. When the port controller exits the full or high-speed operation states due to Reset or Suspend events, the notification mechanisms are the USB Reset Received bit (URI) and the DCSuspend bits (SLI) respectively."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PCI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Reader of field `AAI`"]
pub type AAI_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `AAI`"]
pub struct AAI_W<'a> {
    w: &'a mut W,
}
impl<'a> AAI_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "USB reset received\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum URI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST = 0,
    #[doc = "1: When the device controller detects a USB Reset and enters the default state, this bit will be set to a one."]
    CLEAR = 1,
}
impl From<URI_A> for bool {
    #[inline(always)]
    fn from(variant: URI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `URI`"]
pub type URI_R = crate::R<bool, URI_A>;
impl URI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> URI_A {
        match self.bits {
            false => URI_A::ST,
            true => URI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == URI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == URI_A::CLEAR
    }
}
#[doc = "Write proxy for field `URI`"]
pub struct URI_W<'a> {
    w: &'a mut W,
}
impl<'a> URI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: URI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(URI_A::ST)
    }
    #[doc = "When the device controller detects a USB Reset and enters the default state, this bit will be set to a one."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(URI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "SOF received\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SRI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST = 0,
    #[doc = "1: When the device controller detects a Start Of (micro) Frame, this bit will be set to a one. When a SOF is extremely late, the device controller will automatically set this bit to indicate that an SOF was expected. Therefore, this bit will be set roughly every 1 ms in device FS mode and every 125  ms in HS mode and will be synchronized to the actual SOF that is received. Since the device controller is initialized to FS before connect, this bit will be set at an interval of 1ms during the prelude to connect and chirp."]
    CLEAR = 1,
}
impl From<SRI_A> for bool {
    #[inline(always)]
    fn from(variant: SRI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SRI`"]
pub type SRI_R = crate::R<bool, SRI_A>;
impl SRI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SRI_A {
        match self.bits {
            false => SRI_A::ST,
            true => SRI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == SRI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == SRI_A::CLEAR
    }
}
#[doc = "Write proxy for field `SRI`"]
pub struct SRI_W<'a> {
    w: &'a mut W,
}
impl<'a> SRI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SRI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(SRI_A::ST)
    }
    #[doc = "When the device controller detects a Start Of (micro) Frame, this bit will be set to a one. When a SOF is extremely late, the device controller will automatically set this bit to indicate that an SOF was expected. Therefore, this bit will be set roughly every 1 ms in device FS mode and every 125 ms in HS mode and will be synchronized to the actual SOF that is received. Since the device controller is initialized to FS before connect, this bit will be set at an interval of 1ms during the prelude to connect and chirp."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(SRI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "DCSuspend\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SLI_A {
    #[doc = "0: The device controller clears the bit upon exiting from a suspend state. This bit is cleared by software writing a one to it."]
    ST = 0,
    #[doc = "1: When a device controller enters a suspend state from an active state, this bit will be set to a one."]
    CLEAR = 1,
}
impl From<SLI_A> for bool {
    #[inline(always)]
    fn from(variant: SLI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `SLI`"]
pub type SLI_R = crate::R<bool, SLI_A>;
impl SLI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SLI_A {
        match self.bits {
            false => SLI_A::ST,
            true => SLI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == SLI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == SLI_A::CLEAR
    }
}
#[doc = "Write proxy for field `SLI`"]
pub struct SLI_W<'a> {
    w: &'a mut W,
}
impl<'a> SLI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SLI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The device controller clears the bit upon exiting from a suspend state. This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(SLI_A::ST)
    }
    #[doc = "When a device controller enters a suspend state from an active state, this bit will be set to a one."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(SLI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "NAK interrupt bit\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum NAKI_A {
    #[doc = "0: This bit is automatically cleared by hardware when the all the enabled TX/RX Endpoint NAK bits are cleared."]
    ST = 0,
    #[doc = "1: It is set by hardware when for a particular endpoint both the TX/RX Endpoint NAK bit and the corresponding TX/RX Endpoint NAK Enable bit are set."]
    CLEAR = 1,
}
impl From<NAKI_A> for bool {
    #[inline(always)]
    fn from(variant: NAKI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `NAKI`"]
pub type NAKI_R = crate::R<bool, NAKI_A>;
impl NAKI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> NAKI_A {
        match self.bits {
            false => NAKI_A::ST,
            true => NAKI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == NAKI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == NAKI_A::CLEAR
    }
}
#[doc = "Write proxy for field `NAKI`"]
pub struct NAKI_W<'a> {
    w: &'a mut W,
}
impl<'a> NAKI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: NAKI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is automatically cleared by hardware when the all the enabled TX/RX Endpoint NAK bits are cleared."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(NAKI_A::ST)
    }
    #[doc = "It is set by hardware when for a particular endpoint both the TX/RX Endpoint NAK bit and the corresponding TX/RX Endpoint NAK Enable bit are set."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(NAKI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - USB interrupt"]
    #[inline(always)]
    pub fn ui(&self) -> UI_R {
        UI_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - USB error interrupt"]
    #[inline(always)]
    pub fn uei(&self) -> UEI_R {
        UEI_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Port change detect."]
    #[inline(always)]
    pub fn pci(&self) -> PCI_R {
        PCI_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Not used in Device mode."]
    #[inline(always)]
    pub fn aai(&self) -> AAI_R {
        AAI_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - USB reset received"]
    #[inline(always)]
    pub fn uri(&self) -> URI_R {
        URI_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - SOF received"]
    #[inline(always)]
    pub fn sri(&self) -> SRI_R {
        SRI_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - DCSuspend"]
    #[inline(always)]
    pub fn sli(&self) -> SLI_R {
        SLI_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 16 - NAK interrupt bit"]
    #[inline(always)]
    pub fn naki(&self) -> NAKI_R {
        NAKI_R::new(((self.bits >> 16) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - USB interrupt"]
    #[inline(always)]
    pub fn ui(&mut self) -> UI_W {
        UI_W { w: self }
    }
    #[doc = "Bit 1 - USB error interrupt"]
    #[inline(always)]
    pub fn uei(&mut self) -> UEI_W {
        UEI_W { w: self }
    }
    #[doc = "Bit 2 - Port change detect."]
    #[inline(always)]
    pub fn pci(&mut self) -> PCI_W {
        PCI_W { w: self }
    }
    #[doc = "Bit 5 - Not used in Device mode."]
    #[inline(always)]
    pub fn aai(&mut self) -> AAI_W {
        AAI_W { w: self }
    }
    #[doc = "Bit 6 - USB reset received"]
    #[inline(always)]
    pub fn uri(&mut self) -> URI_W {
        URI_W { w: self }
    }
    #[doc = "Bit 7 - SOF received"]
    #[inline(always)]
    pub fn sri(&mut self) -> SRI_W {
        SRI_W { w: self }
    }
    #[doc = "Bit 8 - DCSuspend"]
    #[inline(always)]
    pub fn sli(&mut self) -> SLI_W {
        SLI_W { w: self }
    }
    #[doc = "Bit 16 - NAK interrupt bit"]
    #[inline(always)]
    pub fn naki(&mut self) -> NAKI_W {
        NAKI_W { w: self }
    }
}
