#[doc = "Reader of register ULPIVIEWPORT"]
pub type R = crate::R<u32, super::ULPIVIEWPORT>;
#[doc = "Writer for register ULPIVIEWPORT"]
pub type W = crate::W<u32, super::ULPIVIEWPORT>;
#[doc = "Register ULPIVIEWPORT `reset()`'s with value 0"]
impl crate::ResetValue for super::ULPIVIEWPORT {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `ULPIDATWR`"]
pub type ULPIDATWR_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `ULPIDATWR`"]
pub struct ULPIDATWR_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPIDATWR_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | ((value as u32) & 0xff);
        self.w
    }
}
#[doc = "Reader of field `ULPIDATRD`"]
pub type ULPIDATRD_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `ULPIDATRD`"]
pub struct ULPIDATRD_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPIDATRD_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | (((value as u32) & 0xff) << 8);
        self.w
    }
}
#[doc = "Reader of field `ULPIADDR`"]
pub type ULPIADDR_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `ULPIADDR`"]
pub struct ULPIADDR_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPIADDR_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 16)) | (((value as u32) & 0xff) << 16);
        self.w
    }
}
#[doc = "Reader of field `ULPIPORT`"]
pub type ULPIPORT_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `ULPIPORT`"]
pub struct ULPIPORT_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPIPORT_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 24)) | (((value as u32) & 0x07) << 24);
        self.w
    }
}
#[doc = "ULPI sync state. This bit represents the state of the ULPI interface.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ULPISS_A {
    #[doc = "0: In another state  (ie. carkit, serial, low power)"]
    IN_ANOTHER_STATE = 0,
    #[doc = "1: Normal Sync. State."]
    NORMAL_SYNC_STATE = 1,
}
impl From<ULPISS_A> for bool {
    #[inline(always)]
    fn from(variant: ULPISS_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ULPISS`"]
pub type ULPISS_R = crate::R<bool, ULPISS_A>;
impl ULPISS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ULPISS_A {
        match self.bits {
            false => ULPISS_A::IN_ANOTHER_STATE,
            true => ULPISS_A::NORMAL_SYNC_STATE,
        }
    }
    #[doc = "Checks if the value of the field is `IN_ANOTHER_STATE`"]
    #[inline(always)]
    pub fn is_in_another_state(&self) -> bool {
        *self == ULPISS_A::IN_ANOTHER_STATE
    }
    #[doc = "Checks if the value of the field is `NORMAL_SYNC_STATE`"]
    #[inline(always)]
    pub fn is_normal_sync_state(&self) -> bool {
        *self == ULPISS_A::NORMAL_SYNC_STATE
    }
}
#[doc = "Write proxy for field `ULPISS`"]
pub struct ULPISS_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPISS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ULPISS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "In another state (ie. carkit, serial, low power)"]
    #[inline(always)]
    pub fn in_another_state(self) -> &'a mut W {
        self.variant(ULPISS_A::IN_ANOTHER_STATE)
    }
    #[doc = "Normal Sync. State."]
    #[inline(always)]
    pub fn normal_sync_state(self) -> &'a mut W {
        self.variant(ULPISS_A::NORMAL_SYNC_STATE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 27)) | (((value as u32) & 0x01) << 27);
        self.w
    }
}
#[doc = "ULPI Read/Write control. This bit selects between running a read or write operation.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ULPIRW_A {
    #[doc = "0: Read"]
    READ = 0,
    #[doc = "1: Write"]
    WRITE = 1,
}
impl From<ULPIRW_A> for bool {
    #[inline(always)]
    fn from(variant: ULPIRW_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Reader of field `ULPIRW`"]
pub type ULPIRW_R = crate::R<bool, ULPIRW_A>;
impl ULPIRW_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ULPIRW_A {
        match self.bits {
            false => ULPIRW_A::READ,
            true => ULPIRW_A::WRITE,
        }
    }
    #[doc = "Checks if the value of the field is `READ`"]
    #[inline(always)]
    pub fn is_read(&self) -> bool {
        *self == ULPIRW_A::READ
    }
    #[doc = "Checks if the value of the field is `WRITE`"]
    #[inline(always)]
    pub fn is_write(&self) -> bool {
        *self == ULPIRW_A::WRITE
    }
}
#[doc = "Write proxy for field `ULPIRW`"]
pub struct ULPIRW_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPIRW_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ULPIRW_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Read"]
    #[inline(always)]
    pub fn read(self) -> &'a mut W {
        self.variant(ULPIRW_A::READ)
    }
    #[doc = "Write"]
    #[inline(always)]
    pub fn write(self) -> &'a mut W {
        self.variant(ULPIRW_A::WRITE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 29)) | (((value as u32) & 0x01) << 29);
        self.w
    }
}
#[doc = "Reader of field `ULPIRUN`"]
pub type ULPIRUN_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ULPIRUN`"]
pub struct ULPIRUN_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPIRUN_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 30)) | (((value as u32) & 0x01) << 30);
        self.w
    }
}
#[doc = "Reader of field `ULPIWU`"]
pub type ULPIWU_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ULPIWU`"]
pub struct ULPIWU_W<'a> {
    w: &'a mut W,
}
impl<'a> ULPIWU_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 31)) | (((value as u32) & 0x01) << 31);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - When a write operation is commanded, the data to be sent is written to this field."]
    #[inline(always)]
    pub fn ulpidatwr(&self) -> ULPIDATWR_R {
        ULPIDATWR_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - After a read operation completes, the result is placed in this field."]
    #[inline(always)]
    pub fn ulpidatrd(&self) -> ULPIDATRD_R {
        ULPIDATRD_R::new(((self.bits >> 8) & 0xff) as u8)
    }
    #[doc = "Bits 16:23 - When a read or write operation is commanded, the address of the operation is written to this field."]
    #[inline(always)]
    pub fn ulpiaddr(&self) -> ULPIADDR_R {
        ULPIADDR_R::new(((self.bits >> 16) & 0xff) as u8)
    }
    #[doc = "Bits 24:26 - For the wakeup or read/write operation to be executed, this value must be written as 0."]
    #[inline(always)]
    pub fn ulpiport(&self) -> ULPIPORT_R {
        ULPIPORT_R::new(((self.bits >> 24) & 0x07) as u8)
    }
    #[doc = "Bit 27 - ULPI sync state. This bit represents the state of the ULPI interface."]
    #[inline(always)]
    pub fn ulpiss(&self) -> ULPISS_R {
        ULPISS_R::new(((self.bits >> 27) & 0x01) != 0)
    }
    #[doc = "Bit 29 - ULPI Read/Write control. This bit selects between running a read or write operation."]
    #[inline(always)]
    pub fn ulpirw(&self) -> ULPIRW_R {
        ULPIRW_R::new(((self.bits >> 29) & 0x01) != 0)
    }
    #[doc = "Bit 30 - ULPI Read/Write Run. Writing the 1 to this bit will begin the read/write operation. The bit will automatically transition to 0 after the read/write is complete. Once this bit is set, the driver can not set it back to 0. The driver must never executue a wakeup and a read/write operation at the same time."]
    #[inline(always)]
    pub fn ulpirun(&self) -> ULPIRUN_R {
        ULPIRUN_R::new(((self.bits >> 30) & 0x01) != 0)
    }
    #[doc = "Bit 31 - ULPI Wake-up. Writing the 1 to this bit will begin the wakeup operation. The bit will automatically transition to 0 after the wakeup is complete. Once this bit is set, the driver can not set it back to 0. The driver must never executue a wakeup and a read/write operation at the same time."]
    #[inline(always)]
    pub fn ulpiwu(&self) -> ULPIWU_R {
        ULPIWU_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:7 - When a write operation is commanded, the data to be sent is written to this field."]
    #[inline(always)]
    pub fn ulpidatwr(&mut self) -> ULPIDATWR_W {
        ULPIDATWR_W { w: self }
    }
    #[doc = "Bits 8:15 - After a read operation completes, the result is placed in this field."]
    #[inline(always)]
    pub fn ulpidatrd(&mut self) -> ULPIDATRD_W {
        ULPIDATRD_W { w: self }
    }
    #[doc = "Bits 16:23 - When a read or write operation is commanded, the address of the operation is written to this field."]
    #[inline(always)]
    pub fn ulpiaddr(&mut self) -> ULPIADDR_W {
        ULPIADDR_W { w: self }
    }
    #[doc = "Bits 24:26 - For the wakeup or read/write operation to be executed, this value must be written as 0."]
    #[inline(always)]
    pub fn ulpiport(&mut self) -> ULPIPORT_W {
        ULPIPORT_W { w: self }
    }
    #[doc = "Bit 27 - ULPI sync state. This bit represents the state of the ULPI interface."]
    #[inline(always)]
    pub fn ulpiss(&mut self) -> ULPISS_W {
        ULPISS_W { w: self }
    }
    #[doc = "Bit 29 - ULPI Read/Write control. This bit selects between running a read or write operation."]
    #[inline(always)]
    pub fn ulpirw(&mut self) -> ULPIRW_W {
        ULPIRW_W { w: self }
    }
    #[doc = "Bit 30 - ULPI Read/Write Run. Writing the 1 to this bit will begin the read/write operation. The bit will automatically transition to 0 after the read/write is complete. Once this bit is set, the driver can not set it back to 0. The driver must never executue a wakeup and a read/write operation at the same time."]
    #[inline(always)]
    pub fn ulpirun(&mut self) -> ULPIRUN_W {
        ULPIRUN_W { w: self }
    }
    #[doc = "Bit 31 - ULPI Wake-up. Writing the 1 to this bit will begin the wakeup operation. The bit will automatically transition to 0 after the wakeup is complete. Once this bit is set, the driver can not set it back to 0. The driver must never executue a wakeup and a read/write operation at the same time."]
    #[inline(always)]
    pub fn ulpiwu(&mut self) -> ULPIWU_W {
        ULPIWU_W { w: self }
    }
}
